/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>

/* FLTKWrapper */
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

/*
  This is  the main module you should include in your
  octave code. All the FLTK independet widgets will be
  compiled, and linked into a FLTK.oct.
  
  This module FLTK will load all other Fl modules, and
  makes enumerations/flags available, from whole FLTK library.

  use FLTK() to load this FLTK module from your Octave programs.
  
  
  Separtions of modules will help easier compilation, and 
  error identification.
*/




/* Linked Separately */
DEFUN_DLD( fltk , args , , " void fltk(void); " )
{
  

  /* Modules : Other FLTK widgets */
  octave_dynamic_loader::load("Fl_Adjuster","");
  //feval("Fl_Adjuster");

  octave_dynamic_loader::load("Fl_BMP_Image","");
  //feval("Fl_BMP_Image");

  octave_dynamic_loader::load("Fl_Bitmap","");
  //feval("Fl_Bitmap");

  octave_dynamic_loader::load("Fl_Box","");
  //feval("Fl_Box");

  octave_dynamic_loader::load("Fl_Browser","");
  //feval("Fl_Browser");

/* Seems private */
/* octave_dynamic_loader::load("Fl_Browser_",""); */
  octave_dynamic_loader::load("Fl_Button","");
  //feval("Fl_Button");

  octave_dynamic_loader::load("Fl_Chart","");
  //feval("Fl_Chart");

  octave_dynamic_loader::load("Fl_Check_Browser","");
  //feval("Fl_Check_Browser");

  octave_dynamic_loader::load("Fl_Check_Button","");
  //feval("Fl_Check_Button");

  octave_dynamic_loader::load("Fl_Choice","");
  //feval("Fl_Choice");

  octave_dynamic_loader::load("Fl_Clock","");
  //feval("Fl_Clock");

  octave_dynamic_loader::load("Fl_Color_Chooser","");
  //feval("Fl_Color_Chooser");

  octave_dynamic_loader::load("Fl_Counter","");
  //feval("Fl_Counter");

  octave_dynamic_loader::load("Fl_Dial","");
  //feval("Fl_Dial");

  octave_dynamic_loader::load("Fl_Double_Window","");
  //feval("Fl_Double_Window");

  octave_dynamic_loader::load("Fl","");
  //feval("Fl");

  octave_dynamic_loader::load("Fl_File_Browser","");
  //feval("Fl_File_Browser");

  octave_dynamic_loader::load("Fl_File_Chooser","");
  //feval("Fl_File_Chooser");

  octave_dynamic_loader::load("Fl_File_Icon","");
  //feval("Fl_File_Icon");

  octave_dynamic_loader::load("Fl_File_Input","");
  //feval("Fl_File_Input");

  octave_dynamic_loader::load("Fl_Fill_Dial","");
  //feval("Fl_Fill_Dial");

  /*
  octave_dynamic_loader::load("Fl_Fill_Slider","");
  //feval("Fl_Fill_Slider");
  */

  /*
  octave_dynamic_loader::load("Fl_Float_Input","");
  //feval("Fl_Float_Input");
  */

  /*
  octave_dynamic_loader::load("Fl_FormsBitmap","");
  //feval("Fl_FormsBitmap");
  */

  /*
  octave_dynamic_loader::load("Fl_FormsPixmap","");
  //feval("Fl_FormsPixmap");
  */

  /*
  octave_dynamic_loader::load("Fl_Free","");
  //feval("Fl_Free");

  octave_dynamic_loader::load("Fl_GIF_Image","");
  //feval("Fl_GIF_Image");

  octave_dynamic_loader::load("Fl_Gl_Window","");
  //feval("Fl_Gl_Window");


  octave_dynamic_loader::load("Fl_Group","");
  //feval("Fl_Group");
  */

  octave_dynamic_loader::load("Fl_Help_Dialog","");
  //feval("Fl_Help_Dialog");

  octave_dynamic_loader::load("Fl_Help_View","");
  //feval("Fl_Help_View");

  octave_dynamic_loader::load("Fl_Hold_Browser","");
  //feval("Fl_Hold_Browser");

  octave_dynamic_loader::load("Fl_Hor_Fill_Slider","");
  //feval("Fl_Hor_Fill_Slider");

  octave_dynamic_loader::load("Fl_Hor_Nice_Slider","");
  //feval("Fl_Hor_Nice_Slider");

  octave_dynamic_loader::load("Fl_Hor_Slider","");
  //feval("Fl_Hor_Slider");

  octave_dynamic_loader::load("Fl_Hor_Value_Slider","");
  //feval("Fl_Hor_Value_Slider");

  /*
  octave_dynamic_loader::load("Fl_Image","");
  //feval("Fl_Image");
  */

  octave_dynamic_loader::load("Fl_Input","");
  //feval("Fl_Input");

/* Ignored ATM*/
  /* octave_dynamic_loader::load("Fl_Input_",""); */

  octave_dynamic_loader::load("Fl_Int_Input","");
  //feval("Fl_Int_Input");

  octave_dynamic_loader::load("Fl_JPEG_Image","");
  //feval("Fl_JPEG_Image");

  octave_dynamic_loader::load("Fl_Light_Button","");
  //feval("Fl_Light_Button");

  octave_dynamic_loader::load("Fl_Line_Dial","");
  //feval("Fl_Line_Dial");

  /* Holds nothing */
  /* octave_dynamic_loader::load("Fl_Menu",""); */
  
  /* Ignored ATM*/
  /* octave_dynamic_loader::load("Fl_Menu_",""); */

  octave_dynamic_loader::load("Fl_Menu_Bar","");
  octave_dynamic_loader::load("Fl_Menu_Button","");

  /*
    octave_dynamic_loader::load("Fl_Menu_Item","");
    //feval("Fl_Menu_Item");
  */

  octave_dynamic_loader::load("Fl_Menu_Window","");
  octave_dynamic_loader::load("Fl_Multi_Browser","");
  octave_dynamic_loader::load("Fl_Multi_Label","");
  octave_dynamic_loader::load("Fl_Multiline_Input","");
  octave_dynamic_loader::load("Fl_Multiline_Output","");
  octave_dynamic_loader::load("Fl_Nice_Slider","");

  /* octave_dynamic_loader::load("Fl_Object",""); */

  octave_dynamic_loader::load("Fl_Output","");
  octave_dynamic_loader::load("Fl_Overlay_Window","");
  octave_dynamic_loader::load("Fl_PNG_Image","");
  octave_dynamic_loader::load("Fl_PNM_Image","");
  octave_dynamic_loader::load("Fl_Pack","");
  octave_dynamic_loader::load("Fl_Pixmap","");
  octave_dynamic_loader::load("Fl_Positioner","");
  octave_dynamic_loader::load("Fl_Preferences","");
  octave_dynamic_loader::load("Fl_Progress","");
  octave_dynamic_loader::load("Fl_Radio_Button","");
  octave_dynamic_loader::load("Fl_Radio_Light_Button","");
  octave_dynamic_loader::load("Fl_Radio_Round_Button","");
  octave_dynamic_loader::load("Fl_Repeat_Button","");
  octave_dynamic_loader::load("Fl_Return_Button","");


//feval("Fl_Menu_Bar");
//feval("Fl_Menu_Button");
//feval("Fl_Menu_Window");
//feval("Fl_Multi_Browser");
//feval("Fl_Multi_Label");
//feval("Fl_Multiline_Input");
//feval("Fl_Multiline_Output");
//feval("Fl_Nice_Slider");
//feval("Fl_Object");
//feval("Fl_Output");
//feval("Fl_Overlay_Window");
//feval("Fl_PNG_Image");
//feval("Fl_PNM_Image");
//feval("Fl_Pack");
//feval("Fl_Pixmap");
//feval("Fl_Positioner");
//feval("Fl_Preferences");
//feval("Fl_Progress");
//feval("Fl_Radio_Button");
//feval("Fl_Radio_Light_Button");
//feval("Fl_Radio_Round_Button");
//feval("Fl_Repeat_Button");
//feval("Fl_Return_Button");

  octave_dynamic_loader::load("Fl_Roller","");
  //feval("Fl_Roller");

  octave_dynamic_loader::load("Fl_Round_Button","");
  //feval("Fl_Round_Button");

  octave_dynamic_loader::load("Fl_Round_Clock","");
  //feval("Fl_Round_Clock");

  octave_dynamic_loader::load("Fl_Scroll","");
  //feval("Fl_Scroll");

  /*
   octave_dynamic_loader::load("Fl_Scrollbar","");
   //feval("Fl_Scrollbar");
  */

  octave_dynamic_loader::load("Fl_Secret_Input","");
  //feval("Fl_Secret_Input");

  octave_dynamic_loader::load("Fl_Select_Browser","");
  //feval("Fl_Select_Browser");
  /*
  octave_dynamic_loader::load("Fl_Shared_Image","");
  //feval("Fl_Shared_Image");
  */

  octave_dynamic_loader::load("Fl_Simple_Counter","");
  //feval("Fl_Simple_Counter");

  octave_dynamic_loader::load("Fl_Single_Window","");
  //feval("Fl_Single_Window");

  octave_dynamic_loader::load("Fl_Slider","");
  //feval("Fl_Slider");

  /* octave_dynamic_loader::load("Fl_Sys_Menu_Bar","");*/
  octave_dynamic_loader::load("Fl_Tabs","");
  //feval("Fl_Tabs");

  /*
  octave_dynamic_loader::load("Fl_Text_Buffer","");
  //feval("Fl_Text_Buffer");

  octave_dynamic_loader::load("Fl_Text_Display","");
  //feval("Fl_Text_Display");

  octave_dynamic_loader::load("Fl_Text_Editor","");
  //feval("Fl_Text_Editor");
  */

  octave_dynamic_loader::load("Fl_Tile","");
  //feval("Fl_Tile");

  octave_dynamic_loader::load("Fl_Tiled_Image","");
  //feval("Fl_Tiled_Image");

  octave_dynamic_loader::load("Fl_Timer","");
  //feval("Fl_Timer");

  octave_dynamic_loader::load("Fl_Toggle_Button","");
  //feval("Fl_Toggle_Button");

 octave_dynamic_loader::load("Fl_Toggle_Light_Button","");
 octave_dynamic_loader::load("Fl_Toggle_Round_Button","");
  octave_dynamic_loader::load("Fl_Tooltip","");
  //feval("Fl_Tooltip");

  octave_dynamic_loader::load("Fl_Valuator","");
  //feval("Fl_Valuator");

  octave_dynamic_loader::load("Fl_Value_Input","");
  //feval("Fl_Value_Input");

  octave_dynamic_loader::load("Fl_Value_Output","");
  //feval("Fl_Value_Output");

  octave_dynamic_loader::load("Fl_Value_Slider","");
  //feval("Fl_Value_Slider");

  octave_dynamic_loader::load("Fl_Widget","");
  //feval("Fl_Widget");

  octave_dynamic_loader::load("Fl_Window","");
  //feval("Fl_Window");

  octave_dynamic_loader::load("Fl_Wizard","");
  //feval("Fl_Wizard");

  octave_dynamic_loader::load("Fl_XBM_Image","");
  octave_dynamic_loader::load("Fl_XPM_Image","");

  octave_dynamic_loader::load("fl_ask","");
  //feval("fl_ask");

  octave_dynamic_loader::load("fl_draw","");
  //feval("fl_draw");

 /* Holds nothing */ 
 /*octave_dynamic_loader::load("fl_message","");*/

  octave_dynamic_loader::load("fl_show_colormap","");
  octave_dynamic_loader::load("fl_show_input","");

 /* Holds nothing */ 
 /*octave_dynamic_loader::load("gl_draw","");*/
 
 /* TODO */
 /*octave_dynamic_loader::load("glut","");*/
  
  octave_dynamic_loader::load("FLTKWrapper","");
  //feval("FLTKWrapper");

  /* FLTK enumerations */
  octave_dynamic_loader::load("Fl_Enumerations","");
  //feval("Fl_Enumerations");

  /* Just feval all of these functions once.. that will load all submodules */
  /* DO it from the .m files, so its a lot more easier. */


  std::cout<<"Code generated onSat Jul 30 15:53:23 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFlLibrary!\n";

 return octave_value(new FLTKWrapper(0,"Fl"));
}
