/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_version , args , , " static Fl_version ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_version ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_version "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::version ( );
return octave_value(ret_type);
}

#if 0

#if 0

DEFUN_DLD( Fl_arg , args , , " static Fl_arg (int ,char** ,int& ); " )
{
int   _int0 ;
char**   _char1 ;
int&   _int&2 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_arg (int ,char** ,int& ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_arg "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_char1 = new  char  [args( 1 ).string_value ().length()];
strcpy( (char *) _char1 ,args( 1 ).string_value().c_str());
_int&2 = (  int&  ) args( 2 ).int_value();
long int ret_type=(long int) Fl::arg ( _char1,_int&2);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_args , args , , " static Fl_args (int ,char** ,int& ,int (*); " )
{
int   _int0 ;
char**   _char1 ;
int&   _int&2 ;
int   (* ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  static Fl_args (int ,char** ,int& ,int (*); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_args "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_char1 = new  char  [args( 1 ).string_value ().length()];
strcpy( (char *) _char1 ,args( 1 ).string_value().c_str());
_int&2 = (  int&  ) args( 2 ).int_value();
(* = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) Fl::args ( _char1,_int&2,(*);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_args , args , , " static Fl_args (int ,char** ); " )
{
int   _int0 ;
char**   _char1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_args (int ,char** ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_args "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_char1 = new  char  [args( 1 ).string_value ().length()];
strcpy( (char *) _char1 ,args( 1 ).string_value().c_str());
long int ret_type=(long int) Fl::args ( _char1);
return octave_value(ret_type);
}

#endif 

DEFUN_DLD( Fl_display , args , , " static Fl_display (char* ); " )
{
char*   _char0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_display (char* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_display "<<std::endl;
#endif /* DEBUG */
_char0 = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) _char0 ,args( 0 ).string_value().c_str());
long int ret_type=(long int) Fl::display ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_visual , args , , " static Fl_visual (int ); " )
{
int   _int0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_visual (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_visual "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::visual ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_gl_visual , args , , " static Fl_gl_visual (int ,int * alist=0); " )
{
int   _int0 ;
int *   alist=0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_gl_visual (int ,int * alist=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_gl_visual "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
alist=0 =( int * )args( 1 ).long_value();
long int ret_type=(long int) Fl::gl_visual ( alist=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_own_colormap , args , , " static Fl_own_colormap ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_own_colormap ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_own_colormap "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::own_colormap ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_get_system_colors , args , , " static Fl_get_system_colors ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_get_system_colors ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_get_system_colors "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::get_system_colors ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_foreground , args , , " static Fl_foreground (uchar ,uchar ,uchar ); " )
{
uchar   _uchar0 ;
uchar   _uchar1 ;
uchar   _uchar2 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_foreground (uchar ,uchar ,uchar ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_foreground "<<std::endl;
#endif /* DEBUG */
_uchar0 = (  uchar  ) args( 0 ).long_value();
_uchar1 = (  uchar  ) args( 1 ).long_value();
_uchar2 = (  uchar  ) args( 2 ).long_value();
long int ret_type=(long int) Fl::foreground ( _uchar1,_uchar2);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_background , args , , " static Fl_background (uchar ,uchar ,uchar ); " )
{
uchar   _uchar0 ;
uchar   _uchar1 ;
uchar   _uchar2 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_background (uchar ,uchar ,uchar ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_background "<<std::endl;
#endif /* DEBUG */
_uchar0 = (  uchar  ) args( 0 ).long_value();
_uchar1 = (  uchar  ) args( 1 ).long_value();
_uchar2 = (  uchar  ) args( 2 ).long_value();
long int ret_type=(long int) Fl::background ( _uchar1,_uchar2);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_background2 , args , , " static Fl_background2 (uchar ,uchar ,uchar ); " )
{
uchar   _uchar0 ;
uchar   _uchar1 ;
uchar   _uchar2 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_background2 (uchar ,uchar ,uchar ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_background2 "<<std::endl;
#endif /* DEBUG */
_uchar0 = (  uchar  ) args( 0 ).long_value();
_uchar1 = (  uchar  ) args( 1 ).long_value();
_uchar2 = (  uchar  ) args( 2 ).long_value();
long int ret_type=(long int) Fl::background2 ( _uchar1,_uchar2);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_scheme , args , , " static Fl_scheme (char* ); " )
{
char*   _char0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_scheme (char* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_scheme "<<std::endl;
#endif /* DEBUG */
_char0 = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) _char0 ,args( 0 ).string_value().c_str());
long int ret_type=(long int) Fl::scheme ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_scheme , args , , " static Fl_scheme ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_scheme ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_scheme "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::scheme ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_reload_scheme , args , , " static Fl_reload_scheme ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_reload_scheme ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_reload_scheme "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::reload_scheme ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_wait , args , , " static Fl_wait ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_wait ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_wait "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::wait ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_wait , args , , " static Fl_wait (double time); " )
{
double   time ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_wait (double time); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_wait "<<std::endl;
#endif /* DEBUG */
time = (  double  ) args( 0 ).double_value();
long int ret_type=(long int) Fl::wait ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_check , args , , " static Fl_check ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_check ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_check "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::check ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_ready , args , , " static Fl_ready ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_ready ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_ready "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::ready ( );
return octave_value(ret_type);
}

DEFUN_DLD( Fl_add_timeout , args , , " static Fl_add_timeout (double t,Fl_Timeout_Handler ,void* = 0); " )
{
double   t ;
Fl_Timeout_Handler   _Fl_Timeout_Handler0 ;
void*   = 0 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_add_timeout (double t,Fl_Timeout_Handler ,void* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_add_timeout "<<std::endl;
#endif /* DEBUG */
t = (  double  ) args( 0 ).double_value();
_Fl_Timeout_Handler0 = (  Fl_Timeout_Handler  ) args( 1 ).long_value();
= 0 =( void* )args( 2 ).long_value();
long int ret_type=(long int) Fl::add_timeout ( _Fl_Timeout_Handler0,= 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_repeat_timeout , args , , " static Fl_repeat_timeout (double t,Fl_Timeout_Handler ,void* = 0); " )
{
double   t ;
Fl_Timeout_Handler   _Fl_Timeout_Handler0 ;
void*   = 0 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_repeat_timeout (double t,Fl_Timeout_Handler ,void* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_repeat_timeout "<<std::endl;
#endif /* DEBUG */
t = (  double  ) args( 0 ).double_value();
_Fl_Timeout_Handler0 = (  Fl_Timeout_Handler  ) args( 1 ).long_value();
= 0 =( void* )args( 2 ).long_value();
long int ret_type=(long int) Fl::repeat_timeout ( _Fl_Timeout_Handler0,= 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_has_timeout , args , , " static Fl_has_timeout (Fl_Timeout_Handler ,void* = 0); " )
{
Fl_Timeout_Handler   _Fl_Timeout_Handler0 ;
void*   = 0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_has_timeout (Fl_Timeout_Handler ,void* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_has_timeout "<<std::endl;
#endif /* DEBUG */
_Fl_Timeout_Handler0 = (  Fl_Timeout_Handler  ) args( 0 ).long_value();
= 0 =( void* )args( 1 ).long_value();
long int ret_type=(long int) Fl::has_timeout ( = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_remove_timeout , args , , " static Fl_remove_timeout (Fl_Timeout_Handler ,void* = 0); " )
{
Fl_Timeout_Handler   _Fl_Timeout_Handler0 ;
void*   = 0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_remove_timeout (Fl_Timeout_Handler ,void* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_remove_timeout "<<std::endl;
#endif /* DEBUG */
_Fl_Timeout_Handler0 = (  Fl_Timeout_Handler  ) args( 0 ).long_value();
= 0 =( void* )args( 1 ).long_value();
long int ret_type=(long int) Fl::remove_timeout ( = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_add_check , args , , " static Fl_add_check (Fl_Timeout_Handler ,void* = 0); " )
{
Fl_Timeout_Handler   _Fl_Timeout_Handler0 ;
void*   = 0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_add_check (Fl_Timeout_Handler ,void* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_add_check "<<std::endl;
#endif /* DEBUG */
_Fl_Timeout_Handler0 = (  Fl_Timeout_Handler  ) args( 0 ).long_value();
= 0 =( void* )args( 1 ).long_value();
long int ret_type=(long int) Fl::add_check ( = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_has_check , args , , " static Fl_has_check (Fl_Timeout_Handler ,void* = 0); " )
{
Fl_Timeout_Handler   _Fl_Timeout_Handler0 ;
void*   = 0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_has_check (Fl_Timeout_Handler ,void* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_has_check "<<std::endl;
#endif /* DEBUG */
_Fl_Timeout_Handler0 = (  Fl_Timeout_Handler  ) args( 0 ).long_value();
= 0 =( void* )args( 1 ).long_value();
long int ret_type=(long int) Fl::has_check ( = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_remove_check , args , , " static Fl_remove_check (Fl_Timeout_Handler ,void* = 0); " )
{
Fl_Timeout_Handler   _Fl_Timeout_Handler0 ;
void*   = 0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_remove_check (Fl_Timeout_Handler ,void* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_remove_check "<<std::endl;
#endif /* DEBUG */
_Fl_Timeout_Handler0 = (  Fl_Timeout_Handler  ) args( 0 ).long_value();
= 0 =( void* )args( 1 ).long_value();
long int ret_type=(long int) Fl::remove_check ( = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_add_fd , args , , " static Fl_add_fd (int fd,int when,void (*cb); " )
{
int   fd ;
int   when ;
void   (*cb ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_add_fd (int fd,int when,void (*cb); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_add_fd "<<std::endl;
#endif /* DEBUG */
fd = (  int  ) args( 0 ).int_value();
when = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl::add_fd ( when,(*cb);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_add_fd , args , , " static Fl_add_fd (int fd,void (*cb); " )
{
int   fd ;
void   (*cb ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_add_fd (int fd,void (*cb); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_add_fd "<<std::endl;
#endif /* DEBUG */
fd = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::add_fd ( (*cb);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_remove_fd , args , , " static Fl_remove_fd (int ,int when); " )
{
int   _int0 ;
int   when ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_remove_fd (int ,int when); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_remove_fd "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
when = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl::remove_fd ( when);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_remove_fd , args , , " static Fl_remove_fd (int ); " )
{
int   _int0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_remove_fd (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_remove_fd "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::remove_fd ( );
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_add_idle , args , , " static Fl_add_idle (void); " )
{
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_add_idle (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_add_idle "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::add_idle ( );
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_has_idle , args , , " static Fl_has_idle (void); " )
{
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_has_idle (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_has_idle "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::has_idle ( );
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_remove_idle , args , , " static Fl_remove_idle (void); " )
{
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_remove_idle (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_remove_idle "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::remove_idle ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_damage , args , , " static Fl_damage ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_damage ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_damage "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::damage ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_redraw , args , , " static Fl_redraw ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_redraw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_redraw "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::redraw ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_flush , args , , " static Fl_flush ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_flush ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_flush "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::flush ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_void , args , , " static Fl_void (*warning ); " )
{
*warning   _warning0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_void (*warning ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_void "<<std::endl;
#endif /* DEBUG */
_warning0 =( *warning )args( 0 ).long_value();
long int ret_type=(long int) Fl::void ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_void , args , , " static Fl_void (*error ); " )
{
*error   _error0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_void (*error ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_void "<<std::endl;
#endif /* DEBUG */
_error0 =( *error )args( 0 ).long_value();
long int ret_type=(long int) Fl::void ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_void , args , , " static Fl_void (*fatal ); " )
{
*fatal   _fatal0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_void (*fatal ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_void "<<std::endl;
#endif /* DEBUG */
_fatal0 =( *fatal )args( 0 ).long_value();
long int ret_type=(long int) Fl::void ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_first_window , args , , " static Fl_first_window ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_first_window ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_first_window "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::first_window ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_first_window , args , , " static Fl_first_window (Fl_Window* ); " )
{
Fl_Window*   _Fl_Window0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_first_window (Fl_Window* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_first_window "<<std::endl;
#endif /* DEBUG */
_Fl_Window0 =( Fl_Window* )args( 0 ).long_value();
long int ret_type=(long int) Fl::first_window ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_next_window , args , , " static Fl_next_window (Fl_Window* ); " )
{
Fl_Window*   _Fl_Window0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_next_window (Fl_Window* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_next_window "<<std::endl;
#endif /* DEBUG */
_Fl_Window0 =( Fl_Window* )args( 0 ).long_value();
long int ret_type=(long int) Fl::next_window ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_modal , args , , " static Fl_modal ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_modal ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_modal "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::modal ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_grab , args , , " static Fl_grab ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_grab ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_grab "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::grab ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_grab , args , , " static Fl_grab (Fl_Window* ); " )
{
Fl_Window*   _Fl_Window0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_grab (Fl_Window* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_grab "<<std::endl;
#endif /* DEBUG */
_Fl_Window0 =( Fl_Window* )args( 0 ).long_value();
long int ret_type=(long int) Fl::grab ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event , args , , " static Fl_event ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_x , args , , " static Fl_event_x ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_x ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_x "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_x ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_y , args , , " static Fl_event_y ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_y ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_y "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_y ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_x_root , args , , " static Fl_event_x_root ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_x_root ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_x_root "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_x_root ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_y_root , args , , " static Fl_event_y_root ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_y_root ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_y_root "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_y_root ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_dx , args , , " static Fl_event_dx ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_dx ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_dx "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_dx ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_dy , args , , " static Fl_event_dy ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_dy ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_dy "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_dy ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_get_mouse , args , , " static Fl_get_mouse (int &,int &); " )
{
int   & ;
int   & ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_get_mouse (int &,int &); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_get_mouse "<<std::endl;
#endif /* DEBUG */
& = (  int  ) args( 0 ).int_value();
& = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl::get_mouse ( &);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_clicks , args , , " static Fl_event_clicks ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_clicks ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_clicks "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_clicks ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_clicks , args , , " static Fl_event_clicks (int i); " )
{
int   i ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_event_clicks (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_clicks "<<std::endl;
#endif /* DEBUG */
i = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::event_clicks ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_is_click , args , , " static Fl_event_is_click ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_is_click ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_is_click "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_is_click ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_is_click , args , , " static Fl_event_is_click (int i); " )
{
int   i ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_event_is_click (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_is_click "<<std::endl;
#endif /* DEBUG */
i = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::event_is_click ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_button , args , , " static Fl_event_button ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_button ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_button "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_button ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_state , args , , " static Fl_event_state ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_state ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_state "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_state ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_state , args , , " static Fl_event_state (int i); " )
{
int   i ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_event_state (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_state "<<std::endl;
#endif /* DEBUG */
i = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::event_state ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_key , args , , " static Fl_event_key ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_key ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_key "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_key ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_key , args , , " static Fl_event_key (int ); " )
{
int   _int0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_event_key (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_key "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::event_key ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_get_key , args , , " static Fl_get_key (int ); " )
{
int   _int0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_get_key (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_get_key "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::get_key ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_text , args , , " static Fl_event_text ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_text ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_text "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_text ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_length , args , , " static Fl_event_length ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_length ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_length "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_length ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_compose , args , , " static Fl_compose (int &del); " )
{
int   &del ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_compose (int &del); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_compose "<<std::endl;
#endif /* DEBUG */
&del = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::compose ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_compose_reset , args , , " static Fl_compose_reset ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_compose_reset ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_compose_reset "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::compose_reset ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_inside , args , , " static Fl_event_inside (int ,int ,int ,int ); " )
{
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  static Fl_event_inside (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_inside "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) Fl::event_inside ( _int1,_int2,_int3);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_inside , args , , " static Fl_event_inside (Fl_Widget* ); " )
{
Fl_Widget*   _Fl_Widget0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_event_inside (Fl_Widget* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_inside "<<std::endl;
#endif /* DEBUG */
_Fl_Widget0 =( Fl_Widget* )args( 0 ).long_value();
long int ret_type=(long int) Fl::event_inside ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_test_shortcut , args , , " static Fl_test_shortcut (int ); " )
{
int   _int0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_test_shortcut (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_test_shortcut "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::test_shortcut ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_handle , args , , " static Fl_handle (int ,Fl_Window* ); " )
{
int   _int0 ;
Fl_Window*   _Fl_Window1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_handle (int ,Fl_Window* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_handle "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_Fl_Window1 =( Fl_Window* )args( 1 ).long_value();
long int ret_type=(long int) Fl::handle ( _Fl_Window1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_belowmouse , args , , " static Fl_belowmouse ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_belowmouse ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_belowmouse "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::belowmouse ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_belowmouse , args , , " static Fl_belowmouse (Fl_Widget* ); " )
{
Fl_Widget*   _Fl_Widget0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_belowmouse (Fl_Widget* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_belowmouse "<<std::endl;
#endif /* DEBUG */
_Fl_Widget0 =( Fl_Widget* )args( 0 ).long_value();
long int ret_type=(long int) Fl::belowmouse ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_pushed , args , , " static Fl_pushed ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_pushed ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_pushed "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::pushed ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_pushed , args , , " static Fl_pushed (Fl_Widget* ); " )
{
Fl_Widget*   _Fl_Widget0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_pushed (Fl_Widget* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_pushed "<<std::endl;
#endif /* DEBUG */
_Fl_Widget0 =( Fl_Widget* )args( 0 ).long_value();
long int ret_type=(long int) Fl::pushed ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_focus , args , , " static Fl_focus ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_focus ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_focus "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::focus ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_focus , args , , " static Fl_focus (Fl_Widget* ); " )
{
Fl_Widget*   _Fl_Widget0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_focus (Fl_Widget* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_focus "<<std::endl;
#endif /* DEBUG */
_Fl_Widget0 =( Fl_Widget* )args( 0 ).long_value();
long int ret_type=(long int) Fl::focus ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_add_handler , args , , " static Fl_add_handler (int (*h); " )
{
int   (*h ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_add_handler (int (*h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_add_handler "<<std::endl;
#endif /* DEBUG */
(*h = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::add_handler ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_remove_handler , args , , " static Fl_remove_handler (int (*h); " )
{
int   (*h ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_remove_handler (int (*h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_remove_handler "<<std::endl;
#endif /* DEBUG */
(*h = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::remove_handler ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_copy , args , , " static Fl_copy (char* stuff,int len,int clipboard = 0); " )
{
char*   stuff ;
int   len ;
int   clipboard = 0 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_copy (char* stuff,int len,int clipboard = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_copy "<<std::endl;
#endif /* DEBUG */
stuff = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) stuff ,args( 0 ).string_value().c_str());
len = (  int  ) args( 1 ).int_value();
clipboard = 0 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) Fl::copy ( len,clipboard = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_paste , args , , " static Fl_paste (Fl_Widget &receiver,int clipboard); " )
{
Fl_Widget   &receiver ;
int   clipboard ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_paste (Fl_Widget &receiver,int clipboard); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_paste "<<std::endl;
#endif /* DEBUG */
&receiver = (  Fl_Widget  ) args( 0 ).long_value();
clipboard = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl::paste ( clipboard);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_dnd , args , , " static Fl_dnd ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_dnd ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_dnd "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::dnd ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_selection_owner , args , , " static Fl_selection_owner ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_selection_owner ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_selection_owner "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::selection_owner ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_selection_owner , args , , " static Fl_selection_owner (Fl_Widget* ); " )
{
Fl_Widget*   _Fl_Widget0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_selection_owner (Fl_Widget* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_selection_owner "<<std::endl;
#endif /* DEBUG */
_Fl_Widget0 =( Fl_Widget* )args( 0 ).long_value();
long int ret_type=(long int) Fl::selection_owner ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_selection , args , , " static Fl_selection (Fl_Widget &owner,char* ,int len); " )
{
Fl_Widget   &owner ;
char*   _char0 ;
int   len ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_selection (Fl_Widget &owner,char* ,int len); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_selection "<<std::endl;
#endif /* DEBUG */
&owner = (  Fl_Widget  ) args( 0 ).long_value();
_char0 = new  char  [args( 1 ).string_value ().length()];
strcpy( (char *) _char0 ,args( 1 ).string_value().c_str());
len = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) Fl::selection ( _char0,len);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_paste , args , , " static Fl_paste (Fl_Widget &receiver); " )
{
Fl_Widget   &receiver ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_paste (Fl_Widget &receiver); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_paste "<<std::endl;
#endif /* DEBUG */
&receiver = (  Fl_Widget  ) args( 0 ).long_value();
long int ret_type=(long int) Fl::paste ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_x , args , , " static Fl_x ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_x ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_x "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::x ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_y , args , , " static Fl_y ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_y ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_y "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::y ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_w , args , , " static Fl_w ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_w ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_w "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::w ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_h , args , , " static Fl_h ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_h ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_h "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::h ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_set_color , args , , " static Fl_set_color (Fl_Color ,uchar ,uchar ,uchar ); " )
{
Fl_Color   _Fl_Color0 ;
uchar   _uchar1 ;
uchar   _uchar2 ;
uchar   _uchar3 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  static Fl_set_color (Fl_Color ,uchar ,uchar ,uchar ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_color "<<std::endl;
#endif /* DEBUG */
_Fl_Color0 = (  Fl_Color  ) args( 0 ).long_value();
_uchar1 = (  uchar  ) args( 1 ).long_value();
_uchar2 = (  uchar  ) args( 2 ).long_value();
_uchar3 = (  uchar  ) args( 3 ).long_value();
long int ret_type=(long int) Fl::set_color ( _uchar1,_uchar2,_uchar3);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_set_color , args , , " static Fl_set_color (Fl_Color ,unsigned ); " )
{
Fl_Color   _Fl_Color0 ;
unsigned   _unsigned1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_set_color (Fl_Color ,unsigned ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_color "<<std::endl;
#endif /* DEBUG */
_Fl_Color0 = (  Fl_Color  ) args( 0 ).long_value();
_unsigned1 = (  unsigned  ) args( 1 ).long_value();
long int ret_type=(long int) Fl::set_color ( _unsigned1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_get_color , args , , " static Fl_get_color (Fl_Color ); " )
{
Fl_Color   _Fl_Color0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_get_color (Fl_Color ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_get_color "<<std::endl;
#endif /* DEBUG */
_Fl_Color0 = (  Fl_Color  ) args( 0 ).long_value();
long int ret_type=(long int) Fl::get_color ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_get_color , args , , " static Fl_get_color (Fl_Color ,uchar& ,uchar& ,uchar& ); " )
{
Fl_Color   _Fl_Color0 ;
uchar&   _uchar&1 ;
uchar&   _uchar&2 ;
uchar&   _uchar&3 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  static Fl_get_color (Fl_Color ,uchar& ,uchar& ,uchar& ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_get_color "<<std::endl;
#endif /* DEBUG */
_Fl_Color0 = (  Fl_Color  ) args( 0 ).long_value();
_uchar&1 = (  uchar&  ) args( 1 ).long_value();
_uchar&2 = (  uchar&  ) args( 2 ).long_value();
_uchar&3 = (  uchar&  ) args( 3 ).long_value();
long int ret_type=(long int) Fl::get_color ( _uchar&1,_uchar&2,_uchar&3);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_free_color , args , , " static Fl_free_color (Fl_Color ,int overlay = 0); " )
{
Fl_Color   _Fl_Color0 ;
int   overlay = 0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_free_color (Fl_Color ,int overlay = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_free_color "<<std::endl;
#endif /* DEBUG */
_Fl_Color0 = (  Fl_Color  ) args( 0 ).long_value();
overlay = 0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl::free_color ( overlay = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_get_font , args , , " static Fl_get_font (Fl_Font ); " )
{
Fl_Font   _Fl_Font0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_get_font (Fl_Font ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_get_font "<<std::endl;
#endif /* DEBUG */
_Fl_Font0 = (  Fl_Font  ) args( 0 ).long_value();
long int ret_type=(long int) Fl::get_font ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_get_font_name , args , , " static Fl_get_font_name (Fl_Font ,int* attributes = 0); " )
{
Fl_Font   _Fl_Font0 ;
int*   attributes = 0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_get_font_name (Fl_Font ,int* attributes = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_get_font_name "<<std::endl;
#endif /* DEBUG */
_Fl_Font0 = (  Fl_Font  ) args( 0 ).long_value();
attributes = 0 =( int* )args( 1 ).long_value();
long int ret_type=(long int) Fl::get_font_name ( attributes = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_get_font_sizes , args , , " static Fl_get_font_sizes (Fl_Font ,int*& sizep); " )
{
Fl_Font   _Fl_Font0 ;
int*&   sizep ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_get_font_sizes (Fl_Font ,int*& sizep); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_get_font_sizes "<<std::endl;
#endif /* DEBUG */
_Fl_Font0 = (  Fl_Font  ) args( 0 ).long_value();
sizep =( int*& )args( 1 ).long_value();
long int ret_type=(long int) Fl::get_font_sizes ( sizep);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_set_font , args , , " static Fl_set_font (Fl_Font ,char* ); " )
{
Fl_Font   _Fl_Font0 ;
char*   _char1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_set_font (Fl_Font ,char* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_font "<<std::endl;
#endif /* DEBUG */
_Fl_Font0 = (  Fl_Font  ) args( 0 ).long_value();
_char1 = new  char  [args( 1 ).string_value ().length()];
strcpy( (char *) _char1 ,args( 1 ).string_value().c_str());
long int ret_type=(long int) Fl::set_font ( _char1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_set_font , args , , " static Fl_set_font (Fl_Font ,Fl_Font ); " )
{
Fl_Font   _Fl_Font0 ;
Fl_Font   _Fl_Font1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_set_font (Fl_Font ,Fl_Font ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_font "<<std::endl;
#endif /* DEBUG */
_Fl_Font0 = (  Fl_Font  ) args( 0 ).long_value();
_Fl_Font1 = (  Fl_Font  ) args( 1 ).long_value();
long int ret_type=(long int) Fl::set_font ( _Fl_Font1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_set_fonts , args , , " static Fl_set_fonts (char* = 0); " )
{
char*   = 0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_set_fonts (char* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_fonts "<<std::endl;
#endif /* DEBUG */
= 0 = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) = 0 ,args( 0 ).string_value().c_str());
long int ret_type=(long int) Fl::set_fonts ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_set_labeltype , args , , " static Fl_set_labeltype (Fl_Labeltype ,Fl_Label_Draw_F* ,Fl_Label_Measure_F* ); " )
{
Fl_Labeltype   _Fl_Labeltype0 ;
Fl_Label_Draw_F*   _Fl_Label_Draw_F1 ;
Fl_Label_Measure_F*   _Fl_Label_Measure_F2 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_set_labeltype (Fl_Labeltype ,Fl_Label_Draw_F* ,Fl_Label_Measure_F* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_labeltype "<<std::endl;
#endif /* DEBUG */
_Fl_Labeltype0 = (  Fl_Labeltype  ) args( 0 ).long_value();
_Fl_Label_Draw_F1 =( Fl_Label_Draw_F* )args( 1 ).long_value();
_Fl_Label_Measure_F2 =( Fl_Label_Measure_F* )args( 2 ).long_value();
long int ret_type=(long int) Fl::set_labeltype ( _Fl_Label_Draw_F1,_Fl_Label_Measure_F2);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_set_labeltype , args , , " static Fl_set_labeltype (Fl_Labeltype ,Fl_Labeltype from); " )
{
Fl_Labeltype   _Fl_Labeltype0 ;
Fl_Labeltype   from ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_set_labeltype (Fl_Labeltype ,Fl_Labeltype from); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_labeltype "<<std::endl;
#endif /* DEBUG */
_Fl_Labeltype0 = (  Fl_Labeltype  ) args( 0 ).long_value();
from = (  Fl_Labeltype  ) args( 1 ).long_value();
long int ret_type=(long int) Fl::set_labeltype ( from);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_*get_boxtype , args , , " static Fl_*get_boxtype (Fl_Boxtype ); " )
{
Fl_Boxtype   _Fl_Boxtype0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_*get_boxtype (Fl_Boxtype ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_*get_boxtype "<<std::endl;
#endif /* DEBUG */
_Fl_Boxtype0 = (  Fl_Boxtype  ) args( 0 ).long_value();
long int ret_type=(long int) Fl::*get_boxtype ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_set_boxtype , args , , " static Fl_set_boxtype (Fl_Boxtype ,Fl_Box_Draw_F* ,uchar ,uchar ,uchar ,uchar ); " )
{
Fl_Boxtype   _Fl_Boxtype0 ;
Fl_Box_Draw_F*   _Fl_Box_Draw_F1 ;
uchar   _uchar2 ;
uchar   _uchar3 ;
uchar   _uchar4 ;
uchar   _uchar5 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  static Fl_set_boxtype (Fl_Boxtype ,Fl_Box_Draw_F* ,uchar ,uchar ,uchar ,uchar ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_boxtype "<<std::endl;
#endif /* DEBUG */
_Fl_Boxtype0 = (  Fl_Boxtype  ) args( 0 ).long_value();
_Fl_Box_Draw_F1 =( Fl_Box_Draw_F* )args( 1 ).long_value();
_uchar2 = (  uchar  ) args( 2 ).long_value();
_uchar3 = (  uchar  ) args( 3 ).long_value();
_uchar4 = (  uchar  ) args( 4 ).long_value();
_uchar5 = (  uchar  ) args( 5 ).long_value();
long int ret_type=(long int) Fl::set_boxtype ( _Fl_Box_Draw_F1,_uchar2,_uchar3,_uchar4,_uchar5);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_set_boxtype , args , , " static Fl_set_boxtype (Fl_Boxtype ,Fl_Boxtype from); " )
{
Fl_Boxtype   _Fl_Boxtype0 ;
Fl_Boxtype   from ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_set_boxtype (Fl_Boxtype ,Fl_Boxtype from); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_boxtype "<<std::endl;
#endif /* DEBUG */
_Fl_Boxtype0 = (  Fl_Boxtype  ) args( 0 ).long_value();
from = (  Fl_Boxtype  ) args( 1 ).long_value();
long int ret_type=(long int) Fl::set_boxtype ( from);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_box_dx , args , , " static Fl_box_dx (Fl_Boxtype ); " )
{
Fl_Boxtype   _Fl_Boxtype0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_box_dx (Fl_Boxtype ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_box_dx "<<std::endl;
#endif /* DEBUG */
_Fl_Boxtype0 = (  Fl_Boxtype  ) args( 0 ).long_value();
long int ret_type=(long int) Fl::box_dx ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_box_dy , args , , " static Fl_box_dy (Fl_Boxtype ); " )
{
Fl_Boxtype   _Fl_Boxtype0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_box_dy (Fl_Boxtype ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_box_dy "<<std::endl;
#endif /* DEBUG */
_Fl_Boxtype0 = (  Fl_Boxtype  ) args( 0 ).long_value();
long int ret_type=(long int) Fl::box_dy ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_box_dw , args , , " static Fl_box_dw (Fl_Boxtype ); " )
{
Fl_Boxtype   _Fl_Boxtype0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_box_dw (Fl_Boxtype ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_box_dw "<<std::endl;
#endif /* DEBUG */
_Fl_Boxtype0 = (  Fl_Boxtype  ) args( 0 ).long_value();
long int ret_type=(long int) Fl::box_dw ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_box_dh , args , , " static Fl_box_dh (Fl_Boxtype ); " )
{
Fl_Boxtype   _Fl_Boxtype0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_box_dh (Fl_Boxtype ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_box_dh "<<std::endl;
#endif /* DEBUG */
_Fl_Boxtype0 = (  Fl_Boxtype  ) args( 0 ).long_value();
long int ret_type=(long int) Fl::box_dh ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_draw_box_active , args , , " static Fl_draw_box_active ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_draw_box_active ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw_box_active "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::draw_box_active ( );
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_set_abort , args , , " static Fl_set_abort (void); " )
{
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_set_abort (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_abort "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::set_abort ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_void , args , , " static Fl_void (*atclose ); " )
{
*atclose   _atclose0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_void (*atclose ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_void "<<std::endl;
#endif /* DEBUG */
_atclose0 =( *atclose )args( 0 ).long_value();
long int ret_type=(long int) Fl::void ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_default_atclose , args , , " static Fl_default_atclose (Fl_Window* ,void* ); " )
{
Fl_Window*   _Fl_Window0 ;
void*   _void1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_default_atclose (Fl_Window* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_default_atclose "<<std::endl;
#endif /* DEBUG */
_Fl_Window0 =( Fl_Window* )args( 0 ).long_value();
_void1 =( void* )args( 1 ).long_value();
long int ret_type=(long int) Fl::default_atclose ( _void1);
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_set_atclose , args , , " static Fl_set_atclose (void); " )
{
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_set_atclose (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_atclose "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::set_atclose ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_shift , args , , " static Fl_event_shift ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_shift ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_shift "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_shift ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_ctrl , args , , " static Fl_event_ctrl ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_ctrl ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_ctrl "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_ctrl ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_alt , args , , " static Fl_event_alt ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_alt ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_alt "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_alt ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_buttons , args , , " static Fl_event_buttons ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_buttons ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_buttons "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_buttons ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_button1 , args , , " static Fl_event_button1 ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_button1 ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_button1 "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_button1 ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_button2 , args , , " static Fl_event_button2 ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_button2 ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_button2 "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_button2 ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_event_button3 , args , , " static Fl_event_button3 ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_event_button3 ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_event_button3 "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::event_button3 ( );
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_set_idle , args , , " static Fl_set_idle (void); " )
{
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_set_idle (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_set_idle "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::set_idle ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_grab , args , , " static Fl_grab (Fl_Window&win ); " )
{
Fl_Window&win   _Fl_Window&win0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_grab (Fl_Window&win ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_grab "<<std::endl;
#endif /* DEBUG */
_Fl_Window&win0 = (  Fl_Window&win  ) args( 0 ).long_value();
long int ret_type=(long int) Fl::grab ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_release , args , , " static Fl_release ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_release ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_release "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::release ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_visible_focus , args , , " static Fl_visible_focus (int v); " )
{
int   v ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_visible_focus (int v); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_visible_focus "<<std::endl;
#endif /* DEBUG */
v = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::visible_focus ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_visible_focus , args , , " static Fl_visible_focus ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_visible_focus ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_visible_focus "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::visible_focus ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_dnd_text_ops , args , , " static Fl_dnd_text_ops (int v); " )
{
int   v ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_dnd_text_ops (int v); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_dnd_text_ops "<<std::endl;
#endif /* DEBUG */
v = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) Fl::dnd_text_ops ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_dnd_text_ops , args , , " static Fl_dnd_text_ops ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_dnd_text_ops ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_dnd_text_ops "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::dnd_text_ops ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_lock , args , , " static Fl_lock ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_lock ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_lock "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::lock ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_unlock , args , , " static Fl_unlock ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_unlock ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_unlock "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::unlock ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_awake , args , , " static Fl_awake (void* message = 0); " )
{
void*   message = 0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_awake (void* message = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_awake "<<std::endl;
#endif /* DEBUG */
message = 0 =( void* )args( 0 ).long_value();
long int ret_type=(long int) Fl::awake ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_thread_message , args , , " static Fl_thread_message ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_thread_message ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_thread_message "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::thread_message ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_delete_widget , args , , " static Fl_delete_widget (Fl_Widget * w); " )
{
Fl_Widget *   w ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_delete_widget (Fl_Widget * w); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_delete_widget "<<std::endl;
#endif /* DEBUG */
w =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) Fl::delete_widget ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_do_widget_deletion , args , , " static Fl_do_widget_deletion ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_do_widget_deletion ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_do_widget_deletion "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::do_widget_deletion ( );
return octave_value(ret_type);
}
#endif


DEFUN_DLD( Fl_run , args , , " static Fl_run ( ); " )
{
  if(args.length()!= 0 )
   {
    std::cout<< "eg:  static Fl_run ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
 std::cout<<" Fl_run "<<std::endl;
#endif /* DEBUG */
 long int ret_type=(long int) Fl::run ( );
 return octave_value(ret_type);
}
DEFUN_DLD( Fl_readqueue , args , , " static Fl_readqueue ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  static Fl_readqueue ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_readqueue "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) Fl::readqueue ( );
return octave_value(ret_type);
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl, args , , " void -generate_static_code(void); " )
{
octave_dynamic_loader::load("Fl_version" ,"");

/*
    octave_dynamic_loader::load("Fl_arg" ,"");
    octave_dynamic_loader::load("Fl_args" ,"");
    octave_dynamic_loader::load("Fl_args" ,"");
*/

octave_dynamic_loader::load("Fl_display" ,"");
octave_dynamic_loader::load("Fl_visual" ,"");
octave_dynamic_loader::load("Fl_gl_visual" ,"");
octave_dynamic_loader::load("Fl_own_colormap" ,"");
octave_dynamic_loader::load("Fl_get_system_colors" ,"");
octave_dynamic_loader::load("Fl_foreground" ,"");
octave_dynamic_loader::load("Fl_background" ,"");
octave_dynamic_loader::load("Fl_background2" ,"");
octave_dynamic_loader::load("Fl_scheme" ,"");
octave_dynamic_loader::load("Fl_scheme" ,"");
octave_dynamic_loader::load("Fl_reload_scheme" ,"");
octave_dynamic_loader::load("Fl_wait" ,"");
octave_dynamic_loader::load("Fl_wait" ,"");
octave_dynamic_loader::load("Fl_check" ,"");
octave_dynamic_loader::load("Fl_ready" ,"");

octave_dynamic_loader::load("Fl_run" ,"");

octave_dynamic_loader::load("Fl_readqueue" ,"");
octave_dynamic_loader::load("Fl_add_timeout" ,"");
octave_dynamic_loader::load("Fl_repeat_timeout" ,"");
octave_dynamic_loader::load("Fl_has_timeout" ,"");
octave_dynamic_loader::load("Fl_remove_timeout" ,"");
octave_dynamic_loader::load("Fl_add_check" ,"");
octave_dynamic_loader::load("Fl_has_check" ,"");
octave_dynamic_loader::load("Fl_remove_check" ,"");
octave_dynamic_loader::load("Fl_add_fd" ,"");
octave_dynamic_loader::load("Fl_remove_fd" ,"");

octave_dynamic_loader::load("Fl_add_idle" ,"");
octave_dynamic_loader::load("Fl_has_idle" ,"");

octave_dynamic_loader::load("Fl_remove_idle" ,"");
octave_dynamic_loader::load("Fl_damage" ,"");
octave_dynamic_loader::load("Fl_redraw" ,"");
octave_dynamic_loader::load("Fl_flush" ,"");
octave_dynamic_loader::load("Fl_first_window" ,"");
octave_dynamic_loader::load("Fl_next_window" ,"");
octave_dynamic_loader::load("Fl_modal" ,"");
octave_dynamic_loader::load("Fl_grab" ,"");
octave_dynamic_loader::load("Fl_event" ,"");
octave_dynamic_loader::load("Fl_event_x" ,"");
octave_dynamic_loader::load("Fl_event_y" ,"");
octave_dynamic_loader::load("Fl_event_x_root" ,"");
octave_dynamic_loader::load("Fl_event_y_root" ,"");
octave_dynamic_loader::load("Fl_event_dx" ,"");
octave_dynamic_loader::load("Fl_event_dy" ,"");
octave_dynamic_loader::load("Fl_get_mouse" ,"");
octave_dynamic_loader::load("Fl_event_clicks" ,"");
octave_dynamic_loader::load("Fl_event_clicks" ,"");
octave_dynamic_loader::load("Fl_event_is_click" ,"");
octave_dynamic_loader::load("Fl_event_is_click" ,"");
octave_dynamic_loader::load("Fl_event_button" ,"");
octave_dynamic_loader::load("Fl_event_state" ,"");
octave_dynamic_loader::load("Fl_event_state" ,"");
octave_dynamic_loader::load("Fl_event_key" ,"");
octave_dynamic_loader::load("Fl_event_key" ,"");
octave_dynamic_loader::load("Fl_get_key" ,"");
octave_dynamic_loader::load("Fl_event_text" ,"");
octave_dynamic_loader::load("Fl_event_length" ,"");
octave_dynamic_loader::load("Fl_compose" ,"");
octave_dynamic_loader::load("Fl_compose_reset" ,"");
octave_dynamic_loader::load("Fl_event_inside" ,"");
octave_dynamic_loader::load("Fl_event_inside" ,"");
octave_dynamic_loader::load("Fl_test_shortcut" ,"");
octave_dynamic_loader::load("Fl_handle" ,"");
octave_dynamic_loader::load("Fl_belowmouse" ,"");
octave_dynamic_loader::load("Fl_belowmouse" ,"");
octave_dynamic_loader::load("Fl_pushed" ,"");
octave_dynamic_loader::load("Fl_focus" ,"");
octave_dynamic_loader::load("Fl_add_handler" ,"");
octave_dynamic_loader::load("Fl_remove_handler" ,"");
octave_dynamic_loader::load("Fl_copy" ,"");
octave_dynamic_loader::load("Fl_paste" ,"");
octave_dynamic_loader::load("Fl_dnd" ,"");
octave_dynamic_loader::load("Fl_selection_owner" ,"");
octave_dynamic_loader::load("Fl_selection" ,"");
octave_dynamic_loader::load("Fl_paste" ,"");
octave_dynamic_loader::load("Fl_x" ,"");
octave_dynamic_loader::load("Fl_y" ,"");
octave_dynamic_loader::load("Fl_w" ,"");
octave_dynamic_loader::load("Fl_h" ,"");
octave_dynamic_loader::load("Fl_set_color" ,"");
octave_dynamic_loader::load("Fl_get_color" ,"");
octave_dynamic_loader::load("Fl_free_color" ,"");
octave_dynamic_loader::load("Fl_get_font" ,"");
octave_dynamic_loader::load("Fl_get_font_name" ,"");
octave_dynamic_loader::load("Fl_get_font_sizes" ,"");
octave_dynamic_loader::load("Fl_set_font" ,"");
octave_dynamic_loader::load("Fl_set_fonts" ,"");
octave_dynamic_loader::load("Fl_set_labeltype" ,"");
octave_dynamic_loader::load("Fl_get_boxtype" ,"");
octave_dynamic_loader::load("Fl_set_boxtype" ,"");
octave_dynamic_loader::load("Fl_box_dx" ,"");
octave_dynamic_loader::load("Fl_box_dy" ,"");
octave_dynamic_loader::load("Fl_box_dw" ,"");
octave_dynamic_loader::load("Fl_box_dh" ,"");
octave_dynamic_loader::load("Fl_draw_box_active" ,"");
octave_dynamic_loader::load("Fl_set_abort" ,"");
octave_dynamic_loader::load("Fl_void" ,"");
octave_dynamic_loader::load("Fl_default_atclose" ,"");
octave_dynamic_loader::load("Fl_set_atclose" ,"");
octave_dynamic_loader::load("Fl_event_shift" ,"");
octave_dynamic_loader::load("Fl_event_ctrl" ,"");
octave_dynamic_loader::load("Fl_event_alt" ,"");
octave_dynamic_loader::load("Fl_event_buttons" ,"");
octave_dynamic_loader::load("Fl_event_button1" ,"");
octave_dynamic_loader::load("Fl_event_button2" ,"");
octave_dynamic_loader::load("Fl_event_button3" ,"");
octave_dynamic_loader::load("Fl_set_idle" ,"");
octave_dynamic_loader::load("Fl_grab" ,"");
octave_dynamic_loader::load("Fl_release" ,"");
octave_dynamic_loader::load("Fl_visible_focus" ,"");
octave_dynamic_loader::load("Fl_visible_focus" ,"");
octave_dynamic_loader::load("Fl_dnd_text_ops" ,"");
octave_dynamic_loader::load("Fl_dnd_text_ops" ,"");
octave_dynamic_loader::load("Fl_lock" ,"");
octave_dynamic_loader::load("Fl_unlock" ,"");
octave_dynamic_loader::load("Fl_awake" ,"");
octave_dynamic_loader::load("Fl_thread_message" ,"");
octave_dynamic_loader::load("Fl_delete_widget" ,"");
octave_dynamic_loader::load("Fl_do_widget_deletion" ,"");
std::cout<<"Code generated onMon Aug  1 23:33:31 2005\n Compiled on " __DATE__  __TIME__ "\n loaded-generate_static_codeLibrary!"<<std::endl;

 return octave_value(new FLTKStaticWrapper(0,"Fl"));
}
