/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Browser_remove , args , , " void Fl_Browser_remove (int ); " )
{
  Fl_Browser *   _Fl_BrowserPtr ;
  int   _int0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  void Fl_Browser_remove (int ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Browser_remove "<<std::endl;
#endif /* DEBUG */
  _Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
  _int0 = (  int  ) args( 1 ).int_value();
  _Fl_BrowserPtr->remove ( _int0);
  return octave_value();
}

DEFUN_DLD( Fl_Browser_add , args , , " void Fl_Browser_add (char* ,void* = 0); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
char*   _char0 ;
void*  arg ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Browser_add (char* ,void* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_add "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
_char0 =( char* )args( 1 ).long_value();
arg =( void* )args( 2 ).long_value();
_Fl_BrowserPtr->add ( _char0,arg);
return octave_value();
}
DEFUN_DLD( Fl_Browser_insert , args , , " void Fl_Browser_insert (int ,char* ,void* = 0); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   _int0 ;
char*   _char1 ;
void*   arg ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Browser_insert (int ,char* ,void* = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_insert "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_char1 =( char* )args( 2 ).long_value();
arg =( void* )args( 3 ).long_value();
_Fl_BrowserPtr->insert ( _int0,_char1,arg);
return octave_value();
}

DEFUN_DLD( Fl_Browser_move , args , , " void Fl_Browser_move (int to,int from); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   to ;
int   from ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Browser_move (int to,int from); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_move "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
to = (  int  ) args( 1 ).int_value();
from = (  int  ) args( 2 ).int_value();
_Fl_BrowserPtr->move ( to,from);
return octave_value();
}
DEFUN_DLD( Fl_Browser_load , args , , " int Fl_Browser_load (char* filename); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
char*   filename ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Browser_load (char* filename); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_load "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
filename =( char* )args( 1 ).long_value();
long int ret_type=(long int) _Fl_BrowserPtr->load ( filename);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser_swap , args , , " void Fl_Browser_swap (int a,int b); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   a ;
int   b ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Browser_swap (int a,int b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_swap "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
a = (  int  ) args( 1 ).int_value();
b = (  int  ) args( 2 ).int_value();
_Fl_BrowserPtr->swap ( a,b);
return octave_value();
}
DEFUN_DLD( Fl_Browser_clear , args , , " void Fl_Browser_clear ( ); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Browser_clear ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_clear "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
_Fl_BrowserPtr->clear ( );
return octave_value();
}
DEFUN_DLD( Fl_Browser_size , args , , " int Fl_Browser_size ( ); " )
{
  Fl_Browser *   _Fl_BrowserPtr ;
  int   W ;
  int   H ;
  if(args.length()!= 1 && args.length()!= 3 )
    {
      std::cout<< "eg:  int Fl_Browser_size ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
std::cout<<" Fl_Browser_size "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();

 if(args.length()!= 3 )
   {
     long int ret_type=(long int) _Fl_BrowserPtr->size ( );
     return octave_value(ret_type);
   }
W = (  int  ) args( 1 ).int_value();
H = (  int  ) args( 2 ).int_value();
_Fl_BrowserPtr->size ( W,H);
return octave_value(); 
}

DEFUN_DLD( Fl_Browser_topline , args , , " int Fl_Browser_topline ( ); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   l ;

 if(args.length()!= 1 && args.length()!= 2)
  {
   std::cout<< "eg:  int Fl_Browser_topline ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_topline "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
 if(args.length()==1)
   { 
     long int ret_type=(long int) _Fl_BrowserPtr->topline ( );
     return octave_value(ret_type);
   }

 l = (  int  ) args( 1 ).int_value();
 _Fl_BrowserPtr->topline ( l);
 return octave_value();
}

DEFUN_DLD( Fl_Browser_lineposition , args , , " void Fl_Browser_lineposition (int); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   _int0 ;
int  _Fl_Line_Position1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Browser_lineposition (int ,Fl_Line_Position ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_lineposition "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_Fl_Line_Position1 =  args( 2 ).long_value();
 _Fl_BrowserPtr->lineposition ( _int0,(Fl_Browser::Fl_Line_Position)_Fl_Line_Position1);
return octave_value();
}

DEFUN_DLD( Fl_Browser_bottomline , args , , " void Fl_Browser_bottomline (int l); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   l ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser_bottomline (int l); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_bottomline "<<std::endl;
#endif /* DEBUG */
 _Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
 l = (  int  ) args( 1 ).int_value();
 _Fl_BrowserPtr->bottomline ( l);
 return octave_value();
}

DEFUN_DLD( Fl_Browser_middleline , args , , " void Fl_Browser_middleline (int l); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   l ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser_middleline (int l); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_middleline "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
l = (  int  ) args( 1 ).int_value();
_Fl_BrowserPtr->middleline ( l);
return octave_value();
}

DEFUN_DLD( Fl_Browser_select , args , , " int Fl_Browser_select (int ,int ); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   _int0 ;
int   _int1 ;

 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Browser_select (int ,int1 ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
 std::cout<<" Fl_Browser_select "<<std::endl;
#endif /* DEBUG */

_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_BrowserPtr->select ( _int0,_int1);
return octave_value(ret_type);
}

DEFUN_DLD( Fl_Browser_selected , args , , " int Fl_Browser_selected (int ); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Browser_selected (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_selected "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_BrowserPtr->selected ( _int0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser_show , args , , " void Fl_Browser_show (int n); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   n ;
 if(args.length()!= 2 && args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Browser_show (int n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_show "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
 if( args.length()!= 1 )
   {
     n = (  int  ) args( 1 ).int_value();
     _Fl_BrowserPtr->show ( n);
     return octave_value();
   }
 _Fl_BrowserPtr->show ( );
 return octave_value();
}

DEFUN_DLD( Fl_Browser_hide , args , , " void Fl_Browser_hide (int n); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   n ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser_hide (int n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_hide "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
 if(args.length()!= 1 )
   {
     n = (  int  ) args( 1 ).int_value();
     _Fl_BrowserPtr->hide ( n);
     return octave_value();
   }
_Fl_BrowserPtr->hide ( );
 return octave_value();
}

DEFUN_DLD( Fl_Browser_visible , args , , " int Fl_Browser_visible (int n); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   n ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Browser_visible (int n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_visible "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
n = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_BrowserPtr->visible ( n);
return octave_value(ret_type);
}

DEFUN_DLD( Fl_Browser_value , args , , " void Fl_Browser_value (int v); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   v ;
 if(args.length()!= 2 && args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Browser_value (int v); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_value "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
 if(args.length()!= 1 )
   { 
     v = (  int  ) args( 1 ).int_value();
     _Fl_BrowserPtr->value ( v);
     return octave_value();
   }

 long int ret_type=(long int) _Fl_BrowserPtr->value ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Browser_text , args , , " void Fl_Browser_text (int ,char* ); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   _int0 ;
char*   _char1 ;
 if(args.length()!= 3 ||  args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser_text (int ,char* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_text "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
 if(args.length()==3)
   { 
     _int0 = (  int  ) args( 1 ).int_value();
     _char1 =( char* )strdup(args( 2 ).string_value().c_str());
     _Fl_BrowserPtr->text ( _int0,_char1);
     return octave_value();
   }

 _int0 = (  int  ) args( 1 ).int_value();
 string  ret_type(  (const char *) _Fl_BrowserPtr->text ( _int0));
 return octave_value(ret_type);
}





DEFUN_DLD( Fl_Browser_data , args , , " void Fl_Browser_data (int ,void* v); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   _int0 ;
void*   v ;

 if(args.length()!= 3  && args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser_data (int ,void* v); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_data "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
  if(args.length()!= 2 )
    {
      _int0 = (  int  ) args( 1 ).int_value();
      v =( void* )args( 2 ).long_value();
      _Fl_BrowserPtr->data ( _int0,v);
      return octave_value();
    }

  _int0 = (  int  ) args( 1 ).int_value();
  long int ret_type= (long int) _Fl_BrowserPtr->data ( _int0);
  return octave_value(ret_type);
}

DEFUN_DLD( Fl_Browser_format_char , args , , " char Fl_Browser_format_char ( ); " )
{
  Fl_Browser *   _Fl_BrowserPtr ;
  if(args.length()!= 1 && args.length()!= 2  )
    {
      std::cout<< "eg:  char Fl_Browser_format_char ( ); " <<std::endl;
      return octave_value(-1);
    }

#ifdef DEBUG
  std::cout<<" Fl_Browser_format_char "<<std::endl;
#endif /* DEBUG */
  _Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
  if(args.length()!= 2  )
    {
      long int ret_type=(long int) _Fl_BrowserPtr->format_char ( );
      return octave_value(ret_type);
    }

  _Fl_BrowserPtr->format_char ((int) args(1).long_value());
  return octave_value();
}

DEFUN_DLD( Fl_Browser_column_char , args , , " char Fl_Browser_column_char ( ); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
 if(args.length()!= 1 && args.length()!= 2 )
  {
   std::cout<< "eg:  char Fl_Browser_column_char ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_column_char "<<std::endl;
#endif /* DEBUG */
 _Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
 if(args.length()==1)
   {
     long int ret_type=(long int) _Fl_BrowserPtr->column_char ( );
     return octave_value(ret_type);
   }


 _Fl_BrowserPtr->column_char ( (  char  ) args( 1 ).long_value());
 return octave_value();
}

DEFUN_DLD( Fl_Browser_column_widths , args , , " int* Fl_Browser_column_widths ( ); " )
{
  Fl_Browser *   _Fl_BrowserPtr ;
  Matrix mat; 
 
 if(args.length()!= 1 && args.length()!= 2 )
   {
     std::cout<< "eg:  int* Fl_Browser_column_widths ( ); " <<std::endl;
     return octave_value(-1);
   }

#ifdef DEBUG
 std::cout<<" Fl_Browser_column_widths "<<std::endl;
#endif /* DEBUG */
 
 _Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();


 int iter=0;

 if(args.length()==1)
   {
     const int *ptr;
     ptr=_Fl_BrowserPtr->column_widths ( );
     while(ptr!=NULL)
       {
	 mat.elem(0,iter++)=*ptr;
	 ptr++;
       }
     return octave_value(mat);
   }

 int *ptr;
 ptr=new int [mat.cols()];
 for(iter=0;iter<mat.cols();iter++)
   ptr[iter]=(int )mat.elem(0,iter);
 
 _Fl_BrowserPtr->column_widths (ptr);
 return octave_value();
}

DEFUN_DLD( Fl_Browser_displayed , args , , " int Fl_Browser_displayed (int n); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   n ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Browser_displayed (int n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_displayed "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
n = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_BrowserPtr->displayed ( n);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser_make_visible , args , , " void Fl_Browser_make_visible (int n); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   n ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser_make_visible (int n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_make_visible "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
n = (  int  ) args( 1 ).int_value();
_Fl_BrowserPtr->make_visible ( n);
return octave_value();
}
DEFUN_DLD( Fl_Browser_replace , args , , " void Fl_Browser_replace (int a,char* b); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   a ;
char*   b ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Browser_replace (int a,char* b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_replace "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
a = (  int  ) args( 1 ).int_value();
b =( char* )args( 2 ).long_value();
_Fl_BrowserPtr->replace ( a,b);
return octave_value();
}
DEFUN_DLD( Fl_Browser_display , args , , " void Fl_Browser_display (int ,int=1 ); " )
{
Fl_Browser *   _Fl_BrowserPtr ;
int   _int0 ;
int   _int1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Browser_display (int ,int=1 ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser_display "<<std::endl;
#endif /* DEBUG */
_Fl_BrowserPtr =( Fl_Browser * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_Fl_BrowserPtr->display ( _int0,_int1);
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Browser , args , , " void Fl_Browser(void); " )
{

  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      Fl_Browser *flb=new Fl_Browser(args(0).int_value(),args(1).int_value(),
				       args(2).int_value(),args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Browser"));
    }

  octave_dynamic_loader::load("Fl_Browser_remove" ,"");
  octave_dynamic_loader::load("Fl_Browser_add" ,"");
  octave_dynamic_loader::load("Fl_Browser_insert" ,"");
  octave_dynamic_loader::load("Fl_Browser_move" ,"");
  octave_dynamic_loader::load("Fl_Browser_load" ,"");
  octave_dynamic_loader::load("Fl_Browser_swap" ,"");
  octave_dynamic_loader::load("Fl_Browser_clear" ,"");
  octave_dynamic_loader::load("Fl_Browser_size" ,"");
  octave_dynamic_loader::load("Fl_Browser_topline" ,"");
  octave_dynamic_loader::load("Fl_Browser_lineposition" ,"");
  octave_dynamic_loader::load("Fl_Browser_bottomline" ,"");
  octave_dynamic_loader::load("Fl_Browser_middleline" ,"");
  octave_dynamic_loader::load("Fl_Browser_select" ,"");
  octave_dynamic_loader::load("Fl_Browser_selected" ,"");
  
  octave_dynamic_loader::load("Fl_Browser_show" ,"");
  octave_dynamic_loader::load("Fl_Browser_hide" ,"");
 
  octave_dynamic_loader::load("Fl_Browser_visible" ,"");
  octave_dynamic_loader::load("Fl_Browser_value" ,"");
  octave_dynamic_loader::load("Fl_Browser_text" ,"");
  octave_dynamic_loader::load("Fl_Browser_data" ,"");
  octave_dynamic_loader::load("Fl_Browser_format_char" ,"");
  octave_dynamic_loader::load("Fl_Browser_column_char" ,"");
  octave_dynamic_loader::load("Fl_Browser_column_widths" ,"");
  octave_dynamic_loader::load("Fl_Browser_displayed" ,"");
  octave_dynamic_loader::load("Fl_Browser_make_visible" ,"");
  octave_dynamic_loader::load("Fl_Browser_if" ,"");
  octave_dynamic_loader::load("Fl_Browser_replace" ,"");
  octave_dynamic_loader::load("Fl_Browser_display" ,"");

 std::cout<< "Code generated onSat Jul 30 23:28:31 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_BrowserLibrary!\n";
 
 return octave_value(new FLTKStaticWrapper(0,"Fl_Browser"));
}
