/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Browser__handle , args , , " int Fl_Browser__handle (int ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Browser__handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__handle "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Browser_Ptr->handle ( _int0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__resize , args , , " void Fl_Browser__resize (int ,int ,int ,int ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Browser__resize (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__resize "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
_Fl_Browser_Ptr->resize ( _int0,_int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_Browser__select , args , , " int Fl_Browser__select (void * ,int=1 ,int docallbacks=0); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
void *   _void0 ;
int=1   _int=11 ;
int   docallbacks=0 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Browser__select (void * ,int=1 ,int docallbacks=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__select "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_void0 =( void * )args( 1 ).long_value();
_int=11 = (  int=1  ) args( 2 ).int_value();
docallbacks=0 = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) _Fl_Browser_Ptr->select ( _void0,_int=11,docallbacks=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__select_only , args , , " int Fl_Browser__select_only (void * ,int docallbacks=0); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
void *   _void0 ;
int   docallbacks=0 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Browser__select_only (void * ,int docallbacks=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__select_only "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_void0 =( void * )args( 1 ).long_value();
docallbacks=0 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Browser_Ptr->select_only ( _void0,docallbacks=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__deselect , args , , " int Fl_Browser__deselect (int docallbacks=0); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
int   docallbacks=0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Browser__deselect (int docallbacks=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__deselect "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
docallbacks=0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Browser_Ptr->deselect ( docallbacks=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__position , args , , " int Fl_Browser__position ( ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Browser__position ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__position "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Browser_Ptr->position ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__hposition , args , , " int Fl_Browser__hposition ( ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Browser__hposition ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__hposition "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Browser_Ptr->hposition ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__position , args , , " void Fl_Browser__position (int ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser__position (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__position "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_Fl_Browser_Ptr->position ( _int0);
return octave_value();
}
DEFUN_DLD( Fl_Browser__hposition , args , , " void Fl_Browser__hposition (int ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser__hposition (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__hposition "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_Fl_Browser_Ptr->hposition ( _int0);
return octave_value();
}
DEFUN_DLD( Fl_Browser__display , args , , " void Fl_Browser__display (void* ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
void*   _void*0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser__display (void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__display "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_void*0 =( void* )args( 1 ).long_value();
_Fl_Browser_Ptr->display ( _void*0);
return octave_value();
}
DEFUN_DLD( Fl_Browser__has_scrollbar , args , , " uchar Fl_Browser__has_scrollbar ( ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  uchar Fl_Browser__has_scrollbar ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__has_scrollbar "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Browser_Ptr->has_scrollbar ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__has_scrollbar , args , , " void Fl_Browser__has_scrollbar (uchar i); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
uchar   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser__has_scrollbar (uchar i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__has_scrollbar "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
i = (  uchar  ) args( 1 ).long_value();
_Fl_Browser_Ptr->has_scrollbar ( i);
return octave_value();
}
DEFUN_DLD( Fl_Browser__textfont , args , , " Fl_Font Fl_Browser__textfont ( ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Font Fl_Browser__textfont ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__textfont "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Browser_Ptr->textfont ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__textfont , args , , " void Fl_Browser__textfont (uchar s); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
uchar   s ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser__textfont (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__textfont "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
s = (  uchar  ) args( 1 ).long_value();
_Fl_Browser_Ptr->textfont ( s);
return octave_value();
}
DEFUN_DLD( Fl_Browser__textsize , args , , " uchar Fl_Browser__textsize ( ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  uchar Fl_Browser__textsize ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__textsize "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Browser_Ptr->textsize ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__textsize , args , , " void Fl_Browser__textsize (uchar s); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
uchar   s ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser__textsize (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__textsize "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
s = (  uchar  ) args( 1 ).long_value();
_Fl_Browser_Ptr->textsize ( s);
return octave_value();
}
DEFUN_DLD( Fl_Browser__textcolor , args , , " Fl_Color Fl_Browser__textcolor ( ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Color Fl_Browser__textcolor ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Browser_Ptr->textcolor ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__textcolor , args , , " void Fl_Browser__textcolor (n ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
n   _n0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Browser__textcolor (n ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_n0 = (  n  ) args( 1 ).long_value();
_Fl_Browser_Ptr->textcolor ( _n0);
return octave_value();
}
DEFUN_DLD( Fl_Browser__scrollbar_width , args , , " static Fl_Browser__scrollbar_width (int b); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
int   b ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_Browser__scrollbar_width (int b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__scrollbar_width "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
b = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Browser_Ptr->scrollbar_width ( b);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__scrollbar_width , args , , " static Fl_Browser__scrollbar_width ( ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_Browser__scrollbar_width ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__scrollbar_width "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Browser_Ptr->scrollbar_width ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Browser__scrollbar_right , args , , " void Fl_Browser__scrollbar_right ( ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Browser__scrollbar_right ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__scrollbar_right "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_Fl_Browser_Ptr->scrollbar_right ( );
return octave_value();
}
DEFUN_DLD( Fl_Browser__scrollbar_left , args , , " void Fl_Browser__scrollbar_left ( ); " )
{
Fl_Browser_ *   _Fl_Browser_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Browser__scrollbar_left ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Browser__scrollbar_left "<<std::endl;
#endif /* DEBUG */
_Fl_Browser_Ptr =( Fl_Browser_ * )args( 0 ).long_value();
_Fl_Browser_Ptr->scrollbar_left ( );
return octave_value();
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Browser_ , args , , " void Fl_Browser_(void); " )
{
  /* This is a class with a protected constructor!
   * you may only subclass it, and write functions
   */
  
  octave_dynamic_loader::load("Fl_Browser__handle" ,"");
  octave_dynamic_loader::load("Fl_Browser__resize" ,"");
  octave_dynamic_loader::load("Fl_Browser__select" ,"");
  octave_dynamic_loader::load("Fl_Browser__select_only" ,"");
  octave_dynamic_loader::load("Fl_Browser__deselect" ,"");
  octave_dynamic_loader::load("Fl_Browser__position" ,"");
  octave_dynamic_loader::load("Fl_Browser__hposition" ,"");
  octave_dynamic_loader::load("Fl_Browser__position" ,"");
  octave_dynamic_loader::load("Fl_Browser__hposition" ,"");
  octave_dynamic_loader::load("Fl_Browser__display" ,"");
  octave_dynamic_loader::load("Fl_Browser__has_scrollbar" ,"");
  octave_dynamic_loader::load("Fl_Browser__has_scrollbar" ,"");
  octave_dynamic_loader::load("Fl_Browser__textfont" ,"");
  octave_dynamic_loader::load("Fl_Browser__textfont" ,"");
  octave_dynamic_loader::load("Fl_Browser__textsize" ,"");
  octave_dynamic_loader::load("Fl_Browser__textsize" ,"");
  octave_dynamic_loader::load("Fl_Browser__textcolor" ,"");
  octave_dynamic_loader::load("Fl_Browser__textcolor" ,"");
  octave_dynamic_loader::load("Fl_Browser__scrollbar_width" ,"");
  octave_dynamic_loader::load("Fl_Browser__scrollbar_width" ,"");
  octave_dynamic_loader::load("Fl_Browser__scrollbar_right" ,"");
  octave_dynamic_loader::load("Fl_Browser__scrollbar_left" ,"");
  return octave_value("Code generated onSat Jul 30 23:28:31 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Browser_Library!");
}

/*
  I guess best to leave this stuff, temporarily out of 
  the build tree.
*/
