/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

//protected?
#if 0
DEFUN_DLD( Fl_Button_draw , args , , " virtual Fl_Button_draw ( ); " )
{
Fl_Button *   _Fl_ButtonPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_Button_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Button_draw "<<std::endl;
#endif /* DEBUG */
_Fl_ButtonPtr =( Fl_Button * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_ButtonPtr->draw ( );
return octave_value(ret_type);
}
#endif

// Virtual!
#if 0
DEFUN_DLD( Fl_Button_handle , args , , " virtual Fl_Button_handle (int ); " )
{
Fl_Button *   _Fl_ButtonPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  virtual Fl_Button_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Button_handle "<<std::endl;
#endif /* DEBUG */
_Fl_ButtonPtr =( Fl_Button * )args( 0 ).long_value();

return octave_value(ret_type);
}
#endif

DEFUN_DLD( Fl_Button_value , args , , " int Fl_Button_value (int ); " )
{
Fl_Button *   _Fl_ButtonPtr ;
int   _int0 ;
 if(!(args.length()<= 2 && args.length()>=1) )
  {
   std::cout<< "eg:  int Fl_Button_value (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Button_value "<<std::endl;
#endif /* DEBUG */
_Fl_ButtonPtr =( Fl_Button * )args( 0 ).long_value();
 if(args.length()==2)
   { 
     _int0 = (  int  ) args( 1 ).int_value();
     long int ret_type=(long int) _Fl_ButtonPtr->value ( _int0);
     return octave_value(ret_type);
   }
 long int ret_type=(long int) _Fl_ButtonPtr->value ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Button_set , args , , " int Fl_Button_set ( ); " )
{
Fl_Button *   _Fl_ButtonPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Button_set ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Button_set "<<std::endl;
#endif /* DEBUG */
_Fl_ButtonPtr =( Fl_Button * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_ButtonPtr->set ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Button_clear , args , , " int Fl_Button_clear ( ); " )
{
Fl_Button *   _Fl_ButtonPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Button_clear ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Button_clear "<<std::endl;
#endif /* DEBUG */
_Fl_ButtonPtr =( Fl_Button * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_ButtonPtr->clear ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Button_setonly , args , , " void Fl_Button_setonly ( ); " )
{
Fl_Button *   _Fl_ButtonPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Button_setonly ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Button_setonly "<<std::endl;
#endif /* DEBUG */
_Fl_ButtonPtr =( Fl_Button * )args( 0 ).long_value();
_Fl_ButtonPtr->setonly ( );
return octave_value();
}

DEFUN_DLD( Fl_Button_shortcut , args , , " int Fl_Button_shortcut ( ); " )
{
Fl_Button *   _Fl_ButtonPtr ;
 if(!(args.length()>= 1 && args.length() <= 2))
   {
     std::cout<< "eg:  int Fl_Button_shortcut ( ); " <<std::endl;
     return octave_value(-1);
   }
#ifdef DEBUG
 std::cout<<" Fl_Button_shortcut "<<std::endl;
#endif /* DEBUG */
 _Fl_ButtonPtr =( Fl_Button * )args( 0 ).long_value();
 if(args.length()==2)
   {
     int s;
     s = (  int  ) args( 1 ).int_value();
     _Fl_ButtonPtr->shortcut ( s);
     return octave_value();
   }
 long int ret_type=(long int) _Fl_ButtonPtr->shortcut ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Button_down_box , args , , " void Fl_Button_down_box (Fl_Boxtype b); " )
{
Fl_Button *   _Fl_ButtonPtr ;
Fl_Boxtype   b ;
 if(args.length()!= 2 && args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Button_down_box (Fl_Boxtype b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Button_down_box "<<std::endl;
#endif /* DEBUG */
_Fl_ButtonPtr =( Fl_Button * )args( 0 ).long_value();

 if(args.length()!= 2 )
   {
     long int ret_type=(long int) _Fl_ButtonPtr->down_box ( );
     return octave_value(ret_type);
   }
 
 b = (  Fl_Boxtype  ) args( 1 ).long_value();
 _Fl_ButtonPtr->down_box ( b);
 return octave_value();
}

DEFUN_DLD( Fl_Button_down_color , args , , " void Fl_Button_down_color (c ); " )
{
Fl_Button *   _Fl_ButtonPtr ;
unsigned   _c0 ;

 if((args.length()<= 2  && args.length()>=1))
  {
   std::cout<< "eg:  void Fl_Button_down_color (c ); " <<std::endl;
   return octave_value(-1);
  }

#ifdef DEBUG
 std::cout<<" Fl_Button_down_color "<<std::endl;
#endif /* DEBUG */
 
 _Fl_ButtonPtr =( Fl_Button * )args( 0 ).long_value();
 if(args.length()==2)
   { 
     _c0 = ( unsigned  ) args( 1 ).long_value();
     _Fl_ButtonPtr->down_color ( _c0);
     return octave_value();
   }
 long int ret_type=(long int) _Fl_ButtonPtr->down_color ( );
 return octave_value(ret_type);
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Button , args , , " void Fl_Button(void); " )
{

  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      Fl_Button *flb=new Fl_Button(args(0).int_value(),args(1).int_value(),
				   args(2).int_value(),args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Button"));
    }

// protected & virtual
#if 0
octave_dynamic_loader::load("Fl_Button_draw" ,"");
octave_dynamic_loader::load("Fl_Button_handle" ,"");
#endif 

octave_dynamic_loader::load("Fl_Button_value" ,"");
octave_dynamic_loader::load("Fl_Button_set" ,"");
octave_dynamic_loader::load("Fl_Button_clear" ,"");
octave_dynamic_loader::load("Fl_Button_setonly" ,"");
octave_dynamic_loader::load("Fl_Button_shortcut" ,"");
octave_dynamic_loader::load("Fl_Button_down_box" ,"");
octave_dynamic_loader::load("Fl_Button_shortcut" ,"");
octave_dynamic_loader::load("Fl_Button_down_color" ,"");

 std::cout<< "Code generated onSat Jul 30 23:28:31 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_ButtonLibrary!\n";
 return octave_value(new FLTKStaticWrapper(0,"Fl_Button"));
}
