/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
#if 0
DEFUN_DLD( Fl_Chart_draw , args , , " void Fl_Chart_draw ( ); " )
{
Fl_Chart *   _Fl_ChartPtr ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Chart_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
 std::cout<<" Fl_Chart_draw "<<std::endl;
#endif /* DEBUG */
 _Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
/* Nothing! */
_Fl_ChartPtr->draw ( );
return octave_value();
}
#endif /* PROTECTED !! */

DEFUN_DLD( Fl_Chart_clear , args , , " void Fl_Chart_clear ( ); " )
{
Fl_Chart *   _Fl_ChartPtr ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Chart_clear ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Chart_clear "<<std::endl;
#endif /* DEBUG */
_Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
/* Nothing! */
_Fl_ChartPtr->clear ( );
return octave_value();
}
DEFUN_DLD( Fl_Chart_add , args , , " void Fl_Chart_add (double ,char * =0,unsigned=0 ); " )
{
Fl_Chart *   _Fl_ChartPtr ;
double   _double0 ;
char *   _char1 =0;
unsigned   _unsigned2 =0;
 if(!(args.length()>= 2  && args.length() <= 4))
  {
   std::cout<< "eg:  void Fl_Chart_add (double ,char * =0,unsigned=0 ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Chart_add "<<std::endl;
#endif /* DEBUG */

_Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
_double0 = (  double  ) args( 1 ).double_value();
 switch(args.length())
   {
   case 2:
     _unsigned2=0;
     _char1=NULL;
     break;
   case 3:
     _char1=NULL;
   case 4:
     _char1 = new  char   [args( 2 ).string_value ().length()];
     strcpy( (char *) _char1 ,args( 2 ).string_value().c_str());
     _unsigned2 = (  unsigned  ) args( 3 ).long_value();
   }
 _Fl_ChartPtr->add ( _double0,_char1,_unsigned2);
return octave_value();
}

DEFUN_DLD( Fl_Chart_insert , args , ,
	   " void Fl_Chart_insert (int ,double ,char * =0,unsigned=0 ); " )
{
  Fl_Chart *   _Fl_ChartPtr ;
  int   _int0 ;
  double   _double1 ;
  char *   _char2 ;
  unsigned   _unsigned3 ;
  if(!(args.length()>= 3  && args.length() <= 5) )
    {
      std::cout<< "eg:  void Fl_Chart_insert (int ,double ,char * =0,unsigned=0 ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Chart_insert "<<std::endl;
#endif /* DEBUG */

 _Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_double1 = (  double  ) args( 2 ).double_value();

 switch(args.length())
   {
   case 3:
     _char2=NULL;
     _unsigned3=0;
     break;
   case 4:
     _char2 = new  char   [args( 3 ).string_value ().length()];
     strcpy( (char *) _char2 ,args( 3 ).string_value().c_str());
     _unsigned3=0;
     break;
   case 5:
     _char2 = new  char   [args( 3 ).string_value ().length()];
     strcpy( (char *) _char2 ,args( 3 ).string_value().c_str());

     _unsigned3 = (  unsigned  ) args( 4 ).long_value();
     _Fl_ChartPtr->insert ( _int0,_double1,_char2,_unsigned3);
     break;
   };
return octave_value();
}

DEFUN_DLD( Fl_Chart_replace , args , , " void Fl_Chart_replace (int ,double ,char * =0,unsigned=0 ); " )
{
Fl_Chart *   _Fl_ChartPtr ;
 int   _int0 ;
 double   _double1 ;
 char *   _char2 =0;
 unsigned   _unsigned3 =0;
 if(!(args.length() >= 3  && args.length() <= 5))
   {
     std::cout<< "eg:  void Fl_Chart_replace (int ,double ,char * =0,unsigned=0 ); " <<std::endl;
     return octave_value(-1);
  }
#ifdef DEBUG
 std::cout<<" Fl_Chart_replace "<<std::endl;
#endif /* DEBUG */
_Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_double1 = (  double  ) args( 2 ).double_value();

 switch(args.length())
   {
   case 3:
     _char2=NULL;
     _unsigned3=0;
     break;
   case 4:
     _char2 = new  char   [args( 3 ).string_value ().length()];
     strcpy( (char *) _char2 ,args( 3 ).string_value().c_str());
     _unsigned3=0;
     break;
   case 5:
     _char2 = new  char   [args( 3 ).string_value ().length()];
     strcpy( (char *) _char2 ,args( 3 ).string_value().c_str());
     _unsigned3 = (  unsigned  ) args( 4 ).long_value();
     break;
   }
 _Fl_ChartPtr->replace ( _int0,_double1,_char2,_unsigned3);
 return octave_value();
}

/* acts as get-bounds if no argument is passed */
DEFUN_DLD( Fl_Chart_bounds , args , , " void Fl_Chart_bounds (double a,double b); " )
{
  Fl_Chart *   _Fl_ChartPtr ;
  double   a ;
  double   b ;
  Matrix m;
  if(!(args.length()== 3  && args.length()==1))
    {
      std::cout<< "eg:  void Fl_Chart_bounds (double a,double b); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Chart_bounds "<<std::endl;
#endif /* DEBUG */
  _Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
  if (args.length()==3)
    { 
     a = (  double  ) args( 1 ).double_value();
     b = (  double  ) args( 2 ).double_value();
     _Fl_ChartPtr->bounds ( a,b);
     return octave_value();
    }

  _Fl_ChartPtr->bounds ( &a,&b);
  m(0,0)=a;
  m(0,1)=b;
  return octave_value(m);
}


DEFUN_DLD( Fl_Chart_size , args , , " void Fl_Chart_size (int W,int H); " )
{
Fl_Chart *   _Fl_ChartPtr ;
int   W ;
int   H ;
 if(!(args.length()== 3 && args.length()==1) )
  {
   std::cout<< "eg:  void Fl_Chart_size (int W,int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Chart_size "<<std::endl;
#endif /* DEBUG */
_Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
if(args.length() == 3)
{
  W = (  int  ) args( 1 ).int_value();
  H = (  int  ) args( 2 ).int_value();
  _Fl_ChartPtr->size ( W,H);
  return octave_value();
}
 
 long int ret_type=(long int) _Fl_ChartPtr->size ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Chart_maxsize , args , , " void Fl_Chart_maxsize (int ); " )
{
Fl_Chart *   _Fl_ChartPtr ;
int   _int0 ;
 if(!(args.length()<= 2  && args.length() >= 1))
  {
   std::cout<< "eg:  void Fl_Chart_maxsize (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Chart_maxsize "<<std::endl;
#endif /* DEBUG */
_Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
 if(args.length() == 2)
   { 
     _int0 = (  int  ) args( 1 ).int_value();
     _Fl_ChartPtr->maxsize ( _int0);
     return octave_value();
   }
 long int val=_Fl_ChartPtr->maxsize ();
 return octave_value(val);
}

DEFUN_DLD( Fl_Chart_textfont , args , , " void Fl_Chart_textfont (uchar s); " )
{
  Fl_Chart *   _Fl_ChartPtr ;
  uchar   s ;
  if(!(args.length()<= 2  && args.length()>=1))
    {
      std::cout<< "eg:  void Fl_Chart_textfont (uchar s); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
std::cout<<" Fl_Chart_textfont "<<std::endl;
#endif /* DEBUG */
_Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
 if (args.length() == 2)
   { 
     s = (  uchar  ) args( 1 ).long_value();
     _Fl_ChartPtr->textfont ( s);
     return octave_value();
   }
 Fl_Font ft=(Fl_Font)_Fl_ChartPtr->textfont ();
 return octave_value(ft);
}

DEFUN_DLD( Fl_Chart_textsize , args , , " void Fl_Chart_textsize (uchar s); " )
{
Fl_Chart *   _Fl_ChartPtr ;
uchar   s ;
 if(!(args.length()<= 2  && args.length()>=1))
  {
   std::cout<< "eg:  void Fl_Chart_textsize (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Chart_textsize "<<std::endl;
#endif /* DEBUG */
_Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
 if(args.length()==2)
   { 
     s = (  uchar  ) args( 1 ).long_value();
     _Fl_ChartPtr->textsize ( s);
     return octave_value();
   }
 long int szz=(long int)_Fl_ChartPtr->textsize (); 
 return octave_value(szz);
}
DEFUN_DLD( Fl_Chart_textcolor , args , , " void Fl_Chart_textcolor (unsigned n );" )
{
Fl_Chart *   _Fl_ChartPtr ;
unsigned   _n0 ;
 if(!(args.length() <= 2  && args.length()>=1))
  {
   std::cout<< "eg:  void Fl_Chart_textcolor (unsigned n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Chart_textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();
 if (args.length() == 1)
   {
     Fl_Color ret_type=(Fl_Color) _Fl_ChartPtr->textcolor ( );
     return octave_value(ret_type);
   }
 
 _n0 = ( unsigned  ) args( 1 ).long_value();
 _Fl_ChartPtr->textcolor ( _n0);
 
return octave_value();
}

DEFUN_DLD( Fl_Chart_autosize , args , , " void Fl_Chart_autosize (uchar n); " )
{
Fl_Chart *   _Fl_ChartPtr ;
uchar   n ;
 if(!(args.length()>= 1 && args.length() <= 2 ))
  {
   std::cout<< "eg:  void Fl_Chart_autosize (uchar n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Chart_autosize "<<std::endl;
#endif /* DEBUG */
_Fl_ChartPtr =( Fl_Chart * )args( 0 ).long_value();

 if (args.length()==2)
   { 
     n = (  uchar  ) args( 1 ).long_value();
     _Fl_ChartPtr->autosize ( n);
   }
 else
   _Fl_ChartPtr->autosize ( );
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Chart , args , , " void Fl_Chart(void); " )
{

  if(args.length() == 5)
    {
      Fl_Chart *chart=new Fl_Chart(args(0).int_value(),
				   args(1).int_value(),
				   args(2).int_value(),
				   args(3).int_value(),
				   args(4).string_value().c_str());

      return octave_value(new FLTKWrapper(chart ,"Fl_Chart"));
    }

  /* octave_dynamic_loader::load("Fl_Chart_draw" ,""); */
  octave_dynamic_loader::load("Fl_Chart_clear" ,"");
  octave_dynamic_loader::load("Fl_Chart_add" ,"");
  octave_dynamic_loader::load("Fl_Chart_insert" ,"");
  octave_dynamic_loader::load("Fl_Chart_replace" ,"");
  octave_dynamic_loader::load("Fl_Chart_bounds" ,"");
  octave_dynamic_loader::load("Fl_Chart_size" ,"");
  octave_dynamic_loader::load("Fl_Chart_maxsize" ,"");
  octave_dynamic_loader::load("Fl_Chart_textfont" ,"");
  octave_dynamic_loader::load("Fl_Chart_textsize" ,"");
  octave_dynamic_loader::load("Fl_Chart_textcolor" ,"");
  octave_dynamic_loader::load("Fl_Chart_autosize" ,"");
  std::cout<<"Code generated onSat Jul 30 23:28:31 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_ChartLibrary!\n";
  return octave_value(new FLTKStaticWrapper(0,"Fl_Chart"));
}

/*
  C++ uses two functions for overloading.
  In Octave, only one function willdo.
  Duplicates are a headache!!
*/
