/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Check_Browser_add , args , , " int Fl_Check_Browser_add (char * s,int b); " )
{
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
char *   s ;
int   b ;
 if(args.length()!= 3 && args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Check_Browser_add (char * s,int b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_add "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();

if(args.length()==3)
   {
     s = new  char   [args( 1 ).string_value ().length()];
     strcpy( (char *) s ,args( 1 ).string_value().c_str());
     b = (  int  ) args( 2 ).int_value();
     long int ret_type=(long int) _Fl_Check_BrowserPtr->add ( s,b);
     return octave_value(ret_type);
   }
 else if(args.length()==2)
   {
     s = new  char   [args( 1 ).string_value ().length()];
     strcpy( (char *) s ,args( 1 ).string_value().c_str());
     long int ret_type=(long int) _Fl_Check_BrowserPtr->add ( s);
     return octave_value(ret_type);     
   } 

 return octave_value("Error: Cannot Have happened");
}
DEFUN_DLD( Fl_Check_Browser_clear , args , , " void Fl_Check_Browser_clear ( ); " )
{
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Check_Browser_clear ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_clear "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();
_Fl_Check_BrowserPtr->clear ( );
return octave_value();
}
DEFUN_DLD( Fl_Check_Browser_nitems , args , , " int Fl_Check_Browser_nitems ( ); " )
{
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Check_Browser_nitems ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_nitems "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Check_BrowserPtr->nitems ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Check_Browser_nchecked , args , , " int Fl_Check_Browser_nchecked ( ); " )
{
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Check_Browser_nchecked ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_nchecked "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Check_BrowserPtr->nchecked ( );
return octave_value(ret_type);
}

DEFUN_DLD( Fl_Check_Browser_checked , args , , " void Fl_Check_Browser_checked (int item,int b); " )
{
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
int   item ;
int   b ;
 if(args.length()!= 3 && args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Check_Browser_checked (int item,int b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_checked "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();
 if(args.length()==3)
   { 
     item = (  int  ) args( 1 ).int_value();
     b = (  int  ) args( 2 ).int_value();
     _Fl_Check_BrowserPtr->checked ( item,b);
     return octave_value();
   }
 item = (  int  ) args( 1 ).int_value();
 long int ret_type=(long int) _Fl_Check_BrowserPtr->checked ( item);
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Check_Browser_set_checked , args , , " void Fl_Check_Browser_set_checked (int item); " )
   {
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
int   item ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Check_Browser_set_checked (int item); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_set_checked "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();
item = (  int  ) args( 1 ).int_value();
_Fl_Check_BrowserPtr->set_checked ( item);
return octave_value();
}
DEFUN_DLD( Fl_Check_Browser_check_all , args , , " void Fl_Check_Browser_check_all ( ); " )
{
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Check_Browser_check_all ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_check_all "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();
_Fl_Check_BrowserPtr->check_all ( );
return octave_value();
}
DEFUN_DLD( Fl_Check_Browser_check_none , args , , " void Fl_Check_Browser_check_none ( ); " )
{
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Check_Browser_check_none ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_check_none "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();
_Fl_Check_BrowserPtr->check_none ( );
return octave_value();
}
DEFUN_DLD( Fl_Check_Browser_value , args , , " int Fl_Check_Browser_value ( ); " )
{
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Check_Browser_value ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_value "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Check_BrowserPtr->value ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Check_Browser_text , args , , " char * Fl_Check_Browser_text (int item); " )
{
Fl_Check_Browser *   _Fl_Check_BrowserPtr ;
int   item ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  char * Fl_Check_Browser_text (int item); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Check_Browser_text "<<std::endl;
#endif /* DEBUG */
_Fl_Check_BrowserPtr =( Fl_Check_Browser * )args( 0 ).long_value();
item = (  int  ) args( 1 ).int_value();
string  ret_type(  (const char *) _Fl_Check_BrowserPtr->text ( item));
return octave_value(ret_type);
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Check_Browser , args , , " void Fl_Check_Browser(void); " )
{

octave_dynamic_loader::load("Fl_Check_Browser_add" ,"");
octave_dynamic_loader::load("Fl_Check_Browser_clear" ,"");
octave_dynamic_loader::load("Fl_Check_Browser_nitems" ,"");
octave_dynamic_loader::load("Fl_Check_Browser_nchecked" ,"");
octave_dynamic_loader::load("Fl_Check_Browser_checked" ,"");
octave_dynamic_loader::load("Fl_Check_Browser_set_checked" ,"");
octave_dynamic_loader::load("Fl_Check_Browser_check_all" ,"");
octave_dynamic_loader::load("Fl_Check_Browser_check_none" ,"");
octave_dynamic_loader::load("Fl_Check_Browser_value" ,"");
 octave_dynamic_loader::load("Fl_Check_Browser_text" ,"");
 std::cout<< "Code generated onSat Jul 30 23:28:31 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Check_BrowserLibrary!\n";

 return octave_value(new FLTKStaticWrapper(0,"Fl_Check_Browser"));
}
