/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

/* FLCC HUEBOX ignore ATM */
#if 0
DEFUN_DLD( Fl_Color_Chooser_draw , args , , " void Fl_Color_Chooser_draw ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Color_Chooser_draw ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_draw "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _Fl_Color_ChooserPtr->draw ( );
  return octave_value();
}
DEFUN_DLD( Fl_Color_Chooser_handle_key , args , , " int Fl_Color_Chooser_handle_key (int ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  int   _int0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  int Fl_Color_Chooser_handle_key (int ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_handle_key "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _int0 = (  int  ) args( 1 ).int_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->handle_key ( _int0);
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_handle , args , , " int Fl_Color_Chooser_handle (int ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  int   _int0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  int Fl_Color_Chooser_handle (int ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_handle "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _int0 = (  int  ) args( 1 ).int_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->handle ( _int0);
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_draw , args , , " void Fl_Color_Chooser_draw ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Color_Chooser_draw ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_draw "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _Fl_Color_ChooserPtr->draw ( );
  return octave_value();
}
DEFUN_DLD( Fl_Color_Chooser_handle_key , args , , " int Fl_Color_Chooser_handle_key (int ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  int   _int0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  int Fl_Color_Chooser_handle_key (int ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_handle_key "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _int0 = (  int  ) args( 1 ).int_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->handle_key ( _int0);
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_handle , args , , " int Fl_Color_Chooser_handle (int ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  int   _int0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  int Fl_Color_Chooser_handle (int ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_handle "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _int0 = (  int  ) args( 1 ).int_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->handle ( _int0);
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_format , args , , " int Fl_Color_Chooser_format (char* ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  char*   _char*0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  int Fl_Color_Chooser_format (char* ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_format "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _char*0 =( char* )args( 1 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->format ( _char*0);
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_set_valuators , args , , " void Fl_Color_Chooser_set_valuators ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Color_Chooser_set_valuators ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_set_valuators "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _Fl_Color_ChooserPtr->set_valuators ( );
  return octave_value();
}
DEFUN_DLD( Fl_Color_Chooser_rgb_cb , args , , " static Fl_Color_Chooser_rgb_cb (Fl_Widget* ,void* ); " )
{
  Fl_Widget*   _Fl_Widget ;
  void*   _void;
  
  if(args.length()!= 3 )
    {
      std::cout<< "eg:  static Fl_Color_Chooser_rgb_cb (Fl_Widget* ,void* ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_rgb_cb "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _Fl_Widget*0 =( Fl_Widget* )args( 1 ).long_value();
  _void*1 =( void* )args( 2 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->rgb_cb ( _Fl_Widget*0,_void*1);
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_mode_cb , args , , " static Fl_Color_Chooser_mode_cb (Fl_Widget* ,void* ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  Fl_Widget*   _Fl_Widget*0 ;
  void*   _void*1 ;
  if(args.length()!= 3 )
    {
      std::cout<< "eg:  static Fl_Color_Chooser_mode_cb (Fl_Widget* ,void* ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_mode_cb "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _Fl_Widget*0 =( Fl_Widget* )args( 1 ).long_value();
  _void*1 =( void* )args( 2 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->mode_cb ( _Fl_Widget*0,_void*1);
  return octave_value(ret_type);
}
#endif /* 0 */

DEFUN_DLD( Fl_Color_Chooser_mode , args , , " int Fl_Color_Chooser_mode ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  int Fl_Color_Chooser_mode ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_mode "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->mode ( );
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_hue , args , , " double Fl_Color_Chooser_hue ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  double Fl_Color_Chooser_hue ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_hue "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->hue ( );
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_saturation , args , , " double Fl_Color_Chooser_saturation ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  double Fl_Color_Chooser_saturation ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_saturation "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->saturation ( );
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_value , args , , " double Fl_Color_Chooser_value ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  double Fl_Color_Chooser_value ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_value "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->value ( );
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_r , args , , " double Fl_Color_Chooser_r ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  double Fl_Color_Chooser_r ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_r "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->r ( );
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_g , args , , " double Fl_Color_Chooser_g ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  double Fl_Color_Chooser_g ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_g "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->g ( );
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_b , args , , " double Fl_Color_Chooser_b ( ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  double Fl_Color_Chooser_b ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_b "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->b ( );
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_hsv , args , , " int Fl_Color_Chooser_hsv (double ,double ,double ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  double   _double0 ;
  double   _double1 ;
  double   _double2 ;
  if(args.length()!= 4 )
    {
      std::cout<< "eg:  int Fl_Color_Chooser_hsv (double ,double ,double ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_hsv "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _double0 = (  double  ) args( 1 ).double_value();
  _double1 = (  double  ) args( 2 ).double_value();
  _double2 = (  double  ) args( 3 ).double_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->hsv ( _double0,_double1,_double2);
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_rgb , args , , " int Fl_Color_Chooser_rgb (double ,double ,double ); " )
{
  Fl_Color_Chooser *   _Fl_Color_ChooserPtr ;
  double   _double0 ;
  double   _double1 ;
  double   _double2 ;
  if(args.length()!= 4 )
    {
      std::cout<< "eg:  int Fl_Color_Chooser_rgb (double ,double ,double ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_rgb "<<std::endl;
#endif /* DEBUG */
  _Fl_Color_ChooserPtr =( Fl_Color_Chooser * )args( 0 ).long_value();
  _double0 = (  double  ) args( 1 ).double_value();
  _double1 = (  double  ) args( 2 ).double_value();
  _double2 = (  double  ) args( 3 ).double_value();
  long int ret_type=(long int) _Fl_Color_ChooserPtr->rgb ( _double0,_double1,_double2);
  return octave_value(ret_type);
}
DEFUN_DLD( Fl_Color_Chooser_hsv2rgb , args , ,
	   " static Fl_Color_Chooser_hsv2rgb (double ,double ,double); " )
{
  double   _double0 ;
  double   _double1 ;
  double   _double2 ;
  double   _double3 ;
  double   _double4 ;
  double   _double5 ;
  Matrix m;
  

  if(args.length()!= 3 )
    {
      std::cout<< "eg:  static Fl_Color_Chooser_hsv2rgb (double ,double ,double ,double& ,double& ,double& ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_hsv2rgb "<<std::endl;
#endif /* DEBUG */

  _double0 = (  double  ) args( 0 ).double_value();
  _double1 = (  double  ) args( 1 ).double_value();
  _double2 = (  double  ) args( 2 ).double_value();

  Fl_Color_Chooser::hsv2rgb ( _double0,_double1, _double2,
			      _double3,_double4,_double5);
  m.elem(0,0)=_double3;
  m.elem(0,1)=_double4;
  m.elem(0,2)=_double5;

  return octave_value(m);
}

DEFUN_DLD( Fl_Color_Chooser_rgb2hsv , args , , " static Fl_Color_Chooser_rgb2hsv (double ,double ,double); " )
{
  double   _double0 ;
  double   _double1 ;
  double   _double2 ;
  double   _double3 ;
  double   _double4 ;
  double   _double5 ;
  Matrix m;


  if(args.length()!= 3 )
    {
      std::cout<< "eg:  static Fl_Color_Chooser_rgb2hsv (double ,double ,double ,double& ,double& ,double& ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_rgb2hsv "<<std::endl;
#endif /* DEBUG */
  _double0 = (  double  ) args( 0 ).double_value();
  _double1 = (  double  ) args( 1 ).double_value();
  _double2 = (  double  ) args( 2 ).double_value();

  Fl_Color_Chooser::rgb2hsv ( _double0,_double1, _double2,
			      _double3,_double4,_double5);
  m.elem(0,0)=_double3;
  m.elem(0,1)=_double4;
  m.elem(0,2)=_double5;

  return octave_value(m);
}

/*
TODO: Implement ' uchar &' version of lf_color_chooser
    : Return value can be changed to: [val, r,g,b]
    : Second row can be values in uchar, first row in double. !
*/
DEFUN_DLD( Fl_Color_Chooser_fl_color_chooser , args , , " int Fl_Color_Chooser_fl_color_chooser (char* name,double& r,double& g,double& b); " )
{
  char*   name ;
  double   r =0;
  double   g =0 ;
  double   b  =0;
  if(args.length()!= 4 )
    {
      std::cout<< "eg:  int Fl_Color_Chooser_fl_color_chooser (char* name,double& r,double& g,double& b); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Color_Chooser_fl_color_chooser "<<std::endl;
#endif /* DEBUG */
  name =( char* )args( 0 ).long_value();
  r = (  double  ) args( 1 ).double_value();
  g = (  double  ) args( 2 ).double_value();
  b = (  double  ) args( 3 ).double_value();
  long int ret_type=(long int) fl_color_chooser ( name,r,g,b);
  return octave_value(ret_type);
}


/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Color_Chooser , args , , " void Fl_Color_Chooser(void); " )
{

  
  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      
      Fl_Color_Chooser *flb=new Fl_Color_Chooser(args(0).int_value(),
						 args(1).int_value(),
						 args(2).int_value(),
						 args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Color_Chooser"));
    }

#if 0
  octave_dynamic_loader::load("Fl_Color_Chooser_draw" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_handle_key" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_handle" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_draw" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_handle_key" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_handle" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_format" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_set_valuators" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_rgb_cb" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_mode_cb" ,"");
#endif /* PRIVATE */

  octave_dynamic_loader::load("Fl_Color_Chooser_mode" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_hue" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_saturation" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_value" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_r" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_g" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_b" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_hsv" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_rgb" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_hsv2rgb" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_rgb2hsv" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_fl_color_chooser" ,"");
  octave_dynamic_loader::load("Fl_Color_Chooser_fl_color_chooser" ,"");

  std::cout<<"Code generated onSat Jul 30 23:28:31 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Color_ChooserLibrary!\n";
  
  return octave_value(new FLTKStaticWrapper(0,"Fl_Color_Chooser"));
}

/* Ignoring other classes
   Flcc_HueBox
   Flcc_ValueBox
   Flcc_Value_Input
*/
