/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Dial_handle , args , , " int Fl_Dial_handle (int ); " )
{
Fl_Dial *   _Fl_DialPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Dial_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Dial_handle "<<std::endl;
#endif /* DEBUG */
_Fl_DialPtr =( Fl_Dial * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_DialPtr->handle ( _int0);
return octave_value(ret_type);
}

DEFUN_DLD( Fl_Dial_angle1 , args , , " void Fl_Dial_angle1 (short a); " )
{
Fl_Dial *   _Fl_DialPtr ;
short   a ;
 if(args.length()!= 2 && args.length()==1)
  {
   std::cout<< "eg:  void Fl_Dial_angle1 (short a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Dial_angle1 "<<std::endl;
#endif /* DEBUG */
_Fl_DialPtr =( Fl_Dial * )args( 0 ).long_value();

 if(args.length()==1)
   { 
     long int ret_type=(long int) _Fl_DialPtr->angle1 ( );
     return octave_value(ret_type); 
   }

a = (  short  ) args( 1 ).long_value();
_Fl_DialPtr->angle1 ( a);
return octave_value();
}

DEFUN_DLD( Fl_Dial_angle2 , args , , " void Fl_Dial_angle2 (short a); " )
{
Fl_Dial *   _Fl_DialPtr ;
short   a ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Dial_angle2 (short a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Dial_angle2 "<<std::endl;
#endif /* DEBUG */
_Fl_DialPtr =( Fl_Dial * )args( 0 ).long_value();
 if(args.length()!= 1 )
   {
     a = (  short  ) args( 1 ).long_value();
     _Fl_DialPtr->angle2 ( a);
     return octave_value();
   }

 long int ret_type=(long int) _Fl_DialPtr->angle2 ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Dial_angles , args , , " void Fl_Dial_angles (short a,short b); " )
{
Fl_Dial *   _Fl_DialPtr ;
short   a ;
short   b ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Dial_angles (short a,short b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Dial_angles "<<std::endl;
#endif /* DEBUG */
_Fl_DialPtr =( Fl_Dial * )args( 0 ).long_value();
a = (  short  ) args( 1 ).long_value();
b = (  short  ) args( 2 ).long_value();
_Fl_DialPtr->angles ( a,b);
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Dial , args , , " void Fl_Dial(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      Fl_Dial *flb=new Fl_Dial(args(0).int_value(),args(1).int_value(),
				       args(2).int_value(),args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Dial"));
    }

  octave_dynamic_loader::load("Fl_Dial_handle" ,"");
  octave_dynamic_loader::load("Fl_Dial_angle1" ,"");
  octave_dynamic_loader::load("Fl_Dial_angle2" ,"");
  octave_dynamic_loader::load("Fl_Dial_angles" ,"");
  
  std::cout<<"Code generated onSat Jul 30 23:28:31 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_DialLibrary!\n";
  
  return octave_value(new FLTKStaticWrapper(0,"Fl_Dial"));
}
