/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

#if 0
DEFUN_DLD( Fl_Double_Window_flush , args , , " void Fl_Double_Window_flush (int eraseoverlay); " )
{
Fl_Double_Window *   _Fl_Double_WindowPtr ;
int   eraseoverlay ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Double_Window_flush (int eraseoverlay); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Double_Window_flush "<<std::endl;
#endif /* DEBUG */
_Fl_Double_WindowPtr =( Fl_Double_Window * )args( 0 ).long_value();
eraseoverlay = (  int  ) args( 1 ).int_value();
_Fl_Double_WindowPtr->flush ( eraseoverlay);
return octave_value();
}
DEFUN_DLD( Fl_Double_Window_show , args , , " void Fl_Double_Window_show ( ); " )
{
Fl_Double_Window *   _Fl_Double_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Double_Window_show ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Double_Window_show "<<std::endl;
#endif /* DEBUG */
_Fl_Double_WindowPtr =( Fl_Double_Window * )args( 0 ).long_value();
_Fl_Double_WindowPtr->show ( );
return octave_value();
}
DEFUN_DLD( Fl_Double_Window_show , args , , " void Fl_Double_Window_show (int a,char * *b); " )
{
Fl_Double_Window *   _Fl_Double_WindowPtr ;
int   a ;
char *   *b ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Double_Window_show (int a,char * *b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Double_Window_show "<<std::endl;
#endif /* DEBUG */
_Fl_Double_WindowPtr =( Fl_Double_Window * )args( 0 ).long_value();
a = (  int  ) args( 1 ).int_value();
*b = new  char   [args( 2 ).string_value ().length()];
strcpy( (char *) *b ,args( 2 ).string_value().c_str());
_Fl_Double_WindowPtr->show ( a,*b);
return octave_value();
}
DEFUN_DLD( Fl_Double_Window_flush , args , , " void Fl_Double_Window_flush ( ); " )
{
Fl_Double_Window *   _Fl_Double_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Double_Window_flush ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Double_Window_flush "<<std::endl;
#endif /* DEBUG */
_Fl_Double_WindowPtr =( Fl_Double_Window * )args( 0 ).long_value();
_Fl_Double_WindowPtr->flush ( );
return octave_value();
}
DEFUN_DLD( Fl_Double_Window_resize , args , , " void Fl_Double_Window_resize (int ,int ,int ,int ); " )
{
Fl_Double_Window *   _Fl_Double_WindowPtr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Double_Window_resize (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Double_Window_resize "<<std::endl;
#endif /* DEBUG */
_Fl_Double_WindowPtr =( Fl_Double_Window * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
_Fl_Double_WindowPtr->resize ( _int0,_int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_Double_Window_hide , args , , " void Fl_Double_Window_hide ( ); " )
{
Fl_Double_Window *   _Fl_Double_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Double_Window_hide ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Double_Window_hide "<<std::endl;
#endif /* DEBUG */
_Fl_Double_WindowPtr =( Fl_Double_Window * )args( 0 ).long_value();
_Fl_Double_WindowPtr->hide ( );
return octave_value();
}
DEFUN_DLD( Fl_Double_Window_Fl_Window , args , , " : Fl_Double_Window_Fl_Window (W ,H ,l ); " )
{
Fl_Double_Window *   _Fl_Double_WindowPtr ;
W   _W0 ;
H   _H1 ;
l   _l2 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  : Fl_Double_Window_Fl_Window (W ,H ,l ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Double_Window_Fl_Window "<<std::endl;
#endif /* DEBUG */
_Fl_Double_WindowPtr =( Fl_Double_Window * )args( 0 ).long_value();
_W0 = (  W  ) args( 1 ).long_value();
_H1 = (  H  ) args( 2 ).long_value();
_l2 = (  l  ) args( 3 ).long_value();
long int ret_type=(long int) _Fl_Double_WindowPtr->Fl_Window ( _W0,_H1,_l2);
return octave_value(ret_type);
}
#endif 

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Double_Window , args , , " void Fl_Double_Window(void); " )
{
  
  std::cout<<args.length()<<std::endl;

  if (args.length() >=2 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      else if(args.length()==3)
	str=strdup(args(2).string_value().c_str());
      
      Fl_Double_Window *flb;
      
      if(args.length()>=4)
	{
	flb=new Fl_Double_Window(args(0).int_value(),
				 args(1).int_value(),
				 args(2).int_value(),
				 args(3).int_value(),str);
	}
      else
	{
	  flb=new Fl_Double_Window(args(0).int_value(),
				   args(1).int_value(),
				   str);
	}
      
      return octave_value(new FLTKWrapper(flb,"Fl_Double_Window"));
    }

  octave_dynamic_loader::load("Fl_Double_Window_flush" ,"");
  octave_dynamic_loader::load("Fl_Double_Window_show" ,"");
  octave_dynamic_loader::load("Fl_Double_Window_flush" ,"");
  octave_dynamic_loader::load("Fl_Double_Window_resize" ,"");
  octave_dynamic_loader::load("Fl_Double_Window_hide" ,"");
  
  std::cout<< "Code generated onSat Jul 30 23:28:31 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Double_WindowLibrary!\n";
  
 return octave_value(new FLTKStaticWrapper(0,"Fl_Double_Window"));
}
