/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>

/* FLTK specific includes */
/* FLTKWrapper */
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}


DEFUN_DLD(_Fl_Enum3,args,,"")
{

  DEFCONST_INTERNAL(HORIZONTAL,1 ,"");
  DEFCONST_INTERNAL(VERTICAL,2 ,"");
  DEFCONST_INTERNAL(BOTH,3 ,"");
  DEFCONST_INTERNAL(ALWAYS_ON,4 ,"");
  DEFCONST_INTERNAL(HORIZONTAL_ALWAYS,5 ,"");
  DEFCONST_INTERNAL(VERTICAL_ALWAYS,6 ,"");
  DEFCONST_INTERNAL(BOTH_ALWAYS,7 ,"");

  DEFCONST_INTERNAL(FL_MENU_INACTIVE,1 ,"");
  DEFCONST_INTERNAL(FL_MENU_TOGGLE,2 ,"");
  DEFCONST_INTERNAL(FL_MENU_VALUE,4 ,"");
  DEFCONST_INTERNAL(FL_MENU_RADIO,8 ,"");
  DEFCONST_INTERNAL(FL_MENU_INVISIBLE,0x10 ,"");
  DEFCONST_INTERNAL(FL_SUBMENU_POINTER,0x20 ,"");
  DEFCONST_INTERNAL(FL_SUBMENU,0x40 ,"");
  DEFCONST_INTERNAL(FL_MENU_DIVIDER,0x80 ,"");
  DEFCONST_INTERNAL(FL_MENU_HORIZONTAL,0x100 ,"");
  DEFCONST_INTERNAL(FL_PUP_NONE,0 ,"");
  DEFCONST_INTERNAL(FL_PUP_GREY,FL_MENU_INACTIVE ,"");
  DEFCONST_INTERNAL(FL_PUP_GRAY,FL_MENU_INACTIVE ,"");
  DEFCONST_INTERNAL(FL_MENU_BOX,FL_MENU_TOGGLE ,"");
  DEFCONST_INTERNAL(FL_PUP_BOX,FL_MENU_TOGGLE ,"");
  DEFCONST_INTERNAL(FL_MENU_CHECK,FL_MENU_VALUE ,"");
  DEFCONST_INTERNAL(FL_PUP_CHECK,FL_MENU_VALUE ,"");
  DEFCONST_INTERNAL(FL_PUP_RADIO,FL_MENU_RADIO ,"");
  DEFCONST_INTERNAL(FL_PUP_INVISIBLE,FL_MENU_INVISIBLE ,"");
  DEFCONST_INTERNAL(FL_PUP_SUBMENU,FL_SUBMENU_POINTER ,"");

  /* contains #define'd values, & enumerations */
  return octave_value(new FLTKStaticWrapper(0,"Fl_Enumerations"));
}

#if 0

  DEFCONST_INTERNAL(FL_PLACE_FREE,0 ,"");
  DEFCONST_INTERNAL(FL_PLACE_MOUSE,1 ,"");
  DEFCONST_INTERNAL(FL_PLACE_CENTER,2 ,"");
  DEFCONST_INTERNAL(FL_PLACE_POSITION,4 ,"");
  DEFCONST_INTERNAL(FL_PLACE_SIZE,8 ,"");
  DEFCONST_INTERNAL(FL_PLACE_GEOMETRY,16 ,"");
  DEFCONST_INTERNAL(FL_PLACE_ASPECT,32 ,"");
  DEFCONST_INTERNAL(FL_PLACE_FULLSCREEN,64 ,"");
  DEFCONST_INTERNAL(FL_PLACE_HOTSPOT,128 ,"");
  DEFCONST_INTERNAL(FL_PLACE_ICONIC,256 ,"");
  DEFCONST_INTERNAL(FL_FREE_SIZE,16384 ,"");
  DEFCONST_INTERNAL(FL_FIX_SIZE,32768 ,"");

  DEFCONST_INTERNAL(FL_FULLBORDER,1 ,"");
  DEFCONST_INTERNAL(FL_TRANSIENT,2 ,"");

#endif

#if 0
  DEFCONST_INTERNAL(GLUT_RETURN_ZERO,0 ,"");
  DEFCONST_INTERNAL(GLUT_WINDOW_X,1 ,"");
  DEFCONST_INTERNAL(GLUT_WINDOW_Y,2 ,"");
  DEFCONST_INTERNAL(GLUT_WINDOW_WIDTH,3 ,"");
  DEFCONST_INTERNAL(GLUT_WINDOW_HEIGHT,4 ,"");
  DEFCONST_INTERNAL(GLUT_WINDOW_PARENT,5 ,"");
  DEFCONST_INTERNAL(GLUT_SCREEN_WIDTH,6 ,"");
  DEFCONST_INTERNAL(GLUT_SCREEN_HEIGHT,7 ,"");
  DEFCONST_INTERNAL(GLUT_MENU_NUM_ITEMS,8 ,"");
  DEFCONST_INTERNAL(GLUT_DISPLAY_MODE_POSSIBLE,9 ,"");
  DEFCONST_INTERNAL(GLUT_INIT_WINDOW_X,10 ,"");
  DEFCONST_INTERNAL(GLUT_INIT_WINDOW_Y,11 ,"");
  DEFCONST_INTERNAL(GLUT_INIT_WINDOW_WIDTH,12 ,"");
  DEFCONST_INTERNAL(GLUT_INIT_WINDOW_HEIGHT,13 ,"");
  DEFCONST_INTERNAL(GLUT_INIT_DISPLAY_MODE,14 ,"");
  DEFCONST_INTERNAL(GLUT_WINDOW_BUFFER_SIZE,15 ,"");

  DEFCONST_INTERNAL(IEEE_,-1 ,"");
  DEFCONST_INTERNAL(SVID_,1 ,"");
  DEFCONST_INTERNAL(XOPEN_,2 ,"");
  DEFCONST_INTERNAL(POSIX_,3 ,"");
  DEFCONST_INTERNAL(ISOC_,4 ,"");


  DEFCONST_INTERNAL(XOMOrientation_LTR_TTB,0 ,"");
  DEFCONST_INTERNAL(XOMOrientation_RTL_TTB,1 ,"");
  DEFCONST_INTERNAL(XOMOrientation_TTB_LTR,2 ,"");
  DEFCONST_INTERNAL(XOMOrientation_TTB_RTL,3 ,"");
  DEFCONST_INTERNAL(XOMOrientation_Context,4 ,"");
  DEFCONST_INTERNAL(XIMAbsolutePosition,5 ,"");
  DEFCONST_INTERNAL(XIMDontChange,6 ,"");
  DEFCONST_INTERNAL(XIMIsInvisible,0 ,"");
  DEFCONST_INTERNAL(XIMIsPrimary,1 ,"");
  DEFCONST_INTERNAL(XIMIsSecondary,2 ,"");
  DEFCONST_INTERNAL(XIMTextType,0 ,"");
  DEFCONST_INTERNAL(XIMBitmapType,1 ,"");
  DEFCONST_INTERNAL(XStringStyle,0 ,"");
  DEFCONST_INTERNAL(XCompoundTextStyle,1 ,"");
  DEFCONST_INTERNAL(XTextStyle,2 ,"");
  DEFCONST_INTERNAL(XStdICCTextStyle,3 ,"");
  DEFCONST_INTERNAL(XUTF8StringStyle,4 ,"");
#endif
