/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
#if 0
DEFUN_DLD( Fl_File_Chooser_atoll , args , , " long Fl_File_Chooser_atoll (__const char *__nptr); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
char *__nptr ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  long Fl_File_Chooser_atoll (__const char *__nptr); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_atoll "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
 *__nptr = (  char *  ) args( 1 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->atoll ( *__nptr);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser___val[ , args , , " long Fl_File_Chooser___val[ (1024 / (8 * sizeof (unsigned long int); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
1024   / (8 * sizeof (unsigned long int ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  long Fl_File_Chooser___val[ (1024 / (8 * sizeof (unsigned long int); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser___val[ "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
/ (8 * sizeof (unsigned long int = (  1024  ) args( 1 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->__val[ ( / (8 * sizeof (unsigned long int);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_favoritesButtonCB , args , , " void Fl_File_Chooser_favoritesButtonCB ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_favoritesButtonCB ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_favoritesButtonCB "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->favoritesButtonCB ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_favoritesCB , args , , " void Fl_File_Chooser_favoritesCB (Fl_Widget * w); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Widget *   w ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_favoritesCB (Fl_Widget * w); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_favoritesCB "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
w =( Fl_Widget * )args( 1 ).long_value();
_Fl_File_ChooserPtr->favoritesCB ( w);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_fileListCB , args , , " void Fl_File_Chooser_fileListCB ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_fileListCB ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_fileListCB "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->fileListCB ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_fileNameCB , args , , " void Fl_File_Chooser_fileNameCB ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_fileNameCB ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_fileNameCB "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->fileNameCB ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_newdir , args , , " void Fl_File_Chooser_newdir ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_newdir ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_newdir "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->newdir ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_previewCB , args , , " static Fl_File_Chooser_previewCB (Fl_File_Chooser * fc); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_File_Chooser *   fc ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_previewCB (Fl_File_Chooser * fc); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_previewCB "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
fc =( Fl_File_Chooser * )args( 1 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->previewCB ( fc);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_showChoiceCB , args , , " void Fl_File_Chooser_showChoiceCB ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_showChoiceCB ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_showChoiceCB "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->showChoiceCB ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_update_favorites , args , , " void Fl_File_Chooser_update_favorites ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_update_favorites ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_update_favorites "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->update_favorites ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_update_preview , args , , " void Fl_File_Chooser_update_preview ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_update_preview ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_update_preview "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->update_preview ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_cb_window , args , , " static Fl_File_Chooser_cb_window (Fl_Double_Window* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Double_Window*   _Fl_Double_Window*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_window (Fl_Double_Window* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_window "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Double_Window*0 =( Fl_Double_Window* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_window ( _Fl_Double_Window*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_showChoice , args , , " static Fl_File_Chooser_cb_showChoice (Fl_Choice* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Choice*   _Fl_Choice*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_showChoice (Fl_Choice* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_showChoice "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Choice*0 =( Fl_Choice* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_showChoice ( _Fl_Choice*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_favoritesButton , args , , " static Fl_File_Chooser_cb_favoritesButton (Fl_Menu_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Menu_Button*   _Fl_Menu_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_favoritesButton (Fl_Menu_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_favoritesButton "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Menu_Button*0 =( Fl_Menu_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_favoritesButton ( _Fl_Menu_Button*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_newButton , args , , " static Fl_File_Chooser_cb_newButton (Fl_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Button*   _Fl_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_newButton (Fl_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_newButton "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Button*0 =( Fl_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_newButton ( _Fl_Button*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_ , args , , " static Fl_File_Chooser_cb_ (Fl_Tile* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Tile*   _Fl_Tile*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_ (Fl_Tile* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_ "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Tile*0 =( Fl_Tile* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_ ( _Fl_Tile*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_fileList , args , , " static Fl_File_Chooser_cb_fileList (Fl_File_Browser* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_File_Browser*   _Fl_File_Browser*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_fileList (Fl_File_Browser* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_fileList "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_Browser*0 =( Fl_File_Browser* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_fileList ( _Fl_File_Browser*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_previewButton , args , , " static Fl_File_Chooser_cb_previewButton (Fl_Check_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Check_Button*   _Fl_Check_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_previewButton (Fl_Check_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_previewButton "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Check_Button*0 =( Fl_Check_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_previewButton ( _Fl_Check_Button*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_fileName , args , , " static Fl_File_Chooser_cb_fileName (Fl_File_Input* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_File_Input*   _Fl_File_Input*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_fileName (Fl_File_Input* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_fileName "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_Input*0 =( Fl_File_Input* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_fileName ( _Fl_File_Input*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_okButton , args , , " static Fl_File_Chooser_cb_okButton (Fl_Return_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Return_Button*   _Fl_Return_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_okButton (Fl_Return_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_okButton "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Return_Button*0 =( Fl_Return_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_okButton ( _Fl_Return_Button*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_Cancel , args , , " static Fl_File_Chooser_cb_Cancel (Fl_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Button*   _Fl_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_Cancel (Fl_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_Cancel "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Button*0 =( Fl_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_Cancel ( _Fl_Button*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_favList , args , , " static Fl_File_Chooser_cb_favList (Fl_File_Browser* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_File_Browser*   _Fl_File_Browser*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_favList (Fl_File_Browser* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_favList "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_Browser*0 =( Fl_File_Browser* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_favList ( _Fl_File_Browser*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_favUpButton , args , , " static Fl_File_Chooser_cb_favUpButton (Fl_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Button*   _Fl_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_favUpButton (Fl_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_favUpButton "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Button*0 =( Fl_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_favUpButton ( _Fl_Button*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_favDeleteButton , args , , " static Fl_File_Chooser_cb_favDeleteButton (Fl_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Button*   _Fl_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_favDeleteButton (Fl_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_favDeleteButton "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Button*0 =( Fl_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_favDeleteButton ( _Fl_Button*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_favDownButton , args , , " static Fl_File_Chooser_cb_favDownButton (Fl_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Button*   _Fl_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_favDownButton (Fl_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_favDownButton "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Button*0 =( Fl_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_favDownButton ( _Fl_Button*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_favCancelButton , args , , " static Fl_File_Chooser_cb_favCancelButton (Fl_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Button*   _Fl_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_favCancelButton (Fl_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_favCancelButton "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Button*0 =( Fl_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_favCancelButton ( _Fl_Button*0,_void*1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_cb_favOkButton , args , , " static Fl_File_Chooser_cb_favOkButton (Fl_Return_Button* ,void* ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Return_Button*   _Fl_Return_Button*0 ;
void*   _void*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_File_Chooser_cb_favOkButton (Fl_Return_Button* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_cb_favOkButton "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_Return_Button*0 =( Fl_Return_Button* )args( 1 ).long_value();
_void*1 =( void* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->cb_favOkButton ( _Fl_Return_Button*0,_void*1);
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_File_Chooser_callback , args , , " void Fl_File_Chooser_callback (void); " )
{
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_callback (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_callback "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->callback ( (*cb);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_color , args , , " void Fl_File_Chooser_color (Fl_Color c); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Color   c ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_color (Fl_Color c); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_color "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
c = (  Fl_Color  ) args( 1 ).long_value();
_Fl_File_ChooserPtr->color ( c);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_color , args , , " Fl_Color Fl_File_Chooser_color ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Color Fl_File_Chooser_color ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_color "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->color ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_count , args , , " int Fl_File_Chooser_count ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_File_Chooser_count ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_count "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->count ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_directory , args , , " void Fl_File_Chooser_directory (char * d); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
char *   d ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_directory (char * d); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_directory "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
d = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) d ,args( 1 ).string_value().c_str());
_Fl_File_ChooserPtr->directory ( d);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_directory , args , , " char * Fl_File_Chooser_directory ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char * Fl_File_Chooser_directory ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_directory "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_File_ChooserPtr->directory ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_filter , args , , " void Fl_File_Chooser_filter (char * p); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
char *   p ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_filter (char * p); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_filter "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
p = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) p ,args( 1 ).string_value().c_str());
_Fl_File_ChooserPtr->filter ( p);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_filter , args , , " char * Fl_File_Chooser_filter ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char * Fl_File_Chooser_filter ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_filter "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_File_ChooserPtr->filter ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_filter_value , args , , " int Fl_File_Chooser_filter_value ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_File_Chooser_filter_value ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_filter_value "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->filter_value ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_filter_value , args , , " void Fl_File_Chooser_filter_value (int f); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
int   f ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_filter_value (int f); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_filter_value "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
f = (  int  ) args( 1 ).int_value();
_Fl_File_ChooserPtr->filter_value ( f);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_hide , args , , " void Fl_File_Chooser_hide ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_hide ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_hide "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->hide ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_iconsize , args , , " void Fl_File_Chooser_iconsize (uchar s); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
uchar   s ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_iconsize (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_iconsize "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
s = (  uchar  ) args( 1 ).long_value();
_Fl_File_ChooserPtr->iconsize ( s);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_iconsize , args , , " uchar Fl_File_Chooser_iconsize ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  uchar Fl_File_Chooser_iconsize ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_iconsize "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->iconsize ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_label , args , , " void Fl_File_Chooser_label (char * l); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
char *   l ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_label (char * l); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_label "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
l = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) l ,args( 1 ).string_value().c_str());
_Fl_File_ChooserPtr->label ( l);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_label , args , , " char * Fl_File_Chooser_label ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char * Fl_File_Chooser_label ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_label "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_File_ChooserPtr->label ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_preview , args , , " void Fl_File_Chooser_preview (int e); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
int   e ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_preview (int e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_preview "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
e = (  int  ) args( 1 ).int_value();
_Fl_File_ChooserPtr->preview ( e);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_preview , args , , " int Fl_File_Chooser_preview ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_File_Chooser_preview ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_preview "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->preview ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_rescan , args , , " void Fl_File_Chooser_rescan ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_rescan ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_rescan "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->rescan ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_show , args , , " void Fl_File_Chooser_show ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_show ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_show "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->show ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_shown , args , , " int Fl_File_Chooser_shown ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_File_Chooser_shown ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_shown "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->shown ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_textcolor , args , , " void Fl_File_Chooser_textcolor (Fl_Color c); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
Fl_Color   c ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_textcolor (Fl_Color c); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
c = (  Fl_Color  ) args( 1 ).long_value();
_Fl_File_ChooserPtr->textcolor ( c);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_textcolor , args , , " Fl_Color Fl_File_Chooser_textcolor ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Color Fl_File_Chooser_textcolor ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->textcolor ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_textfont , args , , " void Fl_File_Chooser_textfont (uchar f); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
uchar   f ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_textfont (uchar f); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_textfont "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
f = (  uchar  ) args( 1 ).long_value();
_Fl_File_ChooserPtr->textfont ( f);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_textfont , args , , " uchar Fl_File_Chooser_textfont ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  uchar Fl_File_Chooser_textfont ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_textfont "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->textfont ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_textsize , args , , " void Fl_File_Chooser_textsize (uchar s); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
uchar   s ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_textsize (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_textsize "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
s = (  uchar  ) args( 1 ).long_value();
_Fl_File_ChooserPtr->textsize ( s);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_textsize , args , , " uchar Fl_File_Chooser_textsize ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  uchar Fl_File_Chooser_textsize ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_textsize "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->textsize ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_type , args , , " void Fl_File_Chooser_type (int t); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
int   t ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_type (int t); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_type "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
t = (  int  ) args( 1 ).int_value();
_Fl_File_ChooserPtr->type ( t);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_type , args , , " int Fl_File_Chooser_type ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_File_Chooser_type ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_type "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->type ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_value , args , , " char * Fl_File_Chooser_value (int f = 1); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
int   f = 1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  char * Fl_File_Chooser_value (int f = 1); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_value "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
f = 1 = (  int  ) args( 1 ).int_value();
string  ret_type(  (const char *) _Fl_File_ChooserPtr->value ( f = 1));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_value , args , , " void Fl_File_Chooser_value (char * filename); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
char *   filename ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_value (char * filename); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_value "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
filename = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) filename ,args( 1 ).string_value().c_str());
_Fl_File_ChooserPtr->value ( filename);
return octave_value();
}
DEFUN_DLD( Fl_File_Chooser_visible , args , , " int Fl_File_Chooser_visible ( ); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_File_Chooser_visible ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_visible "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_ChooserPtr->visible ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_fl_dir_chooser , args , , " char * Fl_File_Chooser_fl_dir_chooser (char * message,char * fname,int relative=0); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
char *   message ;
char *   fname ;
int   relative=0 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  char * Fl_File_Chooser_fl_dir_chooser (char * message,char * fname,int relative=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_fl_dir_chooser "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
message = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) message ,args( 1 ).string_value().c_str());
fname = new  char   [args( 2 ).string_value ().length()];
strcpy( (char *) fname ,args( 2 ).string_value().c_str());
relative=0 = (  int  ) args( 3 ).int_value();
string  ret_type(  (const char *) _Fl_File_ChooserPtr->fl_dir_chooser ( message,fname,relative=0));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Chooser_fl_file_chooser , args , , " char * Fl_File_Chooser_fl_file_chooser (char * message,char * pat,char * fname,int relative=0); " )
{
Fl_File_Chooser *   _Fl_File_ChooserPtr ;
char *   message ;
char *   pat ;
char *   fname ;
int   relative=0 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  char * Fl_File_Chooser_fl_file_chooser (char * message,char * pat,char * fname,int relative=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_fl_file_chooser "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
message = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) message ,args( 1 ).string_value().c_str());
pat = new  char   [args( 2 ).string_value ().length()];
strcpy( (char *) pat ,args( 2 ).string_value().c_str());
fname = new  char   [args( 3 ).string_value ().length()];
strcpy( (char *) fname ,args( 3 ).string_value().c_str());
relative=0 = (  int  ) args( 4 ).int_value();
string  ret_type(  (const char *) _Fl_File_ChooserPtr->fl_file_chooser ( message,pat,fname,relative=0));
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_File_Chooser_fl_file_chooser_callback , args , , " void Fl_File_Chooser_fl_file_chooser_callback (void); " )
{
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Chooser_fl_file_chooser_callback (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Chooser_fl_file_chooser_callback "<<std::endl;
#endif /* DEBUG */
_Fl_File_ChooserPtr =( Fl_File_Chooser * )args( 0 ).long_value();
_Fl_File_ChooserPtr->fl_file_chooser_callback ( (*cb);
return octave_value();
}
#endif /* 0 */

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_File_Chooser , args , , " void Fl_File_Chooser(void); " )
{
  if(args.length()==4)
    {
      Fl_File_Chooser *fl=new 
	Fl_File_Chooser( args(0).string_value().c_str(),
			 args(1).string_value().c_str(),
			 args(2).int_value(),
			 args(3).string_value().c_str());
      return octave_value(new FLTKWrapper(fl,"Fl_File_Chooser"));
    }

  octave_dynamic_loader::load("Fl_File_Chooser_atoll" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser___val[" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_favoritesButtonCB" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_favoritesCB" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_fileListCB" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_fileNameCB" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_newdir" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_previewCB" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_showChoiceCB" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_update_favorites" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_update_preview" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_window" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_showChoice" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_favoritesButton" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_newButton" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_fileList" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_previewButton" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_fileName" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_okButton" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_Cancel" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_favList" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_favUpButton" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_favDeleteButton" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_favDownButton" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_favCancelButton" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_cb_favOkButton" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_callback" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_color" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_color" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_count" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_directory" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_directory" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_filter" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_filter" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_filter_value" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_filter_value" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_hide" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_iconsize" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_iconsize" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_label" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_label" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_preview" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_preview" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_rescan" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_show" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_shown" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_textcolor" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_textcolor" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_textfont" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_textfont" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_textsize" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_textsize" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_type" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_type" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_value" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_value" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_visible" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_fl_dir_chooser" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_fl_file_chooser" ,"");
  octave_dynamic_loader::load("Fl_File_Chooser_fl_file_chooser_callback" ,"");
  return octave_value("Code generated onSat Jul 30 23:28:31 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_File_ChooserLibrary!");
}
