/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_File_Icon_add , args , , " short * Fl_File_Icon_add (short d); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
short   d ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  short * Fl_File_Icon_add (short d); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_add "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
d = (  short  ) args( 1 ).long_value();
long int ret_type= (long int) _Fl_File_IconPtr->add ( d);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Icon_add_color , args , , " short * Fl_File_Icon_add_color (Fl_Color c); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
Fl_Color   c ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  short * Fl_File_Icon_add_color (Fl_Color c); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_add_color "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
c = (  Fl_Color  ) args( 1 ).long_value();
long int ret_type= (long int) _Fl_File_IconPtr->add_color ( c);
return octave_value(ret_type);
}

DEFUN_DLD( Fl_File_Icon_add_vertex , args , , " short * Fl_File_Icon_add_vertex (int x,int y); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
int   x ;
int   y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  short * Fl_File_Icon_add_vertex (int x,int y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_add_vertex "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
 if((int)args(1).double_value()!=args(1).int_value())
   {
     double x,y;
     x = args( 1 ).double_value();
     y = args( 2 ).double_value();
     long int ret_type= (long int) _Fl_File_IconPtr->add_vertex ((float) x,(float)y);
     return octave_value(ret_type);
   }

 x = (  int  ) args( 1 ).int_value();
 y = (  int  ) args( 2 ).int_value();
 long int ret_type= (long int) _Fl_File_IconPtr->add_vertex ( x,y);
return octave_value(ret_type);
}

DEFUN_DLD( Fl_File_Icon_clear , args , , " void Fl_File_Icon_clear ( ); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_File_Icon_clear ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_clear "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
_Fl_File_IconPtr->clear ( );
return octave_value();
}
DEFUN_DLD( Fl_File_Icon_draw , args , , " void Fl_File_Icon_draw (int x,int y,int w,int h,Fl_Color ic,int active ); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
int   x ;
int   y ;
int   w ;
int   h ;
Fl_Color   ic ;
int   active=1 ;
 if(args.length()!= 7 || args.length()!=6)
  {
   std::cout<< "eg:  void Fl_File_Icon_draw (int x,int y,int w,int h,Fl_Color ic,int active = 1); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_draw "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
w = (  int  ) args( 3 ).int_value();
h = (  int  ) args( 4 ).int_value();
ic = (  Fl_Color  ) args( 5 ).long_value();
 if(args.length()==7)   
   active =  (  int  ) args( 6 ).int_value();
 _Fl_File_IconPtr->draw ( x,y,w,h,ic,active );
 return octave_value();
}

DEFUN_DLD( Fl_File_Icon_label , args , , " void Fl_File_Icon_label (Fl_Widget * w); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
Fl_Widget *   w ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Icon_label (Fl_Widget * w); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_label "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
w =( Fl_Widget * )args( 1 ).long_value();
_Fl_File_IconPtr->label ( w);
return octave_value();
}

DEFUN_DLD( Fl_File_Icon_labeltype , args , , " static Fl_File_Icon_labeltype (Fl_Label * o,int x,int y,int w,int h,Fl_Align a); " )
{
Fl_Label *   o ;
int   x ;
int   y ;
int   w ;
int   h ;
Fl_Align   a ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  static Fl_File_Icon_labeltype (Fl_Label * o,int x,int y,int w,int h,Fl_Align a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_labeltype "<<std::endl;
#endif /* DEBUG */
 o =( Fl_Label * )args( 0 ).long_value();
 x = (  int  ) args( 1 ).int_value();
 y = (  int  ) args( 2 ).int_value();
 w = (  int  ) args( 3 ).int_value();
 h = (  int  ) args( 4 ).int_value();
 a = (  Fl_Align  ) args( 5 ).long_value();

 Fl_File_Icon::labeltype ( o,x,y,w,h,a);
 return octave_value();
}

// Loads Icon from filename.
DEFUN_DLD( Fl_File_Icon_load , args , , " void Fl_File_Icon_load (char * f); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
char *   f ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_File_Icon_load (char * f); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_load "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
f = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) f ,args( 1 ).string_value().c_str());
_Fl_File_IconPtr->load ( f);
return octave_value();
}
DEFUN_DLD( Fl_File_Icon_load_fti , args , , " int Fl_File_Icon_load_fti (char * fti); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
char *   fti ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_File_Icon_load_fti (char * fti); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_load_fti "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
fti = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) fti ,args( 1 ).string_value().c_str());
long int ret_type=(long int) _Fl_File_IconPtr->load_fti ( fti);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Icon_load_image , args , , " int Fl_File_Icon_load_image (char * i); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
char *   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_File_Icon_load_image (char * i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_load_image "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
i = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) i ,args( 1 ).string_value().c_str());
long int ret_type=(long int) _Fl_File_IconPtr->load_image ( i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Icon_next , args , , " Fl_File_Icon * Fl_File_Icon_next ( ); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_File_Icon * Fl_File_Icon_next ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_next "<<std::endl;
#endif /* DEBUG */
 _Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
 Fl_File_Icon* ret_type=  _Fl_File_IconPtr->next ( );
 return octave_value(new FLTKWrapper(ret_type,"Fl_File_Icon"));
}

DEFUN_DLD( Fl_File_Icon_pattern , args , , " char * Fl_File_Icon_pattern ( ); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char * Fl_File_Icon_pattern ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_pattern "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_File_IconPtr->pattern ( ));
 return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Icon_size , args , , " int Fl_File_Icon_size ( ); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_File_Icon_size ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_size "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_IconPtr->size ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_File_Icon_type , args , , " int Fl_File_Icon_type ( ); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_File_Icon_type ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_type "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_File_IconPtr->type ( );
return octave_value(ret_type);
}
// Returns the data array of this Icon[matrix,]
DEFUN_DLD( Fl_File_Icon_value , args , , " short * Fl_File_Icon_value ( ); " )
{
Fl_File_Icon *   _Fl_File_IconPtr ;

 if(args.length()!= 1 )
  {
   std::cout<< "eg:  short * Fl_File_Icon_value ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_value "<<std::endl;
#endif /* DEBUG */
_Fl_File_IconPtr =( Fl_File_Icon * )args( 0 ).long_value();

 Matrix m(1,_Fl_File_IconPtr->size());
 short int *ptr= _Fl_File_IconPtr->value ( );
 for(int i=0;i<_Fl_File_IconPtr->size();i++)
   m.elem(0,i)=ptr[i];
 
 return octave_value(m);
}

DEFUN_DLD( Fl_File_Icon_find , args , , " static Fl_File_Icon_find (char * filename,int filetype = ANY); " )
{
  char *   filename ;
  int   filetype = 0;
 if(args.length()!= 1 || args.length()!=2)
  {
   std::cout<< "eg:  static Fl_File_Icon_*find (char * filename,int filetype = ANY); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_*find "<<std::endl;
#endif /* DEBUG */
filename = new  char   [args( 0 ).string_value ().length()];
strcpy( (char *) filename ,args( 0 ).string_value().c_str());

 if (args.length()!=2)
   filetype =0;
 else
   filetype = (  int  ) args(1).int_value();
 
  Fl_File_Icon* fptr = Fl_File_Icon::find ( filename,filetype);
  return octave_value(new FLTKWrapper(fptr,"Fl_File_Icon"));
}

DEFUN_DLD( Fl_File_Icon_first , args , , " static Fl_File_Icon_first ( ); " )
{
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_File_Icon_*first ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_File_Icon_*first "<<std::endl;
#endif /* DEBUG */
 
 Fl_File_Icon* fptr = Fl_File_Icon::first();
 return octave_value(new FLTKWrapper(fptr,"Fl_File_Icon"));
}

/* void: zero arguments taken */
DEFUN_DLD( Fl_File_Icon_load_system_icons , args , , " static Fl_File_Icon_load_system_icons (void); " )
{
#ifdef DEBUG
  std::cout<<" Fl_File_Icon_load_system_icons "<<std::endl;
#endif /* DEBUG */

 Fl_File_Icon::load_system_icons ();

 return octave_value();
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_File_Icon , args , , " void Fl_File_Icon(void); " )
{

  if (args.length() == 3)
    {
      char *str=NULL;
      Matrix mat;
      int maxval=0;

      str=strdup(args(0).string_value().c_str());
      mat=args(2).matrix_value();

      maxval=mat.cols();

      short int val[maxval];
      for(int i=0;i<maxval;i++)
	val[i]=(short int)mat.elem(0,i);
      
      Fl_File_Icon *flb=new Fl_File_Icon(str,args(1).int_value(),
					 maxval,val);
      
      return octave_value(new FLTKWrapper(flb,"Fl_File_Icon"));
    }

  octave_dynamic_loader::load("Fl_File_Icon_add" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_add_color" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_add_vertex" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_clear" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_draw" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_label" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_labeltype" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_load" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_load_fti" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_load_image" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_next" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_pattern" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_size" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_type" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_value" ,"");

  /* Static Functions */ 
  octave_dynamic_loader::load("Fl_File_Icon_find" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_first" ,"");
  octave_dynamic_loader::load("Fl_File_Icon_load_system_icons" ,"");
  
  std::cout<<"Code generated on Sun Jul 31 12:56:28 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_File_IconLibrary!\n";
  return octave_value(new FLTKStaticWrapper(0,"Fl_File_Icon"));
}
