/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

#if 0
DEFUN_DLD( Fl_FormsPixmap_set , args , , " void Fl_FormsPixmap_set (int W,int H,uchar * bits); " )
{
Fl_FormsPixmap *   _Fl_FormsPixmapPtr ;
uchar *   bits ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_FormsPixmap_set (uchar * bits); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
 std::cout<<" Fl_FormsPixmap_set "<<std::endl;
#endif /* DEBUG */
 _Fl_FormsPixmapPtr =( Fl_FormsPixmap * )args( 0 ).long_value();
 bits =  new  uchar   [args( 1 ).string_value ().length()];
 strcpy( (char *) bits ,args( 2 ).string_value().c_str());
 _Fl_FormsPixmapPtr->set (bits);
return octave_value();
}
#endif

DEFUN_DLD( Fl_FormsPixmap_pixmap , args , , " void Fl_FormsPixmap__pixmap (Fl_Bitmap * B); " )
{
Fl_FormsPixmap *   _Fl_FormsPixmapPtr ;
Fl_Pixmap *   B ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_FormsPixmap_bitmap (Fl_Bitmap * B); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_FormsPixmap_bitmap "<<std::endl;
#endif /* DEBUG */
_Fl_FormsPixmapPtr =( Fl_FormsPixmap * )args( 0 ).long_value();
 if(args.length()!= 1 )
   {
     B =( Fl_Pixmap * )args( 1 ).long_value();
     _Fl_FormsPixmapPtr->Pixmap ( B);
     return octave_value();
   }

 Fl_Pixmap * ret_type=  _Fl_FormsPixmapPtr->Pixmap ( );
 return octave_value(new FLTKWrapper(ret_type,"Fl_Pixmap"));
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_FormsPixmap , args , , " void Fl_FormsPixmap(void); " )
{
  if (args.length() >= 5 && args.length() <= 6)
    {
      char *str=NULL;
      if(args.length()==6)
        str=strdup(args(5).string_value().c_str());
      
      Fl_FormsPixmap *flb=new Fl_FormsPixmap((Fl_Boxtype)args(0).int_value(),
					 args(1).int_value(),
					 args(2).int_value(),
					 args(3).int_value(),
					 args(4).int_value(),
					 str);

      return octave_value(new FLTKWrapper(flb,"Fl_FormsPixmap"));
    }


  //NOT IMPLEMENTED: Dontknow how this works
  /* octave_dynamic_loader::load("Fl_FormsPixmap_set" ,""); */

  octave_dynamic_loader::load("Fl_FormsPixmap_pixmap" ,"");
  
  std::cout<< "Code generated onSat Jul 30 23:28:32 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_FormsPixmapLibrary!\n";
  
   return octave_value(new FLTKStaticWrapper(0,"Fl_FormsPixmap"));
}
