/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

#if 0
DEFUN_DLD( Fl_Free_step , args , , " static Fl_Free_step (void * ); " )
{
Fl_Free *   _Fl_FreePtr ;
void *   _void0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_Free_step (void * ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Free_step "<<std::endl;
#endif /* DEBUG */
_Fl_FreePtr =( Fl_Free * )args( 0 ).long_value();
_void0 =( void * )args( 1 ).long_value();
long int ret_type=(long int) _Fl_FreePtr->step ( _void0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Free_draw , args , , " void Fl_Free_draw ( ); " )
{
Fl_Free *   _Fl_FreePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Free_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Free_draw "<<std::endl;
#endif /* DEBUG */
_Fl_FreePtr =( Fl_Free * )args( 0 ).long_value();
_Fl_FreePtr->draw ( );
return octave_value();
}
DEFUN_DLD( Fl_Free_handle , args , , " int Fl_Free_handle (int ); " )
{
Fl_Free *   _Fl_FreePtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Free_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Free_handle "<<std::endl;
#endif /* DEBUG */
_Fl_FreePtr =( Fl_Free * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_FreePtr->handle ( _int0);
return octave_value(ret_type);
}
#endif

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Free , args , , " void Fl_Free(void); " )
{
  /* NoT IMPLEMENTED */

  octave_dynamic_loader::load("Fl_Free_step" ,"");
  octave_dynamic_loader::load("Fl_Free_draw" ,"");
  octave_dynamic_loader::load("Fl_Free_handle" ,"");

  return octave_value("Code generated onSat Jul 30 23:28:32 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_FreeLibrary!");
}
