/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

#if 0
DEFUN_DLD( Fl_Gl_Window_draw_overlay , args , , " virtual Fl_Gl_Window_draw_overlay ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_Gl_Window_draw_overlay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_draw_overlay "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->draw_overlay ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_init , args , , " void Fl_Gl_Window_init ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_init ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_init "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->init ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_make_overlay , args , , " void Fl_Gl_Window_make_overlay ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_make_overlay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_make_overlay "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->make_overlay ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_can_do , args , , " static Fl_Gl_Window_can_do (int ,int * ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
int   _int0 ;
int *   _int1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Gl_Window_can_do (int ,int * ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_can_do "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 =( int * )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->can_do ( _int0,_int1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_mode , args , , " int Fl_Gl_Window_mode (int ,int * ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
int   _int0 ;
int *   _int1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Gl_Window_mode (int ,int * ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_mode "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 =( int * )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->mode ( _int0,_int1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_show , args , , " void Fl_Gl_Window_show ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_show ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_show "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->show ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_show , args , , " void Fl_Gl_Window_show (int a,char * *b); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
int   a ;
char *   *b ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_show (int a,char * *b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_show "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
a = (  int  ) args( 1 ).int_value();
*b = new  char   [args( 2 ).string_value ().length()];
strcpy( (char *) *b ,args( 2 ).string_value().c_str());
_Fl_Gl_WindowPtr->show ( a,*b);
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_flush , args , , " void Fl_Gl_Window_flush ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_flush ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_flush "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->flush ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_hide , args , , " void Fl_Gl_Window_hide ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_hide ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_hide "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->hide ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_resize , args , , " void Fl_Gl_Window_resize (int ,int ,int ,int ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_resize (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_resize "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
_Fl_Gl_WindowPtr->resize ( _int0,_int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_valid , args , , " char Fl_Gl_Window_valid ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char Fl_Gl_Window_valid ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_valid "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->valid ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_valid , args , , " void Fl_Gl_Window_valid (char v); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
char   v ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_valid (char v); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_valid "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
v = (  char  ) args( 1 ).long_value();
_Fl_Gl_WindowPtr->valid ( v);
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_invalidate , args , , " void Fl_Gl_Window_invalidate ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_invalidate ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_invalidate "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->invalidate ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_can_do , args , , " static Fl_Gl_Window_can_do (int m); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
int   m ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_Gl_Window_can_do (int m); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_can_do "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
m = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->can_do ( m);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_can_do , args , , " static Fl_Gl_Window_can_do (int * m); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
int *   m ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_Gl_Window_can_do (int * m); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_can_do "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
m =( int * )args( 1 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->can_do ( m);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_can_do , args , , " int Fl_Gl_Window_can_do ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Gl_Window_can_do ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_can_do "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->can_do ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_mode , args , , " Fl_Mode Fl_Gl_Window_mode ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Mode Fl_Gl_Window_mode ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_mode "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->mode ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_mode , args , , " int Fl_Gl_Window_mode (int a); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
int   a ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Gl_Window_mode (int a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_mode "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
a = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->mode ( a);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_mode , args , , " int Fl_Gl_Window_mode (int * a); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
int *   a ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Gl_Window_mode (int * a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_mode "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
a =( int * )args( 1 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->mode ( a);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_context , args , , " void* Fl_Gl_Window_context ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void* Fl_Gl_Window_context ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_context "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
long int ret_type= (long int) _Fl_Gl_WindowPtr->context ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_context , args , , " void Fl_Gl_Window_context (void* ,int destroy_flag = 0); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
void*   _void*0 ;
int   destroy_flag = 0 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_context (void* ,int destroy_flag = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_context "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_void*0 =( void* )args( 1 ).long_value();
destroy_flag = 0 = (  int  ) args( 2 ).int_value();
_Fl_Gl_WindowPtr->context ( _void*0,destroy_flag = 0);
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_make_current , args , , " void Fl_Gl_Window_make_current ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_make_current ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_make_current "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->make_current ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_swap_buffers , args , , " void Fl_Gl_Window_swap_buffers ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_swap_buffers ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_swap_buffers "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->swap_buffers ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_ortho , args , , " void Fl_Gl_Window_ortho ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_ortho ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_ortho "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->ortho ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_can_do_overlay , args , , " int Fl_Gl_Window_can_do_overlay ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Gl_Window_can_do_overlay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_can_do_overlay "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->can_do_overlay ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Gl_Window_redraw_overlay , args , , " void Fl_Gl_Window_redraw_overlay ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_redraw_overlay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_redraw_overlay "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->redraw_overlay ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_hide_overlay , args , , " void Fl_Gl_Window_hide_overlay ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_hide_overlay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_hide_overlay "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->hide_overlay ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_make_overlay_current , args , , " void Fl_Gl_Window_make_overlay_current ( ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Gl_Window_make_overlay_current ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_make_overlay_current "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_Fl_Gl_WindowPtr->make_overlay_current ( );
return octave_value();
}
DEFUN_DLD( Fl_Gl_Window_Fl_Window , args , , " : Fl_Gl_Window_Fl_Window (X ,Y ,W ,H ,l ); " )
{
Fl_Gl_Window *   _Fl_Gl_WindowPtr ;
X   _X0 ;
Y   _Y1 ;
W   _W2 ;
H   _H3 ;
l   _l4 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  : Fl_Gl_Window_Fl_Window (X ,Y ,W ,H ,l ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Gl_Window_Fl_Window "<<std::endl;
#endif /* DEBUG */
_Fl_Gl_WindowPtr =( Fl_Gl_Window * )args( 0 ).long_value();
_X0 = (  X  ) args( 1 ).long_value();
_Y1 = (  Y  ) args( 2 ).long_value();
_W2 = (  W  ) args( 3 ).long_value();
_H3 = (  H  ) args( 4 ).long_value();
_l4 = (  l  ) args( 5 ).long_value();
long int ret_type=(long int) _Fl_Gl_WindowPtr->Fl_Window ( _X0,_Y1,_W2,_H3,_l4);
return octave_value(ret_type);
}
#endif /* 0 */

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Gl_Window , args , , " void Fl_Gl_Window(void); " )
{

  /* NOT IMPLEMENTED */

#if 0
octave_dynamic_loader::load("Fl_Gl_Window_draw_overlay" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_init" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_make_overlay" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_can_do" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_mode" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_show" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_show" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_flush" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_hide" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_resize" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_valid" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_valid" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_invalidate" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_can_do" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_can_do" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_can_do" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_mode" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_mode" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_mode" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_context" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_context" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_make_current" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_swap_buffers" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_ortho" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_can_do_overlay" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_redraw_overlay" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_hide_overlay" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_make_overlay_current" ,"");
octave_dynamic_loader::load("Fl_Gl_Window_Fl_Window" ,"");
#endif

return octave_value("Code generated onSat Jul 30 23:28:32 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Gl_WindowLibrary!");
}
