/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
#if 0
DEFUN_DLD( Fl_End_navigation , args , , " int Fl_End_navigation (int ); " )
{
Fl_Group *   _Fl_GroupPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_End_navigation (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_navigation "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_End_navigation ( _int0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_draw , args , , " void Fl_End_draw ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_End_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_draw "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
Fl_End_draw ( );
return octave_value();
}
DEFUN_DLD( Fl_End_draw_child , args , , " void Fl_End_draw_child (Fl_Widget& ); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   _Fl_Widget&0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_draw_child (Fl_Widget& ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_draw_child "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_Fl_Widget&0 = (  Fl_Widget&  ) args( 1 ).long_value();
Fl_End_draw_child ( _Fl_Widget&0);
return octave_value();
}
DEFUN_DLD( Fl_End_draw_children , args , , " void Fl_End_draw_children ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_End_draw_children ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_draw_children "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
Fl_End_draw_children ( );
return octave_value();
}
DEFUN_DLD( Fl_End_draw_outside_label , args , , " void Fl_End_draw_outside_label (Fl_Widget& ); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   _Fl_Widget&0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_draw_outside_label (Fl_Widget& ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_draw_outside_label "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_Fl_Widget&0 = (  Fl_Widget&  ) args( 1 ).long_value();
Fl_End_draw_outside_label ( _Fl_Widget&0);
return octave_value();
}
DEFUN_DLD( Fl_End_update_child , args , , " void Fl_End_update_child (Fl_Widget& ); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   _Fl_Widget&0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_update_child (Fl_Widget& ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_update_child "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_Fl_Widget&0 = (  Fl_Widget&  ) args( 1 ).long_value();
Fl_End_update_child ( _Fl_Widget&0);
return octave_value();
}
DEFUN_DLD( Fl_End_sizes , args , , " short* Fl_End_sizes ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  short* Fl_End_sizes ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_sizes "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
long int ret_type= (long int) Fl_End_sizes ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_handle , args , , " int Fl_End_handle (int ); " )
{
Fl_Group *   _Fl_GroupPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_End_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_handle "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_End_handle ( _int0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_begin , args , , " void Fl_End_begin ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_End_begin ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_begin "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
Fl_End_begin ( );
return octave_value();
}
DEFUN_DLD( Fl_End_end , args , , " void Fl_End_end ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_End_end ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_end "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
Fl_End_end ( );
return octave_value();
}
DEFUN_DLD( Fl_End_*current , args , , " static Fl_End_*current ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_End_*current ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_*current "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
long int ret_type=(long int) Fl_End_*current ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_current , args , , " static Fl_End_current (Fl_Group * g); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Group *   g ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_End_current (Fl_Group * g); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_current "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
g =( Fl_Group * )args( 1 ).long_value();
long int ret_type=(long int) Fl_End_current ( g);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_children , args , , " int Fl_End_children ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_End_children ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_children "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
long int ret_type=(long int) Fl_End_children ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_child , args , , " Fl_Widget* Fl_End_child (int n); " )
{
Fl_Group *   _Fl_GroupPtr ;
int   n ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  Fl_Widget* Fl_End_child (int n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_child "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
n = (  int  ) args( 1 ).int_value();
long int ret_type= (long int) Fl_End_child ( n);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_find , args , , " int Fl_End_find (Fl_Widget* ); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget*   _Fl_Widget*0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_End_find (Fl_Widget* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_find "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_Fl_Widget*0 =( Fl_Widget* )args( 1 ).long_value();
long int ret_type=(long int) Fl_End_find ( _Fl_Widget*0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_find , args , , " int Fl_End_find (Fl_Widget& o); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   o ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_End_find (Fl_Widget& o); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_find "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
o = (  Fl_Widget&  ) args( 1 ).long_value();
long int ret_type=(long int) Fl_End_find ( o);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_array , args , , " Fl_Widget* Fl_End_array ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Widget* Fl_End_array ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_array "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
long int ret_type= (long int) Fl_End_array ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_resize , args , , " void Fl_End_resize (int ,int ,int ,int ); " )
{
Fl_Group *   _Fl_GroupPtr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_End_resize (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_resize "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
Fl_End_resize ( _int0,_int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_End_add , args , , " void Fl_End_add (Fl_Widget& ); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   _Fl_Widget&0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_add (Fl_Widget& ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_add "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_Fl_Widget&0 = (  Fl_Widget&  ) args( 1 ).long_value();
Fl_End_add ( _Fl_Widget&0);
return octave_value();
}
DEFUN_DLD( Fl_End_add , args , , " void Fl_End_add (Fl_Widget* o); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget*   o ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_add (Fl_Widget* o); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_add "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
o =( Fl_Widget* )args( 1 ).long_value();
Fl_End_add ( o);
return octave_value();
}
DEFUN_DLD( Fl_End_insert , args , , " void Fl_End_insert (Fl_Widget& ,int i); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   _Fl_Widget&0 ;
int   i ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_End_insert (Fl_Widget& ,int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_insert "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_Fl_Widget&0 = (  Fl_Widget&  ) args( 1 ).long_value();
i = (  int  ) args( 2 ).int_value();
Fl_End_insert ( _Fl_Widget&0,i);
return octave_value();
}
DEFUN_DLD( Fl_End_insert , args , , " void Fl_End_insert (Fl_Widget& o,Fl_Widget* before); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   o ;
Fl_Widget*   before ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_End_insert (Fl_Widget& o,Fl_Widget* before); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_insert "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
o = (  Fl_Widget&  ) args( 1 ).long_value();
before =( Fl_Widget* )args( 2 ).long_value();
Fl_End_insert ( o,before);
return octave_value();
}
DEFUN_DLD( Fl_End_remove , args , , " void Fl_End_remove (Fl_Widget& ); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   _Fl_Widget&0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_remove (Fl_Widget& ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_remove "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
_Fl_Widget&0 = (  Fl_Widget&  ) args( 1 ).long_value();
Fl_End_remove ( _Fl_Widget&0);
return octave_value();
}
DEFUN_DLD( Fl_End_remove , args , , " void Fl_End_remove (Fl_Widget* o); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget*   o ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_remove (Fl_Widget* o); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_remove "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
o =( Fl_Widget* )args( 1 ).long_value();
Fl_End_remove ( o);
return octave_value();
}
DEFUN_DLD( Fl_End_clear , args , , " void Fl_End_clear ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_End_clear ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_clear "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
Fl_End_clear ( );
return octave_value();
}
DEFUN_DLD( Fl_End_resizable , args , , " void Fl_End_resizable (Fl_Widget& o); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   o ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_resizable (Fl_Widget& o); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_resizable "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
o = (  Fl_Widget&  ) args( 1 ).long_value();
Fl_End_resizable ( o);
return octave_value();
}
DEFUN_DLD( Fl_End_resizable , args , , " void Fl_End_resizable (Fl_Widget* o); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget*   o ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_resizable (Fl_Widget* o); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_resizable "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
o =( Fl_Widget* )args( 1 ).long_value();
Fl_End_resizable ( o);
return octave_value();
}
DEFUN_DLD( Fl_End_resizable , args , , " Fl_Widget* Fl_End_resizable ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Widget* Fl_End_resizable ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_resizable "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
long int ret_type= (long int) Fl_End_resizable ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_add_resizable , args , , " void Fl_End_add_resizable (Fl_Widget& o); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget&   o ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_add_resizable (Fl_Widget& o); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_add_resizable "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
o = (  Fl_Widget&  ) args( 1 ).long_value();
Fl_End_add_resizable ( o);
return octave_value();
}
DEFUN_DLD( Fl_End_init_sizes , args , , " void Fl_End_init_sizes ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_End_init_sizes ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_init_sizes "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
Fl_End_init_sizes ( );
return octave_value();
}
DEFUN_DLD( Fl_End_focus , args , , " void Fl_End_focus (Fl_Widget* o); " )
{
Fl_Group *   _Fl_GroupPtr ;
Fl_Widget*   o ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_End_focus (Fl_Widget* o); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_focus "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
o =( Fl_Widget* )args( 1 ).long_value();
Fl_End_focus ( o);
return octave_value();
}
DEFUN_DLD( Fl_End__ddfdesign_kludge , args , , " Fl_Widget* Fl_End__ddfdesign_kludge ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Widget* Fl_End__ddfdesign_kludge ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End__ddfdesign_kludge "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
long int ret_type= (long int) Fl_End__ddfdesign_kludge ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_End_forms_end , args , , " void Fl_End_forms_end ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_End_forms_end ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_forms_end "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
Fl_End_forms_end ( );
return octave_value();
}
DEFUN_DLD( Fl_End_Fl_End , args , , " Fl_End( Fl_End_Fl_End ( ); " )
{
Fl_Group *   _Fl_GroupPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_End( Fl_End_Fl_End ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_End_Fl_End "<<std::endl;
#endif /* DEBUG */
_Fl_GroupPtr =( Fl_Group * )args( 0 ).long_value();
long int ret_type=(long int) Fl_End_Fl_End ( );
return octave_value(ret_type);
}
#endif

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Group , args , , " void Fl_Group(void); " )
{
#if 0
octave_dynamic_loader::load("Fl_End_navigation" ,"");
octave_dynamic_loader::load("Fl_End_draw" ,"");
octave_dynamic_loader::load("Fl_End_draw_child" ,"");
octave_dynamic_loader::load("Fl_End_draw_children" ,"");
octave_dynamic_loader::load("Fl_End_draw_outside_label" ,"");
octave_dynamic_loader::load("Fl_End_update_child" ,"");
octave_dynamic_loader::load("Fl_End_sizes" ,"");
octave_dynamic_loader::load("Fl_End_handle" ,"");
octave_dynamic_loader::load("Fl_End_begin" ,"");
octave_dynamic_loader::load("Fl_End_end" ,"");
octave_dynamic_loader::load("Fl_End_*current" ,"");
octave_dynamic_loader::load("Fl_End_current" ,"");
octave_dynamic_loader::load("Fl_End_children" ,"");
octave_dynamic_loader::load("Fl_End_child" ,"");
octave_dynamic_loader::load("Fl_End_find" ,"");
octave_dynamic_loader::load("Fl_End_find" ,"");
octave_dynamic_loader::load("Fl_End_array" ,"");
octave_dynamic_loader::load("Fl_End_resize" ,"");
octave_dynamic_loader::load("Fl_End_add" ,"");
octave_dynamic_loader::load("Fl_End_add" ,"");
octave_dynamic_loader::load("Fl_End_insert" ,"");
octave_dynamic_loader::load("Fl_End_insert" ,"");
octave_dynamic_loader::load("Fl_End_remove" ,"");
octave_dynamic_loader::load("Fl_End_remove" ,"");
octave_dynamic_loader::load("Fl_End_clear" ,"");
octave_dynamic_loader::load("Fl_End_resizable" ,"");
octave_dynamic_loader::load("Fl_End_resizable" ,"");
octave_dynamic_loader::load("Fl_End_resizable" ,"");
octave_dynamic_loader::load("Fl_End_add_resizable" ,"");
octave_dynamic_loader::load("Fl_End_init_sizes" ,"");
octave_dynamic_loader::load("Fl_End_focus" ,"");
octave_dynamic_loader::load("Fl_End__ddfdesign_kludge" ,"");
octave_dynamic_loader::load("Fl_End_forms_end" ,"");
octave_dynamic_loader::load("Fl_End_Fl_End" ,"");
#endif

return octave_value("Code generated onSat Jul 30 23:28:32 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_GroupLibrary!");
}
