/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

DEFUN_DLD( Fl_Help_Dialog_h , args , , " int Fl_Help_Dialog_h ( ); " )
{
  Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  int Fl_Help_Dialog_h ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Help_Dialog_h "<<std::endl;
#endif /* DEBUG */
  _Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_Help_DialogPtr->h ( );
  return octave_value(ret_type);
}

DEFUN_DLD( Fl_Help_Dialog_hide , args , , " void Fl_Help_Dialog_hide ( ); " )
{
  Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Help_Dialog_hide ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Help_Dialog_hide "<<std::endl;
#endif /* DEBUG */
  _Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
  _Fl_Help_DialogPtr->hide ( );
  return octave_value();
}
DEFUN_DLD( Fl_Help_Dialog_load , args , , " void Fl_Help_Dialog_load (char * f); " )
{
Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
char *   f ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Help_Dialog_load (char * f); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Help_Dialog_load "<<std::endl;
#endif /* DEBUG */
_Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
f = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) f ,args( 1 ).string_value().c_str());
_Fl_Help_DialogPtr->load ( f);
return octave_value();
}
DEFUN_DLD( Fl_Help_Dialog_position , args , , " void Fl_Help_Dialog_position (int xx,int yy); " )
{
Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
int   xx ;
int   yy ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Help_Dialog_position (int xx,int yy); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Help_Dialog_position "<<std::endl;
#endif /* DEBUG */
_Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
xx = (  int  ) args( 1 ).int_value();
yy = (  int  ) args( 2 ).int_value();
_Fl_Help_DialogPtr->position ( xx,yy);
return octave_value();
}
DEFUN_DLD( Fl_Help_Dialog_resize , args , , " void Fl_Help_Dialog_resize (int xx,int yy,int ww,int hh); " )
{
Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
int   xx ;
int   yy ;
int   ww ;
int   hh ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Help_Dialog_resize (int xx,int yy,int ww,int hh); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Help_Dialog_resize "<<std::endl;
#endif /* DEBUG */
_Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
xx = (  int  ) args( 1 ).int_value();
yy = (  int  ) args( 2 ).int_value();
ww = (  int  ) args( 3 ).int_value();
hh = (  int  ) args( 4 ).int_value();
_Fl_Help_DialogPtr->resize ( xx,yy,ww,hh);
return octave_value();
}
DEFUN_DLD( Fl_Help_Dialog_show , args , , " void Fl_Help_Dialog_show (Cell {}); " )
{
  Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
  Cell  matrix;

  if(args.length()!= 2 || args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Help_Dialog_show (Cell {}); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Help_Dialog_show "<<std::endl;
#endif /* DEBUG */
  _Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
  
  if(args.length()==1)
    { 
      _Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
      _Fl_Help_DialogPtr->show ( );
      return octave_value();
    }

  matrix=args(1).cell_value();
  char *list_args[matrix.cols()];


  for(int i=0;i<matrix.cols();i++)
    {
      list_args[i]=strdup(matrix(0,i).string_value().c_str());
      matrix(0,i).print(std::cout,true);
    }

  _Fl_Help_DialogPtr->show (matrix.cols(),list_args);

  for(int i=0;i<matrix.cols();i++)
    free(list_args[i]);

  return octave_value();
}

DEFUN_DLD( Fl_Help_Dialog_textsize , args , , " void Fl_Help_Dialog_textsize (uchar s); " )
{
Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
uchar   s ;
 if(args.length()!= 2 || args.length()!=1)
  {
   std::cout<< "eg:  void Fl_Help_Dialog_textsize (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Help_Dialog_textsize "<<std::endl;
#endif /* DEBUG */ 
_Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
 if(args.length()==1)
   {
     long int ret_val = _Fl_Help_DialogPtr->textsize();
     return octave_value(ret_val);
   }
 s = (  uchar  ) args( 1 ).long_value();
 _Fl_Help_DialogPtr->textsize ( s);
 return octave_value();
}


DEFUN_DLD( Fl_Help_Dialog_topline , args , , " void Fl_Help_Dialog_topline (char * n); " )
{
Fl_Help_Dialog *   _Fl_Help_DialogPtr ;

 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Help_Dialog_topline (char * n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Help_Dialog_topline "<<std::endl;
#endif /* DEBUG */
 _Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
 if(args(1).is_string())
   { 
     char *n;
     n = new  char   [args( 1 ).string_value ().length()];
     strcpy( (char *) n ,args( 1 ).string_value().c_str());
     _Fl_Help_DialogPtr->topline ( n);
   }
 else
   {
     int n;
     n = (  int  ) args( 1 ).int_value();
     _Fl_Help_DialogPtr->topline ( n);
   }

return octave_value();
}

DEFUN_DLD( Fl_Help_Dialog_visible , args , , " int Fl_Help_Dialog_visible ( ); " )
{
Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Help_Dialog_visible ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Help_Dialog_visible "<<std::endl;
#endif /* DEBUG */
_Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Help_DialogPtr->visible ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Help_Dialog_w , args , , " int Fl_Help_Dialog_w ( ); " )
{
Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Help_Dialog_w ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Help_Dialog_w "<<std::endl;
#endif /* DEBUG */
_Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Help_DialogPtr->w ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Help_Dialog_x , args , , " int Fl_Help_Dialog_x ( ); " )
{
Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Help_Dialog_x ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Help_Dialog_x "<<std::endl;
#endif /* DEBUG */
_Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Help_DialogPtr->x ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Help_Dialog_y , args , , " int Fl_Help_Dialog_y ( ); " )
{
Fl_Help_Dialog *   _Fl_Help_DialogPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Help_Dialog_y ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Help_Dialog_y "<<std::endl;
#endif /* DEBUG */
_Fl_Help_DialogPtr =( Fl_Help_Dialog * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Help_DialogPtr->y ( );
return octave_value(ret_type);
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Help_Dialog , args , , " void Fl_Help_Dialog(void); " )
{
  static int i=0;
  if (i==0)
    {
      octave_dynamic_loader::load("Fl_Help_Dialog_Fl_Help_Dialog" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_h" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_hide" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_load" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_position" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_resize" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_show" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_show" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_textsize" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_textsize" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_topline" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_topline" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_visible" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_w" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_x" ,"");
      octave_dynamic_loader::load("Fl_Help_Dialog_y" ,"");
      return octave_value("Code generated onSat Jul 30 23:28:32 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Help_DialogLibrary!");
      i++;
      return octave_value();
    }
  
  Fl_Help_Dialog *hdg = new Fl_Help_Dialog();
  return octave_value(new FLTKWrapper(hdg,"Fl_Help_Dialog"));
}

