/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

/* TODO */
#if 0
DEFUN_DLD( Fl_RGB_Image_operator= , args , , " Fl_Image Fl_RGB_Image_operator= (Fl_Image &); " )
{
Fl_Image *   _Fl_ImagePtr ;
Fl_Image   & ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  Fl_Image Fl_RGB_Image_operator= (Fl_Image &); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_operator= "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
& = (  Fl_Image  ) args( 1 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_operator= ( &);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_w , args , , " void Fl_RGB_Image_w (int W); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   W ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_RGB_Image_w (int W); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_w "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
W = (  int  ) args( 1 ).int_value();
Fl_RGB_Image_w ( W);
return octave_value();
}
DEFUN_DLD( Fl_RGB_Image_h , args , , " void Fl_RGB_Image_h (int H); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   H ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_RGB_Image_h (int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_h "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
H = (  int  ) args( 1 ).int_value();
Fl_RGB_Image_h ( H);
return octave_value();
}
DEFUN_DLD( Fl_RGB_Image_d , args , , " void Fl_RGB_Image_d (int D); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   D ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_RGB_Image_d (int D); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_d "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
D = (  int  ) args( 1 ).int_value();
Fl_RGB_Image_d ( D);
return octave_value();
}
DEFUN_DLD( Fl_RGB_Image_ld , args , , " void Fl_RGB_Image_ld (int LD); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   LD ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_RGB_Image_ld (int LD); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_ld "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
LD = (  int  ) args( 1 ).int_value();
Fl_RGB_Image_ld ( LD);
return octave_value();
}
DEFUN_DLD( Fl_RGB_Image_data , args , , " void Fl_RGB_Image_data (char * const *p,int c); " )
{
Fl_Image *   _Fl_ImagePtr ;
char *   const *p ;
int   c ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_RGB_Image_data (char * const *p,int c); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_data "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
const *p = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) const *p ,args( 1 ).string_value().c_str());
c = (  int  ) args( 2 ).int_value();
Fl_RGB_Image_data ( const *p,c);
return octave_value();
}
DEFUN_DLD( Fl_RGB_Image_draw_empty , args , , " void Fl_RGB_Image_draw_empty (int X,int Y); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   X ;
int   Y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_RGB_Image_draw_empty (int X,int Y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_draw_empty "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
Fl_RGB_Image_draw_empty ( X,Y);
return octave_value();
}
DEFUN_DLD( Fl_RGB_Image_labeltype , args , , " static Fl_RGB_Image_labeltype (Fl_Label * lo,int lx,int ly,int lw,int lh,Fl_Align la); " )
{
Fl_Image *   _Fl_ImagePtr ;
Fl_Label *   lo ;
int   lx ;
int   ly ;
int   lw ;
int   lh ;
Fl_Align   la ;
 if(args.length()!= 7 )
  {
   std::cout<< "eg:  static Fl_RGB_Image_labeltype (Fl_Label * lo,int lx,int ly,int lw,int lh,Fl_Align la); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_labeltype "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
lo =( Fl_Label * )args( 1 ).long_value();
lx = (  int  ) args( 2 ).int_value();
ly = (  int  ) args( 3 ).int_value();
lw = (  int  ) args( 4 ).int_value();
lh = (  int  ) args( 5 ).int_value();
la = (  Fl_Align  ) args( 6 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_labeltype ( lo,lx,ly,lw,lh,la);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_measure , args , , " static Fl_RGB_Image_measure (Fl_Label * lo,int &lw,int &lh); " )
{
Fl_Image *   _Fl_ImagePtr ;
Fl_Label *   lo ;
int   &lw ;
int   &lh ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  static Fl_RGB_Image_measure (Fl_Label * lo,int &lw,int &lh); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_measure "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
lo =( Fl_Label * )args( 1 ).long_value();
&lw = (  int  ) args( 2 ).int_value();
&lh = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) Fl_RGB_Image_measure ( lo,&lw,&lh);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_w , args , , " int Fl_RGB_Image_w ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_RGB_Image_w ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_w "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_w ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_h , args , , " int Fl_RGB_Image_h ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_RGB_Image_h ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_h "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_h ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_d , args , , " int Fl_RGB_Image_d ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_RGB_Image_d ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_d "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_d ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_ld , args , , " int Fl_RGB_Image_ld ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_RGB_Image_ld ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_ld "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_ld ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_count , args , , " int Fl_RGB_Image_count ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_RGB_Image_count ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_count "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_count ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_*data , args , , " char * Fl_RGB_Image_*data ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char * Fl_RGB_Image_*data ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_*data "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
string  ret_type(  (const char *) Fl_RGB_Image_*data ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_*copy , args , , " virtual Fl_RGB_Image_*copy (int W,int H); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   W ;
int   H ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_*copy (int W,int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_*copy "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
W = (  int  ) args( 1 ).int_value();
H = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) Fl_RGB_Image_*copy ( W,H);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_copy , args , , " Fl_Image * Fl_RGB_Image_copy ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Image * Fl_RGB_Image_copy ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_copy "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type= (long int) Fl_RGB_Image_copy ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_color_average , args , , " virtual Fl_RGB_Image_color_average (Fl_Color c,float i); " )
{
Fl_Image *   _Fl_ImagePtr ;
Fl_Color   c ;
float   i ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_color_average (Fl_Color c,float i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_color_average "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
c = (  Fl_Color  ) args( 1 ).long_value();
i = (  float  ) args( 2 ).double_value();
long int ret_type=(long int) Fl_RGB_Image_color_average ( c,i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_inactive , args , , " void Fl_RGB_Image_inactive ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_RGB_Image_inactive ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_inactive "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
Fl_RGB_Image_inactive ( );
return octave_value();
}
DEFUN_DLD( Fl_RGB_Image_desaturate , args , , " virtual Fl_RGB_Image_desaturate ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_desaturate ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_desaturate "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_desaturate ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_label , args , , " virtual Fl_RGB_Image_label (Fl_Widget*w ); " )
{
Fl_Image *   _Fl_ImagePtr ;
Fl_Widget*w   _Fl_Widget*w0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_label (Fl_Widget*w ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_label "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
_Fl_Widget*w0 =( Fl_Widget*w )args( 1 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_label ( _Fl_Widget*w0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_label , args , , " virtual Fl_RGB_Image_label (Fl_Menu_Item*m ); " )
{
Fl_Image *   _Fl_ImagePtr ;
Fl_Menu_Item*m   _Fl_Menu_Item*m0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_label (Fl_Menu_Item*m ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_label "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
_Fl_Menu_Item*m0 =( Fl_Menu_Item*m )args( 1 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_label ( _Fl_Menu_Item*m0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_draw , args , , " virtual Fl_RGB_Image_draw (int X,int Y,int W,int H,int cx=0,int cy=0); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   X ;
int   Y ;
int   W ;
int   H ;
int   cx=0 ;
int   cy=0 ;
 if(args.length()!= 7 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_draw (int X,int Y,int W,int H,int cx=0,int cy=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_draw "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
W = (  int  ) args( 3 ).int_value();
H = (  int  ) args( 4 ).int_value();
cx=0 = (  int  ) args( 5 ).int_value();
cy=0 = (  int  ) args( 6 ).int_value();
long int ret_type=(long int) Fl_RGB_Image_draw ( X,Y,W,H,cx=0,cy=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_draw , args , , " void Fl_RGB_Image_draw (int X,int Y); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   X ;
int   Y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_RGB_Image_draw (int X,int Y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_draw "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
Fl_RGB_Image_draw ( X,Y);
return octave_value();
}
DEFUN_DLD( Fl_RGB_Image_uncache , args , , " virtual Fl_RGB_Image_uncache ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_uncache ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_uncache "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_uncache ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_Fl_Image , args , , " Fl_Image(W,H,D Fl_RGB_Image_Fl_Image (W ,H ,D ); " )
{
Fl_Image *   _Fl_ImagePtr ;
W   _W0 ;
H   _H1 ;
D   _D2 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  Fl_Image(W,H,D Fl_RGB_Image_Fl_Image (W ,H ,D ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_Fl_Image "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
_W0 = (  W  ) args( 1 ).long_value();
_H1 = (  H  ) args( 2 ).long_value();
_D2 = (  D  ) args( 3 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_Fl_Image ( _W0,_H1,_D2);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_*copy , args , , " virtual Fl_RGB_Image_*copy (int W,int H); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   W ;
int   H ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_*copy (int W,int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_*copy "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
W = (  int  ) args( 1 ).int_value();
H = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) Fl_RGB_Image_*copy ( W,H);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_copy , args , , " Fl_Image * Fl_RGB_Image_copy ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Image * Fl_RGB_Image_copy ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_copy "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type= (long int) Fl_RGB_Image_copy ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_color_average , args , , " virtual Fl_RGB_Image_color_average (Fl_Color c,float i); " )
{
Fl_Image *   _Fl_ImagePtr ;
Fl_Color   c ;
float   i ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_color_average (Fl_Color c,float i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_color_average "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
c = (  Fl_Color  ) args( 1 ).long_value();
i = (  float  ) args( 2 ).double_value();
long int ret_type=(long int) Fl_RGB_Image_color_average ( c,i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_desaturate , args , , " virtual Fl_RGB_Image_desaturate ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_desaturate ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_desaturate "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_desaturate ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_draw , args , , " virtual Fl_RGB_Image_draw (int X,int Y,int W,int H,int cx=0,int cy=0); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   X ;
int   Y ;
int   W ;
int   H ;
int   cx=0 ;
int   cy=0 ;
 if(args.length()!= 7 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_draw (int X,int Y,int W,int H,int cx=0,int cy=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_draw "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
W = (  int  ) args( 3 ).int_value();
H = (  int  ) args( 4 ).int_value();
cx=0 = (  int  ) args( 5 ).int_value();
cy=0 = (  int  ) args( 6 ).int_value();
long int ret_type=(long int) Fl_RGB_Image_draw ( X,Y,W,H,cx=0,cy=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_draw , args , , " void Fl_RGB_Image_draw (int X,int Y); " )
{
Fl_Image *   _Fl_ImagePtr ;
int   X ;
int   Y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_RGB_Image_draw (int X,int Y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_draw "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
Fl_RGB_Image_draw ( X,Y);
return octave_value();
}
DEFUN_DLD( Fl_RGB_Image_label , args , , " virtual Fl_RGB_Image_label (Fl_Widget*w ); " )
{
Fl_Image *   _Fl_ImagePtr ;
Fl_Widget*w   _Fl_Widget*w0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_label (Fl_Widget*w ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_label "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
_Fl_Widget*w0 =( Fl_Widget*w )args( 1 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_label ( _Fl_Widget*w0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_label , args , , " virtual Fl_RGB_Image_label (Fl_Menu_Item*m ); " )
{
Fl_Image *   _Fl_ImagePtr ;
Fl_Menu_Item*m   _Fl_Menu_Item*m0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_label (Fl_Menu_Item*m ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_label "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
_Fl_Menu_Item*m0 =( Fl_Menu_Item*m )args( 1 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_label ( _Fl_Menu_Item*m0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_RGB_Image_uncache , args , , " virtual Fl_RGB_Image_uncache ( ); " )
{
Fl_Image *   _Fl_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_RGB_Image_uncache ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_RGB_Image_uncache "<<std::endl;
#endif /* DEBUG */
_Fl_ImagePtr =( Fl_Image * )args( 0 ).long_value();
long int ret_type=(long int) Fl_RGB_Image_uncache ( );
return octave_value(ret_type);
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Image , args , , " void Fl_Image(void); " )
{
octave_dynamic_loader::load("Fl_RGB_Image_operator=" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_w" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_h" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_d" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_ld" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_data" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_draw_empty" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_labeltype" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_measure" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_w" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_h" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_d" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_ld" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_count" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_*data" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_*copy" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_copy" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_color_average" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_inactive" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_desaturate" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_label" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_label" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_draw" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_draw" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_uncache" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_Fl_Image" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_*copy" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_copy" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_color_average" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_desaturate" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_draw" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_draw" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_label" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_label" ,"");
octave_dynamic_loader::load("Fl_RGB_Image_uncache" ,"");
return octave_value("Code generated onSat Jul 30 23:28:32 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_ImageLibrary!");
}
#endif /*TODO*/

/*
  Rewrite a 2 separate modules, Fl_Image, Fl_RGB_Image,
*/
