/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

#if 0
DEFUN_DLD( Fl_Input__expand , args , , " char* Fl_Input__expand (char* ,char* ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
char*   _char*0 ;
char*   _char*1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  char* Fl_Input__expand (char* ,char* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__expand "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_char*0 =( char* )args( 1 ).long_value();
_char*1 =( char* )args( 2 ).long_value();
string  ret_type(  (const char *) _Fl_Input_Ptr->expand ( _char*0,_char*1));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__expandpos , args , , " double Fl_Input__expandpos (char* ,char* ,char* ,int* ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
char*   _char*0 ;
char*   _char*1 ;
char*   _char*2 ;
int*   _int*3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  double Fl_Input__expandpos (char* ,char* ,char* ,int* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__expandpos "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_char*0 =( char* )args( 1 ).long_value();
_char*1 =( char* )args( 2 ).long_value();
_char*2 =( char* )args( 3 ).long_value();
_int*3 =( int* )args( 4 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->expandpos ( _char*0,_char*1,_char*2,_int*3);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__minimal_update , args , , " void Fl_Input__minimal_update (int ,int ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   _int0 ;
int   _int1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Input__minimal_update (int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__minimal_update "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_Fl_Input_Ptr->minimal_update ( _int0,_int1);
return octave_value();
}
DEFUN_DLD( Fl_Input__minimal_update , args , , " void Fl_Input__minimal_update (int p); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   p ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__minimal_update (int p); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__minimal_update "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
p = (  int  ) args( 1 ).int_value();
_Fl_Input_Ptr->minimal_update ( p);
return octave_value();
}
DEFUN_DLD( Fl_Input__put_in_buffer , args , , " void Fl_Input__put_in_buffer (int newsize); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   newsize ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__put_in_buffer (int newsize); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__put_in_buffer "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
newsize = (  int  ) args( 1 ).int_value();
_Fl_Input_Ptr->put_in_buffer ( newsize);
return octave_value();
}
DEFUN_DLD( Fl_Input__setfont , args , , " void Fl_Input__setfont ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Input__setfont ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__setfont "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_Fl_Input_Ptr->setfont ( );
return octave_value();
}
DEFUN_DLD( Fl_Input__word_start , args , , " int Fl_Input__word_start (int i); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__word_start (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__word_start "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->word_start ( i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__word_end , args , , " int Fl_Input__word_end (int i); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__word_end (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__word_end "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->word_end ( i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__line_start , args , , " int Fl_Input__line_start (int i); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__line_start (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__line_start "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->line_start ( i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__line_end , args , , " int Fl_Input__line_end (int i); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__line_end (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__line_end "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->line_end ( i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__drawtext , args , , " void Fl_Input__drawtext (int ,int ,int ,int ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Input__drawtext (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__drawtext "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
_Fl_Input_Ptr->drawtext ( _int0,_int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_Input__up_down_position , args , , " int Fl_Input__up_down_position (int ,int keepmark=0); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   _int0 ;
int   keepmark=0 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Input__up_down_position (int ,int keepmark=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__up_down_position "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
keepmark=0 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->up_down_position ( _int0,keepmark=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__handle_mouse , args , , " void Fl_Input__handle_mouse (int ,int ,int ,int ,int keepmark=0); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
int   keepmark=0 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_Input__handle_mouse (int ,int ,int ,int ,int keepmark=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__handle_mouse "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
keepmark=0 = (  int  ) args( 5 ).int_value();
_Fl_Input_Ptr->handle_mouse ( _int0,_int1,_int2,_int3,keepmark=0);
return octave_value();
}
DEFUN_DLD( Fl_Input__handletext , args , , " int Fl_Input__handletext (int e,int ,int ,int ,int ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   e ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  int Fl_Input__handletext (int e,int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__handletext "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
e = (  int  ) args( 1 ).int_value();
_int0 = (  int  ) args( 2 ).int_value();
_int1 = (  int  ) args( 3 ).int_value();
_int2 = (  int  ) args( 4 ).int_value();
_int3 = (  int  ) args( 5 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->handletext ( e,_int0,_int1,_int2,_int3);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__maybe_do_callback , args , , " void Fl_Input__maybe_do_callback ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Input__maybe_do_callback ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__maybe_do_callback "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_Fl_Input_Ptr->maybe_do_callback ( );
return octave_value();
}
DEFUN_DLD( Fl_Input__xscroll , args , , " int Fl_Input__xscroll ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__xscroll ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__xscroll "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->xscroll ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__yscroll , args , , " int Fl_Input__yscroll ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__yscroll ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__yscroll "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->yscroll ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__resize , args , , " void Fl_Input__resize (int ,int ,int ,int ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Input__resize (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__resize "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
_Fl_Input_Ptr->resize ( _int0,_int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_Input__value , args , , " int Fl_Input__value (char* ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
char*   _char*0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__value (char* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__value "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_char*0 =( char* )args( 1 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->value ( _char*0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__value , args , , " int Fl_Input__value (char* ,int ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
char*   _char*0 ;
int   _int1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Input__value (char* ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__value "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_char*0 =( char* )args( 1 ).long_value();
_int1 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->value ( _char*0,_int1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__static_value , args , , " int Fl_Input__static_value (char* ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
char*   _char*0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__static_value (char* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__static_value "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_char*0 =( char* )args( 1 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->static_value ( _char*0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__static_value , args , , " int Fl_Input__static_value (char* ,int ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
char*   _char*0 ;
int   _int1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Input__static_value (char* ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__static_value "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_char*0 =( char* )args( 1 ).long_value();
_int1 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->static_value ( _char*0,_int1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__value , args , , " char* Fl_Input__value ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char* Fl_Input__value ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__value "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_Input_Ptr->value ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__index , args , , " char Fl_Input__index (int i); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  char Fl_Input__index (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__index "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->index ( i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__size , args , , " int Fl_Input__size ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__size ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__size "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->size ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__size , args , , " void Fl_Input__size (int W,int H); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   W ;
int   H ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Input__size (int W,int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__size "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
W = (  int  ) args( 1 ).int_value();
H = (  int  ) args( 2 ).int_value();
_Fl_Input_Ptr->size ( W,H);
return octave_value();
}
DEFUN_DLD( Fl_Input__maximum_size , args , , " int Fl_Input__maximum_size ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__maximum_size ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__maximum_size "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->maximum_size ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__maximum_size , args , , " void Fl_Input__maximum_size (int m); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   m ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__maximum_size (int m); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__maximum_size "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
m = (  int  ) args( 1 ).int_value();
_Fl_Input_Ptr->maximum_size ( m);
return octave_value();
}
DEFUN_DLD( Fl_Input__position , args , , " int Fl_Input__position ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__position ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__position "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->position ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__mark , args , , " int Fl_Input__mark ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__mark ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__mark "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->mark ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__position , args , , " int Fl_Input__position (int p,int m); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   p ;
int   m ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Input__position (int p,int m); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__position "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
p = (  int  ) args( 1 ).int_value();
m = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->position ( p,m);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__position , args , , " int Fl_Input__position (int p); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   p ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__position (int p); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__position "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
p = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->position ( p);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__mark , args , , " int Fl_Input__mark (int m); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   m ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__mark (int m); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__mark "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
m = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->mark ( m);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__replace , args , , " int Fl_Input__replace (int ,int ,char* ,int=0 ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   _int0 ;
int   _int1 ;
char*   _char*2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  int Fl_Input__replace (int ,int ,char* ,int=0 ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__replace "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_char*2 =( char* )args( 3 ).long_value();
_int3 = (  int  ) args( 4 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->replace ( _int0,_int1,_char*2,_int3);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__cut , args , , " int Fl_Input__cut ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__cut ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__cut "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->cut ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__cut , args , , " int Fl_Input__cut (int n); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   n ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__cut (int n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__cut "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
n = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->cut ( n);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__cut , args , , " int Fl_Input__cut (int a,int b); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   a ;
int   b ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Input__cut (int a,int b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__cut "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
a = (  int  ) args( 1 ).int_value();
b = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->cut ( a,b);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__insert , args , , " int Fl_Input__insert (char* t,int l=0); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
char*   t ;
int   l=0 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Input__insert (char* t,int l=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__insert "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
t =( char* )args( 1 ).long_value();
l=0 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->insert ( t,l=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__copy , args , , " int Fl_Input__copy (int clipboard); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   clipboard ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Input__copy (int clipboard); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__copy "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
clipboard = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Input_Ptr->copy ( clipboard);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__undo , args , , " int Fl_Input__undo ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__undo ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__undo "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->undo ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__copy_cuts , args , , " int Fl_Input__copy_cuts ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__copy_cuts ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__copy_cuts "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->copy_cuts ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__textfont , args , , " Fl_Font Fl_Input__textfont ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Font Fl_Input__textfont ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__textfont "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->textfont ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__textfont , args , , " void Fl_Input__textfont (uchar s); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
uchar   s ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__textfont (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__textfont "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
s = (  uchar  ) args( 1 ).long_value();
_Fl_Input_Ptr->textfont ( s);
return octave_value();
}
DEFUN_DLD( Fl_Input__textsize , args , , " uchar Fl_Input__textsize ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  uchar Fl_Input__textsize ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__textsize "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->textsize ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__textsize , args , , " void Fl_Input__textsize (uchar s); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
uchar   s ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__textsize (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__textsize "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
s = (  uchar  ) args( 1 ).long_value();
_Fl_Input_Ptr->textsize ( s);
return octave_value();
}
DEFUN_DLD( Fl_Input__textcolor , args , , " Fl_Color Fl_Input__textcolor ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Color Fl_Input__textcolor ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->textcolor ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__textcolor , args , , " void Fl_Input__textcolor (n ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
n   _n0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__textcolor (n ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_n0 = (  n  ) args( 1 ).long_value();
_Fl_Input_Ptr->textcolor ( _n0);
return octave_value();
}
DEFUN_DLD( Fl_Input__cursor_color , args , , " Fl_Color Fl_Input__cursor_color ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Color Fl_Input__cursor_color ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__cursor_color "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->cursor_color ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__cursor_color , args , , " void Fl_Input__cursor_color (n ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
n   _n0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__cursor_color (n ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__cursor_color "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_n0 = (  n  ) args( 1 ).long_value();
_Fl_Input_Ptr->cursor_color ( _n0);
return octave_value();
}
DEFUN_DLD( Fl_Input__input_type , args , , " int Fl_Input__input_type ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__input_type ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__input_type "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->input_type ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__input_type , args , , " void Fl_Input__input_type (int t); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   t ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__input_type (int t); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__input_type "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
t = (  int  ) args( 1 ).int_value();
_Fl_Input_Ptr->input_type ( t);
return octave_value();
}
DEFUN_DLD( Fl_Input__readonly , args , , " int Fl_Input__readonly ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__readonly ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__readonly "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->readonly ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__readonly , args , , " void Fl_Input__readonly (int b); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   b ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__readonly (int b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__readonly "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
b = (  int  ) args( 1 ).int_value();
_Fl_Input_Ptr->readonly ( b);
return octave_value();
}
DEFUN_DLD( Fl_Input__type , args , , " else Fl_Input__type ((uchar ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
(uchar   _(uchar0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  else Fl_Input__type ((uchar ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__type "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_(uchar0 = (  (uchar  ) args( 1 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->type ( _(uchar0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__wrap , args , , " int Fl_Input__wrap ( ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Input__wrap ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__wrap "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->wrap ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Input__wrap , args , , " void Fl_Input__wrap (int b); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
int   b ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Input__wrap (int b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__wrap "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
b = (  int  ) args( 1 ).int_value();
_Fl_Input_Ptr->wrap ( b);
return octave_value();
}
DEFUN_DLD( Fl_Input__type , args , , " else Fl_Input__type ((uchar ); " )
{
Fl_Input_ *   _Fl_Input_Ptr ;
(uchar   _(uchar0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  else Fl_Input__type ((uchar ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Input__type "<<std::endl;
#endif /* DEBUG */
_Fl_Input_Ptr =( Fl_Input_ * )args( 0 ).long_value();
_(uchar0 = (  (uchar  ) args( 1 ).long_value();
long int ret_type=(long int) _Fl_Input_Ptr->type ( _(uchar0);
return octave_value(ret_type);
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Input_ , args , , " void Fl_Input_(void); " )
{
octave_dynamic_loader::load("Fl_Input__expand" ,"");
octave_dynamic_loader::load("Fl_Input__expandpos" ,"");
octave_dynamic_loader::load("Fl_Input__minimal_update" ,"");
octave_dynamic_loader::load("Fl_Input__minimal_update" ,"");
octave_dynamic_loader::load("Fl_Input__put_in_buffer" ,"");
octave_dynamic_loader::load("Fl_Input__setfont" ,"");
octave_dynamic_loader::load("Fl_Input__word_start" ,"");
octave_dynamic_loader::load("Fl_Input__word_end" ,"");
octave_dynamic_loader::load("Fl_Input__line_start" ,"");
octave_dynamic_loader::load("Fl_Input__line_end" ,"");
octave_dynamic_loader::load("Fl_Input__drawtext" ,"");
octave_dynamic_loader::load("Fl_Input__up_down_position" ,"");
octave_dynamic_loader::load("Fl_Input__handle_mouse" ,"");
octave_dynamic_loader::load("Fl_Input__handletext" ,"");
octave_dynamic_loader::load("Fl_Input__maybe_do_callback" ,"");
octave_dynamic_loader::load("Fl_Input__xscroll" ,"");
octave_dynamic_loader::load("Fl_Input__yscroll" ,"");
octave_dynamic_loader::load("Fl_Input__resize" ,"");
octave_dynamic_loader::load("Fl_Input__value" ,"");
octave_dynamic_loader::load("Fl_Input__value" ,"");
octave_dynamic_loader::load("Fl_Input__static_value" ,"");
octave_dynamic_loader::load("Fl_Input__static_value" ,"");
octave_dynamic_loader::load("Fl_Input__value" ,"");
octave_dynamic_loader::load("Fl_Input__index" ,"");
octave_dynamic_loader::load("Fl_Input__size" ,"");
octave_dynamic_loader::load("Fl_Input__size" ,"");
octave_dynamic_loader::load("Fl_Input__maximum_size" ,"");
octave_dynamic_loader::load("Fl_Input__maximum_size" ,"");
octave_dynamic_loader::load("Fl_Input__position" ,"");
octave_dynamic_loader::load("Fl_Input__mark" ,"");
octave_dynamic_loader::load("Fl_Input__position" ,"");
octave_dynamic_loader::load("Fl_Input__position" ,"");
octave_dynamic_loader::load("Fl_Input__mark" ,"");
octave_dynamic_loader::load("Fl_Input__replace" ,"");
octave_dynamic_loader::load("Fl_Input__cut" ,"");
octave_dynamic_loader::load("Fl_Input__cut" ,"");
octave_dynamic_loader::load("Fl_Input__cut" ,"");
octave_dynamic_loader::load("Fl_Input__insert" ,"");
octave_dynamic_loader::load("Fl_Input__copy" ,"");
octave_dynamic_loader::load("Fl_Input__undo" ,"");
octave_dynamic_loader::load("Fl_Input__copy_cuts" ,"");
octave_dynamic_loader::load("Fl_Input__textfont" ,"");
octave_dynamic_loader::load("Fl_Input__textfont" ,"");
octave_dynamic_loader::load("Fl_Input__textsize" ,"");
octave_dynamic_loader::load("Fl_Input__textsize" ,"");
octave_dynamic_loader::load("Fl_Input__textcolor" ,"");
octave_dynamic_loader::load("Fl_Input__textcolor" ,"");
octave_dynamic_loader::load("Fl_Input__cursor_color" ,"");
octave_dynamic_loader::load("Fl_Input__cursor_color" ,"");
octave_dynamic_loader::load("Fl_Input__input_type" ,"");
octave_dynamic_loader::load("Fl_Input__input_type" ,"");
octave_dynamic_loader::load("Fl_Input__readonly" ,"");
octave_dynamic_loader::load("Fl_Input__readonly" ,"");
octave_dynamic_loader::load("Fl_Input__type" ,"");
octave_dynamic_loader::load("Fl_Input__wrap" ,"");
octave_dynamic_loader::load("Fl_Input__wrap" ,"");
octave_dynamic_loader::load("Fl_Input__type" ,"");
return octave_value("Code generated onSat Jul 30 23:28:32 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Input_Library!");
}
#endif /* 0 */
/*
  Low priority module , workup later.
*/
