/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

#if 0

DEFUN_DLD( Fl_Menu__item_pathname , args , , " int Fl_Menu__item_pathname (char * name,int namelen,Fl_Menu_Item * finditem=0); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
char *   name ;
int   namelen ;
Fl_Menu_Item *   finditem=0 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Menu__item_pathname (char * name,int namelen,Fl_Menu_Item * finditem=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__item_pathname "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
name = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) name ,args( 1 ).string_value().c_str());
namelen = (  int  ) args( 2 ).int_value();
finditem=0 =( Fl_Menu_Item * )args( 3 ).long_value();
long int ret_type=(long int) _Fl_Menu_Ptr->item_pathname ( name,namelen,finditem=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__picked , args , , " Fl_Menu_Item* Fl_Menu__picked (Fl_Menu_Item* ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
Fl_Menu_Item*   _Fl_Menu_Item*0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  Fl_Menu_Item* Fl_Menu__picked (Fl_Menu_Item* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__picked "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_Fl_Menu_Item*0 =( Fl_Menu_Item* )args( 1 ).long_value();
long int ret_type= (long int) _Fl_Menu_Ptr->picked ( _Fl_Menu_Item*0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__find_item , args , , " Fl_Menu_Item* Fl_Menu__find_item (char * name); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
char *   name ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  Fl_Menu_Item* Fl_Menu__find_item (char * name); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__find_item "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
name = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) name ,args( 1 ).string_value().c_str());
long int ret_type= (long int) _Fl_Menu_Ptr->find_item ( name);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__test_shortcut , args , , " Fl_Menu_Item* Fl_Menu__test_shortcut ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Menu_Item* Fl_Menu__test_shortcut ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__test_shortcut "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type= (long int) _Fl_Menu_Ptr->test_shortcut ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__global , args , , " void Fl_Menu__global ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Menu__global ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__global "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_Fl_Menu_Ptr->global ( );
return octave_value();
}
DEFUN_DLD( Fl_Menu__menu , args , , " Fl_Menu_Item * Fl_Menu__menu ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Menu_Item * Fl_Menu__menu ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__menu "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type= (long int) _Fl_Menu_Ptr->menu ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__menu , args , , " void Fl_Menu__menu (Fl_Menu_Item * m); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
Fl_Menu_Item *   m ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Menu__menu (Fl_Menu_Item * m); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__menu "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
m =( Fl_Menu_Item * )args( 1 ).long_value();
_Fl_Menu_Ptr->menu ( m);
return octave_value();
}
DEFUN_DLD( Fl_Menu__copy , args , , " void Fl_Menu__copy (Fl_Menu_Item * m,void* user_data = 0); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
Fl_Menu_Item *   m ;
void*   user_data = 0 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Menu__copy (Fl_Menu_Item * m,void* user_data = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__copy "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
m =( Fl_Menu_Item * )args( 1 ).long_value();
user_data = 0 =( void* )args( 2 ).long_value();
_Fl_Menu_Ptr->copy ( m,user_data = 0);
return octave_value();
}
DEFUN_DLD( Fl_Menu__add , args , , " int Fl_Menu__add (char* ,int shortcut,Fl_Callback* ,void* = 0,int = 0); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
char*   _char*0 ;
int   shortcut ;
Fl_Callback*   _Fl_Callback*1 ;
void*   = 0 ;
int   = 0 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  int Fl_Menu__add (char* ,int shortcut,Fl_Callback* ,void* = 0,int = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__add "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_char*0 =( char* )args( 1 ).long_value();
shortcut = (  int  ) args( 2 ).int_value();
_Fl_Callback*1 =( Fl_Callback* )args( 3 ).long_value();
= 0 =( void* )args( 4 ).long_value();
= 0 = (  int  ) args( 5 ).int_value();
long int ret_type=(long int) _Fl_Menu_Ptr->add ( _char*0,shortcut,_Fl_Callback*1,= 0,= 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__size , args , , " int Fl_Menu__size ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Menu__size ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__size "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Menu_Ptr->size ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__size , args , , " void Fl_Menu__size (int W,int H); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
int   W ;
int   H ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Menu__size (int W,int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__size "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
W = (  int  ) args( 1 ).int_value();
H = (  int  ) args( 2 ).int_value();
_Fl_Menu_Ptr->size ( W,H);
return octave_value();
}
DEFUN_DLD( Fl_Menu__clear , args , , " void Fl_Menu__clear ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Menu__clear ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__clear "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_Fl_Menu_Ptr->clear ( );
return octave_value();
}
DEFUN_DLD( Fl_Menu__add , args , , " int Fl_Menu__add (char * ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
char *   _char0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Menu__add (char * ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__add "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_char0 = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) _char0 ,args( 1 ).string_value().c_str());
long int ret_type=(long int) _Fl_Menu_Ptr->add ( _char0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__replace , args , , " void Fl_Menu__replace (int ,char * ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
int   _int0 ;
char *   _char1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Menu__replace (int ,char * ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__replace "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_char1 = new  char   [args( 2 ).string_value ().length()];
strcpy( (char *) _char1 ,args( 2 ).string_value().c_str());
_Fl_Menu_Ptr->replace ( _int0,_char1);
return octave_value();
}
DEFUN_DLD( Fl_Menu__remove , args , , " void Fl_Menu__remove (int ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Menu__remove (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__remove "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_Fl_Menu_Ptr->remove ( _int0);
return octave_value();
}
DEFUN_DLD( Fl_Menu__shortcut , args , , " void Fl_Menu__shortcut (int i,int s); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
int   i ;
int   s ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Menu__shortcut (int i,int s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__shortcut "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
s = (  int  ) args( 2 ).int_value();
_Fl_Menu_Ptr->shortcut ( i,s);
return octave_value();
}
DEFUN_DLD( Fl_Menu__mode , args , , " void Fl_Menu__mode (int i,int fl); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
int   i ;
int   fl ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Menu__mode (int i,int fl); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__mode "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
fl = (  int  ) args( 2 ).int_value();
_Fl_Menu_Ptr->mode ( i,fl);
return octave_value();
}
DEFUN_DLD( Fl_Menu__mode , args , , " int Fl_Menu__mode (int i); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
int   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Menu__mode (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__mode "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Menu_Ptr->mode ( i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__mvalue , args , , " Fl_Menu_Item * Fl_Menu__mvalue ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Menu_Item * Fl_Menu__mvalue ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__mvalue "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type= (long int) _Fl_Menu_Ptr->mvalue ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__value , args , , " int Fl_Menu__value ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Menu__value ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__value "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Menu_Ptr->value ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__value , args , , " int Fl_Menu__value (Fl_Menu_Item* ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
Fl_Menu_Item*   _Fl_Menu_Item*0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Menu__value (Fl_Menu_Item* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__value "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_Fl_Menu_Item*0 =( Fl_Menu_Item* )args( 1 ).long_value();
long int ret_type=(long int) _Fl_Menu_Ptr->value ( _Fl_Menu_Item*0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__value , args , , " int Fl_Menu__value (int i); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
int   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Menu__value (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__value "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Menu_Ptr->value ( i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__text , args , , " char * Fl_Menu__text ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char * Fl_Menu__text ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__text "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_Menu_Ptr->text ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__text , args , , " char * Fl_Menu__text (int i); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
int   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  char * Fl_Menu__text (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__text "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
string  ret_type(  (const char *) _Fl_Menu_Ptr->text ( i));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__textfont , args , , " Fl_Font Fl_Menu__textfont ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Font Fl_Menu__textfont ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__textfont "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Menu_Ptr->textfont ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__textfont , args , , " void Fl_Menu__textfont (uchar c); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
uchar   c ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Menu__textfont (uchar c); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__textfont "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
c = (  uchar  ) args( 1 ).long_value();
_Fl_Menu_Ptr->textfont ( c);
return octave_value();
}
DEFUN_DLD( Fl_Menu__textsize , args , , " uchar Fl_Menu__textsize ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  uchar Fl_Menu__textsize ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__textsize "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Menu_Ptr->textsize ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__textsize , args , , " void Fl_Menu__textsize (uchar c); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
uchar   c ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Menu__textsize (uchar c); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__textsize "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
c = (  uchar  ) args( 1 ).long_value();
_Fl_Menu_Ptr->textsize ( c);
return octave_value();
}
DEFUN_DLD( Fl_Menu__textcolor , args , , " Fl_Color Fl_Menu__textcolor ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Color Fl_Menu__textcolor ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Menu_Ptr->textcolor ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__textcolor , args , , " void Fl_Menu__textcolor (c ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
c   _c0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Menu__textcolor (c ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_c0 = (  c  ) args( 1 ).long_value();
_Fl_Menu_Ptr->textcolor ( _c0);
return octave_value();
}
DEFUN_DLD( Fl_Menu__down_box , args , , " Fl_Boxtype Fl_Menu__down_box ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Boxtype Fl_Menu__down_box ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__down_box "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Menu_Ptr->down_box ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__down_box , args , , " void Fl_Menu__down_box (Fl_Boxtype b); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
Fl_Boxtype   b ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Menu__down_box (Fl_Boxtype b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__down_box "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
b = (  Fl_Boxtype  ) args( 1 ).long_value();
_Fl_Menu_Ptr->down_box ( b);
return octave_value();
}
DEFUN_DLD( Fl_Menu__down_color , args , , " Fl_Color Fl_Menu__down_color ( ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Color Fl_Menu__down_color ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__down_color "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Menu_Ptr->down_color ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu__down_color , args , , " void Fl_Menu__down_color (c ); " )
{
Fl_Menu_ *   _Fl_Menu_Ptr ;
c   _c0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Menu__down_color (c ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu__down_color "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_Ptr =( Fl_Menu_ * )args( 0 ).long_value();
_c0 = (  c  ) args( 1 ).long_value();
_Fl_Menu_Ptr->down_color ( _c0);
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Menu_ , args , , " void Fl_Menu_(void); " )
{
octave_dynamic_loader::load("Fl_Menu__item_pathname" ,"");
octave_dynamic_loader::load("Fl_Menu__picked" ,"");
octave_dynamic_loader::load("Fl_Menu__find_item" ,"");
octave_dynamic_loader::load("Fl_Menu__test_shortcut" ,"");
octave_dynamic_loader::load("Fl_Menu__global" ,"");
octave_dynamic_loader::load("Fl_Menu__menu" ,"");
octave_dynamic_loader::load("Fl_Menu__menu" ,"");
octave_dynamic_loader::load("Fl_Menu__copy" ,"");
octave_dynamic_loader::load("Fl_Menu__add" ,"");
octave_dynamic_loader::load("Fl_Menu__size" ,"");
octave_dynamic_loader::load("Fl_Menu__size" ,"");
octave_dynamic_loader::load("Fl_Menu__clear" ,"");
octave_dynamic_loader::load("Fl_Menu__add" ,"");
octave_dynamic_loader::load("Fl_Menu__replace" ,"");
octave_dynamic_loader::load("Fl_Menu__remove" ,"");
octave_dynamic_loader::load("Fl_Menu__shortcut" ,"");
octave_dynamic_loader::load("Fl_Menu__mode" ,"");
octave_dynamic_loader::load("Fl_Menu__mode" ,"");
octave_dynamic_loader::load("Fl_Menu__mvalue" ,"");
octave_dynamic_loader::load("Fl_Menu__value" ,"");
octave_dynamic_loader::load("Fl_Menu__value" ,"");
octave_dynamic_loader::load("Fl_Menu__value" ,"");
octave_dynamic_loader::load("Fl_Menu__text" ,"");
octave_dynamic_loader::load("Fl_Menu__text" ,"");
octave_dynamic_loader::load("Fl_Menu__textfont" ,"");
octave_dynamic_loader::load("Fl_Menu__textfont" ,"");
octave_dynamic_loader::load("Fl_Menu__textsize" ,"");
octave_dynamic_loader::load("Fl_Menu__textsize" ,"");
octave_dynamic_loader::load("Fl_Menu__textcolor" ,"");
octave_dynamic_loader::load("Fl_Menu__textcolor" ,"");
octave_dynamic_loader::load("Fl_Menu__down_box" ,"");
octave_dynamic_loader::load("Fl_Menu__down_box" ,"");
octave_dynamic_loader::load("Fl_Menu__down_color" ,"");
octave_dynamic_loader::load("Fl_Menu__down_color" ,"");

 std::cout<< "Code generated onSat Jul 30 23:28:33 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Menu_Library!\n";
 return octave_value(new FLTKWrapper(0,"Fl_Menu_"));
}
#endif /* 0 */
/* Ignored ATM, Low Priority*/
