/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_Menu_Window_show , args , , " void Fl_Menu_Window_show ( ); " )
{
Fl_Menu_Window *   _Fl_Menu_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Menu_Window_show ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu_Window_show "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_WindowPtr =( Fl_Menu_Window * )args( 0 ).long_value();
_Fl_Menu_WindowPtr->show ( );
return octave_value();
}
DEFUN_DLD( Fl_Menu_Window_erase , args , , " void Fl_Menu_Window_erase ( ); " )
{
Fl_Menu_Window *   _Fl_Menu_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Menu_Window_erase ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu_Window_erase "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_WindowPtr =( Fl_Menu_Window * )args( 0 ).long_value();
_Fl_Menu_WindowPtr->erase ( );
return octave_value();
}
DEFUN_DLD( Fl_Menu_Window_flush , args , , " void Fl_Menu_Window_flush ( ); " )
{
Fl_Menu_Window *   _Fl_Menu_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Menu_Window_flush ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu_Window_flush "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_WindowPtr =( Fl_Menu_Window * )args( 0 ).long_value();
_Fl_Menu_WindowPtr->flush ( );
return octave_value();
}
DEFUN_DLD( Fl_Menu_Window_hide , args , , " void Fl_Menu_Window_hide ( ); " )
{
Fl_Menu_Window *   _Fl_Menu_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Menu_Window_hide ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu_Window_hide "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_WindowPtr =( Fl_Menu_Window * )args( 0 ).long_value();
_Fl_Menu_WindowPtr->hide ( );
return octave_value();
}
DEFUN_DLD( Fl_Menu_Window_overlay , args , , " int Fl_Menu_Window_overlay ( ); " )
{
Fl_Menu_Window *   _Fl_Menu_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Menu_Window_overlay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu_Window_overlay "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_WindowPtr =( Fl_Menu_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Menu_WindowPtr->overlay ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Menu_Window_set_overlay , args , , " void Fl_Menu_Window_set_overlay ( ); " )
{
Fl_Menu_Window *   _Fl_Menu_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Menu_Window_set_overlay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu_Window_set_overlay "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_WindowPtr =( Fl_Menu_Window * )args( 0 ).long_value();
_Fl_Menu_WindowPtr->set_overlay ( );
return octave_value();
}
DEFUN_DLD( Fl_Menu_Window_clear_overlay , args , , " void Fl_Menu_Window_clear_overlay ( ); " )
{
Fl_Menu_Window *   _Fl_Menu_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Menu_Window_clear_overlay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Menu_Window_clear_overlay "<<std::endl;
#endif /* DEBUG */
_Fl_Menu_WindowPtr =( Fl_Menu_Window * )args( 0 ).long_value();
_Fl_Menu_WindowPtr->clear_overlay ( );
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Menu_Window , args , , " void Fl_Menu_Window(void); " )
{
  if (args.length() >= 2 && args.length() <= 5 )
    {
      char *str=NULL;     
      switch(args.length())
	{
	case 3:
	  str=strdup(args(2).string_value().c_str());
	  break;
	case 2:
	  str=NULL;
	  break;
	case 4:
	  str=NULL;
	  break;
	case 5:
	  str=strdup(args(4).string_value().c_str());
	  break;
	}

      Fl_Menu_Window *flb=NULL;
      if(args.length()>=4)
	{
	  flb=new Fl_Menu_Window(args(0).int_value(),
                             args(1).int_value(),
			     args(2).int_value(),
                             args(3).int_value(),str);
	}
      else
	{
	  flb=new  Fl_Menu_Window(args(0).int_value(),
				  args(1).int_value(),
				  str);
	}
      return octave_value(new FLTKWrapper(flb,"Fl_Menu_Window"));
    }

  octave_dynamic_loader::load("Fl_Menu_Window_show" ,"");
  octave_dynamic_loader::load("Fl_Menu_Window_erase" ,"");
  octave_dynamic_loader::load("Fl_Menu_Window_flush" ,"");
  octave_dynamic_loader::load("Fl_Menu_Window_hide" ,"");
  octave_dynamic_loader::load("Fl_Menu_Window_overlay" ,"");
  octave_dynamic_loader::load("Fl_Menu_Window_set_overlay" ,"");
  octave_dynamic_loader::load("Fl_Menu_Window_clear_overlay" ,"");

  std::cout<<"Code generated onMon Aug  1 18:05:46 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Menu_WindowLibrary!"<<std::endl; 
  return octave_value(new FLTKStaticWrapper(0,"Fl_Menu_Window"));
}
