/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_Pack_draw , args , , " void Fl_Pack_draw ( ); " )
{
Fl_Pack *   _Fl_PackPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Pack_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Pack_draw "<<std::endl;
#endif /* DEBUG */
_Fl_PackPtr =( Fl_Pack * )args( 0 ).long_value();
_Fl_PackPtr->draw ( );
return octave_value();
}

DEFUN_DLD( Fl_Pack_spacing , args , , " void Fl_Pack_spacing (int i); " )
{
Fl_Pack *   _Fl_PackPtr ;
int   i ;
 if(args.length()!= 2 || args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Pack_spacing (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Pack_spacing "<<std::endl;
#endif /* DEBUG */
_Fl_PackPtr =( Fl_Pack * )args( 0 ).long_value();

 if(args.length()!= 1 )
   {
     i = (  int  ) args( 1 ).int_value();
     _Fl_PackPtr->spacing ( i);
     return octave_value();
   }
 
 long int ret_type=(long int) _Fl_PackPtr->spacing ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Pack_horizontal , args , , " uchar Fl_Pack_horizontal ( ); " )
{
  Fl_Pack *   _Fl_PackPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  uchar Fl_Pack_horizontal ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Pack_horizontal "<<std::endl;
#endif /* DEBUG */
  _Fl_PackPtr =( Fl_Pack * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_PackPtr->horizontal ( );
  return octave_value(ret_type);
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Pack , args , , " void Fl_Pack(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      Fl_Pack *flb=new Fl_Pack(args(0).int_value(),
                             args(1).int_value(),
			     args(2).int_value(),
                             args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Pack"));
    }
  octave_dynamic_loader::load("Fl_Pack_draw" ,"");
  octave_dynamic_loader::load("Fl_Pack_spacing" ,"");
  octave_dynamic_loader::load("Fl_Pack_horizontal" ,"");
  std::cout<<"Code generated onMon Aug  1 16:59:46 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_PackLibrary!"<<std::endl;

return octave_value(new FLTKStaticWrapper(0,"Fl_Pack"));
}
