/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Positioner_handle , args , , " int Fl_Positioner_handle (int ); " )
{
Fl_Positioner *   _Fl_PositionerPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Positioner_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Positioner_handle "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_PositionerPtr->handle ( _int0);
return octave_value(ret_type);
}

DEFUN_DLD( Fl_Positioner_yvalue , args , , " double Fl_Positioner_yvalue ( ); " )
{
Fl_Positioner *   _Fl_PositionerPtr ;
 if(args.length()!= 1  || args.length()!= 2)
  {
std::cout<< "eg:  double Fl_Positioner_yvalue ( ); " <<std::endl;
return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Positioner_yvalue "<<std::endl;
#endif /* DEBUG */
 _Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
 if(args.length()==1)
   {     
     return octave_value(_Fl_PositionerPtr->yvalue ());
   }
 return octave_value( _Fl_PositionerPtr->yvalue (args(1).long_value()));
}
DEFUN_DLD( Fl_Positioner_xvalue , args , , " int Fl_Positioner_xvalue (double ); " )
{
Fl_Positioner *   _Fl_PositionerPtr ;
double   _double0 ;
 if(args.length()!= 2 || args.length()!=1)
   {
     std::cout<< "eg:  int Fl_Positioner_xvalue (double ); " <<std::endl;
     return octave_value(-1);
   }

#ifdef DEBUG
std::cout<<" Fl_Positioner_xvalue "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
_double0 = (  double  ) args( 1 ).double_value();
long int ret_type=(long int) _Fl_PositionerPtr->xvalue ( _double0);
return octave_value(ret_type);
}



DEFUN_DLD( Fl_Positioner_value , args , , " int Fl_Positioner_value (double ,double ); " )
{
Fl_Positioner *   _Fl_PositionerPtr ;
double   _double0 ;
double   _double1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Positioner_value (double ,double ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Positioner_value "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
 long int ret_type=0;
 _double0 = (  double  ) args( 1 ).double_value();
 _double1 = (  double  ) args( 2 ).double_value();
 ret_type=_Fl_PositionerPtr->value ( _double0,_double1);
 return octave_value(ret_type);
}
DEFUN_DLD( Fl_Positioner_xbounds , args , , " void Fl_Positioner_xbounds (double ,double ); " )
{
Fl_Positioner *   _Fl_PositionerPtr ;
double   _double0 ;
double   _double1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Positioner_xbounds (double ,double ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Positioner_xbounds "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
_double0 = (  double  ) args( 1 ).double_value();
_double1 = (  double  ) args( 2 ).double_value();
_Fl_PositionerPtr->xbounds ( _double0,_double1);
return octave_value();
}

DEFUN_DLD( Fl_Positioner_xminimum , args , , " void Fl_Positioner_xminimum (double a); " )
{
  Fl_Positioner *   _Fl_PositionerPtr ;
  double   a ;
  if(args.length()!= 2 || args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Positioner_xminimum (double a); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
std::cout<<" Fl_Positioner_xminimum "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
 if(args.length()!= 1 )
   {
     a = (  double  ) args( 1 ).double_value();
     _Fl_PositionerPtr->xminimum ( a);
     return octave_value();
   }

 long int ret_type=(long int) _Fl_PositionerPtr->xminimum ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Positioner_xmaximum , args , , " void Fl_Positioner_xmaximum (double a); " )
{
  Fl_Positioner *   _Fl_PositionerPtr ;
  double   a ;
  if(args.length()!= 2 || args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Positioner_xmaximum (double a); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
std::cout<<" Fl_Positioner_xmaximum "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
 if(args.length()!= 1 )
   {
     a = (  double  ) args( 1 ).double_value();
     _Fl_PositionerPtr->xmaximum ( a);
     return octave_value();
   }

 long int ret_type=(long int) _Fl_PositionerPtr->xmaximum ( );
 return octave_value(ret_type);
}


DEFUN_DLD( Fl_Positioner_yminimum , args , , " void Fl_Positioner_yminimum (double a); " )
{
  Fl_Positioner *   _Fl_PositionerPtr ;
  double   a ;
  if(args.length()!= 2 || args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Positioner_yminimum (double a); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
std::cout<<" Fl_Positioner_yminimum "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
 if(args.length()!= 1 )
   {
     a = (  double  ) args( 1 ).double_value();
     _Fl_PositionerPtr->yminimum ( a);
     return octave_value();
   }

 long int ret_type=(long int) _Fl_PositionerPtr->yminimum ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Positioner_ymaximum , args , , " void Fl_Positioner_ymaximum (double a); " )
{
  Fl_Positioner *   _Fl_PositionerPtr ;
  double   a ;
  if(args.length()!= 2 || args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Positioner_ymaximum (double a); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
std::cout<<" Fl_Positioner_ymaximum "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
 if(args.length()!= 1 )
   {
     a = (  double  ) args( 1 ).double_value();
     _Fl_PositionerPtr->ymaximum ( a);
     return octave_value();
   }

 long int ret_type=(long int) _Fl_PositionerPtr->ymaximum ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Positioner_ybounds , args , , " void Fl_Positioner_ybounds (double ,double ); " )
{
Fl_Positioner *   _Fl_PositionerPtr ;
double   _double0 ;
double   _double1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Positioner_ybounds (double ,double ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Positioner_ybounds "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
_double0 = (  double  ) args( 1 ).double_value();
_double1 = (  double  ) args( 2 ).double_value();
_Fl_PositionerPtr->ybounds ( _double0,_double1);
return octave_value();
}


DEFUN_DLD( Fl_Positioner_xstep , args , , " void Fl_Positioner_xstep (double a); " )
{
Fl_Positioner *   _Fl_PositionerPtr ;
double   a ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Positioner_xstep (double a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Positioner_xstep "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
a = (  double  ) args( 1 ).double_value();
_Fl_PositionerPtr->xstep ( a);
return octave_value();
}
DEFUN_DLD( Fl_Positioner_ystep , args , , " void Fl_Positioner_ystep (double a); " )
{
Fl_Positioner *   _Fl_PositionerPtr ;
double   a ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Positioner_ystep (double a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Positioner_ystep "<<std::endl;
#endif /* DEBUG */
_Fl_PositionerPtr =( Fl_Positioner * )args( 0 ).long_value();
a = (  double  ) args( 1 ).double_value();
_Fl_PositionerPtr->ystep ( a);
return octave_value();
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Positioner , args , , " void Fl_Positioner(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      Fl_Positioner *flb=new Fl_Positioner(args(0).int_value(),
                             args(1).int_value(),
			     args(2).int_value(),
                             args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Positioner"));
    }
  octave_dynamic_loader::load("Fl_Positioner_handle" ,"");
  octave_dynamic_loader::load("Fl_Positioner_xvalue" ,"");
  octave_dynamic_loader::load("Fl_Positioner_yvalue" ,"");
  octave_dynamic_loader::load("Fl_Positioner_value" ,"");
  octave_dynamic_loader::load("Fl_Positioner_xbounds" ,"");
  octave_dynamic_loader::load("Fl_Positioner_xminimum" ,"");
  octave_dynamic_loader::load("Fl_Positioner_xmaximum" ,"");
  octave_dynamic_loader::load("Fl_Positioner_ybounds" ,"");
  octave_dynamic_loader::load("Fl_Positioner_yminimum" ,"");
  octave_dynamic_loader::load("Fl_Positioner_ymaximum" ,"");
  octave_dynamic_loader::load("Fl_Positioner_xstep" ,"");
  octave_dynamic_loader::load("Fl_Positioner_ystep" ,"");
  
  std::cout<<"Code generated onMon Aug  1 17:08:37 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_PositionerLibrary!"<<std::endl;
  
  return octave_value(new FLTKStaticWrapper(0,"Fl_Positioner"));
}
