/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Progress_maximum , args , , " void Fl_Progress_maximum (float v); " )
{
Fl_Progress *   _Fl_ProgressPtr ;
float   v ;
 if(args.length()!= 2 || args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Progress_maximum (float v); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Progress_maximum "<<std::endl;
#endif /* DEBUG */

 if (args.length()==1)
   {
     long int ret_type=(long int) _Fl_ProgressPtr->maximum ( );
     return octave_value(ret_type);
   }
_Fl_ProgressPtr =( Fl_Progress * )args( 0 ).long_value();
v = (  float  ) args( 1 ).double_value();
_Fl_ProgressPtr->maximum ( v);
return octave_value();
}
DEFUN_DLD( Fl_Progress_minimum , args , , " void Fl_Progress_minimum (float v); " )
{
Fl_Progress *   _Fl_ProgressPtr ;
float   v ;
 if(args.length()!= 2 || args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Progress_minimum (float v); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Progress_minimum "<<std::endl;
#endif /* DEBUG */
_Fl_ProgressPtr =( Fl_Progress * )args( 0 ).long_value();

 if(args.length()==1)
   {
     long int ret_type=(long int) _Fl_ProgressPtr->minimum ( );
     return octave_value(ret_type);
   }
 
 v = (  float  ) args( 1 ).double_value();
 _Fl_ProgressPtr->minimum ( v);
 return octave_value();
}
DEFUN_DLD( Fl_Progress_value , args , , " void Fl_Progress_value (float v); " )
{
Fl_Progress *   _Fl_ProgressPtr ;
float   v ;
 if(args.length()!= 2 || args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Progress_value (float v); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Progress_value "<<std::endl;
#endif /* DEBUG */
_Fl_ProgressPtr =( Fl_Progress * )args( 0 ).long_value();
 if(args.length()==1)
   {
     long int ret_type=(long int) _Fl_ProgressPtr->value ( );
     return octave_value(ret_type);
   }
 
v = (  float  ) args( 1 ).double_value();
_Fl_ProgressPtr->value ( v);
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Progress , args , , " void Fl_Progress(void); " )
{

  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      Fl_Progress *flb=new Fl_Progress(args(0).int_value(),args(1).int_value(),
				       args(2).int_value(),args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Progress"));
    }

  octave_dynamic_loader::load("Fl_Progress_maximum" ,"");
  octave_dynamic_loader::load("Fl_Progress_minimum" ,"");
  octave_dynamic_loader::load("Fl_Progress_value" ,"");
  std::cout<<"Code generated onSun Jul 31 16:20:21 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_ProgressLibrary!"<<std::endl;
  return octave_value(new FLTKStaticWrapper(0,"Fl_Progress"));
}
