/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Roller_handle , args , , " int Fl_Roller_handle (int ); " )
{
  Fl_Roller *   _Fl_RollerPtr ;
  int   _int0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  int Fl_Roller_handle (int ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Roller_handle "<<std::endl;
#endif /* DEBUG */
  _Fl_RollerPtr =( Fl_Roller * )args( 0 ).long_value();
  _int0 = (  int  ) args( 1 ).int_value();
  long int ret_type=(long int) _Fl_RollerPtr->handle ( _int0);
  return octave_value(ret_type);
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Roller , args , , " void Fl_Roller(void); " )
{
    if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;
      if(args.length()==5)
        str=strdup(args(4).string_value().c_str());
      Fl_Roller *flb=new Fl_Roller(args(0).int_value(),args(1).int_value(),
				   args(2).int_value(),args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Roller"));
    }

  
  octave_dynamic_loader::load("Fl_Roller_handle" ,"");

  std::cout<<"Code generated onSat Jul 30 23:28:34 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_RollerLibrary!"<<std::endl;

  return octave_value();
}
