/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

#if 0
DEFUN_DLD( Fl_Scrollbar_timeout_cb , args , , " static Fl_Scrollbar_timeout_cb (void* ); " )
{
Fl_Scrollbar *   _Fl_ScrollbarPtr ;
void*   _void0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_Scrollbar_timeout_cb (void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Scrollbar_timeout_cb "<<std::endl;
#endif /* DEBUG */
_Fl_ScrollbarPtr =( Fl_Scrollbar * )args( 0 ).long_value();
_void0 =( void* )args( 1 ).long_value();
long int ret_type=(long int) _Fl_ScrollbarPtr->timeout_cb ( _void0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Scrollbar_increment_cb , args , , " void Fl_Scrollbar_increment_cb ( ); " )
{
Fl_Scrollbar *   _Fl_ScrollbarPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Scrollbar_increment_cb ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Scrollbar_increment_cb "<<std::endl;
#endif /* DEBUG */
_Fl_ScrollbarPtr =( Fl_Scrollbar * )args( 0 ).long_value();
_Fl_ScrollbarPtr->increment_cb ( );
return octave_value();
}
DEFUN_DLD( Fl_Scrollbar_draw , args , , " void Fl_Scrollbar_draw ( ); " )
{
Fl_Scrollbar *   _Fl_ScrollbarPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Scrollbar_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Scrollbar_draw "<<std::endl;
#endif /* DEBUG */
_Fl_ScrollbarPtr =( Fl_Scrollbar * )args( 0 ).long_value();
_Fl_ScrollbarPtr->draw ( );
return octave_value();
}
DEFUN_DLD( Fl_Scrollbar_handle , args , , " int Fl_Scrollbar_handle (int ); " )
{
Fl_Scrollbar *   _Fl_ScrollbarPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Scrollbar_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Scrollbar_handle "<<std::endl;
#endif /* DEBUG */
_Fl_ScrollbarPtr =( Fl_Scrollbar * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_ScrollbarPtr->handle ( _int0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Scrollbar_value , args , , " int Fl_Scrollbar_value ( ); " )
{
Fl_Scrollbar *   _Fl_ScrollbarPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Scrollbar_value ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Scrollbar_value "<<std::endl;
#endif /* DEBUG */
_Fl_ScrollbarPtr =( Fl_Scrollbar * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_ScrollbarPtr->value ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Scrollbar_value , args , , " int Fl_Scrollbar_value (int p,int s,int top,int total); " )
{
Fl_Scrollbar *   _Fl_ScrollbarPtr ;
int   p ;
int   s ;
int   top ;
int   total ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  int Fl_Scrollbar_value (int p,int s,int top,int total); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Scrollbar_value "<<std::endl;
#endif /* DEBUG */
_Fl_ScrollbarPtr =( Fl_Scrollbar * )args( 0 ).long_value();
p = (  int  ) args( 1 ).int_value();
s = (  int  ) args( 2 ).int_value();
top = (  int  ) args( 3 ).int_value();
total = (  int  ) args( 4 ).int_value();
long int ret_type=(long int) _Fl_ScrollbarPtr->value ( p,s,top,total);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Scrollbar_scrollvalue , args , , " return Fl_Scrollbar_scrollvalue (p ,s ,top ,total ); " )
{
Fl_Scrollbar *   _Fl_ScrollbarPtr ;
p   _p0 ;
s   _s1 ;
top   _top2 ;
total   _total3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  return Fl_Scrollbar_scrollvalue (p ,s ,top ,total ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Scrollbar_scrollvalue "<<std::endl;
#endif /* DEBUG */
_Fl_ScrollbarPtr =( Fl_Scrollbar * )args( 0 ).long_value();
_p0 = (  p  ) args( 1 ).long_value();
_s1 = (  s  ) args( 2 ).long_value();
_top2 = (  top  ) args( 3 ).long_value();
_total3 = (  total  ) args( 4 ).long_value();
long int ret_type=(long int) _Fl_ScrollbarPtr->scrollvalue ( _p0,_s1,_top2,_total3);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Scrollbar_linesize , args , , " int Fl_Scrollbar_linesize ( ); " )
{
Fl_Scrollbar *   _Fl_ScrollbarPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Scrollbar_linesize ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Scrollbar_linesize "<<std::endl;
#endif /* DEBUG */
_Fl_ScrollbarPtr =( Fl_Scrollbar * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_ScrollbarPtr->linesize ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Scrollbar_linesize , args , , " void Fl_Scrollbar_linesize (int i); " )
{
Fl_Scrollbar *   _Fl_ScrollbarPtr ;
int   i ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Scrollbar_linesize (int i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Scrollbar_linesize "<<std::endl;
#endif /* DEBUG */
_Fl_ScrollbarPtr =( Fl_Scrollbar * )args( 0 ).long_value();
i = (  int  ) args( 1 ).int_value();
_Fl_ScrollbarPtr->linesize ( i);
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Scrollbar , args , , " void Fl_Scrollbar(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
        {
         char *str=NULL;      
         if(args.length()==5)
         str=strdup(args(4).string_value().c_str());
         Fl_Scrollbar *flb=new Fl_Scrollbar(args(0).int_value(),
                             args(1).int_value(),
                             args(2).int_value(),
                             args(3).int_value(),str);
                 return octave_value(new FLTKWrapper(flb,"Fl_Scrollbar"));
                 }
octave_dynamic_loader::load("Fl_Scrollbar_timeout_cb" ,"");
octave_dynamic_loader::load("Fl_Scrollbar_increment_cb" ,"");
octave_dynamic_loader::load("Fl_Scrollbar_draw" ,"");
octave_dynamic_loader::load("Fl_Scrollbar_handle" ,"");
octave_dynamic_loader::load("Fl_Scrollbar_value" ,"");
octave_dynamic_loader::load("Fl_Scrollbar_value" ,"");
octave_dynamic_loader::load("Fl_Scrollbar_scrollvalue" ,"");
octave_dynamic_loader::load("Fl_Scrollbar_linesize" ,"");
octave_dynamic_loader::load("Fl_Scrollbar_linesize" ,"");
std::cout<<"Code generated onTue Aug  2 13:57:21 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_ScrollbarLibrary!"<<std::endl;
return octave_value(new FLTKStaticWrapper(0,"Fl_Scrollbar"));
}
#endif
/* do it later */
