/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

#if 0
DEFUN_DLD( Fl_Shared_Image_compare , args , , " static Fl_Shared_Image_compare (Fl_Shared_Image * *i0,Fl_Shared_Image * *i1); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
Fl_Shared_Image *   *i0 ;
Fl_Shared_Image *   *i1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Shared_Image_compare (Fl_Shared_Image * *i0,Fl_Shared_Image * *i1); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_compare "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
*i0 =( Fl_Shared_Image * )args( 1 ).long_value();
*i1 =( Fl_Shared_Image * )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->compare ( *i0,*i1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_Fl_Shared_Image , args , , " Fl_Shared_Image( Fl_Shared_Image_Fl_Shared_Image ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Shared_Image( Fl_Shared_Image_Fl_Shared_Image ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_Fl_Shared_Image "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->Fl_Shared_Image ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_add , args , , " void Fl_Shared_Image_add ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Shared_Image_add ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_add "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
_Fl_Shared_ImagePtr->add ( );
return octave_value();
}
DEFUN_DLD( Fl_Shared_Image_update , args , , " void Fl_Shared_Image_update ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Shared_Image_update ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_update "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
_Fl_Shared_ImagePtr->update ( );
return octave_value();
}
DEFUN_DLD( Fl_Shared_Image_name , args , , " char * Fl_Shared_Image_name ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char * Fl_Shared_Image_name ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_name "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_Shared_ImagePtr->name ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_refcount , args , , " int Fl_Shared_Image_refcount ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Shared_Image_refcount ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_refcount "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->refcount ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_release , args , , " void Fl_Shared_Image_release ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Shared_Image_release ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_release "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
_Fl_Shared_ImagePtr->release ( );
return octave_value();
}
DEFUN_DLD( Fl_Shared_Image_reload , args , , " void Fl_Shared_Image_reload ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Shared_Image_reload ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_reload "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
_Fl_Shared_ImagePtr->reload ( );
return octave_value();
}
DEFUN_DLD( Fl_Shared_Image_*copy , args , , " virtual Fl_Shared_Image_*copy (int W,int H); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
int   W ;
int   H ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  virtual Fl_Shared_Image_*copy (int W,int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_*copy "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
W = (  int  ) args( 1 ).int_value();
H = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->*copy ( W,H);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_copy , args , , " Fl_Image * Fl_Shared_Image_copy ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Image * Fl_Shared_Image_copy ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_copy "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
long int ret_type= (long int) _Fl_Shared_ImagePtr->copy ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_color_average , args , , " virtual Fl_Shared_Image_color_average (Fl_Color c,float i); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
Fl_Color   c ;
float   i ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  virtual Fl_Shared_Image_color_average (Fl_Color c,float i); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_color_average "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
c = (  Fl_Color  ) args( 1 ).long_value();
i = (  float  ) args( 2 ).double_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->color_average ( c,i);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_desaturate , args , , " virtual Fl_Shared_Image_desaturate ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_Shared_Image_desaturate ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_desaturate "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->desaturate ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_draw , args , , " virtual Fl_Shared_Image_draw (int X,int Y,int W,int H,int cx,int cy); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
int   X ;
int   Y ;
int   W ;
int   H ;
int   cx ;
int   cy ;
 if(args.length()!= 7 )
  {
   std::cout<< "eg:  virtual Fl_Shared_Image_draw (int X,int Y,int W,int H,int cx,int cy); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_draw "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
W = (  int  ) args( 3 ).int_value();
H = (  int  ) args( 4 ).int_value();
cx = (  int  ) args( 5 ).int_value();
cy = (  int  ) args( 6 ).int_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->draw ( X,Y,W,H,cx,cy);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_draw , args , , " void Fl_Shared_Image_draw (int X,int Y); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
int   X ;
int   Y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Shared_Image_draw (int X,int Y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_draw "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
_Fl_Shared_ImagePtr->draw ( X,Y);
return octave_value();
}
DEFUN_DLD( Fl_Shared_Image_uncache , args , , " virtual Fl_Shared_Image_uncache ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_Shared_Image_uncache ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_uncache "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->uncache ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_*find , args , , " static Fl_Shared_Image_*find (char * n,int W = 0,int H = 0); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
char *   n ;
int   W = 0 ;
int   H = 0 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  static Fl_Shared_Image_*find (char * n,int W = 0,int H = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_*find "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
n = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) n ,args( 1 ).string_value().c_str());
W = 0 = (  int  ) args( 2 ).int_value();
H = 0 = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->*find ( n,W = 0,H = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_*get , args , , " static Fl_Shared_Image_*get (char * n,int W = 0,int H = 0); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
char *   n ;
int   W = 0 ;
int   H = 0 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  static Fl_Shared_Image_*get (char * n,int W = 0,int H = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_*get "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
n = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) n ,args( 1 ).string_value().c_str());
W = 0 = (  int  ) args( 2 ).int_value();
H = 0 = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->*get ( n,W = 0,H = 0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_**images , args , , " static Fl_Shared_Image_**images ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_Shared_Image_**images ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_**images "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->**images ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_num_images , args , , " static Fl_Shared_Image_num_images ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  static Fl_Shared_Image_num_images ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_num_images "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->num_images ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_add_handler , args , , " static Fl_Shared_Image_add_handler (Fl_Shared_Handler f); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
Fl_Shared_Handler   f ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_Shared_Image_add_handler (Fl_Shared_Handler f); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_add_handler "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
f = (  Fl_Shared_Handler  ) args( 1 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->add_handler ( f);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_remove_handler , args , , " static Fl_Shared_Image_remove_handler (Fl_Shared_Handler f); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
Fl_Shared_Handler   f ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_Shared_Image_remove_handler (Fl_Shared_Handler f); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_remove_handler "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
f = (  Fl_Shared_Handler  ) args( 1 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->remove_handler ( f);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Shared_Image_fl_register_images , args , , " extern Fl_Shared_Image_fl_register_images ( ); " )
{
Fl_Shared_Image *   _Fl_Shared_ImagePtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  extern Fl_Shared_Image_fl_register_images ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Shared_Image_fl_register_images "<<std::endl;
#endif /* DEBUG */
_Fl_Shared_ImagePtr =( Fl_Shared_Image * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Shared_ImagePtr->fl_register_images ( );
return octave_value(ret_type);
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Shared_Image , args , , " void Fl_Shared_Image(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
        {
         char *str=NULL;      
         if(args.length()==5)
         str=strdup(args(4).string_value().c_str());
         Fl_Shared_Image *flb=new Fl_Shared_Image(args(0).int_value(),
                             args(1).int_value(),
                             args(2).int_value(),
                             args(3).int_value(),str);
                 return octave_value(new FLTKWrapper(flb,"Fl_Shared_Image"));
                 }
octave_dynamic_loader::load("Fl_Shared_Image_compare" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_Fl_Shared_Image" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_add" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_update" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_name" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_refcount" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_release" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_reload" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_*copy" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_copy" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_color_average" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_desaturate" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_draw" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_draw" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_uncache" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_*find" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_*get" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_**images" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_num_images" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_add_handler" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_remove_handler" ,"");
octave_dynamic_loader::load("Fl_Shared_Image_fl_register_images" ,"");
std::cout<<"Code generated onTue Aug  2 13:58:17 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Shared_ImageLibrary!"<<std::endl;
return octave_value(new FLTKStaticWrapper(0,"Fl_Shared_Image"));
}
#endif
