/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_Single_Window_show , args , , " void Fl_Single_Window_show ( ); " )
{
  Fl_Single_Window *   _Fl_Single_WindowPtr ;
  Cell  matrix;

 if(args.length()!= 1 || args.length()!= 2)
  {
   std::cout<< "eg:  void Fl_Single_Window_show ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Single_Window_show "<<std::endl;
#endif /* DEBUG */
_Fl_Single_WindowPtr =( Fl_Single_Window * )args( 0 ).long_value();

 if(args.length()==1)
   { 
     _Fl_Single_WindowPtr->show ( );
     return octave_value();
   }
  matrix=args(1).cell_value();
  char *list_args[matrix.cols()];

  for(int i=0;i<matrix.cols();i++)
    {
      list_args[i]=strdup(matrix(0,i).string_value().c_str());
      matrix(0,i).print(std::cout,true);
    }

  _Fl_Single_WindowPtr->show(matrix.cols(),list_args);
  
  for(int i=0;i<matrix.cols();i++)
    free(list_args[i]);
  
  return octave_value();
}

DEFUN_DLD( Fl_Single_Window_flush , args , , " void Fl_Single_Window_flush ( ); " )
{
  Fl_Single_Window *   _Fl_Single_WindowPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Single_Window_flush ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Single_Window_flush "<<std::endl;
#endif /* DEBUG */
  _Fl_Single_WindowPtr =( Fl_Single_Window * )args( 0 ).long_value();
  _Fl_Single_WindowPtr->flush ( );
  return octave_value();
}

DEFUN_DLD( Fl_Single_Window_make_current , args , , " int Fl_Single_Window_make_current ( ); " )
{
  Fl_Single_Window *   _Fl_Single_WindowPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  int Fl_Single_Window_make_current ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Single_Window_make_current "<<std::endl;
#endif /* DEBUG */
  _Fl_Single_WindowPtr =( Fl_Single_Window * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_Single_WindowPtr->make_current ( );
  return octave_value(ret_type);
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Single_Window , args , , " void Fl_Single_Window(void); " )
{
  if (args.length() >=2 && args.length() <= 5 )
    {
      char *str=NULL;      
      Fl_Single_Window *flb;

      switch(args.length())
	{
	case 2:
	case 4:
	  str=NULL;
	  break;
	case 3:
	case 5:
	  str=strdup(args(4).string_value().c_str());
	  break;
	}

      flb=new Fl_Single_Window(args(0).int_value(),
			       args(1).int_value(),
			       str);

      if(args.length()==4 || args.length()==5)
	{
	  flb=new Fl_Single_Window(args(0).int_value(),
				   args(1).int_value(),
				   args(2).int_value(),
				   args(3).int_value(),str);
	}
      return octave_value(new FLTKWrapper(flb,"Fl_Single_Window"));
    }

  octave_dynamic_loader::load("Fl_Single_Window_show" ,"");
  octave_dynamic_loader::load("Fl_Single_Window_flush" ,"");
  octave_dynamic_loader::load("Fl_Single_Window_make_current" ,"");
  
  std::cout<<"Code generated onMon Aug  1 17:53:44 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Single_WindowLibrary!"<<std::endl;
  
  return octave_value(new FLTKStaticWrapper(0,"Fl_Single_Window"));
}
