/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_Slider_draw , args , , " void Fl_Slider_draw ( ); " )
{
Fl_Slider *   _Fl_SliderPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Slider_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Slider_draw "<<std::endl;
#endif /* DEBUG */
_Fl_SliderPtr =( Fl_Slider * )args( 0 ).long_value();
_Fl_SliderPtr->draw ( );
return octave_value();
}
DEFUN_DLD( Fl_Slider_handle , args , , " int Fl_Slider_handle (int ); " )
{
Fl_Slider *   _Fl_SliderPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Slider_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Slider_handle "<<std::endl;
#endif /* DEBUG */
_Fl_SliderPtr =( Fl_Slider * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_SliderPtr->handle ( _int0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Slider_scrollvalue , args , , " int Fl_Slider_scrollvalue (int windowtop,int windowsize,int first,int totalsize); " )
{
Fl_Slider *   _Fl_SliderPtr ;
int   windowtop ;
int   windowsize ;
int   first ;
int   totalsize ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  int Fl_Slider_scrollvalue (int windowtop,int windowsize,int first,int totalsize); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Slider_scrollvalue "<<std::endl;
#endif /* DEBUG */
_Fl_SliderPtr =( Fl_Slider * )args( 0 ).long_value();
 windowtop = (  int  ) args( 1 ).int_value();
 windowsize = (  int  ) args( 2 ).int_value();
 first = (  int  ) args( 3 ).int_value();
 totalsize = (  int  ) args( 4 ).int_value();
 long int ret_type=(long int) _Fl_SliderPtr->scrollvalue ( windowtop,windowsize,first,totalsize);
 return octave_value(ret_type);
}
DEFUN_DLD( Fl_Slider_bounds , args , , " void Fl_Slider_bounds (double a,double b); " )
{
Fl_Slider *   _Fl_SliderPtr ;
double   a ;
double   b ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Slider_bounds (double a,double b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Slider_bounds "<<std::endl;
#endif /* DEBUG */
_Fl_SliderPtr =( Fl_Slider * )args( 0 ).long_value();
a = (  double  ) args( 1 ).double_value();
b = (  double  ) args( 2 ).double_value();
_Fl_SliderPtr->bounds ( a,b);
return octave_value();
}

DEFUN_DLD( Fl_Slider_slider_size , args , , " void Fl_Slider_slider_size (double v); " )
{
Fl_Slider *   _Fl_SliderPtr ;
double   v ;
 if(!(args.length()<= 2 && args.length()>=1))
   {
     std::cout<< "eg:  void Fl_Slider_slider_size (double v); " <<std::endl;
  return octave_value(-1);
}
#ifdef DEBUG
 std::cout<<" Fl_Slider_slider_size "<<std::endl;
#endif /* DEBUG */
_Fl_SliderPtr =( Fl_Slider * )args( 0 ).long_value();
 
 if(args.length()== 1 )
   {
     long int ret_type=(long int) _Fl_SliderPtr->slider_size ( );
     return octave_value(ret_type);
   }
 v = (  double  ) args( 1 ).double_value();
 _Fl_SliderPtr->slider_size ( v);
 return octave_value();
}

DEFUN_DLD( Fl_Slider_slider , args , , " void Fl_Slider_slider (Fl_Boxtype c); " )
{
Fl_Slider *   _Fl_SliderPtr ;
Fl_Boxtype   c ;

 if(args.length()!= 2 || args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Slider_slider (Fl_Boxtype c); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Slider_slider "<<std::endl;
#endif /* DEBUG */
_Fl_SliderPtr =( Fl_Slider * )args( 0 ).long_value();

 if( args.length()!= 1)
   {
     c = (  Fl_Boxtype  ) args( 1 ).long_value();
     _Fl_SliderPtr->slider ( c);
     return octave_value();
   } 

 _Fl_SliderPtr =( Fl_Slider * )args( 0 ).long_value();
 long int ret_type=(long int) _Fl_SliderPtr->slider ( );
 return octave_value(ret_type); 
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Slider , args , , " void Fl_Slider(void); " )
{
  if (args.length() >= 4 && args.length() <= 6)
    {
      char *str=NULL;      
      Fl_Slider *fls;

      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());

      if (args.length()<=5)
	{
	  fls=new Fl_Slider(args(0).int_value(),args(1).int_value(),
			    args(2).int_value(),args(3).int_value(),str);
	}
      else
	{
	  str=strdup(args(5).string_value().c_str());
	  fls=new Fl_Slider(args(0).long_value(),args(1).int_value(),
			    args(2).int_value(),args(3).int_value(),
			    args(4).int_value(),str);
	}
      
      return octave_value(new FLTKWrapper(fls,"Fl_Slider"));
    }

  octave_dynamic_loader::load("Fl_Slider_draw" ,"");
  octave_dynamic_loader::load("Fl_Slider_handle" ,"");
  octave_dynamic_loader::load("Fl_Slider_scrollvalue" ,"");
  octave_dynamic_loader::load("Fl_Slider_bounds" ,"");
  octave_dynamic_loader::load("Fl_Slider_slider_size" ,"");
  octave_dynamic_loader::load("Fl_Slider_slider" ,"");

  std::cout<<"Code generated onSat Jul 30 23:28:34 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_SliderLibrary!\n";

  return octave_value(new FLTKStaticWrapper(0,"Fl_Slider"));
}
