/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Tabs_handle , args , , " int Fl_Tabs_handle (int ); " )
{
  Fl_Tabs *   _Fl_TabsPtr ;
  int   _int0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  int Fl_Tabs_handle (int ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Tabs_handle "<<std::endl;
#endif /* DEBUG */
  _Fl_TabsPtr =( Fl_Tabs * )args( 0 ).long_value();
  _int0 = (  int  ) args( 1 ).int_value();
  long int ret_type=(long int) _Fl_TabsPtr->handle ( _int0);
  return octave_value(ret_type);
}

DEFUN_DLD( Fl_Tabs_value , args , , " int Fl_Tabs_value (Fl_Widget * ); " )
{
Fl_Tabs *   _Fl_TabsPtr =NULL;
Fl_Widget *   _Fl_Widget0 ;
 if(!(args.length()<= 2 && args.length()>=1) )
  {
   std::cout<< "eg:  int Fl_Tabs_value (Fl_Widget * ); " <<std::endl;
   return octave_value(-1);
  }

#ifdef DEBUG
 std::cout<<" Fl_Tabs_value "<<std::endl;
#endif /* DEBUG */

 if(args.length()==1)
   {
     Fl_Widget * ret_type=  _Fl_TabsPtr->value ( );
     return octave_value(new FLTKWrapper(ret_type,"Fl_Widget"));
   }
 
_Fl_TabsPtr =( Fl_Tabs * )args( 0 ).long_value();
_Fl_Widget0 =( Fl_Widget * )args( 1 ).long_value();
long int ret_type=(long int) _Fl_TabsPtr->value ( _Fl_Widget0);
return octave_value(ret_type);
}

DEFUN_DLD( Fl_Tabs_push , args , , " int Fl_Tabs_push (Fl_Widget * ); " )
{
Fl_Tabs *   _Fl_TabsPtr =NULL;
Fl_Widget *   _Fl_Widget0 =NULL;
 if(!(args.length()<= 2 && args.length()>=1) )
   {
     std::cout<< "eg:  int Fl_Tabs_push (Fl_Widget * ); " <<std::endl;
     return octave_value(-1);
   }
#ifdef DEBUG
 std::cout<<" Fl_Tabs_push "<<std::endl;
#endif /* DEBUG */
 if(args.length()==1)
   {
     long int ret_type= (long int) _Fl_TabsPtr->push ( );
     return octave_value(new FLTKWrapper((void *)ret_type,"Fl_Widget"));
   }

 _Fl_TabsPtr =( Fl_Tabs * )args( 0 ).long_value();
 _Fl_Widget0 =( Fl_Widget * )args( 1 ).long_value();
 long int ret_type=(long int) _Fl_TabsPtr->push ( _Fl_Widget0);
 return octave_value(ret_type);
}
DEFUN_DLD( Fl_Tabs_which , args , , " Fl_Widget * Fl_Tabs_which (int event_x,int event_y); " )
{
Fl_Tabs *   _Fl_TabsPtr ;
int   event_x ;
int   event_y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  Fl_Widget * Fl_Tabs_which (int event_x,int event_y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Tabs_which "<<std::endl;
#endif /* DEBUG */
_Fl_TabsPtr =( Fl_Tabs * )args( 0 ).long_value();
event_x = (  int  ) args( 1 ).int_value();
event_y = (  int  ) args( 2 ).int_value();
long int ret_type= (long int) _Fl_TabsPtr->which ( event_x,event_y);
return octave_value(ret_type);
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Tabs , args , , " void Fl_Tabs(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      Fl_Tabs *flb=new Fl_Tabs(args(0).int_value(),args(1).int_value(),
			       args(2).int_value(),args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Tabs"));
    }

  octave_dynamic_loader::load("Fl_Tabs_handle" ,"");
  octave_dynamic_loader::load("Fl_Tabs_value" ,"");
  octave_dynamic_loader::load("Fl_Tabs_push" ,"");
  octave_dynamic_loader::load("Fl_Tabs_which" ,"");
  return octave_value("Code generated onSat Jul 30 23:28:34 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_TabsLibrary!");
}
