/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
#if 0
DEFUN_DLD( Fl_Text_Buffer_set , args , , " void Fl_Text_Buffer_set (int start,int end); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_set (int start,int end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_set "<<std::endl;
#endif /* DEBUG */
 _Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
 start = (  int  ) args( 1 ).int_value();
 end = (  int  ) args( 2 ).int_value();
 _Fl_Text_BufferPtr->set ( start,end);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_set_rectangular , args , , " void Fl_Text_Buffer_set_rectangular (int start,int end,int rectStart,int rectEnd); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
int   rectStart ;
int   rectEnd ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_set_rectangular (int start,int end,int rectStart,int rectEnd); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_set_rectangular "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
rectStart = (  int  ) args( 3 ).int_value();
rectEnd = (  int  ) args( 4 ).int_value();
_Fl_Text_BufferPtr->set_rectangular ( start,end,rectStart,rectEnd);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_update , args , , " void Fl_Text_Buffer_update (int pos,int nDeleted,int nInserted); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
int   nDeleted ;
int   nInserted ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_update (int pos,int nDeleted,int nInserted); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_update "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
nDeleted = (  int  ) args( 2 ).int_value();
nInserted = (  int  ) args( 3 ).int_value();
_Fl_Text_BufferPtr->update ( pos,nDeleted,nInserted);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_rectangular , args , , " char Fl_Text_Buffer_rectangular ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char Fl_Text_Buffer_rectangular ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_rectangular "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->rectangular ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_start , args , , " int Fl_Text_Buffer_start ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_start ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_start "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->start ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_end , args , , " int Fl_Text_Buffer_end ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_end ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_end "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->end ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_rect_start , args , , " int Fl_Text_Buffer_rect_start ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_rect_start ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_rect_start "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->rect_start ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_rect_end , args , , " int Fl_Text_Buffer_rect_end ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_rect_end ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_rect_end "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->rect_end ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_selected , args , , " char Fl_Text_Buffer_selected ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char Fl_Text_Buffer_selected ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_selected "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->selected ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_selected , args , , " void Fl_Text_Buffer_selected (char b); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char   b ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_selected (char b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_selected "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
b = (  char  ) args( 1 ).long_value();
_Fl_Text_BufferPtr->selected ( b);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_includes , args , , " int Fl_Text_Buffer_includes (int pos,int lineStartPos,int dispIndex); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
int   lineStartPos ;
int   dispIndex ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_includes (int pos,int lineStartPos,int dispIndex); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_includes "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
lineStartPos = (  int  ) args( 2 ).int_value();
dispIndex = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->includes ( pos,lineStartPos,dispIndex);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_position , args , , " int Fl_Text_Buffer_position (int* start,int* end); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int*   start ;
int*   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_position (int* start,int* end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_position "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start =( int* )args( 1 ).long_value();
end =( int* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->position ( start,end);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_position , args , , " int Fl_Text_Buffer_position (int* start,int* end,int* isRect,int* rectStart,int* rectEnd); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int*   start ;
int*   end ;
int*   isRect ;
int*   rectStart ;
int*   rectEnd ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_position (int* start,int* end,int* isRect,int* rectStart,int* rectEnd); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_position "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start =( int* )args( 1 ).long_value();
end =( int* )args( 2 ).long_value();
isRect =( int* )args( 3 ).long_value();
rectStart =( int* )args( 4 ).long_value();
rectEnd =( int* )args( 5 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->position ( start,end,isRect,rectStart,rectEnd);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_length , args , , " int Fl_Text_Buffer_length ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_length ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_length "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->length ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_text , args , , " char* Fl_Text_Buffer_text ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char* Fl_Text_Buffer_text ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_text "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_Text_BufferPtr->text ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_text , args , , " void Fl_Text_Buffer_text (char* text); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char*   text ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_text (char* text); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_text "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
text =( char* )args( 1 ).long_value();
_Fl_Text_BufferPtr->text ( text);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_text_range , args , , " char* Fl_Text_Buffer_text_range (int start,int end); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  char* Fl_Text_Buffer_text_range (int start,int end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_text_range "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
string  ret_type(  (const char *) _Fl_Text_BufferPtr->text_range ( start,end));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_character , args , , " char Fl_Text_Buffer_character (int pos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  char Fl_Text_Buffer_character (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_character "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->character ( pos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_text_in_rectangle , args , , " char* Fl_Text_Buffer_text_in_rectangle (int start,int end,int rectStart,int rectEnd); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
int   rectStart ;
int   rectEnd ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  char* Fl_Text_Buffer_text_in_rectangle (int start,int end,int rectStart,int rectEnd); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_text_in_rectangle "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
rectStart = (  int  ) args( 3 ).int_value();
rectEnd = (  int  ) args( 4 ).int_value();
string  ret_type(  (const char *) _Fl_Text_BufferPtr->text_in_rectangle ( start,end,rectStart,rectEnd));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_insert , args , , " void Fl_Text_Buffer_insert (int pos,char* text); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
char*   text ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_insert (int pos,char* text); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_insert "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
text =( char* )args( 2 ).long_value();
_Fl_Text_BufferPtr->insert ( pos,text);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_append , args , , " void Fl_Text_Buffer_append (char* t); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char*   t ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_append (char* t); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_append "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
t =( char* )args( 1 ).long_value();
_Fl_Text_BufferPtr->append ( t);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_remove , args , , " void Fl_Text_Buffer_remove (int start,int end); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_remove (int start,int end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_remove "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
_Fl_Text_BufferPtr->remove ( start,end);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_replace , args , , " void Fl_Text_Buffer_replace (int start,int end,char * text); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
char *   text ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_replace (int start,int end,char * text); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_replace "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
text = new  char   [args( 3 ).string_value ().length()];
strcpy( (char *) text ,args( 3 ).string_value().c_str());
_Fl_Text_BufferPtr->replace ( start,end,text);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_copy , args , , " void Fl_Text_Buffer_copy (Fl_Text_Buffer* fromBuf,int fromStart,int fromEnd,int toPos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
Fl_Text_Buffer*   fromBuf ;
int   fromStart ;
int   fromEnd ;
int   toPos ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_copy (Fl_Text_Buffer* fromBuf,int fromStart,int fromEnd,int toPos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_copy "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
fromBuf =( Fl_Text_Buffer* )args( 1 ).long_value();
fromStart = (  int  ) args( 2 ).int_value();
fromEnd = (  int  ) args( 3 ).int_value();
toPos = (  int  ) args( 4 ).int_value();
_Fl_Text_BufferPtr->copy ( fromBuf,fromStart,fromEnd,toPos);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_undo , args , , " int Fl_Text_Buffer_undo (int * cp=0); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int *   cp=0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_undo (int * cp=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_undo "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
cp=0 =( int * )args( 1 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->undo ( cp=0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_canUndo , args , , " void Fl_Text_Buffer_canUndo (char flag=1); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char   flag=1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_canUndo (char flag=1); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_canUndo "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
flag=1 = (  char  ) args( 1 ).long_value();
_Fl_Text_BufferPtr->canUndo ( flag=1);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_insertfile , args , , " int Fl_Text_Buffer_insertfile (char * file,int pos,int buflen = 128*1024); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char *   file ;
int   pos ;
int   buflen = 128*1024 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_insertfile (char * file,int pos,int buflen = 128*1024); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_insertfile "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
file = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) file ,args( 1 ).string_value().c_str());
pos = (  int  ) args( 2 ).int_value();
buflen = 128*1024 = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->insertfile ( file,pos,buflen = 128*1024);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_appendfile , args , , " int Fl_Text_Buffer_appendfile (char * file,int buflen = 128*1024); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char *   file ;
int   buflen = 128*1024 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_appendfile (char * file,int buflen = 128*1024); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_appendfile "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
file = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) file ,args( 1 ).string_value().c_str());
buflen = 128*1024 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->appendfile ( file,buflen = 128*1024);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_insertfile , args , , " { Fl_Text_Buffer_insertfile (file ,length( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
file   _file0 ;
length(   _length(1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  { Fl_Text_Buffer_insertfile (file ,length( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_insertfile "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_file0 = (  file  ) args( 1 ).long_value();
_length(1 = (  length(  ) args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->insertfile ( _file0,_length(1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_loadfile , args , , " int Fl_Text_Buffer_loadfile (char * file,int buflen = 128*1024); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char *   file ;
int   buflen = 128*1024 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_loadfile (char * file,int buflen = 128*1024); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_loadfile "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
file = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) file ,args( 1 ).string_value().c_str());
buflen = 128*1024 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->loadfile ( file,buflen = 128*1024);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_select , args , , " { Fl_Text_Buffer_select (0 ,length( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
0   _00 ;
length(   _length(1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  { Fl_Text_Buffer_select (0 ,length( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_select "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_00 = (  0  ) args( 1 ).long_value();
_length(1 = (  length(  ) args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->select ( _00,_length(1);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_outputfile , args , , " int Fl_Text_Buffer_outputfile (char * file,int start,int end,int buflen = 128*1024); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char *   file ;
int   start ;
int   end ;
int   buflen = 128*1024 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_outputfile (char * file,int start,int end,int buflen = 128*1024); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_outputfile "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
file = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) file ,args( 1 ).string_value().c_str());
start = (  int  ) args( 2 ).int_value();
end = (  int  ) args( 3 ).int_value();
buflen = 128*1024 = (  int  ) args( 4 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->outputfile ( file,start,end,buflen = 128*1024);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_savefile , args , , " int Fl_Text_Buffer_savefile (char * file,int buflen = 128*1024); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char *   file ;
int   buflen = 128*1024 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_savefile (char * file,int buflen = 128*1024); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_savefile "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
file = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) file ,args( 1 ).string_value().c_str());
buflen = 128*1024 = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->savefile ( file,buflen = 128*1024);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_outputfile , args , , " { Fl_Text_Buffer_outputfile (file ,0 ,length( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
file   _file0 ;
0   _01 ;
length(   _length(2 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  { Fl_Text_Buffer_outputfile (file ,0 ,length( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_outputfile "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_file0 = (  file  ) args( 1 ).long_value();
_01 = (  0  ) args( 2 ).long_value();
_length(2 = (  length(  ) args( 3 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->outputfile ( _file0,_01,_length(2);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_remove_rectangular , args , , " void Fl_Text_Buffer_remove_rectangular (int start,int end,int rectStart,int rectEnd); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
int   rectStart ;
int   rectEnd ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_remove_rectangular (int start,int end,int rectStart,int rectEnd); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_remove_rectangular "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
rectStart = (  int  ) args( 3 ).int_value();
rectEnd = (  int  ) args( 4 ).int_value();
_Fl_Text_BufferPtr->remove_rectangular ( start,end,rectStart,rectEnd);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_clear_rectangular , args , , " void Fl_Text_Buffer_clear_rectangular (int start,int end,int rectStart,int rectEnd); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
int   rectStart ;
int   rectEnd ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_clear_rectangular (int start,int end,int rectStart,int rectEnd); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_clear_rectangular "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
rectStart = (  int  ) args( 3 ).int_value();
rectEnd = (  int  ) args( 4 ).int_value();
_Fl_Text_BufferPtr->clear_rectangular ( start,end,rectStart,rectEnd);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_tab_distance , args , , " int Fl_Text_Buffer_tab_distance ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_tab_distance ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_tab_distance "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->tab_distance ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_tab_distance , args , , " void Fl_Text_Buffer_tab_distance (int tabDist); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   tabDist ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_tab_distance (int tabDist); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_tab_distance "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
tabDist = (  int  ) args( 1 ).int_value();
_Fl_Text_BufferPtr->tab_distance ( tabDist);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_select , args , , " void Fl_Text_Buffer_select (int start,int end); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_select (int start,int end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_select "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
_Fl_Text_BufferPtr->select ( start,end);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_selected , args , , " int Fl_Text_Buffer_selected ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_selected ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_selected "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->selected ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_unselect , args , , " void Fl_Text_Buffer_unselect ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_unselect ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_unselect "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_Fl_Text_BufferPtr->unselect ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_select_rectangular , args , , " void Fl_Text_Buffer_select_rectangular (int start,int end,int rectStart,int rectEnd); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
int   rectStart ;
int   rectEnd ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_select_rectangular (int start,int end,int rectStart,int rectEnd); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_select_rectangular "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
rectStart = (  int  ) args( 3 ).int_value();
rectEnd = (  int  ) args( 4 ).int_value();
_Fl_Text_BufferPtr->select_rectangular ( start,end,rectStart,rectEnd);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_selection_position , args , , " int Fl_Text_Buffer_selection_position (int* start,int* end); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int*   start ;
int*   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_selection_position (int* start,int* end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_selection_position "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start =( int* )args( 1 ).long_value();
end =( int* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->selection_position ( start,end);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_selection_text , args , , " char* Fl_Text_Buffer_selection_text ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char* Fl_Text_Buffer_selection_text ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_selection_text "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_Text_BufferPtr->selection_text ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_remove_selection , args , , " void Fl_Text_Buffer_remove_selection ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_remove_selection ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_remove_selection "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_Fl_Text_BufferPtr->remove_selection ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_replace_selection , args , , " void Fl_Text_Buffer_replace_selection (char* text); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char*   text ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_replace_selection (char* text); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_replace_selection "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
text =( char* )args( 1 ).long_value();
_Fl_Text_BufferPtr->replace_selection ( text);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_secondary_select , args , , " void Fl_Text_Buffer_secondary_select (int start,int end); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_secondary_select (int start,int end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_secondary_select "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
_Fl_Text_BufferPtr->secondary_select ( start,end);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_secondary_unselect , args , , " void Fl_Text_Buffer_secondary_unselect ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_secondary_unselect ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_secondary_unselect "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_Fl_Text_BufferPtr->secondary_unselect ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_secondary_selection_text , args , , " char* Fl_Text_Buffer_secondary_selection_text ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char* Fl_Text_Buffer_secondary_selection_text ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_secondary_selection_text "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_Text_BufferPtr->secondary_selection_text ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_remove_secondary_selection , args , , " void Fl_Text_Buffer_remove_secondary_selection ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_remove_secondary_selection ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_remove_secondary_selection "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_Fl_Text_BufferPtr->remove_secondary_selection ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_replace_secondary_selection , args , , " void Fl_Text_Buffer_replace_secondary_selection (char* text); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char*   text ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_replace_secondary_selection (char* text); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_replace_secondary_selection "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
text =( char* )args( 1 ).long_value();
_Fl_Text_BufferPtr->replace_secondary_selection ( text);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_highlight , args , , " void Fl_Text_Buffer_highlight (int start,int end); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_highlight (int start,int end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_highlight "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
_Fl_Text_BufferPtr->highlight ( start,end);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_unhighlight , args , , " void Fl_Text_Buffer_unhighlight ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_unhighlight ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_unhighlight "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_Fl_Text_BufferPtr->unhighlight ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_highlight_rectangular , args , , " void Fl_Text_Buffer_highlight_rectangular (int start,int end,int rectStart,int rectEnd); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
int   rectStart ;
int   rectEnd ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_highlight_rectangular (int start,int end,int rectStart,int rectEnd); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_highlight_rectangular "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
rectStart = (  int  ) args( 3 ).int_value();
rectEnd = (  int  ) args( 4 ).int_value();
_Fl_Text_BufferPtr->highlight_rectangular ( start,end,rectStart,rectEnd);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_highlight_text , args , , " char* Fl_Text_Buffer_highlight_text ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char* Fl_Text_Buffer_highlight_text ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_highlight_text "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
string  ret_type(  (const char *) _Fl_Text_BufferPtr->highlight_text ( ));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_add_modify_callback , args , , " void Fl_Text_Buffer_add_modify_callback (Fl_Text_Modify_Cb bufModifiedCB,void* cbArg); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
Fl_Text_Modify_Cb   bufModifiedCB ;
void*   cbArg ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_add_modify_callback (Fl_Text_Modify_Cb bufModifiedCB,void* cbArg); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_add_modify_callback "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
bufModifiedCB = (  Fl_Text_Modify_Cb  ) args( 1 ).long_value();
cbArg =( void* )args( 2 ).long_value();
_Fl_Text_BufferPtr->add_modify_callback ( bufModifiedCB,cbArg);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_remove_modify_callback , args , , " void Fl_Text_Buffer_remove_modify_callback (Fl_Text_Modify_Cb bufModifiedCB,void* cbArg); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
Fl_Text_Modify_Cb   bufModifiedCB ;
void*   cbArg ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_remove_modify_callback (Fl_Text_Modify_Cb bufModifiedCB,void* cbArg); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_remove_modify_callback "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
bufModifiedCB = (  Fl_Text_Modify_Cb  ) args( 1 ).long_value();
cbArg =( void* )args( 2 ).long_value();
_Fl_Text_BufferPtr->remove_modify_callback ( bufModifiedCB,cbArg);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_call_modify_callbacks , args , , " void Fl_Text_Buffer_call_modify_callbacks ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_call_modify_callbacks ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_call_modify_callbacks "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_Fl_Text_BufferPtr->call_modify_callbacks ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_add_predelete_callback , args , , " void Fl_Text_Buffer_add_predelete_callback (Fl_Text_Predelete_Cb bufPredelCB,void* cbArg); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
Fl_Text_Predelete_Cb   bufPredelCB ;
void*   cbArg ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_add_predelete_callback (Fl_Text_Predelete_Cb bufPredelCB,void* cbArg); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_add_predelete_callback "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
bufPredelCB = (  Fl_Text_Predelete_Cb  ) args( 1 ).long_value();
cbArg =( void* )args( 2 ).long_value();
_Fl_Text_BufferPtr->add_predelete_callback ( bufPredelCB,cbArg);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_remove_predelete_callback , args , , " void Fl_Text_Buffer_remove_predelete_callback (Fl_Text_Predelete_Cb predelCB,void* cbArg); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
Fl_Text_Predelete_Cb   predelCB ;
void*   cbArg ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_remove_predelete_callback (Fl_Text_Predelete_Cb predelCB,void* cbArg); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_remove_predelete_callback "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
predelCB = (  Fl_Text_Predelete_Cb  ) args( 1 ).long_value();
cbArg =( void* )args( 2 ).long_value();
_Fl_Text_BufferPtr->remove_predelete_callback ( predelCB,cbArg);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_call_predelete_callbacks , args , , " void Fl_Text_Buffer_call_predelete_callbacks ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_call_predelete_callbacks ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_call_predelete_callbacks "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
_Fl_Text_BufferPtr->call_predelete_callbacks ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_line_text , args , , " char* Fl_Text_Buffer_line_text (int pos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  char* Fl_Text_Buffer_line_text (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_line_text "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
string  ret_type(  (const char *) _Fl_Text_BufferPtr->line_text ( pos));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_line_start , args , , " int Fl_Text_Buffer_line_start (int pos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_line_start (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_line_start "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->line_start ( pos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_line_end , args , , " int Fl_Text_Buffer_line_end (int pos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_line_end (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_line_end "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->line_end ( pos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_word_start , args , , " int Fl_Text_Buffer_word_start (int pos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_word_start (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_word_start "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->word_start ( pos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_word_end , args , , " int Fl_Text_Buffer_word_end (int pos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_word_end (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_word_end "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->word_end ( pos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_expand_character , args , , " int Fl_Text_Buffer_expand_character (int pos,int indent,char * outStr); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
int   indent ;
char *   outStr ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_expand_character (int pos,int indent,char * outStr); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_expand_character "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
indent = (  int  ) args( 2 ).int_value();
outStr = new  char   [args( 3 ).string_value ().length()];
strcpy( (char *) outStr ,args( 3 ).string_value().c_str());
long int ret_type=(long int) _Fl_Text_BufferPtr->expand_character ( pos,indent,outStr);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_character_width , args , , " static Fl_Text_Buffer_character_width (char c,int indent,int tabDist,char nullSubsChar); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char   c ;
int   indent ;
int   tabDist ;
char   nullSubsChar ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  static Fl_Text_Buffer_character_width (char c,int indent,int tabDist,char nullSubsChar); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_character_width "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
c = (  char  ) args( 1 ).long_value();
indent = (  int  ) args( 2 ).int_value();
tabDist = (  int  ) args( 3 ).int_value();
nullSubsChar = (  char  ) args( 4 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->character_width ( c,indent,tabDist,nullSubsChar);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_count_displayed_characters , args , , " int Fl_Text_Buffer_count_displayed_characters (int lineStartPos,int targetPos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   lineStartPos ;
int   targetPos ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_count_displayed_characters (int lineStartPos,int targetPos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_count_displayed_characters "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
lineStartPos = (  int  ) args( 1 ).int_value();
targetPos = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->count_displayed_characters ( lineStartPos,targetPos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_skip_displayed_characters , args , , " int Fl_Text_Buffer_skip_displayed_characters (int lineStartPos,int nChars); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   lineStartPos ;
int   nChars ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_skip_displayed_characters (int lineStartPos,int nChars); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_skip_displayed_characters "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
lineStartPos = (  int  ) args( 1 ).int_value();
nChars = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->skip_displayed_characters ( lineStartPos,nChars);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_count_lines , args , , " int Fl_Text_Buffer_count_lines (int startPos,int endPos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   startPos ;
int   endPos ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_count_lines (int startPos,int endPos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_count_lines "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
startPos = (  int  ) args( 1 ).int_value();
endPos = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->count_lines ( startPos,endPos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_skip_lines , args , , " int Fl_Text_Buffer_skip_lines (int startPos,int nLines); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   startPos ;
int   nLines ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_skip_lines (int startPos,int nLines); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_skip_lines "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
startPos = (  int  ) args( 1 ).int_value();
nLines = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->skip_lines ( startPos,nLines);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_rewind_lines , args , , " int Fl_Text_Buffer_rewind_lines (int startPos,int nLines); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   startPos ;
int   nLines ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_rewind_lines (int startPos,int nLines); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_rewind_lines "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
startPos = (  int  ) args( 1 ).int_value();
nLines = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->rewind_lines ( startPos,nLines);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_findchar_forward , args , , " int Fl_Text_Buffer_findchar_forward (int startPos,char searchChar,int* foundPos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   startPos ;
char   searchChar ;
int*   foundPos ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_findchar_forward (int startPos,char searchChar,int* foundPos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_findchar_forward "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
startPos = (  int  ) args( 1 ).int_value();
searchChar = (  char  ) args( 2 ).long_value();
foundPos =( int* )args( 3 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->findchar_forward ( startPos,searchChar,foundPos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_findchar_backward , args , , " int Fl_Text_Buffer_findchar_backward (int startPos,char searchChar,int* foundPos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   startPos ;
char   searchChar ;
int*   foundPos ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_findchar_backward (int startPos,char searchChar,int* foundPos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_findchar_backward "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
startPos = (  int  ) args( 1 ).int_value();
searchChar = (  char  ) args( 2 ).long_value();
foundPos =( int* )args( 3 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->findchar_backward ( startPos,searchChar,foundPos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_findchars_forward , args , , " int Fl_Text_Buffer_findchars_forward (int startPos,char* searchChars,int* foundPos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   startPos ;
char*   searchChars ;
int*   foundPos ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_findchars_forward (int startPos,char* searchChars,int* foundPos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_findchars_forward "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
startPos = (  int  ) args( 1 ).int_value();
searchChars =( char* )args( 2 ).long_value();
foundPos =( int* )args( 3 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->findchars_forward ( startPos,searchChars,foundPos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_findchars_backward , args , , " int Fl_Text_Buffer_findchars_backward (int startPos,char* searchChars,int* foundPos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   startPos ;
char*   searchChars ;
int*   foundPos ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_findchars_backward (int startPos,char* searchChars,int* foundPos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_findchars_backward "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
startPos = (  int  ) args( 1 ).int_value();
searchChars =( char* )args( 2 ).long_value();
foundPos =( int* )args( 3 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->findchars_backward ( startPos,searchChars,foundPos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_substitute_null_characters , args , , " int Fl_Text_Buffer_substitute_null_characters (char* string,int length); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char*   string ;
int   length ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_substitute_null_characters (char* string,int length); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_substitute_null_characters "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
string =( char* )args( 1 ).long_value();
length = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->substitute_null_characters ( string,length);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_unsubstitute_null_characters , args , , " void Fl_Text_Buffer_unsubstitute_null_characters (char* string); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
char*   string ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_unsubstitute_null_characters (char* string); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_unsubstitute_null_characters "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
string =( char* )args( 1 ).long_value();
_Fl_Text_BufferPtr->unsubstitute_null_characters ( string);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_null_substitution_character , args , , " char Fl_Text_Buffer_null_substitution_character ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char Fl_Text_Buffer_null_substitution_character ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_null_substitution_character "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->null_substitution_character ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_primary_selection , args , , " Fl_Text_Selection* Fl_Text_Buffer_primary_selection ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Text_Selection* Fl_Text_Buffer_primary_selection ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_primary_selection "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type= (long int) _Fl_Text_BufferPtr->primary_selection ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_secondary_selection , args , , " Fl_Text_Selection* Fl_Text_Buffer_secondary_selection ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Text_Selection* Fl_Text_Buffer_secondary_selection ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_secondary_selection "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type= (long int) _Fl_Text_BufferPtr->secondary_selection ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_highlight_selection , args , , " Fl_Text_Selection* Fl_Text_Buffer_highlight_selection ( ); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Text_Selection* Fl_Text_Buffer_highlight_selection ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_highlight_selection "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
long int ret_type= (long int) _Fl_Text_BufferPtr->highlight_selection ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_call_predelete_callbacks , args , , " void Fl_Text_Buffer_call_predelete_callbacks (int pos,int nDeleted); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
int   nDeleted ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_call_predelete_callbacks (int pos,int nDeleted); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_call_predelete_callbacks "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
nDeleted = (  int  ) args( 2 ).int_value();
_Fl_Text_BufferPtr->call_predelete_callbacks ( pos,nDeleted);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_insert_ , args , , " int Fl_Text_Buffer_insert_ (int pos,char* text); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
char*   text ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Buffer_insert_ (int pos,char* text); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_insert_ "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
text =( char* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_BufferPtr->insert_ ( pos,text);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_remove_ , args , , " void Fl_Text_Buffer_remove_ (int start,int end); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   start ;
int   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_remove_ (int start,int end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_remove_ "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
_Fl_Text_BufferPtr->remove_ ( start,end);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_move_gap , args , , " void Fl_Text_Buffer_move_gap (int pos); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_move_gap (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_move_gap "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
_Fl_Text_BufferPtr->move_gap ( pos);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_reallocate_with_gap , args , , " void Fl_Text_Buffer_reallocate_with_gap (int newGapStart,int newGapLen); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   newGapStart ;
int   newGapLen ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_reallocate_with_gap (int newGapStart,int newGapLen); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_reallocate_with_gap "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
newGapStart = (  int  ) args( 1 ).int_value();
newGapLen = (  int  ) args( 2 ).int_value();
_Fl_Text_BufferPtr->reallocate_with_gap ( newGapStart,newGapLen);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_selection_text_ , args , , " char* Fl_Text_Buffer_selection_text_ (Fl_Text_Selection* sel); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
Fl_Text_Selection*   sel ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  char* Fl_Text_Buffer_selection_text_ (Fl_Text_Selection* sel); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_selection_text_ "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
sel =( Fl_Text_Selection* )args( 1 ).long_value();
string  ret_type(  (const char *) _Fl_Text_BufferPtr->selection_text_ ( sel));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Buffer_remove_selection_ , args , , " void Fl_Text_Buffer_remove_selection_ (Fl_Text_Selection* sel); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
Fl_Text_Selection*   sel ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_remove_selection_ (Fl_Text_Selection* sel); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_remove_selection_ "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
sel =( Fl_Text_Selection* )args( 1 ).long_value();
_Fl_Text_BufferPtr->remove_selection_ ( sel);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_replace_selection_ , args , , " void Fl_Text_Buffer_replace_selection_ (Fl_Text_Selection* sel,char* text); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
Fl_Text_Selection*   sel ;
char*   text ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_replace_selection_ (Fl_Text_Selection* sel,char* text); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_replace_selection_ "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
sel =( Fl_Text_Selection* )args( 1 ).long_value();
text =( char* )args( 2 ).long_value();
_Fl_Text_BufferPtr->replace_selection_ ( sel,text);
return octave_value();
}
DEFUN_DLD( Fl_Text_Buffer_update_selections , args , , " void Fl_Text_Buffer_update_selections (int pos,int nDeleted,int nInserted); " )
{
Fl_Text_Buffer *   _Fl_Text_BufferPtr ;
int   pos ;
int   nDeleted ;
int   nInserted ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Text_Buffer_update_selections (int pos,int nDeleted,int nInserted); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Buffer_update_selections "<<std::endl;
#endif /* DEBUG */
_Fl_Text_BufferPtr =( Fl_Text_Buffer * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
nDeleted = (  int  ) args( 2 ).int_value();
nInserted = (  int  ) args( 3 ).int_value();
_Fl_Text_BufferPtr->update_selections ( pos,nDeleted,nInserted);
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Text_Buffer , args , , " void Fl_Text_Buffer(void); " )
{
octave_dynamic_loader::load("Fl_Text_Buffer_set" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_set_rectangular" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_update" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_rectangular" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_start" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_end" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_rect_start" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_rect_end" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_selected" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_selected" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_includes" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_position" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_position" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_length" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_text" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_text" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_text_range" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_character" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_text_in_rectangle" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_insert" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_append" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_remove" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_replace" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_copy" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_undo" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_canUndo" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_insertfile" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_appendfile" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_insertfile" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_loadfile" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_select" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_outputfile" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_savefile" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_outputfile" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_remove_rectangular" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_clear_rectangular" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_tab_distance" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_tab_distance" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_select" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_selected" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_unselect" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_select_rectangular" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_selection_position" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_selection_text" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_remove_selection" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_replace_selection" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_secondary_select" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_secondary_unselect" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_secondary_selection_text" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_remove_secondary_selection" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_replace_secondary_selection" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_highlight" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_unhighlight" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_highlight_rectangular" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_highlight_text" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_add_modify_callback" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_remove_modify_callback" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_call_modify_callbacks" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_add_predelete_callback" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_remove_predelete_callback" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_call_predelete_callbacks" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_line_text" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_line_start" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_line_end" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_word_start" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_word_end" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_expand_character" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_character_width" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_count_displayed_characters" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_skip_displayed_characters" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_count_lines" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_skip_lines" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_rewind_lines" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_findchar_forward" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_findchar_backward" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_findchars_forward" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_findchars_backward" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_substitute_null_characters" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_unsubstitute_null_characters" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_null_substitution_character" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_primary_selection" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_secondary_selection" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_highlight_selection" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_call_predelete_callbacks" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_insert_" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_remove_" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_move_gap" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_reallocate_with_gap" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_selection_text_" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_remove_selection_" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_replace_selection_" ,"");
octave_dynamic_loader::load("Fl_Text_Buffer_update_selections" ,"");
return octave_value("Code generated onSat Jul 30 23:28:34 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Text_BufferLibrary!");
}
#endif /* 0 */

/*
  Rewrite as separate modules
*/
