/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
#if 0
DEFUN_DLD( Fl_Text_Display:_fl_text_drag_me , args , , " friend Fl_Text_Display:_fl_text_drag_me (int pos,Fl_Text_Display* d); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
Fl_Text_Display*   d ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  friend Fl_Text_Display:_fl_text_drag_me (int pos,Fl_Text_Display* d); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_fl_text_drag_me "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
d =( Fl_Text_Display* )args( 2 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_fl_text_drag_me ( pos,d);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_handle , args , , " virtual Fl_Text_Display:_handle (int e); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   e ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  virtual Fl_Text_Display:_handle (int e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_handle "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
e = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_handle ( e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_buffer , args , , " void Fl_Text_Display:_buffer (Fl_Text_Buffer* buf); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
Fl_Text_Buffer*   buf ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_buffer (Fl_Text_Buffer* buf); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_buffer "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
buf =( Fl_Text_Buffer* )args( 1 ).long_value();
Fl_Text_Display:_buffer ( buf);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_buffer , args , , " void Fl_Text_Display:_buffer (Fl_Text_Buffer& buf); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
Fl_Text_Buffer&   buf ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_buffer (Fl_Text_Buffer& buf); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_buffer "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
buf = (  Fl_Text_Buffer&  ) args( 1 ).long_value();
Fl_Text_Display:_buffer ( buf);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_buffer , args , , " Fl_Text_Buffer* Fl_Text_Display:_buffer ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Text_Buffer* Fl_Text_Display:_buffer ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_buffer "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type= (long int) Fl_Text_Display:_buffer ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_redisplay_range , args , , " void Fl_Text_Display:_redisplay_range (int start,int end); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   start ;
int   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_redisplay_range (int start,int end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_redisplay_range "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
Fl_Text_Display:_redisplay_range ( start,end);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_scroll , args , , " void Fl_Text_Display:_scroll (int topLineNum,int horizOffset); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   topLineNum ;
int   horizOffset ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_scroll (int topLineNum,int horizOffset); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_scroll "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
topLineNum = (  int  ) args( 1 ).int_value();
horizOffset = (  int  ) args( 2 ).int_value();
Fl_Text_Display:_scroll ( topLineNum,horizOffset);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_insert , args , , " void Fl_Text_Display:_insert (char* text); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
char*   text ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_insert (char* text); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_insert "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
text = new  char  [args( 1 ).string_value ().length()];
strcpy( (char *) text ,args( 1 ).string_value().c_str());
Fl_Text_Display:_insert ( text);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_overstrike , args , , " void Fl_Text_Display:_overstrike (char* text); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
char*   text ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_overstrike (char* text); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_overstrike "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
text = new  char  [args( 1 ).string_value ().length()];
strcpy( (char *) text ,args( 1 ).string_value().c_str());
Fl_Text_Display:_overstrike ( text);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_insert_position , args , , " void Fl_Text_Display:_insert_position (int newPos); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   newPos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_insert_position (int newPos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_insert_position "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
newPos = (  int  ) args( 1 ).int_value();
Fl_Text_Display:_insert_position ( newPos);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_insert_position , args , , " int Fl_Text_Display:_insert_position ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_insert_position ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_insert_position "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_insert_position ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_in_selection , args , , " int Fl_Text_Display:_in_selection (int x,int y); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   x ;
int   y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_in_selection (int x,int y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_in_selection "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_in_selection ( x,y);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_show_insert_position , args , , " void Fl_Text_Display:_show_insert_position ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_show_insert_position ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_show_insert_position "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
Fl_Text_Display:_show_insert_position ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_move_right , args , , " int Fl_Text_Display:_move_right ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_move_right ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_move_right "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_move_right ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_move_left , args , , " int Fl_Text_Display:_move_left ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_move_left ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_move_left "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_move_left ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_move_up , args , , " int Fl_Text_Display:_move_up ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_move_up ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_move_up "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_move_up ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_move_down , args , , " int Fl_Text_Display:_move_down ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_move_down ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_move_down "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_move_down ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_count_lines , args , , " int Fl_Text_Display:_count_lines (int start,int end,bool start_pos_is_line_start); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   start ;
int   end ;
bool   start_pos_is_line_start ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_count_lines (int start,int end,bool start_pos_is_line_start); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_count_lines "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
start_pos_is_line_start = (  bool  ) args( 3 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_count_lines ( start,end,start_pos_is_line_start);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_line_start , args , , " int Fl_Text_Display:_line_start (int pos); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_line_start (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_line_start "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_line_start ( pos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_line_end , args , , " int Fl_Text_Display:_line_end (int pos,bool start_pos_is_line_start); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
bool   start_pos_is_line_start ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_line_end (int pos,bool start_pos_is_line_start); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_line_end "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
start_pos_is_line_start = (  bool  ) args( 2 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_line_end ( pos,start_pos_is_line_start);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_skip_lines , args , , " int Fl_Text_Display:_skip_lines (int startPos,int nLines,bool startPosIsLineStart); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   startPos ;
int   nLines ;
bool   startPosIsLineStart ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_skip_lines (int startPos,int nLines,bool startPosIsLineStart); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_skip_lines "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
startPos = (  int  ) args( 1 ).int_value();
nLines = (  int  ) args( 2 ).int_value();
startPosIsLineStart = (  bool  ) args( 3 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_skip_lines ( startPos,nLines,startPosIsLineStart);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_rewind_lines , args , , " int Fl_Text_Display:_rewind_lines (int startPos,int nLines); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   startPos ;
int   nLines ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_rewind_lines (int startPos,int nLines); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_rewind_lines "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
startPos = (  int  ) args( 1 ).int_value();
nLines = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_rewind_lines ( startPos,nLines);
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_Text_Display:_next_word , args , , " void Fl_Text_Display:_next_word (void); " )
{
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_next_word (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_next_word "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
Fl_Text_Display:_next_word ( _void0);
return octave_value();
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_Text_Display:_previous_word , args , , " void Fl_Text_Display:_previous_word (void); " )
{
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_previous_word (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_previous_word "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
Fl_Text_Display:_previous_word ( _void0);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_show_cursor , args , , " void Fl_Text_Display:_show_cursor (int b = 1); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   b = 1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_show_cursor (int b = 1); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_show_cursor "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
b = 1 = (  int  ) args( 1 ).int_value();
Fl_Text_Display:_show_cursor ( b = 1);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_hide_cursor , args , , " void Fl_Text_Display:_hide_cursor ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_hide_cursor ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_hide_cursor "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
Fl_Text_Display:_hide_cursor ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_cursor_style , args , , " void Fl_Text_Display:_cursor_style (int style); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   style ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_cursor_style (int style); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_cursor_style "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
style = (  int  ) args( 1 ).int_value();
Fl_Text_Display:_cursor_style ( style);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_cursor_color , args , , " Fl_Color Fl_Text_Display:_cursor_color ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Color Fl_Text_Display:_cursor_color ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_cursor_color "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_cursor_color ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_cursor_color , args , , " void Fl_Text_Display:_cursor_color (Fl_Color n); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
Fl_Color   n ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_cursor_color (Fl_Color n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_cursor_color "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
n = (  Fl_Color  ) args( 1 ).long_value();
Fl_Text_Display:_cursor_color ( n);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_scrollbar_width , args , , " int Fl_Text_Display:_scrollbar_width ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_scrollbar_width ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_scrollbar_width "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_scrollbar_width ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_scrollbar_align , args , , " Fl_Align Fl_Text_Display:_scrollbar_align ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Align Fl_Text_Display:_scrollbar_align ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_scrollbar_align "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_scrollbar_align ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_scrollbar_width , args , , " void Fl_Text_Display:_scrollbar_width (int W); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   W ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_scrollbar_width (int W); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_scrollbar_width "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
W = (  int  ) args( 1 ).int_value();
Fl_Text_Display:_scrollbar_width ( W);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_scrollbar_align , args , , " void Fl_Text_Display:_scrollbar_align (Fl_Align a); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
Fl_Align   a ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_scrollbar_align (Fl_Align a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_scrollbar_align "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
a = (  Fl_Align  ) args( 1 ).long_value();
Fl_Text_Display:_scrollbar_align ( a);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_word_start , args , , " int Fl_Text_Display:_word_start (int pos); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_word_start (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_word_start "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_word_start ( pos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_word_end , args , , " int Fl_Text_Display:_word_end (int pos); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_word_end (int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_word_end "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_word_end ( pos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_textfont , args , , " Fl_Font Fl_Text_Display:_textfont ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Font Fl_Text_Display:_textfont ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_textfont "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_textfont ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_textfont , args , , " void Fl_Text_Display:_textfont (uchar s); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
uchar   s ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_textfont (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_textfont "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
s = (  uchar  ) args( 1 ).long_value();
Fl_Text_Display:_textfont ( s);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_textsize , args , , " uchar Fl_Text_Display:_textsize ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  uchar Fl_Text_Display:_textsize ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_textsize "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_textsize ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_textsize , args , , " void Fl_Text_Display:_textsize (uchar s); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
uchar   s ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_textsize (uchar s); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_textsize "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
s = (  uchar  ) args( 1 ).long_value();
Fl_Text_Display:_textsize ( s);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_textcolor , args , , " Fl_Color Fl_Text_Display:_textcolor ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Color Fl_Text_Display:_textcolor ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_textcolor ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_textcolor , args , , " void Fl_Text_Display:_textcolor (n ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
n   _n0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_textcolor (n ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_textcolor "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
_n0 = (  n  ) args( 1 ).long_value();
Fl_Text_Display:_textcolor ( _n0);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_wrapped_column , args , , " int Fl_Text_Display:_wrapped_column (int row,int column); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   row ;
int   column ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_wrapped_column (int row,int column); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_wrapped_column "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
row = (  int  ) args( 1 ).int_value();
column = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_wrapped_column ( row,column);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_wrapped_row , args , , " int Fl_Text_Display:_wrapped_row (int row); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   row ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_wrapped_row (int row); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_wrapped_row "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
row = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_wrapped_row ( row);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_wrap_mode , args , , " void Fl_Text_Display:_wrap_mode (int wrap,int wrap_margin); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   wrap ;
int   wrap_margin ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_wrap_mode (int wrap,int wrap_margin); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_wrap_mode "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
wrap = (  int  ) args( 1 ).int_value();
wrap_margin = (  int  ) args( 2 ).int_value();
Fl_Text_Display:_wrap_mode ( wrap,wrap_margin);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_resize , args , , " virtual Fl_Text_Display:_resize (int X,int Y,int W,int H); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   X ;
int   Y ;
int   W ;
int   H ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  virtual Fl_Text_Display:_resize (int X,int Y,int W,int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_resize "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
W = (  int  ) args( 3 ).int_value();
H = (  int  ) args( 4 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_resize ( X,Y,W,H);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_draw , args , , " virtual Fl_Text_Display:_draw ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_Text_Display:_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_draw "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_draw ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_draw_text , args , , " void Fl_Text_Display:_draw_text (int X,int Y,int W,int H); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   X ;
int   Y ;
int   W ;
int   H ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_draw_text (int X,int Y,int W,int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_draw_text "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
W = (  int  ) args( 3 ).int_value();
H = (  int  ) args( 4 ).int_value();
Fl_Text_Display:_draw_text ( X,Y,W,H);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_draw_range , args , , " void Fl_Text_Display:_draw_range (int start,int end); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   start ;
int   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_draw_range (int start,int end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_draw_range "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
start = (  int  ) args( 1 ).int_value();
end = (  int  ) args( 2 ).int_value();
Fl_Text_Display:_draw_range ( start,end);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_draw_cursor , args , , " void Fl_Text_Display:_draw_cursor (int ,int ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   _int0 ;
int   _int1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_draw_cursor (int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_draw_cursor "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
Fl_Text_Display:_draw_cursor ( _int0,_int1);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_draw_line_numbers , args , , " void Fl_Text_Display:_draw_line_numbers (bool clearAll); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
bool   clearAll ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_draw_line_numbers (bool clearAll); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_draw_line_numbers "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
clearAll = (  bool  ) args( 1 ).long_value();
Fl_Text_Display:_draw_line_numbers ( clearAll);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_clear_rect , args , , " void Fl_Text_Display:_clear_rect (int style,int x,int y,int width,int height); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   style ;
int   x ;
int   y ;
int   width ;
int   height ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_clear_rect (int style,int x,int y,int width,int height); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_clear_rect "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
style = (  int  ) args( 1 ).int_value();
x = (  int  ) args( 2 ).int_value();
y = (  int  ) args( 3 ).int_value();
width = (  int  ) args( 4 ).int_value();
height = (  int  ) args( 5 ).int_value();
Fl_Text_Display:_clear_rect ( style,x,y,width,height);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_display_insert , args , , " void Fl_Text_Display:_display_insert ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_display_insert ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_display_insert "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
Fl_Text_Display:_display_insert ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_offset_line_starts , args , , " void Fl_Text_Display:_offset_line_starts (int newTopLineNum); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   newTopLineNum ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_offset_line_starts (int newTopLineNum); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_offset_line_starts "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
newTopLineNum = (  int  ) args( 1 ).int_value();
Fl_Text_Display:_offset_line_starts ( newTopLineNum);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_calc_line_starts , args , , " void Fl_Text_Display:_calc_line_starts (int startLine,int endLine); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   startLine ;
int   endLine ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_calc_line_starts (int startLine,int endLine); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_calc_line_starts "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
startLine = (  int  ) args( 1 ).int_value();
endLine = (  int  ) args( 2 ).int_value();
Fl_Text_Display:_calc_line_starts ( startLine,endLine);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_calc_last_char , args , , " void Fl_Text_Display:_calc_last_char ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_calc_last_char ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_calc_last_char "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
Fl_Text_Display:_calc_last_char ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_position_to_line , args , , " int Fl_Text_Display:_position_to_line (int pos,int* lineNum); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
int*   lineNum ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_position_to_line (int pos,int* lineNum); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_position_to_line "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
lineNum =( int* )args( 2 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_position_to_line ( pos,lineNum);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_string_width , args , , " int Fl_Text_Display:_string_width (char* string,int length,int style); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
char*   string ;
int   length ;
int   style ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_string_width (char* string,int length,int style); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_string_width "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
string = new  char  [args( 1 ).string_value ().length()];
strcpy( (char *) string ,args( 1 ).string_value().c_str());
length = (  int  ) args( 2 ).int_value();
style = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_string_width ( string,length,style);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_buffer_predelete_cb , args , , " static Fl_Text_Display:_buffer_predelete_cb (int pos,int nDeleted,void* cbArg); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
int   nDeleted ;
void*   cbArg ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  static Fl_Text_Display:_buffer_predelete_cb (int pos,int nDeleted,void* cbArg); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_buffer_predelete_cb "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
nDeleted = (  int  ) args( 2 ).int_value();
cbArg =( void* )args( 3 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_buffer_predelete_cb ( pos,nDeleted,cbArg);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_h_scrollbar_cb , args , , " static Fl_Text_Display:_h_scrollbar_cb (Fl_Scrollbar* w,Fl_Text_Display* d); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
Fl_Scrollbar*   w ;
Fl_Text_Display*   d ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Display:_h_scrollbar_cb (Fl_Scrollbar* w,Fl_Text_Display* d); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_h_scrollbar_cb "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
w =( Fl_Scrollbar* )args( 1 ).long_value();
d =( Fl_Text_Display* )args( 2 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_h_scrollbar_cb ( w,d);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_v_scrollbar_cb , args , , " static Fl_Text_Display:_v_scrollbar_cb (Fl_Scrollbar* w,Fl_Text_Display* d); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
Fl_Scrollbar*   w ;
Fl_Text_Display*   d ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Display:_v_scrollbar_cb (Fl_Scrollbar* w,Fl_Text_Display* d); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_v_scrollbar_cb "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
w =( Fl_Scrollbar* )args( 1 ).long_value();
d =( Fl_Text_Display* )args( 2 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_v_scrollbar_cb ( w,d);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_update_v_scrollbar , args , , " void Fl_Text_Display:_update_v_scrollbar ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_update_v_scrollbar ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_update_v_scrollbar "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
Fl_Text_Display:_update_v_scrollbar ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_update_h_scrollbar , args , , " void Fl_Text_Display:_update_h_scrollbar ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_update_h_scrollbar ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_update_h_scrollbar "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
Fl_Text_Display:_update_h_scrollbar ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_measure_vline , args , , " int Fl_Text_Display:_measure_vline (int visLineNum); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   visLineNum ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_measure_vline (int visLineNum); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_measure_vline "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
visLineNum = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_measure_vline ( visLineNum);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_longest_vline , args , , " int Fl_Text_Display:_longest_vline ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_longest_vline ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_longest_vline "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_longest_vline ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_empty_vlines , args , , " int Fl_Text_Display:_empty_vlines ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_empty_vlines ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_empty_vlines "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_empty_vlines ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_vline_length , args , , " int Fl_Text_Display:_vline_length (int visLineNum); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   visLineNum ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_vline_length (int visLineNum); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_vline_length "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
visLineNum = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_vline_length ( visLineNum);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_xy_to_position , args , , " int Fl_Text_Display:_xy_to_position (int x,int y,int PosType = CHARACTER_POS); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   x ;
int   y ;
int   PosType = CHARACTER_POS ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_xy_to_position (int x,int y,int PosType = CHARACTER_POS); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_xy_to_position "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
PosType = CHARACTER_POS = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_xy_to_position ( x,y,PosType = CHARACTER_POS);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_position_to_xy , args , , " int Fl_Text_Display:_position_to_xy (int pos,int* x,int* y); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
int*   x ;
int*   y ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_position_to_xy (int pos,int* x,int* y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_position_to_xy "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
x =( int* )args( 2 ).long_value();
y =( int* )args( 3 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_position_to_xy ( pos,x,y);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_maintain_absolute_top_line_number , args , , " void Fl_Text_Display:_maintain_absolute_top_line_number (int state); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   state ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_maintain_absolute_top_line_number (int state); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_maintain_absolute_top_line_number "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
state = (  int  ) args( 1 ).int_value();
Fl_Text_Display:_maintain_absolute_top_line_number ( state);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_get_absolute_top_line_number , args , , " int Fl_Text_Display:_get_absolute_top_line_number ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_get_absolute_top_line_number ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_get_absolute_top_line_number "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_get_absolute_top_line_number ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_absolute_top_line_number , args , , " void Fl_Text_Display:_absolute_top_line_number (int oldFirstChar); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   oldFirstChar ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_absolute_top_line_number (int oldFirstChar); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_absolute_top_line_number "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
oldFirstChar = (  int  ) args( 1 ).int_value();
Fl_Text_Display:_absolute_top_line_number ( oldFirstChar);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_maintaining_absolute_top_line_number , args , , " int Fl_Text_Display:_maintaining_absolute_top_line_number ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_maintaining_absolute_top_line_number ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_maintaining_absolute_top_line_number "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_maintaining_absolute_top_line_number ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_reset_absolute_top_line_number , args , , " void Fl_Text_Display:_reset_absolute_top_line_number ( ); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_reset_absolute_top_line_number ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_reset_absolute_top_line_number "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
Fl_Text_Display:_reset_absolute_top_line_number ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_position_to_linecol , args , , " int Fl_Text_Display:_position_to_linecol (int pos,int* lineNum,int* column); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
int*   lineNum ;
int*   column ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_position_to_linecol (int pos,int* lineNum,int* column); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_position_to_linecol "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
lineNum =( int* )args( 2 ).long_value();
column =( int* )args( 3 ).long_value();
long int ret_type=(long int) Fl_Text_Display:_position_to_linecol ( pos,lineNum,column);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_scroll_ , args , , " void Fl_Text_Display:_scroll_ (int topLineNum,int horizOffset); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   topLineNum ;
int   horizOffset ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_scroll_ (int topLineNum,int horizOffset); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_scroll_ "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
topLineNum = (  int  ) args( 1 ).int_value();
horizOffset = (  int  ) args( 2 ).int_value();
Fl_Text_Display:_scroll_ ( topLineNum,horizOffset);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_extend_range_for_styles , args , , " void Fl_Text_Display:_extend_range_for_styles (int* start,int* end); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int*   start ;
int*   end ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_extend_range_for_styles (int* start,int* end); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_extend_range_for_styles "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
start =( int* )args( 1 ).long_value();
end =( int* )args( 2 ).long_value();
Fl_Text_Display:_extend_range_for_styles ( start,end);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_measure_deleted_lines , args , , " void Fl_Text_Display:_measure_deleted_lines (int pos,int nDeleted); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   pos ;
int   nDeleted ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Display:_measure_deleted_lines (int pos,int nDeleted); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_measure_deleted_lines "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
pos = (  int  ) args( 1 ).int_value();
nDeleted = (  int  ) args( 2 ).int_value();
Fl_Text_Display:_measure_deleted_lines ( pos,nDeleted);
return octave_value();
}
DEFUN_DLD( Fl_Text_Display:_measure_proportional_character , args , , " int Fl_Text_Display:_measure_proportional_character (char c,int colNum,int pos); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
char   c ;
int   colNum ;
int   pos ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_measure_proportional_character (char c,int colNum,int pos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_measure_proportional_character "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
c = (  char  ) args( 1 ).long_value();
colNum = (  int  ) args( 2 ).int_value();
pos = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_measure_proportional_character ( c,colNum,pos);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Display:_wrap_uses_character , args , , " int Fl_Text_Display:_wrap_uses_character (int lineEndPos); " )
{
Fl_Text_Display *   _Fl_Text_DisplayPtr ;
int   lineEndPos ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Text_Display:_wrap_uses_character (int lineEndPos); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Display:_wrap_uses_character "<<std::endl;
#endif /* DEBUG */
_Fl_Text_DisplayPtr =( Fl_Text_Display * )args( 0 ).long_value();
lineEndPos = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_Text_Display:_wrap_uses_character ( lineEndPos);
return octave_value(ret_type);
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Text_Display , args , , " void Fl_Text_Display(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
        {
         char *str=NULL;      
         if(args.length()==5)
         str=strdup(args(4).string_value().c_str());
         Fl_Text_Display *flb=new Fl_Text_Display(args(0).int_value(),
                             args(1).int_value(),
                             args(2).int_value(),
                             args(3).int_value(),str);
                 return octave_value(new FLTKWrapper(flb,"Fl_Text_Display"));
                 }
octave_dynamic_loader::load("Fl_Text_Display:_fl_text_drag_me" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_handle" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_buffer" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_buffer" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_buffer" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_redisplay_range" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_scroll" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_insert" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_overstrike" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_insert_position" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_insert_position" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_in_selection" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_show_insert_position" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_move_right" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_move_left" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_move_up" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_move_down" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_count_lines" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_line_start" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_line_end" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_skip_lines" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_rewind_lines" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_next_word" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_previous_word" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_show_cursor" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_hide_cursor" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_cursor_style" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_cursor_color" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_cursor_color" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_scrollbar_width" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_scrollbar_align" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_scrollbar_width" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_scrollbar_align" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_word_start" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_word_end" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_textfont" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_textfont" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_textsize" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_textsize" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_textcolor" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_textcolor" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_wrapped_column" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_wrapped_row" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_wrap_mode" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_resize" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_draw" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_draw_text" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_draw_range" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_draw_cursor" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_draw_line_numbers" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_clear_rect" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_display_insert" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_offset_line_starts" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_calc_line_starts" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_calc_last_char" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_position_to_line" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_string_width" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_buffer_predelete_cb" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_h_scrollbar_cb" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_v_scrollbar_cb" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_update_v_scrollbar" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_update_h_scrollbar" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_measure_vline" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_longest_vline" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_empty_vlines" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_vline_length" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_xy_to_position" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_position_to_xy" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_maintain_absolute_top_line_number" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_get_absolute_top_line_number" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_absolute_top_line_number" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_maintaining_absolute_top_line_number" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_reset_absolute_top_line_number" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_position_to_linecol" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_scroll_" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_extend_range_for_styles" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_measure_deleted_lines" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_measure_proportional_character" ,"");
octave_dynamic_loader::load("Fl_Text_Display:_wrap_uses_character" ,"");
std::cout<<"Code generated onTue Aug  2 17:30:47 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Text_DisplayLibrary!"<<std::endl;
return octave_value(new FLTKStaticWrapper(0,"Fl_Text_Display"));
}
#endif /* 0 */

