/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

#if 0
DEFUN_DLD( Fl_Text_Editor_handle , args , , " virtual Fl_Text_Editor_handle (int e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   e ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  virtual Fl_Text_Editor_handle (int e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_handle "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
e = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->handle ( e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_insert_mode , args , , " void Fl_Text_Editor_insert_mode (int b); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   b ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_insert_mode (int b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_insert_mode "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
b = (  int  ) args( 1 ).int_value();
_Fl_Text_EditorPtr->insert_mode ( b);
return octave_value();
}
DEFUN_DLD( Fl_Text_Editor_insert_mode , args , , " int Fl_Text_Editor_insert_mode ( ); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Editor_insert_mode ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_insert_mode "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->insert_mode ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_add_key_binding , args , , " void Fl_Text_Editor_add_key_binding (int key,int state,Key_Func f,Key_Binding** list); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   key ;
int   state ;
Key_Func   f ;
Key_Binding**   list ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_add_key_binding (int key,int state,Key_Func f,Key_Binding** list); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_add_key_binding "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
key = (  int  ) args( 1 ).int_value();
state = (  int  ) args( 2 ).int_value();
f = (  Key_Func  ) args( 3 ).long_value();
list =( Key_Binding** )args( 4 ).long_value();
_Fl_Text_EditorPtr->add_key_binding ( key,state,f,list);
return octave_value();
}
DEFUN_DLD( Fl_Text_Editor_add_key_binding , args , , " void Fl_Text_Editor_add_key_binding (int key,int state,Key_Func f); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   key ;
int   state ;
Key_Func   f ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_add_key_binding (int key,int state,Key_Func f); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_add_key_binding "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
key = (  int  ) args( 1 ).int_value();
state = (  int  ) args( 2 ).int_value();
f = (  Key_Func  ) args( 3 ).long_value();
_Fl_Text_EditorPtr->add_key_binding ( key,state,f);
return octave_value();
}
DEFUN_DLD( Fl_Text_Editor_add_key_binding , args , , " { Fl_Text_Editor_add_key_binding (key ,state ,f ,&key_bindings ); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
key   _key0 ;
state   _state1 ;
f   _f2 ;
&key_bindings   _&key_bindings3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  { Fl_Text_Editor_add_key_binding (key ,state ,f ,&key_bindings ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_add_key_binding "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
_key0 = (  key  ) args( 1 ).long_value();
_state1 = (  state  ) args( 2 ).long_value();
_f2 = (  f  ) args( 3 ).long_value();
_&key_bindings3 = (  &key_bindings  ) args( 4 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->add_key_binding ( _key0,_state1,_f2,_&key_bindings3);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_remove_key_binding , args , , " void Fl_Text_Editor_remove_key_binding (int key,int state,Key_Binding** list); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   key ;
int   state ;
Key_Binding**   list ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_remove_key_binding (int key,int state,Key_Binding** list); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_remove_key_binding "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
key = (  int  ) args( 1 ).int_value();
state = (  int  ) args( 2 ).int_value();
list =( Key_Binding** )args( 3 ).long_value();
_Fl_Text_EditorPtr->remove_key_binding ( key,state,list);
return octave_value();
}
DEFUN_DLD( Fl_Text_Editor_remove_key_binding , args , , " void Fl_Text_Editor_remove_key_binding (int key,int state); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   key ;
int   state ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_remove_key_binding (int key,int state); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_remove_key_binding "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
key = (  int  ) args( 1 ).int_value();
state = (  int  ) args( 2 ).int_value();
_Fl_Text_EditorPtr->remove_key_binding ( key,state);
return octave_value();
}
DEFUN_DLD( Fl_Text_Editor_remove_key_binding , args , , " { Fl_Text_Editor_remove_key_binding (key ,state ,&key_bindings ); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
key   _key0 ;
state   _state1 ;
&key_bindings   _&key_bindings2 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  { Fl_Text_Editor_remove_key_binding (key ,state ,&key_bindings ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_remove_key_binding "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
_key0 = (  key  ) args( 1 ).long_value();
_state1 = (  state  ) args( 2 ).long_value();
_&key_bindings2 = (  &key_bindings  ) args( 3 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->remove_key_binding ( _key0,_state1,_&key_bindings2);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_remove_all_key_bindings , args , , " void Fl_Text_Editor_remove_all_key_bindings (Key_Binding** list); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
Key_Binding**   list ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_remove_all_key_bindings (Key_Binding** list); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_remove_all_key_bindings "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
list =( Key_Binding** )args( 1 ).long_value();
_Fl_Text_EditorPtr->remove_all_key_bindings ( list);
return octave_value();
}
DEFUN_DLD( Fl_Text_Editor_remove_all_key_bindings , args , , " void Fl_Text_Editor_remove_all_key_bindings ( ); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_remove_all_key_bindings ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_remove_all_key_bindings "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
_Fl_Text_EditorPtr->remove_all_key_bindings ( );
return octave_value();
}
DEFUN_DLD( Fl_Text_Editor_add_default_key_bindings , args , , " void Fl_Text_Editor_add_default_key_bindings (Key_Binding** list); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
Key_Binding**   list ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_add_default_key_bindings (Key_Binding** list); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_add_default_key_bindings "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
list =( Key_Binding** )args( 1 ).long_value();
_Fl_Text_EditorPtr->add_default_key_bindings ( list);
return octave_value();
}
DEFUN_DLD( Fl_Text_Editor_bound_key_function , args , , " Key_Func Fl_Text_Editor_bound_key_function (int key,int state,Key_Binding* list); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   key ;
int   state ;
Key_Binding*   list ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  Key_Func Fl_Text_Editor_bound_key_function (int key,int state,Key_Binding* list); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_bound_key_function "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
key = (  int  ) args( 1 ).int_value();
state = (  int  ) args( 2 ).int_value();
list =( Key_Binding* )args( 3 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->bound_key_function ( key,state,list);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_bound_key_function , args , , " Key_Func Fl_Text_Editor_bound_key_function (int key,int state); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   key ;
int   state ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  Key_Func Fl_Text_Editor_bound_key_function (int key,int state); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_bound_key_function "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
key = (  int  ) args( 1 ).int_value();
state = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->bound_key_function ( key,state);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_bound_key_function , args , , " { Fl_Text_Editor_bound_key_function (key ,state ,key_bindings ); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
key   _key0 ;
state   _state1 ;
key_bindings   _key_bindings2 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  { Fl_Text_Editor_bound_key_function (key ,state ,key_bindings ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_bound_key_function "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
_key0 = (  key  ) args( 1 ).long_value();
_state1 = (  state  ) args( 2 ).long_value();
_key_bindings2 = (  key_bindings  ) args( 3 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->bound_key_function ( _key0,_state1,_key_bindings2);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_default_key_function , args , , " void Fl_Text_Editor_default_key_function (Key_Func f); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
Key_Func   f ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_default_key_function (Key_Func f); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_default_key_function "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
f = (  Key_Func  ) args( 1 ).long_value();
_Fl_Text_EditorPtr->default_key_function ( f);
return octave_value();
}
DEFUN_DLD( Fl_Text_Editor_kf_default , args , , " static Fl_Text_Editor_kf_default (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_default (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_default "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_default ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_ignore , args , , " static Fl_Text_Editor_kf_ignore (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_ignore (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_ignore "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_ignore ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_backspace , args , , " static Fl_Text_Editor_kf_backspace (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_backspace (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_backspace "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_backspace ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_enter , args , , " static Fl_Text_Editor_kf_enter (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_enter (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_enter "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_enter ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_move , args , , " static Fl_Text_Editor_kf_move (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_move (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_move "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_move ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_shift_move , args , , " static Fl_Text_Editor_kf_shift_move (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_shift_move (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_shift_move "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_shift_move ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_ctrl_move , args , , " static Fl_Text_Editor_kf_ctrl_move (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_ctrl_move (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_ctrl_move "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_ctrl_move ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_c_s_move , args , , " static Fl_Text_Editor_kf_c_s_move (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_c_s_move (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_c_s_move "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_c_s_move ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_home , args , , " static Fl_Text_Editor_kf_home (int ,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   _int0 ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_home (int ,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_home "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_home ( _int0,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_end , args , , " static Fl_Text_Editor_kf_end (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_end (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_end "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_end ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_left , args , , " static Fl_Text_Editor_kf_left (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_left (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_left "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_left ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_up , args , , " static Fl_Text_Editor_kf_up (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_up (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_up "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_up ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_right , args , , " static Fl_Text_Editor_kf_right (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_right (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_right "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_right ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_down , args , , " static Fl_Text_Editor_kf_down (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_down (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_down "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_down ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_page_up , args , , " static Fl_Text_Editor_kf_page_up (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_page_up (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_page_up "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_page_up ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_page_down , args , , " static Fl_Text_Editor_kf_page_down (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_page_down (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_page_down "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_page_down ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_insert , args , , " static Fl_Text_Editor_kf_insert (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_insert (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_insert "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_insert ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_delete , args , , " static Fl_Text_Editor_kf_delete (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_delete (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_delete "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_delete ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_copy , args , , " static Fl_Text_Editor_kf_copy (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_copy (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_copy "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_copy ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_cut , args , , " static Fl_Text_Editor_kf_cut (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_cut (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_cut "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_cut ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_paste , args , , " static Fl_Text_Editor_kf_paste (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_paste (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_paste "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_paste ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_select_all , args , , " static Fl_Text_Editor_kf_select_all (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_select_all (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_select_all "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_select_all ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_kf_undo , args , , " static Fl_Text_Editor_kf_undo (int c,Fl_Text_Editor* e); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
int   c ;
Fl_Text_Editor*   e ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  static Fl_Text_Editor_kf_undo (int c,Fl_Text_Editor* e); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_kf_undo "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
c = (  int  ) args( 1 ).int_value();
e =( Fl_Text_Editor* )args( 2 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->kf_undo ( c,e);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_handle_key , args , , " int Fl_Text_Editor_handle_key ( ); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Text_Editor_handle_key ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_handle_key "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_Text_EditorPtr->handle_key ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Text_Editor_maybe_do_callback , args , , " void Fl_Text_Editor_maybe_do_callback ( ); " )
{
Fl_Text_Editor *   _Fl_Text_EditorPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Text_Editor_maybe_do_callback ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Text_Editor_maybe_do_callback "<<std::endl;
#endif /* DEBUG */
_Fl_Text_EditorPtr =( Fl_Text_Editor * )args( 0 ).long_value();
_Fl_Text_EditorPtr->maybe_do_callback ( );
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Text_Editor , args , , " void Fl_Text_Editor(void); " )
{
octave_dynamic_loader::load("Fl_Text_Editor_handle" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_insert_mode" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_insert_mode" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_add_key_binding" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_add_key_binding" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_add_key_binding" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_remove_key_binding" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_remove_key_binding" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_remove_key_binding" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_remove_all_key_bindings" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_remove_all_key_bindings" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_add_default_key_bindings" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_bound_key_function" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_bound_key_function" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_bound_key_function" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_default_key_function" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_default" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_ignore" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_backspace" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_enter" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_move" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_shift_move" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_ctrl_move" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_c_s_move" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_home" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_end" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_left" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_up" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_right" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_down" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_page_up" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_page_down" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_insert" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_delete" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_copy" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_cut" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_paste" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_select_all" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_kf_undo" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_handle_key" ,"");
octave_dynamic_loader::load("Fl_Text_Editor_maybe_do_callback" ,"");
return octave_value("Code generated onSat Jul 30 23:28:34 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Text_EditorLibrary!");
}
#endif /* 0 */
