/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_Tile_handle , args , , " int Fl_Tile_handle (int ); " )
{
Fl_Tile *   _Fl_TilePtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Tile_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Tile_handle "<<std::endl;
#endif /* DEBUG */
_Fl_TilePtr =( Fl_Tile * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_TilePtr->handle ( _int0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Tile_resize , args , , " void Fl_Tile_resize (int ,int ,int ,int ); " )
{
Fl_Tile *   _Fl_TilePtr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Tile_resize (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Tile_resize "<<std::endl;
#endif /* DEBUG */
_Fl_TilePtr =( Fl_Tile * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
_Fl_TilePtr->resize ( _int0,_int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_Tile_position , args , , " void Fl_Tile_position (int ,int ,int ,int ); " )
{
Fl_Tile *   _Fl_TilePtr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Tile_position (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Tile_position "<<std::endl;
#endif /* DEBUG */
_Fl_TilePtr =( Fl_Tile * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
_Fl_TilePtr->position ( _int0,_int1,_int2,_int3);
return octave_value();
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Tile , args , , " void Fl_Tile(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      Fl_Tile *flb=new Fl_Tile(args(0).int_value(),
                             args(1).int_value(),
			     args(2).int_value(),
                             args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Tile"));
    }
octave_dynamic_loader::load("Fl_Tile_handle" ,"");
octave_dynamic_loader::load("Fl_Tile_resize" ,"");
octave_dynamic_loader::load("Fl_Tile_position" ,"");
std::cout<<"Code generated onMon Aug  1 01:29:09 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_TileLibrary!"<<std::endl;
return octave_value(new FLTKStaticWrapper(0,"Fl_Tile"));
}
