/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Timer_handle , args , , " static Fl_Timer_handle ( ); " )
{
  Fl_Timer *ptr=NULL;
  if(args.length()!=2)
    {
      std::cout<< "eg:  static Fl_Timer_value ( ); " <<std::endl;
      return octave_value(-1);
    }

#ifdef DEBUG
  std::cout<<" Fl_Timer_value "<<std::endl;
#endif /* DEBUG */

 ptr=(Fl_Timer *)args(0).long_value();
 
 long int ret_type=(long int) ptr->handle ( args(1).long_value());
 return octave_value(ret_type);
}


DEFUN_DLD( Fl_Timer_value , args , , " static Fl_Timer_value ( ); " )
{
  Fl_Timer *ptr=NULL;
  if(args.length() !=2 || args.length()!=1)
    {
      std::cout<< "eg:  static Fl_Timer_value ( ); " <<std::endl;
      return octave_value(-1);
    }

#ifdef DEBUG
std::cout<<" Fl_Timer_value "<<std::endl;
#endif /* DEBUG */

 ptr=(Fl_Timer *)args(0).long_value();
 if(args.length()!= 2 )
   {
     long int ret_type=(long int) ptr->value ( );
     return octave_value(ret_type);
   }

 unsigned s = (int) args(1).int_value();
 ptr->value(s);
 return octave_value();
}

DEFUN_DLD( Fl_Timer_direction , args , , " static Fl_Timer_direction ( ); " )
{
  Fl_Timer *ptr=NULL;
  if(args.length() !=2 || args.length()!=1)
    {
      std::cout<< "eg:  static Fl_Timer_direction ( ); " <<std::endl;
      return octave_value(-1);
    }

#ifdef DEBUG
std::cout<<" Fl_Timer_direction "<<std::endl;
#endif /* DEBUG */

 ptr=(Fl_Timer *)args(0).long_value();

 if(args.length()!= 2 )
   {
     long int ret_type=(long int)  ptr->direction ( );
     return octave_value(ret_type);
   }

 unsigned s = (  int  ) args( 1 ).int_value();
 ptr->direction ( s);
 return octave_value();
}

DEFUN_DLD( Fl_Timer_suspended, args , , " static Fl_Timer_suspended( ); " )
{
  Fl_Timer *ptr=NULL;
  if(args.length() !=2 || args.length()!=1)
    {
      std::cout<< "eg:  static Fl_Timer_suspended( ); " <<std::endl;
      return octave_value(-1);
    }

#ifdef DEBUG
std::cout<<" Fl_Timer_suspended"<<std::endl;
#endif /* DEBUG */

 ptr=(Fl_Timer *)args(0).long_value();
 if(args.length()!= 2 )
   {
     long int ret_type=(long int) ptr->suspended( );
     return octave_value(ret_type);
   }

unsigned s = (  int  ) args( 1 ).int_value();
 ptr->suspended( s);
 return octave_value();
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Timer , args , , " void Fl_Timer(void); " )
{
  if (args.length() >= 5 && args.length() <= 6)
    {
      char *str=NULL;      
      if(args.length()==6)
	str=strdup(args(5).string_value().c_str());
      
      Fl_Timer *flb=new Fl_Timer(args(0).int_value(),args(1).int_value(),
				 args(2).int_value(),args(3).int_value(),
				 args(4).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Timer"));
    }

  octave_dynamic_loader::load("Fl_Timer_handle" ,"");
  octave_dynamic_loader::load("Fl_Timer_value" ,"");
  octave_dynamic_loader::load("Fl_Timer_direction" ,"");
  octave_dynamic_loader::load("Fl_Timer_suspended" ,"");

  std::cout<<"Code generated onMon Aug  1 19:22:28 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_TimerLibrary!"<<std::endl;
  return octave_value(new FLTKStaticWrapper(0,"Fl_Timer"));
}

