/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_Tooltip_delay , args , , " static Fl_Tooltip_delay ( ); " )
{
 if(args.length()!= 0 || args.length()!=1)
  {
   std::cout<< "eg:  static Fl_Tooltip_delay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Tooltip_delay "<<std::endl;
#endif /* DEBUG */
 if(args.length()==1)
   { 
     long int ret_type=(long int) Fl_Tooltip::delay ( );
     return octave_value(ret_type);
   }

 float f = (  float  ) args( 1 ).double_value();
  Fl_Tooltip::delay ( f);
  return octave_value(); 
}

DEFUN_DLD( Fl_Tooltip_hoverdelay , args , , " static Fl_Tooltip_hoverdelay ( ); " )
{
 if(args.length()!= 0 || args.length()!=1)
  {
   std::cout<< "eg:  static Fl_Tooltip_hoverdelay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Tooltip_hoverdelay "<<std::endl;
#endif /* DEBUG */
 if(args.length()==1)
   { 
     long int ret_type=(long int) Fl_Tooltip::hoverdelay ( );
     return octave_value(ret_type);
   }

 float f = (  float  ) args( 1 ).double_value();
 Fl_Tooltip::hoverdelay ( f);
 return octave_value(); 
}
DEFUN_DLD( Fl_Tooltip_enabled , args , , " static Fl_Tooltip_enabled ( ); " )
{

#ifdef DEBUG
std::cout<<" Fl_Tooltip_enabled "<<std::endl;
#endif /* DEBUG */

 long int ret_type=(long int) Fl_Tooltip::enabled ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Tooltip_enable , args , , " static Fl_Tooltip_enable (int b = 1); " )
{
  int   b = 1 ;//default

  if(args.length() > 1)
  {
   std::cout<< "eg:  static Fl_Tooltip_enable (int b = 1); " <<std::endl;
   return octave_value(-1);
  }

#ifdef DEBUG
std::cout<<" Fl_Tooltip_enable "<<std::endl;
#endif /* DEBUG */

 if(args.length()==1) 
   b = (  int  ) args( 0 ).int_value();
 
  Fl_Tooltip::enable (b);
 return octave_value();
}

DEFUN_DLD( Fl_Tooltip_disable , args , , " static Fl_Tooltip_disable ( ); " )
{

#ifdef DEBUG
std::cout<<" Fl_Tooltip_disable "<<std::endl;
#endif /* DEBUG */
 Fl_Tooltip::disable ( );
 return octave_value();
}

DEFUN_DLD( Fl_Tooltip_enter_area , args , , " static Fl_Tooltip_enter_area (Fl_Widget* w,int X,int Y,int W,int H,char* tip); " )
{
Fl_Widget*   w ;
int   X ;
int   Y ;
int   W ;
int   H ;
char*   tip ;

 if(args.length()!= 6 )
  {
   std::cout<< "eg:  static Fl_Tooltip_enter_area (Fl_Widget* w,int X,int Y,int W,int H,char* tip); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Tooltip_enter_area "<<std::endl;
#endif /* DEBUG */
w =( Fl_Widget* )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
W = (  int  ) args( 3 ).int_value();
H = (  int  ) args( 4 ).int_value();
tip = new  char  [args( 5 ).string_value ().length()];
strcpy( (char *) tip ,args( 5 ).string_value().c_str());

 Fl_Tooltip::enter_area ( w,X,Y,W,H,tip);
 return octave_value();
}
DEFUN_DLD( Fl_Tooltip_current , args , , " static Fl_Tooltip_current ( ); " )
{
  Fl_Widget*   _Fl_Widget0 ;

  if(args.length() >1)
  {
   std::cout<< "eg:  static Fl_Tooltip_current ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Tooltip_current "<<std::endl;
#endif /* DEBUG */

  if(args.length()!= 1 )
    {
      Fl_Widget *wid=(Fl_Widget *)Fl_Tooltip::current ( );
      return octave_value(new FLTKWrapper(wid,"Fl_Widget"));
    }

  _Fl_Widget0 =( Fl_Widget* )args( 0 ).long_value();
  Fl_Tooltip::current ( _Fl_Widget0);  
  return octave_value();
}

DEFUN_DLD( Fl_Tooltip_font , args , , " static Fl_Tooltip_font ( ); " )
{
  if(args.length() > 1)
    {
      std::cout<< "eg:  static Fl_Tooltip_font ( ); " <<std::endl;
      return octave_value(-1);
    }

#ifdef DEBUG
std::cout<<" Fl_Tooltip_font "<<std::endl;
#endif /* DEBUG */

 if(args.length()!= 1 )
   {
     long int ret_type=(long int) Fl_Tooltip::font ( );
     return octave_value(ret_type);
   }

long int s = (  int  ) args( 0 ).int_value();
 Fl_Tooltip::font ( s);
 return octave_value();
}


DEFUN_DLD( Fl_Tooltip_size , args , , " static Fl_Tooltip_size ( ); " )
{
  if(args.length() > 1)
    {
      std::cout<< "eg:  static Fl_Tooltip_size ( ); " <<std::endl;
      return octave_value(-1);
    }

#ifdef DEBUG
std::cout<<" Fl_Tooltip_size "<<std::endl;
#endif /* DEBUG */

 if(args.length()!= 1 )
   {
     long int ret_type=(long int) Fl_Tooltip::size ( );
     return octave_value(ret_type);
   }

long int s = (  int  ) args( 0 ).int_value();
 Fl_Tooltip::size ( s);
 return octave_value();
}


DEFUN_DLD( Fl_Tooltip_color , args , , " static Fl_Tooltip_color ( ); " )
{
 if(args.length() > 1)
{
  std::cout<< "eg:  static Fl_Tooltip_color ( ); " <<std::endl;
  return octave_value(-1);
}

#ifdef DEBUG
std::cout<<" Fl_Tooltip_color "<<std::endl;
#endif /* DEBUG */

 if(args.length()!= 1 )
   {
     long int ret_type=(long int) Fl_Tooltip::color ( );
     return octave_value(ret_type);
   }

long int s = (  int  ) args( 0 ).int_value();
 Fl_Tooltip::color ( s);
 return octave_value();
}

DEFUN_DLD( Fl_Tooltip_textcolor , args , , " static Fl_Tooltip_textcolor ( ); " )
{
  if(args.length() > 1)
    {
      std::cout<< "eg:  static Fl_Tooltip_textcolor ( ); " <<std::endl;
      return octave_value(-1);
    }

#ifdef DEBUG
std::cout<<" Fl_Tooltip_textcolor "<<std::endl;
#endif /* DEBUG */

 if(args.length()!= 1 )
   {
     long int ret_type=(long int) Fl_Tooltip::textcolor ( );
     return octave_value(ret_type);
   }

unsigned s = (  int  ) args( 0 ).int_value();
 Fl_Tooltip::textcolor( s);
return octave_value();
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Tooltip , args , , " void Fl_Tooltip(void); " )
{
  /* No constructors for this Type! */

  /* Static Functions All */
  octave_dynamic_loader::load("Fl_Tooltip_delay" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_hoverdelay" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_enabled" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_enable" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_disable" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_enter_area" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_current" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_font" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_size" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_color" ,"");
  octave_dynamic_loader::load("Fl_Tooltip_textcolor" ,"");
  
  std::cout<<"Code generated onMon Aug  1 18:09:37 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_TooltipLibrary!"<<std::endl;
  
 return octave_value(new FLTKStaticWrapper(0,"Fl_Tooltip"));
}
