/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_Value_Output_handle , args , , " int Fl_Value_Output_handle (int ); " )
{
Fl_Value_Output *   _Fl_Value_OutputPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Value_Output_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Value_Output_handle "<<std::endl;
#endif /* DEBUG */
_Fl_Value_OutputPtr =( Fl_Value_Output * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_Value_OutputPtr->handle ( _int0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Value_Output_draw , args , , " void Fl_Value_Output_draw ( ); " )
{
Fl_Value_Output *   _Fl_Value_OutputPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Value_Output_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Value_Output_draw "<<std::endl;
#endif /* DEBUG */
_Fl_Value_OutputPtr =( Fl_Value_Output * )args( 0 ).long_value();
_Fl_Value_OutputPtr->draw ( );
return octave_value();
}

DEFUN_DLD( Fl_Value_Output_soft , args , , " Fl_Font Fl_Value_Output_soft ( ); " )
{
  Fl_Value_Input *   _Fl_Value_InputPtr ;
  
  if(args.length()!= 1 || args.length()!= 2)
    {
      std::cout<< "eg:  Fl_Font Fl_Value_Output_soft ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Value_Output_soft "<<std::endl;
#endif /* DEBUG */
  _Fl_Value_InputPtr =( Fl_Value_Input * )args( 0 ).long_value();

  if(args.length()!= 2 )
    {
      long int ret_type=(long int) _Fl_Value_InputPtr->soft ( );
      return octave_value(ret_type);
    }

 long int s = (  uchar  ) args( 1 ).long_value();
  _Fl_Value_InputPtr->soft ( s);
  return octave_value();  
}

DEFUN_DLD( Fl_Value_Output_textfont , args , , " Fl_Font Fl_Value_Output_textfont ( ); " )
{
  Fl_Value_Input *   _Fl_Value_InputPtr ;
  
  if(args.length()!= 1 || args.length()!= 2)
    {
      std::cout<< "eg:  Fl_Font Fl_Value_Output_textfont ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Value_Output_textfont "<<std::endl;
#endif /* DEBUG */
  _Fl_Value_InputPtr =( Fl_Value_Input * )args( 0 ).long_value();

  if(args.length()!= 2 )
    {
      long int ret_type=(long int) _Fl_Value_InputPtr->textfont ( );
      return octave_value(ret_type);
    }

long int  s = (  uchar  ) args( 1 ).long_value();
  _Fl_Value_InputPtr->textfont ( s);
  return octave_value();  
}
DEFUN_DLD( Fl_Value_Output_textsize , args , , " Fl_Font Fl_Value_Output_textsize ( ); " )
{
  Fl_Value_Input *   _Fl_Value_InputPtr ;
  
  if(args.length()!= 1 || args.length()!= 2)
    {
      std::cout<< "eg:  Fl_Font Fl_Value_Output_textsize ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Value_Output_textsize "<<std::endl;
#endif /* DEBUG */
  _Fl_Value_InputPtr =( Fl_Value_Input * )args( 0 ).long_value();

  if(args.length()!= 2 )
    {
      long int ret_type=(long int) _Fl_Value_InputPtr->textsize ( );
      return octave_value(ret_type);
    }

long int  s = (  uchar  ) args( 1 ).long_value();
  _Fl_Value_InputPtr->textsize ( s);
  return octave_value();  
}
DEFUN_DLD( Fl_Value_Output_textcolor , args , , " Fl_Font Fl_Value_Output_textcolor ( ); " )
{
  Fl_Value_Input *   _Fl_Value_InputPtr ;
  
  if(args.length()!= 1 || args.length()!= 2)
    {
      std::cout<< "eg:  Fl_Font Fl_Value_Output_textcolor ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Value_Output_textcolor "<<std::endl;
#endif /* DEBUG */
  _Fl_Value_InputPtr =( Fl_Value_Input * )args( 0 ).long_value();

  if(args.length()!= 2 )
    {
      long int ret_type=(long int) _Fl_Value_InputPtr->textcolor ( );
      return octave_value(ret_type);
    }

long int  s = (  uchar  ) args( 1 ).long_value();
  _Fl_Value_InputPtr->textcolor ( s);
  return octave_value();  
}



/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Value_Output , args , , " void Fl_Value_Output(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      Fl_Value_Output *flb=new Fl_Value_Output(args(0).int_value(),
                             args(1).int_value(),
			     args(2).int_value(),
                             args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"Fl_Value_Output"));
    }
  
  octave_dynamic_loader::load("Fl_Value_Output_handle" ,"");
  octave_dynamic_loader::load("Fl_Value_Output_draw" ,"");
  octave_dynamic_loader::load("Fl_Value_Output_soft" ,"");
  octave_dynamic_loader::load("Fl_Value_Output_textfont" ,"");
  octave_dynamic_loader::load("Fl_Value_Output_textsize" ,"");
  octave_dynamic_loader::load("Fl_Value_Output_textcolor" ,"");
  
  std::cout<<"Code generated onMon Aug  1 01:37:12 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_Value_OutputLibrary!"<<std::endl;
  return octave_value(new FLTKStaticWrapper(0,"Fl_Value_Output"));
}
