/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Widget_draw , args , , " virtual Fl_Widget_draw ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_Widget_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std   ::cout<<" Fl_Widget_draw "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 _Fl_WidgetPtr->draw ( );
 return octave_value();
}

DEFUN_DLD( Fl_Widget_handle , args , , " virtual Fl_Widget_handle (int ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  virtual Fl_Widget_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_handle "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) _Fl_WidgetPtr->handle ( _int0);
return octave_value(ret_type);
}

DEFUN_DLD( Fl_Widget_parent , args , , " Fl_Group* Fl_Widget_parent ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
Fl_Group*   p ;
 if(args.length()!= 1 && args.length()!= 2 )
  {
   std::cout<< "eg:  Fl_Group* Fl_Widget_parent ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_parent "<<std::endl;
#endif /* DEBUG */
 if(args.length()!= 2 )
   {
     _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
     Fl_Group *grp= _Fl_WidgetPtr->parent ( );
     return octave_value(new FLTKWrapper(grp,"Fl_Group"));
   }
 
 p =( Fl_Group* )args( 1 ).long_value();
 _Fl_WidgetPtr->parent (p);
 return octave_value();
}

DEFUN_DLD( Fl_Widget_type , args , , " void Fl_Widget_type (uchar t); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
uchar   t ;
 if(args.length()!= 2 && args.length()!= 1  )
  {
   std::cout<< "eg:  void Fl_Widget_type (uchar t); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_type "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()!= 1 )
   {
     t = (  uchar  ) args( 1 ).long_value();
     _Fl_WidgetPtr->type ( t);
     return octave_value();
   }
 
 long int ret_type=(long int) _Fl_WidgetPtr->type ( );
 return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_x , args , , " int Fl_Widget_x ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_x ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_x "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->x ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_y , args , , " int Fl_Widget_y ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_y ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_y "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->y ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_w , args , , " int Fl_Widget_w ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_w ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_w "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->w ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_h , args , , " int Fl_Widget_h ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_h ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_h "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->h ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_resize , args , , " virtual Fl_Widget_resize (int ,int ,int ,int ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  virtual Fl_Widget_resize (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_resize "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
 _Fl_WidgetPtr->resize ( _int0,_int1,_int2,_int3);
 return octave_value();
}
DEFUN_DLD( Fl_Widget_damage_resize , args , , " int Fl_Widget_damage_resize (int ,int ,int ,int ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  int Fl_Widget_damage_resize (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_damage_resize "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
long int ret_type=(long int) _Fl_WidgetPtr->damage_resize ( _int0,_int1,_int2,_int3);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_position , args , , " void Fl_Widget_position (int X,int Y); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
int   X ;
int   Y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Widget_position (int X,int Y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_position "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
X = (  int  ) args( 1 ).int_value();
Y = (  int  ) args( 2 ).int_value();
_Fl_WidgetPtr->position ( X,Y);
return octave_value();
}
DEFUN_DLD( Fl_Widget_size , args , , " void Fl_Widget_size (int W,int H); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
int   W ;
int   H ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Widget_size (int W,int H); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_size "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
W = (  int  ) args( 1 ).int_value();
H = (  int  ) args( 2 ).int_value();
_Fl_WidgetPtr->size ( W,H);
return octave_value();
}
DEFUN_DLD( Fl_Widget_align , args , , " void Fl_Widget_align (uchar a); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  uchar   a ;
  if(args.length()!= 2 && args.length()==1)
    {
      std::cout<< "eg:  void Fl_Widget_align (uchar a); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Widget_align "<<std::endl;
#endif /* DEBUG */
  _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
  
  if(args.length()==1)
    {
      long int ret_type=(long int) _Fl_WidgetPtr->align ( );
      return octave_value(ret_type);
    }
  
  a = (  uchar  ) args( 1 ).long_value();
  _Fl_WidgetPtr->align ( a);
  return octave_value();
}
DEFUN_DLD( Fl_Widget_box , args , , " Fl_Boxtype Fl_Widget_box ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;

 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Fl_Boxtype Fl_Widget_box ( ); " <<std::endl;
   return octave_value(-1);
  }

#ifdef DEBUG
std::cout<<" Fl_Widget_box "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()!= 2 )
   {
     long int ret_type=(long int) _Fl_WidgetPtr->box ( );
     return octave_value(ret_type);
   }

 Fl_Boxtype xa = (  Fl_Boxtype  ) args( 1 ).long_value();
 _Fl_WidgetPtr->box ( xa);
 return octave_value();
}

DEFUN_DLD( Fl_Widget_color , args , , " Fl_Color Fl_Widget_color ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 && args.length()!= 2 && args.length()!= 3 )
  {
   std::cout<< "eg:  Fl_Color Fl_Widget_color ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_color "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if( args.length()== 1)
   {
     long int ret_type=(long int) _Fl_WidgetPtr->color ( );
     return octave_value(ret_type);
   }
 if(args.length() == 2)
   {
     _Fl_WidgetPtr->color (args(1).long_value());
     return octave_value();
   }

 _Fl_WidgetPtr->color ( args( 1 ).long_value(), args( 2 ).long_value());
 return octave_value();
}

DEFUN_DLD( Fl_Widget_selection_color , args , , " Fl_Color Fl_Widget_selection_color ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 && args.length()!= 2 )
  {
   std::cout<< "eg:  Fl_Color Fl_Widget_selection_color ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_selection_color "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()== 1 )
   {
     long int ret_type=(long int) _Fl_WidgetPtr->selection_color ( );
     return octave_value(ret_type);
   }
 _Fl_WidgetPtr->color (args(1).long_value());
 return octave_value();
}

DEFUN_DLD( Fl_Widget_label , args , , " char* Fl_Widget_label ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  if(args.length()!= 1 && args.length()!= 2 )
    {
      std::cout<< "eg:  char* Fl_Widget_label ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Widget_label "<<std::endl;
#endif /* DEBUG */
  _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
  if(args.length()==1)
    {
      string  ret_type(  (const char *) _Fl_WidgetPtr->label ( ));
      return octave_value(ret_type);
    }
  else if(args.length()==2)
    {
      char*   a = new  char  [args( 1 ).string_value ().length()];
      strcpy( (char *) a ,args( 1 ).string_value().c_str());
      _Fl_WidgetPtr->label ( a);
    }
  else if(args.length()==3)
    {
      Fl_Labeltype type = (Fl_Labeltype)args(1).long_value();
      char*   a = new  char  [args( 2 ).string_value ().length()];
      strcpy( (char *) a ,args( 2 ).string_value().c_str());
      _Fl_WidgetPtr->label ( type,a);
    }
  return octave_value();
}

DEFUN_DLD( Fl_Widget_copy_label , args , , 
	   " void Fl_Widget_copy_label (char* a); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  char*   a ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  void Fl_Widget_copy_label (char* a); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Widget_copy_label "<<std::endl;
#endif /* DEBUG */
  _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
  a = new  char  [args( 1 ).string_value ().length()];
  strcpy( (char *) a ,args( 1 ).string_value().c_str());
  _Fl_WidgetPtr->copy_label ( a);
  return octave_value();
}
DEFUN_DLD( Fl_Widget_labeltype , args , , " Fl_Labeltype Fl_Widget_labeltype ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 && args.length()!= 2 )
  {
   std::cout<< "eg:  Fl_Labeltype Fl_Widget_labeltype ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_labeltype "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()!= 2 )
   {
     long int ret_type=(long int) _Fl_WidgetPtr->labeltype ( );
     return octave_value(ret_type);
   }

 Fl_Labeltype   a ;
 a = (  Fl_Labeltype  ) args( 1 ).long_value();
 _Fl_WidgetPtr->labeltype ( a);
 return octave_value();
}

DEFUN_DLD( Fl_Widget_labelcolor , args , , " Fl_Color Fl_Widget_labelcolor ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 && args.length()!= 2)
  {
   std::cout<< "eg:  Fl_Color Fl_Widget_labelcolor ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_labelcolor "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()!=2)
   {
     long int ret_type=(long int) _Fl_WidgetPtr->labelcolor ( );
     return octave_value(ret_type);
   }
 long int a0 = (  long int   ) args( 1 ).long_value();
 _Fl_WidgetPtr->labelcolor (a0);
 return octave_value();
}
DEFUN_DLD( Fl_Widget_labelfont , args , , " Fl_Color Fl_Widget_labelfont ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 && args.length()!= 2)
  {
   std::cout<< "eg:  Fl_Color Fl_Widget_labelfont ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_labelfont "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()!=2)
   {
     long int ret_type=(long int) _Fl_WidgetPtr->labelfont ( );
     return octave_value(ret_type);
   }
 long int a0 = (  long int  ) args( 1 ).long_value();
 _Fl_WidgetPtr->labelfont ( a0);
 return octave_value();
}

DEFUN_DLD( Fl_Widget_labelsize , args , , " Fl_Color Fl_Widget_labelsize ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 && args.length()!= 2)
  {
   std::cout<< "eg:  Fl_Color Fl_Widget_labelsize ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_labelsize "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()!=2)
   {
     long int ret_type=(long int) _Fl_WidgetPtr->labelsize ( );
     return octave_value(ret_type);
   }
 long int _a0 = (  long int ) args( 1 ).long_value();
 _Fl_WidgetPtr->labelsize ( _a0);
 return octave_value();
}


DEFUN_DLD( Fl_Widget_image , args , , " Fl_Image* Fl_Widget_image ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 && args.length()!= 2 )
  {
   std::cout<< "eg:  Fl_Image* Fl_Widget_image ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_image "<<std::endl;
#endif /* DEBUG */
 _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()==1)
   {
     Fl_Image *img= _Fl_WidgetPtr->image ( );
     return octave_value(new FLTKWrapper(img,"Fl_Image"));
   }
 Fl_Image*   a =( Fl_Image* )args( 1 ).long_value();
 _Fl_WidgetPtr->image ( a);
 return octave_value();
}

DEFUN_DLD( Fl_Widget_deimage , args , , " Fl_Image* Fl_Widget_deimage ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
Fl_Image*   a ;

 if(args.length()!= 1 && args.length()!= 2 )
  {
    std::cout<< "eg:  Fl_Image* Fl_Widget_deimage ( ); " <<std::endl;
    return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_deimage "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if( args.length()==1)
   {
     Fl_Image *img= _Fl_WidgetPtr->deimage ( );
     return octave_value(new FLTKWrapper(img,"Fl_Image"));
   }

 a=(Fl_Image *)args(1).long_value();
 _Fl_WidgetPtr->deimage (a );
 return octave_value();
}

#if 0 
/* Cannot support this type of access .*/
DEFUN_DLD( Fl_Widget_deimage , args , , " void Fl_Widget_deimage (Fl_Image& a); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
Fl_Image&   a ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Widget_deimage (Fl_Image& a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_deimage "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
a = (  Fl_Image&  ) args( 1 ).long_value();
_Fl_WidgetPtr->deimage ( a);
return octave_value();
}
#endif

DEFUN_DLD( Fl_Widget_tooltip , args , , " char * Fl_Widget_tooltip ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 && args.length()!= 2 )
  {
   std::cout<< "eg:  char * Fl_Widget_tooltip ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_tooltip "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if( args.length()!= 2 )
   {
     string  ret_type(  (const char *) _Fl_WidgetPtr->tooltip ( ));
     return octave_value(ret_type);
   }
 
 char *t = new  char   [args( 1 ).string_value ().length()];
 strcpy( (char *) t ,args( 1 ).string_value().c_str());
 _Fl_WidgetPtr->tooltip ( t);
 return octave_value();
}
/* Dealwith later*/
#if 0
DEFUN_DLD( Fl_Widget_callback , args , , " Fl_Callback_p Fl_Widget_callback ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  Fl_Callback*   c ;
  void*   p ;

  if(args.length()!= 1 && args.length()!=3  && args.length()!= 2 )
    {
      std::cout<< "eg:  Fl_Callback_p Fl_Widget_callback ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Widget_callback "<<std::endl;
#endif /* DEBUG */
  _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();

  switch(args.length())
    {
    case 1:
      _Fl_WidgetPtr->callback ( );
      break;
    case 2:
      string fcnname=args(1).string_value();
      Fl_Callback0 *cbptr = FLTKWrapper::CreateCallback(_Fl_WidgetPtr,fcnname);
      _Fl_WidgetPtr->callback(cbptr);
      break;
    case 3:
      string fcnname=args(1).string_value();
      void *user_data = args(2).long_value();
      Fl_Callback *cbptr = FLTKWrapper::CreateCallback(_Fl_WidgetPtr,fcnname,
						       user_data);
      _Fl_WidgetPtr->callback(cbptr,user_data);
      p =( void* )args( 2 ).long_value();
      _Fl_WidgetPtr->callback ( c,p);
      break;
    }
  return octave_value();
}
#endif

DEFUN_DLD( Fl_Widget_user_data , args , , " void* Fl_Widget_user_data ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
void*   v ;

 if(args.length()!= 2 && args.length()!= 1 )
  {
   std::cout<< "eg:  void* Fl_Widget_user_data ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_user_data "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()== 1 )
   {
     long int ret_type= (long int) _Fl_WidgetPtr->user_data ( );
     return octave_value(ret_type);
   }

 v =( void* )args( 1 ).long_value();
 _Fl_WidgetPtr->user_data ( v);
 return octave_value();
}

DEFUN_DLD( Fl_Widget_argument , args , , " long Fl_Widget_argument ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 && args.length()!= 2 )
  {
   std::cout<< "eg:  long Fl_Widget_argument ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_argument "<<std::endl;
#endif /* DEBUG */

 _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()==1)
   {
     long int ret_type=(long int) _Fl_WidgetPtr->argument ( );
     return octave_value(ret_type);
   }
 _Fl_WidgetPtr->argument (args( 1 ).long_value());
 return octave_value();
}

DEFUN_DLD( Fl_Widget_when , args , , " Fl_When Fl_Widget_when ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  Fl_When Fl_Widget_when ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Widget_when "<<std::endl;
#endif /* DEBUG */
  _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()!= 2 )
   {
     long int ret_type=(long int) _Fl_WidgetPtr->when ( );
     return octave_value(ret_type);
   }
 _Fl_WidgetPtr->when ( (  uchar  ) args( 1 ).long_value());
 return octave_value();
}

DEFUN_DLD( Fl_Widget_visible , args , , " int Fl_Widget_visible ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_visible ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_visible "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->visible ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_visible_r , args , , " int Fl_Widget_visible_r ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_visible_r ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_visible_r "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->visible_r ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_show , args , , " void Fl_Widget_show ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_show ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_show "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->show ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_hide , args , , " void Fl_Widget_hide ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_hide ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_hide "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->hide ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_set_visible , args , , " void Fl_Widget_set_visible ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_set_visible ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_set_visible "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->set_visible ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_clear_visible , args , , " void Fl_Widget_clear_visible ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_clear_visible ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_clear_visible "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->clear_visible ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_active , args , , " int Fl_Widget_active ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_active ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_active "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->active ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_active_r , args , , " int Fl_Widget_active_r ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_active_r ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_active_r "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->active_r ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_activate , args , , " void Fl_Widget_activate ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_activate ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_activate "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->activate ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_deactivate , args , , " void Fl_Widget_deactivate ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_deactivate ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_deactivate "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->deactivate ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_output , args , , " int Fl_Widget_output ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_output ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_output "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->output ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_set_output , args , , " void Fl_Widget_set_output ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_set_output ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_set_output "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->set_output ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_clear_output , args , , " void Fl_Widget_clear_output ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_clear_output ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_clear_output "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->clear_output ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_takesevents , args , , " int Fl_Widget_takesevents ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_takesevents ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_takesevents "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->takesevents ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_changed , args , , " int Fl_Widget_changed ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_changed ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_changed "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->changed ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_set_changed , args , , " void Fl_Widget_set_changed ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_set_changed ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_set_changed "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->set_changed ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_clear_changed , args , , " void Fl_Widget_clear_changed ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_clear_changed ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_clear_changed "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->clear_changed ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_take_focus , args , , " int Fl_Widget_take_focus ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_take_focus ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_take_focus "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->take_focus ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_set_visible_focus , args , , " void Fl_Widget_set_visible_focus ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_set_visible_focus ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_set_visible_focus "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->set_visible_focus ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_clear_visible_focus , args , , " void Fl_Widget_clear_visible_focus ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_clear_visible_focus ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_clear_visible_focus "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->clear_visible_focus ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_visible_focus , args , , " void Fl_Widget_visible_focus (int v); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
int   v ;
 if(args.length()!= 2 && args.length()!= 1)
  {
   std::cout<< "eg:  void Fl_Widget_visible_focus (int v); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_visible_focus "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
if(args.length()!= 1 )
  {
    v = (  int  ) args( 1 ).int_value();
    _Fl_WidgetPtr->visible_focus ( v);
    return octave_value();
  }

long int ret_type=(long int) _Fl_WidgetPtr->visible_focus ( );
return octave_value(ret_type);
}

#if 0
//#error handle this.
/* static */
DEFUN_DLD( Fl_Widget_default_callback , args , , 
	   " static Fl_Widget_default_callback (Fl_Widget* ,void* ); " )
{
Fl_Widget*   _Fl_Widget0 ;
 void*   _void1 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  static Fl_Widget_default_callback (Fl_Widget* ,void* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_default_callback "<<std::endl;
#endif /* DEBUG */
_Fl_Widget0 =( Fl_Widget* )args( 0 ).long_value();
_void1 =( void* )args( 1 ).long_value();
long int ret_type=(long int) Fl_Widget::default_callback ( _Fl_Widget0,_void1);
return octave_value(ret_type);
}
#endif

DEFUN_DLD( Fl_Widget_do_callback , args , , " void Fl_Widget_do_callback ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  if(args.length()!= 1  && args.length()!=3 && args.length()!=2)
  {
    std::cout<< "eg:  void Fl_Widget_do_callback ( ); " <<std::endl;
    return octave_value(-1);
  }
#ifdef DEBUG
  std::cout<<" Fl_Widget_do_callback "<<std::endl;
#endif /* DEBUG */
  
  if(args.length()==1)
    {
      _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
      _Fl_WidgetPtr->do_callback ( );
      return octave_value();
    }
  
 Fl_Widget*   o ;
 void*   arg=NULL;

 o =( Fl_Widget* )args( 1 ).long_value();

 if(args.length()==3)
   arg=( void* )args( 2 ).long_value();

 if(FLTKWrapper::Exists(arg) && args.length()==3)
   _Fl_WidgetPtr->do_callback (o,arg);
 else 
   _Fl_WidgetPtr->do_callback (o,args(2).long_value());

 return octave_value();
}

/* static one, is Fl_Widget::test_shortcut() */
DEFUN_DLD( Fl_Widget_test_shortcut , args , , " int Fl_Widget_test_shortcut ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 0  && args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Widget_test_shortcut ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_test_shortcut "<<std::endl;
#endif /* DEBUG */ 

 if(args.length()==0)
   {
     /* Static Version */
     _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();     
     long int ret_type=(long int) _Fl_WidgetPtr->test_shortcut ( );
     return octave_value(ret_type);
   }

 long int ret_type=Fl_Widget::test_shortcut(args(1).string_value().c_str());
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Widget_contains , args , , " int Fl_Widget_contains (Fl_Widget* ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  Fl_Widget*   _Fl_Widget0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  int Fl_Widget_contains (Fl_Widget* ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
std::cout<<" Fl_Widget_contains "<<std::endl;
#endif /* DEBUG */
 _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 _Fl_Widget0 =( Fl_Widget* )args( 1 ).long_value();
 long int ret_type=(long int) _Fl_WidgetPtr->contains ( _Fl_Widget0);
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Widget_inside , args , , " int Fl_Widget_inside (Fl_Widget* o); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
Fl_Widget*   o ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Widget_inside (Fl_Widget* o); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_inside "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
o =( Fl_Widget* )args( 1 ).long_value();
long int ret_type=(long int) _Fl_WidgetPtr->inside ( o);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Widget_redraw , args , , " void Fl_Widget_redraw ( ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Widget_redraw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_redraw "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->redraw ( );
return octave_value();
}
DEFUN_DLD( Fl_Widget_redraw_label , args , , " void Fl_Widget_redraw_label ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Widget_redraw_label ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
std::cout<<" Fl_Widget_redraw_label "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
_Fl_WidgetPtr->redraw_label ( );
return octave_value();
}

DEFUN_DLD( Fl_Widget_damage , args , , " uchar Fl_Widget_damage ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  uchar   c ;
  int   _int0 ;
  int   _int1 ;
  int   _int2 ;
  int   _int3 ;

 if(args.length()!= 1 && args.length()!= 6 && args.length()!= 2)
  {
   std::cout<< "eg:  uchar Fl_Widget_damage ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_damage "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();

 if(args.length()==1)
   {
     long int ret_type=(long int) _Fl_WidgetPtr->damage ( );
     return octave_value(ret_type);
   }
 else if(args.length()==6)
   {
     c = (  uchar  ) args( 1 ).long_value();
     _int0 = (  int  ) args( 2 ).int_value();
     _int1 = (  int  ) args( 3 ).int_value();
     _int2 = (  int  ) args( 4 ).int_value();
     _int3 = (  int  ) args( 5 ).int_value();
     _Fl_WidgetPtr->damage ( c,_int0,_int1,_int2,_int3);
   }
 else if(args.length()== 2)
   {
     c = (  uchar  ) args( 1 ).long_value();
     _Fl_WidgetPtr->damage ( c,_int0,_int1,_int2,_int3);
   }
 return octave_value();
}
DEFUN_DLD( Fl_Widget_clear_damage , args , , " void Fl_Widget_clear_damage (uchar c = 0); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
 uchar   c = 0 ;
 if(args.length()!= 2 && args.length()==1)
  {
   std::cout<< "eg:  void Fl_Widget_clear_damage (uchar c = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_clear_damage "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 if(args.length()==2)
   { 
     c =  (  uchar  ) args( 1 ).long_value();
     _Fl_WidgetPtr->clear_damage ( c);
   }
 else
   _Fl_WidgetPtr->clear_damage ();
 
 return octave_value();
}

DEFUN_DLD( Fl_Widget_draw_label , args , , " void Fl_Widget_draw_label (int ,int ,int ,int ,Fl_Align ); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
Fl_Align   _Fl_Align4 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_Widget_draw_label (int ,int ,int ,int ,Fl_Align ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_draw_label "<<std::endl;
#endif /* DEBUG */
_Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 _int0 = (  int  ) args( 1 ).int_value();
 _int1 = (  int  ) args( 2 ).int_value();
 _int2 = (  int  ) args( 3 ).int_value();
 _int3 = (  int  ) args( 4 ).int_value();
 _Fl_Align4 = (  Fl_Align  ) args( 5 ).long_value();
 _Fl_WidgetPtr->draw_label ( _int0,_int1,_int2,_int3,_Fl_Align4);
 return octave_value();
}

/* returns matrix */
DEFUN_DLD( Fl_Widget_measure_label , args , , " void Fl_Widget_measure_label (); " )
{
Fl_Widget *   _Fl_WidgetPtr ;
 int   xx =0;
 int   yy =0;
 Matrix mat(1,2);

 if(args.length()!= 1 )
  {
   std::cout<< "eg:  Matrix[1,2] Fl_Widget_measure_label (); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Widget_measure_label "<<std::endl;
#endif /* DEBUG */

 _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
 _Fl_WidgetPtr->measure_label (xx,yy);

 mat.elem(0,1)=xx;
 mat.elem(0,2)=yy;
 
 return octave_value(mat);
}

DEFUN_DLD( Fl_Widget_window , args , , " Fl_Window* Fl_Widget_window ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  Fl_Window* Fl_Widget_window ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Widget_window "<<std::endl;
#endif /* DEBUG */
  
  _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
  Fl_Window *rt =  _Fl_WidgetPtr->window ( );
  return octave_value(new FLTKWrapper(rt,"Fl_Window"));
}

DEFUN_DLD( Fl_Widget_color2 , args , , " Fl_Color Fl_Widget_color2 ( ); " )
{
  Fl_Widget *   _Fl_WidgetPtr ;
  if(args.length()!= 1 && args.length()!= 2)
    {
      std::cout<< "eg:  Fl_Color Fl_Widget_color2 ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Widget_color2 "<<std::endl;
#endif /* DEBUG */
  if(args.length()== 1)
    {
      _Fl_WidgetPtr =( Fl_Widget * )args( 0 ).long_value();
      Fl_Color ret_type=(Fl_Color) _Fl_WidgetPtr->color2 ( );
      return octave_value(ret_type);
    }
  _Fl_WidgetPtr->color2 (args(1).long_value() );
  return octave_value();
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Widget , args , , " void Fl_Widget(void); " )
{

octave_dynamic_loader::load("Fl_Widget_draw" ,"");
octave_dynamic_loader::load("Fl_Widget_handle" ,"");
octave_dynamic_loader::load("Fl_Widget_parent" ,"");
octave_dynamic_loader::load("Fl_Widget_type" ,"");
octave_dynamic_loader::load("Fl_Widget_x" ,"");
octave_dynamic_loader::load("Fl_Widget_y" ,"");
octave_dynamic_loader::load("Fl_Widget_w" ,"");
octave_dynamic_loader::load("Fl_Widget_h" ,"");
octave_dynamic_loader::load("Fl_Widget_resize" ,"");
octave_dynamic_loader::load("Fl_Widget_damage_resize" ,"");
octave_dynamic_loader::load("Fl_Widget_position" ,"");
octave_dynamic_loader::load("Fl_Widget_size" ,"");
octave_dynamic_loader::load("Fl_Widget_align" ,"");
octave_dynamic_loader::load("Fl_Widget_box" ,"");
octave_dynamic_loader::load("Fl_Widget_selection_color" ,"");
octave_dynamic_loader::load("Fl_Widget_color" ,"");
octave_dynamic_loader::load("Fl_Widget_label" ,"");
octave_dynamic_loader::load("Fl_Widget_copy_label" ,"");
octave_dynamic_loader::load("Fl_Widget_labeltype" ,"");
octave_dynamic_loader::load("Fl_Widget_labelcolor" ,"");
octave_dynamic_loader::load("Fl_Widget_labelfont" ,"");
octave_dynamic_loader::load("Fl_Widget_labelsize" ,"");
octave_dynamic_loader::load("Fl_Widget_image" ,"");
octave_dynamic_loader::load("Fl_Widget_deimage" ,"");
octave_dynamic_loader::load("Fl_Widget_tooltip" ,"");
octave_dynamic_loader::load("Fl_Widget_callback" ,"");
octave_dynamic_loader::load("Fl_Widget_user_data" ,"");
octave_dynamic_loader::load("Fl_Widget_argument" ,"");
octave_dynamic_loader::load("Fl_Widget_when" ,"");
octave_dynamic_loader::load("Fl_Widget_visible_r" ,"");
octave_dynamic_loader::load("Fl_Widget_show" ,"");
octave_dynamic_loader::load("Fl_Widget_hide" ,"");
octave_dynamic_loader::load("Fl_Widget_set_visible" ,"");
octave_dynamic_loader::load("Fl_Widget_clear_visible" ,"");
octave_dynamic_loader::load("Fl_Widget_active" ,"");
octave_dynamic_loader::load("Fl_Widget_active_r" ,"");
octave_dynamic_loader::load("Fl_Widget_activate" ,"");
octave_dynamic_loader::load("Fl_Widget_deactivate" ,"");
octave_dynamic_loader::load("Fl_Widget_output" ,"");
octave_dynamic_loader::load("Fl_Widget_set_output" ,"");
octave_dynamic_loader::load("Fl_Widget_clear_output" ,"");
octave_dynamic_loader::load("Fl_Widget_takesevents" ,"");
octave_dynamic_loader::load("Fl_Widget_changed" ,"");
octave_dynamic_loader::load("Fl_Widget_set_changed" ,"");
octave_dynamic_loader::load("Fl_Widget_clear_changed" ,"");
octave_dynamic_loader::load("Fl_Widget_take_focus" ,"");
octave_dynamic_loader::load("Fl_Widget_set_visible_focus" ,"");
octave_dynamic_loader::load("Fl_Widget_clear_visible_focus" ,"");
octave_dynamic_loader::load("Fl_Widget_visible_focus" ,"");
octave_dynamic_loader::load("Fl_Widget_default_callback" ,"");
octave_dynamic_loader::load("Fl_Widget_do_callback" ,"");
octave_dynamic_loader::load("Fl_Widget_test_shortcut" ,"");
octave_dynamic_loader::load("Fl_Widget_contains" ,"");
octave_dynamic_loader::load("Fl_Widget_inside" ,"");
octave_dynamic_loader::load("Fl_Widget_redraw" ,"");
octave_dynamic_loader::load("Fl_Widget_redraw_label" ,"");
octave_dynamic_loader::load("Fl_Widget_clear_damage" ,"");
octave_dynamic_loader::load("Fl_Widget_damage" ,"");
octave_dynamic_loader::load("Fl_Widget_draw_label" ,"");
octave_dynamic_loader::load("Fl_Widget_measure_label" ,"");
octave_dynamic_loader::load("Fl_Widget_window" ,"");
octave_dynamic_loader::load("Fl_Widget_color2" ,"");
 
 std::cout<<"Code generated onSat Jul 30 23:28:35 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_WidgetLibrary!\n"<<std::endl;

 return octave_value(new FLTKStaticWrapper(0,"Fl_Widget"));
}
/*
  Finally useable
*/
