/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}

DEFUN_DLD( Fl_Window_handle , args , , " virtual Fl_Window_handle (int ); " )
{
  Fl_Window *   _Fl_WindowPtr ;
  int   _int0 ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  virtual Fl_Window_handle (int ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Window_handle "<<std::endl;
#endif /* DEBUG */
  _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
  _int0 = (  int  ) args( 1 ).int_value();
  long int ret_type=(long int) _Fl_WindowPtr->handle ( _int0);
  return octave_value(ret_type);
}

DEFUN_DLD( Fl_Window_resize , args , , " virtual Fl_Window_resize (int ,int ,int ,int ); " )
{
  Fl_Window *   _Fl_WindowPtr ;
  int   _int0 ;
  int   _int1 ;
  int   _int2 ;
  int   _int3 ;
  if(args.length()!= 5 )
    {
   std::cout<< "eg:  virtual Fl_Window_resize (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_resize "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
 _Fl_WindowPtr->resize ( _int0,_int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_Window_border , args , , " int Fl_Window_border ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 && args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Window_border ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_border "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
 if(args.length()!= 2 )
   {
     long int ret_type=(long int) _Fl_WindowPtr->border ( );
     return octave_value(ret_type);
   }

 int b = (  int  ) args( 1 ).int_value();
 _Fl_WindowPtr->border ( b);
 return octave_value();
}

DEFUN_DLD( Fl_Window_clear_border , args , , " void Fl_Window_clear_border ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Window_clear_border ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_clear_border "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
_Fl_WindowPtr->clear_border ( );
return octave_value();
}

DEFUN_DLD( Fl_Window_set_override , args , , " void Fl_Window_set_override ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Window_set_override ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_set_override "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
_Fl_WindowPtr->set_override ( );
return octave_value();
}
DEFUN_DLD( Fl_Window_override , args , , " int Fl_Window_override ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Window_override ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_override "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WindowPtr->override ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Window_set_modal , args , , " void Fl_Window_set_modal ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Window_set_modal ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_set_modal "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
_Fl_WindowPtr->set_modal ( );
return octave_value();
}
DEFUN_DLD( Fl_Window_modal , args , , " int Fl_Window_modal ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Window_modal ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_modal "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WindowPtr->modal ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Window_set_non_modal , args , , " void Fl_Window_set_non_modal ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Window_set_non_modal ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_set_non_modal "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
_Fl_WindowPtr->set_non_modal ( );
return octave_value();
}
DEFUN_DLD( Fl_Window_non_modal , args , , " int Fl_Window_non_modal ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Window_non_modal ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_non_modal "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WindowPtr->non_modal ( );
return octave_value(ret_type);
}

/*
  void hotspot(int x, int y, int offscreen = 0);
  void hotspot(const Fl_Widget*, int offscreen = 0);
*/

DEFUN_DLD( Fl_Window_hotspot , args , , " void Fl_Window_hotspot (int x,int y,int offscreen = 0); " )
{
Fl_Window *   _Fl_WindowPtr ;
Fl_Widget *ptr;
int   x ;
int   y ;
int   offscreen = 0 ;

 if(args.length()!= 4  && args.length()!=3 && args.length()!=2)
  {
   std::cout<< "eg:  void Fl_Window_hotspot (int x,int y,int offscreen = 0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_hotspot "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();

 if(args.length()!= 4)
   {
     int val=0;
     ptr=(Fl_Widget *)args(1).long_value();

     if(args.length()==3)
	 val=args(2).long_value();
     
     _Fl_WindowPtr->hotspot(ptr,val);
   }

 x = (  int  ) args( 1 ).int_value();
 y = (  int  ) args( 2 ).int_value();
 offscreen =  (  int  ) args( 3 ).int_value();
 _Fl_WindowPtr->hotspot ( x,y,offscreen );
 
 return octave_value();
}

DEFUN_DLD( Fl_Window_free_position , args , ,
	   " void Fl_Window_free_position ( ); " )
{
  Fl_Window *   _Fl_WindowPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Window_free_position ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Window_free_position "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
 _Fl_WindowPtr->free_position ( );
 return octave_value();
}

DEFUN_DLD( Fl_Window_size_range , args , , 
	   " void Fl_Window_size_range (int a,int b,int c=0,int d=0,"
	   "int e=0,int f=0,int g=0); " )
{
  Fl_Window *   _Fl_WindowPtr ;
  int   a ;
  int   b;
  int   c=0 ;
  int   d=0 ;
  int   e=0 ;
  int   f=0 ;
  int   g=0 ;
  if(args.length()!= 8  && args.length()!=3)
    {
      std::cout<< "eg:  void Fl_Window_size_range (int a,int b,int c=0,int d=0,int e=0,int f=0,int g=0); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Window_size_range "<<std::endl;
#endif /* DEBUG */
  _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
a = (  int  ) args( 1 ).int_value();
b = (  int  ) args( 2 ).int_value();

 if(args.length()==8)
   {
     c = (  int  ) args( 3 ).int_value();
     d = (  int  ) args( 4 ).int_value();
     e = (  int  ) args( 5 ).int_value();
     f = (  int  ) args( 6 ).int_value();
     g = (  int  ) args( 7 ).int_value();
   }
 _Fl_WindowPtr->size_range ( a,b,c,d,e,f,g);
 return octave_value();
}


DEFUN_DLD( Fl_Window_iconlabel , args , , " void Fl_Window_iconlabel (char* ); " )
{
  Fl_Window *   _Fl_WindowPtr ;
  if(args.length()!= 2 )
    {
      std::cout<< "eg:  void Fl_Window_iconlabel (string)\n"<<std::endl;
      return octave_value(-1);
    }

#ifdef DEBUG
std::cout<<" Fl_Window_iconlabel "<<std::endl;
#endif /* DEBUG */

 _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
 if(args.length()!= 1 )
  {
    _Fl_WindowPtr->iconlabel ( args( 1 ).string_value().c_str());
    return octave_value();
  }
 string  ret_type(  (const char *) _Fl_WindowPtr->iconlabel ( ));
 return octave_value(ret_type);
}


DEFUN_DLD( Fl_Window_label , args , , " char* Fl_Window_label ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 && args.length()!= 2 )
  {
   std::cout<< "eg:  char* Fl_Window_label ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_label "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
  if(args.length()!= 2 )
    {
      string  ret_type(  (const char *) _Fl_WindowPtr->label ( ));
      return octave_value(ret_type);
    }
  string s =args( 1 ).string_value();
  _Fl_WindowPtr->label (s.c_str());
  return octave_value();
}



DEFUN_DLD( Fl_Window_xclass , args , , " char* Fl_Window_xclass ( ); " )
{
  Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  char* Fl_Window_xclass ( ); " <<std::endl;
   return octave_value(-1);
  }

#ifdef DEBUG
 std::cout<<" Fl_Window_xclass "<<std::endl;
#endif /* DEBUG */

 _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
 
 if(args.length()!= 2 )
   {
     string  ret_type(  (const char *) _Fl_WindowPtr->xclass ( ));
     return octave_value(ret_type);
   }
 string c =args( 1 ).string_value();
 _Fl_WindowPtr->xclass ( c.c_str());
 return octave_value();
}

/*
  What is this [void *ic] supposed to mean?
 */
DEFUN_DLD( Fl_Window_icon , args , , " void Fl_Window_icon (void * ic); " )
{
Fl_Window *   _Fl_WindowPtr ;
void *   ic ;
 if(args.length()!= 2 && args.length()!=1)
  {
   std::cout<< "eg:  void Fl_Window_icon (void * ic); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
 std::cout<<" Fl_Window_icon "<<std::endl;
#endif /* DEBUG */
 _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();

 if(args.length()==2)
   {
     ic =( void * )args( 1 ).long_value();
     _Fl_WindowPtr->icon ( ic);
     return octave_value();
   }

 long int ret_type= (long int) _Fl_WindowPtr->icon ( );
 return octave_value(ret_type);
}

DEFUN_DLD( Fl_Window_shown , args , , " virtual Fl_Window_shown ( ); " )
{
  Fl_Window *   _Fl_WindowPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  virtual Fl_Window_hide ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Window_hide "<<std::endl;
#endif /* DEBUG */
  _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
  long int ret_type=(long int) _Fl_WindowPtr->shown ( );
  return octave_value(ret_type);
}

DEFUN_DLD( Fl_Window_hide , args , , " virtual Fl_Window_hide ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  virtual Fl_Window_hide ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_hide "<<std::endl;
#endif /* DEBUG */
 _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
 return  octave_value();
}

DEFUN_DLD( Fl_Window_show , args , , " void Fl_Window_show ({Cell}); " )
{
  Fl_Window *   _Fl_WindowPtr;
  Cell  matrix;

  std::cout<<args.length()<<"args passed to show @ window_show"<<std::endl;
 if(args.length()!= 2 && args.length()!= 1 )
  {
    std::cout<< "eg:  void Fl_Window_show ({Cell}); " <<std::endl;
   return octave_value(-1);
  }

#ifdef DEBUG
 std::cout<<" Fl_Window_show "<<std::endl;
#endif /* DEBUG */
  _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();

  if(args.length()==1)
    {
      _Fl_WindowPtr->hide ( );
      return octave_value();
    }

  matrix=args(1).cell_value();
  char *list_args[matrix.cols()];

  //matrix.print(std::cout,true);
  std::cout<<"r= "<<matrix.rows()<<"c= "<<matrix.cols()<<std::endl;

  for(int i=0;i<matrix.cols();i++)
    {
      list_args[i]=strdup(matrix(0,i).string_value().c_str());
      matrix(0,i).print(std::cout,true);
    }

  _Fl_WindowPtr->show(matrix.cols(),list_args);
  
  for(int i=0;i<matrix.cols();i++)
    free(list_args[i]);
  
  return octave_value();
}

DEFUN_DLD( Fl_Window_fullscreen , args , , " void Fl_Window_fullscreen ( ); " )
{
  Fl_Window *   _Fl_WindowPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Window_fullscreen ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Window_fullscreen "<<std::endl;
#endif /* DEBUG */

  _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
  _Fl_WindowPtr->fullscreen ( );
  return octave_value();
}
DEFUN_DLD( Fl_Window_fullscreen_off , args , , " void Fl_Window_fullscreen_off (int ,int ,int ,int ); " )
{
Fl_Window *   _Fl_WindowPtr ;
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_Window_fullscreen_off (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_fullscreen_off "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
_int1 = (  int  ) args( 2 ).int_value();
_int2 = (  int  ) args( 3 ).int_value();
_int3 = (  int  ) args( 4 ).int_value();
_Fl_WindowPtr->fullscreen_off ( _int0,_int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_Window_iconize , args , , " void Fl_Window_iconize ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Window_iconize ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_iconize "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
_Fl_WindowPtr->iconize ( );
return octave_value();
}
DEFUN_DLD( Fl_Window_x_root , args , , " int Fl_Window_x_root ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Window_x_root ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_x_root "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WindowPtr->x_root ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Window_y_root , args , , " int Fl_Window_y_root ( ); " )
{
Fl_Window *   _Fl_WindowPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  int Fl_Window_y_root ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_y_root "<<std::endl;
#endif /* DEBUG */
_Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
long int ret_type=(long int) _Fl_WindowPtr->y_root ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Window_current , args , , " static Fl_Window_current ( ); " )
{
#ifdef DEBUG
  std::cout<<" Fl_Window_*current "<<std::endl;
#endif /* DEBUG */
  
  Fl_Window *w= Fl_Window::current ( );
  return octave_value(new FLTKWrapper(w,"Fl_Window"));
}


DEFUN_DLD( Fl_Window_make_current , args , , " void Fl_Window_make_current ( ); " )
{
  Fl_Window *   _Fl_WindowPtr ;
  if(args.length()!= 1 )
    {
      std::cout<< "eg:  void Fl_Window_make_current ( ); " <<std::endl;
      return octave_value(-1);
    }
#ifdef DEBUG
  std::cout<<" Fl_Window_make_current "<<std::endl;
#endif /* DEBUG */
  _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
  _Fl_WindowPtr->make_current ( );
  return octave_value();
}

DEFUN_DLD( Fl_Window_cursor , args , , " void Fl_Window_cursor (Fl_Cursor ,Fl_Color=FL_BLACK ,Fl_Color=FL_WHITE ); " )
{
Fl_Window *   _Fl_WindowPtr ;
Fl_Cursor   _Fl_Cursor0 ;
Fl_Color   _Fl_Color1;
Fl_Color   _Fl_Color2;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Window_cursor (Fl_Cursor ,Fl_Color=FL_BLACK ,Fl_Color=FL_WHITE ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_cursor "<<std::endl;
#endif /* DEBUG */
 _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
 _Fl_Cursor0 = ( Fl_Cursor ) args( 1 ).long_value();
 _Fl_Color1 = ( Fl_Color ) args( 2 ).long_value();
 _Fl_Color2 = ( Fl_Color ) args( 3 ).long_value();
 _Fl_WindowPtr->cursor ( _Fl_Cursor0,_Fl_Color1,_Fl_Color2);
 return octave_value();
}
DEFUN_DLD( Fl_Window_default_cursor , args , , " void Fl_Window_default_cursor (Fl_Cursor ,Fl_Color=FL_BLACK ,Fl_Color=FL_WHITE ); " )
{
Fl_Window *   _Fl_WindowPtr ;
Fl_Cursor   _Fl_Cursor0 ;
Fl_Color   _Fl_Color1;
Fl_Color   _Fl_Color2;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Window_default_cursor (Fl_Cursor ,Fl_Color=FL_BLACK ,Fl_Color=FL_WHITE ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_default_cursor "<<std::endl;
#endif /* DEBUG */
 _Fl_WindowPtr =( Fl_Window * )args( 0 ).long_value();
 _Fl_Cursor0 = (  Fl_Cursor  ) args( 1 ).long_value();
 _Fl_Color1 = (  Fl_Color  ) args( 2 ).long_value();
 _Fl_Color2 = (  Fl_Color  ) args( 3 ).long_value();
 _Fl_WindowPtr->default_cursor ( _Fl_Cursor0,_Fl_Color1,_Fl_Color2);
return octave_value();
}

/* Callbacks */
#if 0
DEFUN_DLD( Fl_Window_default_callback , args , , " static Fl_Window_default_callback (Fl_Window* ,string function);" )
{
   string cb_name;

 if(args.length()!= 2 )
  {
    std::cout<< "eg:  static Fl_Window_default_callback (Fl_Window* ,string callback); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Window_default_callback "<<std::endl;
#endif /* DEBUG */

 Fl_Window * _Fl_Window0 =( Fl_Window* )args( 0 ).long_value();
 cb_name =args( 1 ).string_value();
 
 /* DONT -KNOW howto handle callbacks */
 Fl_Window::default_callback ( _Fl_Window0,NULL);

 return octave_value();
}
#endif


DEFUN_DLD( Fl_Window_end , args , , " Fl_Window_end ();" )
{
  if(args.length()!=1)
    {
      std::cout<<"usage: void Fl_Window_end();"<<std::endl;
      return octave_value();
    }
#ifdef DEBUG
std::cout<<" Fl_Window_end "<<std::endl;
#endif /* DEBUG */

 Fl_Window * _Fl_Window0 =( Fl_Window* )args( 0 ).long_value();
 _Fl_Window0->end();

 return octave_value();
}

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( Fl_Window , args , , " void Fl_Window(void); " )
{
  if (args.length() >= 2 && args.length() <= 5)
    {
      char *str=NULL;

      switch(args.length())
	{
	case 2:
	  str=NULL;
	  break;

	case 3:
	  str=strdup(args(2).string_value().c_str());
	  break;

	case 4:
	  str=NULL;
	  break;
	case 5:	    
	  str=strdup(args(4).string_value().c_str());
	  break;
	}
      
      Fl_Window *flb=NULL;
      if(args.length()>=4)	
	flb=new Fl_Window(args(0).int_value(),args(1).int_value(),
			  args(2).int_value(),args(3).int_value(),str);
      else
	flb=new Fl_Window(args(0).int_value(),args(1).int_value(),str);

      return octave_value(new FLTKWrapper(flb,"Fl_Window"));
    }

  octave_dynamic_loader::load("Fl_Window_handle" ,"");
  octave_dynamic_loader::load("Fl_Window_resize" ,"");
  octave_dynamic_loader::load("Fl_Window_border" ,"");
  octave_dynamic_loader::load("Fl_Window_clear_border" ,"");
  octave_dynamic_loader::load("Fl_Window_set_override" ,"");
  octave_dynamic_loader::load("Fl_Window_override" ,"");
  octave_dynamic_loader::load("Fl_Window_set_modal" ,"");
  octave_dynamic_loader::load("Fl_Window_modal" ,"");
  octave_dynamic_loader::load("Fl_Window_set_non_modal" ,"");
  octave_dynamic_loader::load("Fl_Window_non_modal" ,"");
  octave_dynamic_loader::load("Fl_Window_hotspot" ,"");
  octave_dynamic_loader::load("Fl_Window_free_position" ,"");
  octave_dynamic_loader::load("Fl_Window_size_range" ,"");
  octave_dynamic_loader::load("Fl_Window_label" ,"");
  octave_dynamic_loader::load("Fl_Window_iconlabel" ,"");
  octave_dynamic_loader::load("Fl_Window_label" ,"");
  octave_dynamic_loader::load("Fl_Window_iconlabel" ,"");
  octave_dynamic_loader::load("Fl_Window_xclass" ,"");
  octave_dynamic_loader::load("Fl_Window_icon" ,"");
  octave_dynamic_loader::load("Fl_Window_shown" ,"");
  octave_dynamic_loader::load("Fl_Window_hide" ,"");
  octave_dynamic_loader::load("Fl_Window_show" ,"");
  octave_dynamic_loader::load("Fl_Window_end" ,"");
  octave_dynamic_loader::load("Fl_Window_fullscreen" ,"");
  octave_dynamic_loader::load("Fl_Window_fullscreen_off" ,"");
  octave_dynamic_loader::load("Fl_Window_iconize" ,"");
  octave_dynamic_loader::load("Fl_Window_x_root" ,"");
  octave_dynamic_loader::load("Fl_Window_y_root" ,"");
  octave_dynamic_loader::load("Fl_Window_current" ,"");
  octave_dynamic_loader::load("Fl_Window_make_current" ,"");
  octave_dynamic_loader::load("Fl_Window_cursor" ,"");
  octave_dynamic_loader::load("Fl_Window_default_cursor" ,"");

  // Dont -KNOW howto handle callbacks
  //octave_dynamic_loader::load("Fl_Window_default_callback" ,"");

  
  std::cout<<"Code generated onSat Jul 30 23:28:35 2005\n Compiled on " __DATE__  __TIME__ "\n loadedFl_WindowLibrary!\n";

  return octave_value(new FLTKStaticWrapper(0,"Fl_Window"));
}
