/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
#if 0
DEFUN_DLD( Fl_color , args , , " void Fl_color (Fl_Color ); " )
{
Fl_Color   _Fl_Color0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_color (Fl_Color ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_color "<<std::endl;
#endif /* DEBUG */
_Fl_Color0 = (  Fl_Color  ) args( 0 ).long_value();
fl_color ( );
return octave_value();
}
DEFUN_DLD( Fl_color , args , , " void Fl_color (uchar ,uchar ,uchar ); " )
{
uchar   _uchar0 ;
uchar   _uchar1 ;
uchar   _uchar2 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_color (uchar ,uchar ,uchar ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_color "<<std::endl;
#endif /* DEBUG */
_uchar0 = (  uchar  ) args( 0 ).long_value();
_uchar1 = (  uchar  ) args( 1 ).long_value();
_uchar2 = (  uchar  ) args( 2 ).long_value();
fl_color ( _uchar1,_uchar2);
return octave_value();
}
DEFUN_DLD( Fl_push_clip , args , , " void Fl_push_clip (int x,int y,int w,int h); " )
{
int   x ;
int   y ;
int   w ;
int   h ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_push_clip (int x,int y,int w,int h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_push_clip "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
w = (  int  ) args( 2 ).int_value();
h = (  int  ) args( 3 ).int_value();
fl_push_clip ( y,w,h);
return octave_value();
}
DEFUN_DLD( Fl_push_no_clip , args , , " void Fl_push_no_clip ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_push_no_clip ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_push_no_clip "<<std::endl;
#endif /* DEBUG */
fl_push_no_clip ( );
return octave_value();
}
DEFUN_DLD( Fl_pop_clip , args , , " void Fl_pop_clip ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_pop_clip ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_pop_clip "<<std::endl;
#endif /* DEBUG */
fl_pop_clip ( );
return octave_value();
}
DEFUN_DLD( Fl_not_clipped , args , , " int Fl_not_clipped (int x,int y,int w,int h); " )
{
int   x ;
int   y ;
int   w ;
int   h ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_not_clipped (int x,int y,int w,int h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_not_clipped "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
w = (  int  ) args( 2 ).int_value();
h = (  int  ) args( 3 ).int_value();
long int ret_type=(long int) fl_not_clipped ( y,w,h);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_clip_box , args , , " int Fl_clip_box (int ,int ,int ,int ,int& x,int& y,int& w,int& h); " )
{
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
int&   x ;
int&   y ;
int&   w ;
int&   h ;
 if(args.length()!= 8 )
  {
   std::cout<< "eg:  int Fl_clip_box (int ,int ,int ,int ,int& x,int& y,int& w,int& h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_clip_box "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
x = (  int&  ) args( 4 ).int_value();
y = (  int&  ) args( 5 ).int_value();
w = (  int&  ) args( 6 ).int_value();
h = (  int&  ) args( 7 ).int_value();
long int ret_type=(long int) fl_clip_box ( _int1,_int2,_int3,x,y,w,h);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_point , args , , " void Fl_point (int x,int y); " )
{
int   x ;
int   y ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_point (int x,int y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_point "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
fl_point ( y);
return octave_value();
}
DEFUN_DLD( Fl_line_style , args , , " void Fl_line_style (int style,int width=0,char* dashes=0); " )
{
int   style ;
int   width=0 ;
char*   dashes=0 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_line_style (int style,int width=0,char* dashes=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_line_style "<<std::endl;
#endif /* DEBUG */
style = (  int  ) args( 0 ).int_value();
width=0 = (  int  ) args( 1 ).int_value();
dashes=0 = new  char  [args( 2 ).string_value ().length()];
strcpy( (char *) dashes=0 ,args( 2 ).string_value().c_str());
fl_line_style ( width=0,dashes=0);
return octave_value();
}
DEFUN_DLD( Fl_rect , args , , " void Fl_rect (int x,int y,int w,int h); " )
{
int   x ;
int   y ;
int   w ;
int   h ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_rect (int x,int y,int w,int h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_rect "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
w = (  int  ) args( 2 ).int_value();
h = (  int  ) args( 3 ).int_value();
fl_rect ( y,w,h);
return octave_value();
}
DEFUN_DLD( Fl_rectf , args , , " void Fl_rectf (int x,int y,int w,int h); " )
{
int   x ;
int   y ;
int   w ;
int   h ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_rectf (int x,int y,int w,int h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_rectf "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
w = (  int  ) args( 2 ).int_value();
h = (  int  ) args( 3 ).int_value();
fl_rectf ( y,w,h);
return octave_value();
}
DEFUN_DLD( Fl_line , args , , " void Fl_line (int ,int ,int ,int ); " )
{
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_line (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_line "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
fl_line ( _int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_line , args , , " void Fl_line (int ,int ,int ,int ,int ,int ); " )
{
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
int   _int4 ;
int   _int5 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_line (int ,int ,int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_line "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
_int4 = (  int  ) args( 4 ).int_value();
_int5 = (  int  ) args( 5 ).int_value();
fl_line ( _int1,_int2,_int3,_int4,_int5);
return octave_value();
}
DEFUN_DLD( Fl_loop , args , , " void Fl_loop (int ,int ,int ,int ,int ,int ); " )
{
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
int   _int4 ;
int   _int5 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_loop (int ,int ,int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_loop "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
_int4 = (  int  ) args( 4 ).int_value();
_int5 = (  int  ) args( 5 ).int_value();
fl_loop ( _int1,_int2,_int3,_int4,_int5);
return octave_value();
}
DEFUN_DLD( Fl_loop , args , , " void Fl_loop (int ,int ,int ,int ,int ,int ,int ,int ); " )
{
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
int   _int4 ;
int   _int5 ;
int   _int6 ;
int   _int7 ;
 if(args.length()!= 8 )
  {
   std::cout<< "eg:  void Fl_loop (int ,int ,int ,int ,int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_loop "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
_int4 = (  int  ) args( 4 ).int_value();
_int5 = (  int  ) args( 5 ).int_value();
_int6 = (  int  ) args( 6 ).int_value();
_int7 = (  int  ) args( 7 ).int_value();
fl_loop ( _int1,_int2,_int3,_int4,_int5,_int6,_int7);
return octave_value();
}
DEFUN_DLD( Fl_polygon , args , , " void Fl_polygon (int ,int ,int ,int ,int ,int ); " )
{
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
int   _int4 ;
int   _int5 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_polygon (int ,int ,int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_polygon "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
_int4 = (  int  ) args( 4 ).int_value();
_int5 = (  int  ) args( 5 ).int_value();
fl_polygon ( _int1,_int2,_int3,_int4,_int5);
return octave_value();
}
DEFUN_DLD( Fl_polygon , args , , " void Fl_polygon (int ,int ,int ,int ,int ,int ,int ,int ); " )
{
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
int   _int4 ;
int   _int5 ;
int   _int6 ;
int   _int7 ;
 if(args.length()!= 8 )
  {
   std::cout<< "eg:  void Fl_polygon (int ,int ,int ,int ,int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_polygon "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
_int4 = (  int  ) args( 4 ).int_value();
_int5 = (  int  ) args( 5 ).int_value();
_int6 = (  int  ) args( 6 ).int_value();
_int7 = (  int  ) args( 7 ).int_value();
fl_polygon ( _int1,_int2,_int3,_int4,_int5,_int6,_int7);
return octave_value();
}
DEFUN_DLD( Fl_xyline , args , , " void Fl_xyline (int x,int y,int x1); " )
{
int   x ;
int   y ;
int   x1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_xyline (int x,int y,int x1); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_xyline "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
x1 = (  int  ) args( 2 ).int_value();
fl_xyline ( y,x1);
return octave_value();
}
DEFUN_DLD( Fl_xyline , args , , " void Fl_xyline (int x,int y,int x1,int y2); " )
{
int   x ;
int   y ;
int   x1 ;
int   y2 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_xyline (int x,int y,int x1,int y2); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_xyline "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
x1 = (  int  ) args( 2 ).int_value();
y2 = (  int  ) args( 3 ).int_value();
fl_xyline ( y,x1,y2);
return octave_value();
}
DEFUN_DLD( Fl_xyline , args , , " void Fl_xyline (int x,int y,int x1,int y2,int x3); " )
{
int   x ;
int   y ;
int   x1 ;
int   y2 ;
int   x3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_xyline (int x,int y,int x1,int y2,int x3); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_xyline "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
x1 = (  int  ) args( 2 ).int_value();
y2 = (  int  ) args( 3 ).int_value();
x3 = (  int  ) args( 4 ).int_value();
fl_xyline ( y,x1,y2,x3);
return octave_value();
}
DEFUN_DLD( Fl_yxline , args , , " void Fl_yxline (int x,int y,int y1); " )
{
int   x ;
int   y ;
int   y1 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_yxline (int x,int y,int y1); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_yxline "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
y1 = (  int  ) args( 2 ).int_value();
fl_yxline ( y,y1);
return octave_value();
}
DEFUN_DLD( Fl_yxline , args , , " void Fl_yxline (int x,int y,int y1,int x2); " )
{
int   x ;
int   y ;
int   y1 ;
int   x2 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_yxline (int x,int y,int y1,int x2); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_yxline "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
y1 = (  int  ) args( 2 ).int_value();
x2 = (  int  ) args( 3 ).int_value();
fl_yxline ( y,y1,x2);
return octave_value();
}
DEFUN_DLD( Fl_yxline , args , , " void Fl_yxline (int x,int y,int y1,int x2,int y3); " )
{
int   x ;
int   y ;
int   y1 ;
int   x2 ;
int   y3 ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_yxline (int x,int y,int y1,int x2,int y3); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_yxline "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
y1 = (  int  ) args( 2 ).int_value();
x2 = (  int  ) args( 3 ).int_value();
y3 = (  int  ) args( 4 ).int_value();
fl_yxline ( y,y1,x2,y3);
return octave_value();
}
DEFUN_DLD( Fl_arc , args , , " void Fl_arc (int x,int y,int w,int h,double a1,double a2); " )
{
int   x ;
int   y ;
int   w ;
int   h ;
double   a1 ;
double   a2 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_arc (int x,int y,int w,int h,double a1,double a2); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_arc "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
w = (  int  ) args( 2 ).int_value();
h = (  int  ) args( 3 ).int_value();
a1 = (  double  ) args( 4 ).double_value();
a2 = (  double  ) args( 5 ).double_value();
fl_arc ( y,w,h,a1,a2);
return octave_value();
}
DEFUN_DLD( Fl_pie , args , , " void Fl_pie (int x,int y,int w,int h,double a1,double a2); " )
{
int   x ;
int   y ;
int   w ;
int   h ;
double   a1 ;
double   a2 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_pie (int x,int y,int w,int h,double a1,double a2); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_pie "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
w = (  int  ) args( 2 ).int_value();
h = (  int  ) args( 3 ).int_value();
a1 = (  double  ) args( 4 ).double_value();
a2 = (  double  ) args( 5 ).double_value();
fl_pie ( y,w,h,a1,a2);
return octave_value();
}
DEFUN_DLD( Fl_chord , args , , " void Fl_chord (int x,int y,int w,int h,double a1,double a2); " )
{
int   x ;
int   y ;
int   w ;
int   h ;
double   a1 ;
double   a2 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_chord (int x,int y,int w,int h,double a1,double a2); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_chord "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
w = (  int  ) args( 2 ).int_value();
h = (  int  ) args( 3 ).int_value();
a1 = (  double  ) args( 4 ).double_value();
a2 = (  double  ) args( 5 ).double_value();
fl_chord ( y,w,h,a1,a2);
return octave_value();
}
DEFUN_DLD( Fl_push_matrix , args , , " void Fl_push_matrix ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_push_matrix ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_push_matrix "<<std::endl;
#endif /* DEBUG */
fl_push_matrix ( );
return octave_value();
}
DEFUN_DLD( Fl_pop_matrix , args , , " void Fl_pop_matrix ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_pop_matrix ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_pop_matrix "<<std::endl;
#endif /* DEBUG */
fl_pop_matrix ( );
return octave_value();
}
DEFUN_DLD( Fl_scale , args , , " void Fl_scale (double x,double y); " )
{
double   x ;
double   y ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_scale (double x,double y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_scale "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
fl_scale ( y);
return octave_value();
}
DEFUN_DLD( Fl_scale , args , , " void Fl_scale (double x); " )
{
double   x ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_scale (double x); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_scale "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
fl_scale ( );
return octave_value();
}
DEFUN_DLD( Fl_translate , args , , " void Fl_translate (double x,double y); " )
{
double   x ;
double   y ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_translate (double x,double y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_translate "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
fl_translate ( y);
return octave_value();
}
DEFUN_DLD( Fl_rotate , args , , " void Fl_rotate (double d); " )
{
double   d ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_rotate (double d); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_rotate "<<std::endl;
#endif /* DEBUG */
d = (  double  ) args( 0 ).double_value();
fl_rotate ( );
return octave_value();
}
DEFUN_DLD( Fl_mult_matrix , args , , " void Fl_mult_matrix (double a,double b,double c,double d,double x,double y); " )
{
double   a ;
double   b ;
double   c ;
double   d ;
double   x ;
double   y ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_mult_matrix (double a,double b,double c,double d,double x,double y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_mult_matrix "<<std::endl;
#endif /* DEBUG */
a = (  double  ) args( 0 ).double_value();
b = (  double  ) args( 1 ).double_value();
c = (  double  ) args( 2 ).double_value();
d = (  double  ) args( 3 ).double_value();
x = (  double  ) args( 4 ).double_value();
y = (  double  ) args( 5 ).double_value();
fl_mult_matrix ( b,c,d,x,y);
return octave_value();
}
DEFUN_DLD( Fl_begin_points , args , , " void Fl_begin_points ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_begin_points ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_begin_points "<<std::endl;
#endif /* DEBUG */
fl_begin_points ( );
return octave_value();
}
DEFUN_DLD( Fl_begin_line , args , , " void Fl_begin_line ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_begin_line ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_begin_line "<<std::endl;
#endif /* DEBUG */
fl_begin_line ( );
return octave_value();
}
DEFUN_DLD( Fl_begin_loop , args , , " void Fl_begin_loop ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_begin_loop ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_begin_loop "<<std::endl;
#endif /* DEBUG */
fl_begin_loop ( );
return octave_value();
}
DEFUN_DLD( Fl_begin_polygon , args , , " void Fl_begin_polygon ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_begin_polygon ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_begin_polygon "<<std::endl;
#endif /* DEBUG */
fl_begin_polygon ( );
return octave_value();
}
DEFUN_DLD( Fl_vertex , args , , " void Fl_vertex (double x,double y); " )
{
double   x ;
double   y ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_vertex (double x,double y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_vertex "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
fl_vertex ( y);
return octave_value();
}
DEFUN_DLD( Fl_curve , args , , " void Fl_curve (double ,double ,double ,double ,double ,double ,double ,double ); " )
{
double   _double0 ;
double   _double1 ;
double   _double2 ;
double   _double3 ;
double   _double4 ;
double   _double5 ;
double   _double6 ;
double   _double7 ;
 if(args.length()!= 8 )
  {
   std::cout<< "eg:  void Fl_curve (double ,double ,double ,double ,double ,double ,double ,double ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_curve "<<std::endl;
#endif /* DEBUG */
_double0 = (  double  ) args( 0 ).double_value();
_double1 = (  double  ) args( 1 ).double_value();
_double2 = (  double  ) args( 2 ).double_value();
_double3 = (  double  ) args( 3 ).double_value();
_double4 = (  double  ) args( 4 ).double_value();
_double5 = (  double  ) args( 5 ).double_value();
_double6 = (  double  ) args( 6 ).double_value();
_double7 = (  double  ) args( 7 ).double_value();
fl_curve ( _double1,_double2,_double3,_double4,_double5,_double6,_double7);
return octave_value();
}
DEFUN_DLD( Fl_arc , args , , " void Fl_arc (double x,double y,double r,double start,double a); " )
{
double   x ;
double   y ;
double   r ;
double   start ;
double   a ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_arc (double x,double y,double r,double start,double a); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_arc "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
r = (  double  ) args( 2 ).double_value();
start = (  double  ) args( 3 ).double_value();
a = (  double  ) args( 4 ).double_value();
fl_arc ( y,r,start,a);
return octave_value();
}
DEFUN_DLD( Fl_circle , args , , " void Fl_circle (double x,double y,double r); " )
{
double   x ;
double   y ;
double   r ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_circle (double x,double y,double r); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_circle "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
r = (  double  ) args( 2 ).double_value();
fl_circle ( y,r);
return octave_value();
}
DEFUN_DLD( Fl_end_points , args , , " void Fl_end_points ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_end_points ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_end_points "<<std::endl;
#endif /* DEBUG */
fl_end_points ( );
return octave_value();
}
DEFUN_DLD( Fl_end_line , args , , " void Fl_end_line ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_end_line ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_end_line "<<std::endl;
#endif /* DEBUG */
fl_end_line ( );
return octave_value();
}
DEFUN_DLD( Fl_end_loop , args , , " void Fl_end_loop ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_end_loop ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_end_loop "<<std::endl;
#endif /* DEBUG */
fl_end_loop ( );
return octave_value();
}
DEFUN_DLD( Fl_end_polygon , args , , " void Fl_end_polygon ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_end_polygon ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_end_polygon "<<std::endl;
#endif /* DEBUG */
fl_end_polygon ( );
return octave_value();
}
DEFUN_DLD( Fl_begin_complex_polygon , args , , " void Fl_begin_complex_polygon ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_begin_complex_polygon ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_begin_complex_polygon "<<std::endl;
#endif /* DEBUG */
fl_begin_complex_polygon ( );
return octave_value();
}
DEFUN_DLD( Fl_gap , args , , " void Fl_gap ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_gap ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_gap "<<std::endl;
#endif /* DEBUG */
fl_gap ( );
return octave_value();
}
DEFUN_DLD( Fl_end_complex_polygon , args , , " void Fl_end_complex_polygon ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_end_complex_polygon ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_end_complex_polygon "<<std::endl;
#endif /* DEBUG */
fl_end_complex_polygon ( );
return octave_value();
}
DEFUN_DLD( Fl_transform_x , args , , " double Fl_transform_x (double x,double y); " )
{
double   x ;
double   y ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  double Fl_transform_x (double x,double y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_transform_x "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
long int ret_type=(long int) fl_transform_x ( y);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_transform_y , args , , " double Fl_transform_y (double x,double y); " )
{
double   x ;
double   y ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  double Fl_transform_y (double x,double y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_transform_y "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
long int ret_type=(long int) fl_transform_y ( y);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_transform_dx , args , , " double Fl_transform_dx (double x,double y); " )
{
double   x ;
double   y ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  double Fl_transform_dx (double x,double y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_transform_dx "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
long int ret_type=(long int) fl_transform_dx ( y);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_transform_dy , args , , " double Fl_transform_dy (double x,double y); " )
{
double   x ;
double   y ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  double Fl_transform_dy (double x,double y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_transform_dy "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
long int ret_type=(long int) fl_transform_dy ( y);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_transformed_vertex , args , , " void Fl_transformed_vertex (double x,double y); " )
{
double   x ;
double   y ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_transformed_vertex (double x,double y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_transformed_vertex "<<std::endl;
#endif /* DEBUG */
x = (  double  ) args( 0 ).double_value();
y = (  double  ) args( 1 ).double_value();
fl_transformed_vertex ( y);
return octave_value();
}
DEFUN_DLD( Fl_font , args , , " void Fl_font (int face,int size); " )
{
int   face ;
int   size ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_font (int face,int size); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_font "<<std::endl;
#endif /* DEBUG */
face = (  int  ) args( 0 ).int_value();
size = (  int  ) args( 1 ).int_value();
fl_font ( size);
return octave_value();
}
DEFUN_DLD( Fl_height , args , , " int Fl_height ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  int Fl_height ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_height "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) fl_height ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_descent , args , , " int Fl_descent ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  int Fl_descent ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_descent "<<std::endl;
#endif /* DEBUG */
long int ret_type=(long int) fl_descent ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_width , args , , " double Fl_width (char* ); " )
{
char*   _char0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  double Fl_width (char* ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_width "<<std::endl;
#endif /* DEBUG */
_char0 = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) _char0 ,args( 0 ).string_value().c_str());
long int ret_type=(long int) fl_width ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_width , args , , " double Fl_width (char* ,int n); " )
{
char*   _char0 ;
int   n ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  double Fl_width (char* ,int n); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_width "<<std::endl;
#endif /* DEBUG */
_char0 = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) _char0 ,args( 0 ).string_value().c_str());
n = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) fl_width ( n);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_width , args , , " double Fl_width (uchar ); " )
{
uchar   _uchar0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  double Fl_width (uchar ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_width "<<std::endl;
#endif /* DEBUG */
_uchar0 = (  uchar  ) args( 0 ).long_value();
long int ret_type=(long int) fl_width ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_draw , args , , " void Fl_draw (char* ,int x,int y); " )
{
char*   _char0 ;
int   x ;
int   y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_draw (char* ,int x,int y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw "<<std::endl;
#endif /* DEBUG */
_char0 = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) _char0 ,args( 0 ).string_value().c_str());
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
fl_draw ( x,y);
return octave_value();
}
DEFUN_DLD( Fl_draw , args , , " void Fl_draw (char* ,int n,int x,int y); " )
{
char*   _char0 ;
int   n ;
int   x ;
int   y ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_draw (char* ,int n,int x,int y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw "<<std::endl;
#endif /* DEBUG */
_char0 = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) _char0 ,args( 0 ).string_value().c_str());
n = (  int  ) args( 1 ).int_value();
x = (  int  ) args( 2 ).int_value();
y = (  int  ) args( 3 ).int_value();
fl_draw ( n,x,y);
return octave_value();
}
DEFUN_DLD( Fl_measure , args , , " void Fl_measure (char* ,int& x,int& y,int draw_symbols = 1); " )
{
char*   _char0 ;
int&   x ;
int&   y ;
int   draw_symbols = 1 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_measure (char* ,int& x,int& y,int draw_symbols = 1); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_measure "<<std::endl;
#endif /* DEBUG */
_char0 = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) _char0 ,args( 0 ).string_value().c_str());
x = (  int&  ) args( 1 ).int_value();
y = (  int&  ) args( 2 ).int_value();
draw_symbols = 1 = (  int  ) args( 3 ).int_value();
fl_measure ( x,y,draw_symbols = 1);
return octave_value();
}
DEFUN_DLD( Fl_frame , args , , " void Fl_frame (char* s,int x,int y,int w,int h); " )
{
char*   s ;
int   x ;
int   y ;
int   w ;
int   h ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_frame (char* s,int x,int y,int w,int h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_frame "<<std::endl;
#endif /* DEBUG */
s = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) s ,args( 0 ).string_value().c_str());
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
w = (  int  ) args( 3 ).int_value();
h = (  int  ) args( 4 ).int_value();
fl_frame ( x,y,w,h);
return octave_value();
}
DEFUN_DLD( Fl_frame2 , args , , " void Fl_frame2 (char* s,int x,int y,int w,int h); " )
{
char*   s ;
int   x ;
int   y ;
int   w ;
int   h ;
 if(args.length()!= 5 )
  {
   std::cout<< "eg:  void Fl_frame2 (char* s,int x,int y,int w,int h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_frame2 "<<std::endl;
#endif /* DEBUG */
s = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) s ,args( 0 ).string_value().c_str());
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
w = (  int  ) args( 3 ).int_value();
h = (  int  ) args( 4 ).int_value();
fl_frame2 ( x,y,w,h);
return octave_value();
}
DEFUN_DLD( Fl_draw_box , args , , " void Fl_draw_box (Fl_Boxtype ,int x,int y,int w,int h,Fl_Color ); " )
{
Fl_Boxtype   _Fl_Boxtype0 ;
int   x ;
int   y ;
int   w ;
int   h ;
Fl_Color   _Fl_Color1 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  void Fl_draw_box (Fl_Boxtype ,int x,int y,int w,int h,Fl_Color ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw_box "<<std::endl;
#endif /* DEBUG */
_Fl_Boxtype0 = (  Fl_Boxtype  ) args( 0 ).long_value();
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
w = (  int  ) args( 3 ).int_value();
h = (  int  ) args( 4 ).int_value();
_Fl_Color1 = (  Fl_Color  ) args( 5 ).long_value();
fl_draw_box ( x,y,w,h,_Fl_Color1);
return octave_value();
}
DEFUN_DLD( Fl_draw_image , args , , " void Fl_draw_image (uchar* ,int ,int ,int ,int ,int delta=3,int ldelta=0); " )
{
uchar*   _uchar0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
int   _int4 ;
int   delta=3 ;
int   ldelta=0 ;
 if(args.length()!= 7 )
  {
   std::cout<< "eg:  void Fl_draw_image (uchar* ,int ,int ,int ,int ,int delta=3,int ldelta=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw_image "<<std::endl;
#endif /* DEBUG */
_uchar0 = new  uchar  [args( 0 ).string_value ().length()];
strcpy( (char *) _uchar0 ,args( 0 ).string_value().c_str());
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
_int4 = (  int  ) args( 4 ).int_value();
delta=3 = (  int  ) args( 5 ).int_value();
ldelta=0 = (  int  ) args( 6 ).int_value();
fl_draw_image ( _int1,_int2,_int3,_int4,delta=3,ldelta=0);
return octave_value();
}
DEFUN_DLD( Fl_draw_image_mono , args , , " void Fl_draw_image_mono (uchar* ,int ,int ,int ,int ,int delta=1,int ld=0); " )
{
uchar*   _uchar0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
int   _int4 ;
int   delta=1 ;
int   ld=0 ;
 if(args.length()!= 7 )
  {
   std::cout<< "eg:  void Fl_draw_image_mono (uchar* ,int ,int ,int ,int ,int delta=1,int ld=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw_image_mono "<<std::endl;
#endif /* DEBUG */
_uchar0 = new  uchar  [args( 0 ).string_value ().length()];
strcpy( (char *) _uchar0 ,args( 0 ).string_value().c_str());
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
_int4 = (  int  ) args( 4 ).int_value();
delta=1 = (  int  ) args( 5 ).int_value();
ld=0 = (  int  ) args( 6 ).int_value();
fl_draw_image_mono ( _int1,_int2,_int3,_int4,delta=1,ld=0);
return octave_value();
}
DEFUN_DLD( Fl_draw_image , args , , " void Fl_draw_image (Fl_Draw_Image_Cb ,void* ,int ,int ,int ,int ,int delta=3); " )
{
Fl_Draw_Image_Cb   _Fl_Draw_Image_Cb0 ;
void*   _void1 ;
int   _int2 ;
int   _int3 ;
int   _int4 ;
int   _int5 ;
int   delta=3 ;
 if(args.length()!= 7 )
  {
   std::cout<< "eg:  void Fl_draw_image (Fl_Draw_Image_Cb ,void* ,int ,int ,int ,int ,int delta=3); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw_image "<<std::endl;
#endif /* DEBUG */
_Fl_Draw_Image_Cb0 = (  Fl_Draw_Image_Cb  ) args( 0 ).long_value();
_void1 =( void* )args( 1 ).long_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
_int4 = (  int  ) args( 4 ).int_value();
_int5 = (  int  ) args( 5 ).int_value();
delta=3 = (  int  ) args( 6 ).int_value();
fl_draw_image ( _void1,_int2,_int3,_int4,_int5,delta=3);
return octave_value();
}
DEFUN_DLD( Fl_draw_image_mono , args , , " void Fl_draw_image_mono (Fl_Draw_Image_Cb ,void* ,int ,int ,int ,int ,int delta=1); " )
{
Fl_Draw_Image_Cb   _Fl_Draw_Image_Cb0 ;
void*   _void1 ;
int   _int2 ;
int   _int3 ;
int   _int4 ;
int   _int5 ;
int   delta=1 ;
 if(args.length()!= 7 )
  {
   std::cout<< "eg:  void Fl_draw_image_mono (Fl_Draw_Image_Cb ,void* ,int ,int ,int ,int ,int delta=1); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw_image_mono "<<std::endl;
#endif /* DEBUG */
_Fl_Draw_Image_Cb0 = (  Fl_Draw_Image_Cb  ) args( 0 ).long_value();
_void1 =( void* )args( 1 ).long_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
_int4 = (  int  ) args( 4 ).int_value();
_int5 = (  int  ) args( 5 ).int_value();
delta=1 = (  int  ) args( 6 ).int_value();
fl_draw_image_mono ( _void1,_int2,_int3,_int4,_int5,delta=1);
return octave_value();
}
DEFUN_DLD( Fl_rectf , args , , " void Fl_rectf (int x,int y,int w,int h,uchar r,uchar g,uchar b); " )
{
int   x ;
int   y ;
int   w ;
int   h ;
uchar   r ;
uchar   g ;
uchar   b ;
 if(args.length()!= 7 )
  {
   std::cout<< "eg:  void Fl_rectf (int x,int y,int w,int h,uchar r,uchar g,uchar b); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_rectf "<<std::endl;
#endif /* DEBUG */
x = (  int  ) args( 0 ).int_value();
y = (  int  ) args( 1 ).int_value();
w = (  int  ) args( 2 ).int_value();
h = (  int  ) args( 3 ).int_value();
r = (  uchar  ) args( 4 ).long_value();
g = (  uchar  ) args( 5 ).long_value();
b = (  uchar  ) args( 6 ).long_value();
fl_rectf ( y,w,h,r,g,b);
return octave_value();
}
DEFUN_DLD( Fl_read_image , args , , " uchar * Fl_read_image (uchar * p,int x,int y,int w,int h,int alpha=0); " )
{
uchar *   p ;
int   x ;
int   y ;
int   w ;
int   h ;
int   alpha=0 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  uchar * Fl_read_image (uchar * p,int x,int y,int w,int h,int alpha=0); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_read_image "<<std::endl;
#endif /* DEBUG */
p = new  uchar   [args( 0 ).string_value ().length()];
strcpy( (char *) p ,args( 0 ).string_value().c_str());
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
w = (  int  ) args( 3 ).int_value();
h = (  int  ) args( 4 ).int_value();
alpha=0 = (  int  ) args( 5 ).int_value();
string  ret_type(  (const char *) fl_read_image ( x,y,w,h,alpha=0));
return octave_value(ret_type);
}
DEFUN_DLD( Fl_draw_pixmap , args , , " int Fl_draw_pixmap (char* const* data,int x,int y,Fl_Color=FL_GRAY ); " )
{
char*   const* data ;
int   x ;
int   y ;
Fl_Color=FL_GRAY   _Fl_Color=FL_GRAY0 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_draw_pixmap (char* const* data,int x,int y,Fl_Color=FL_GRAY ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw_pixmap "<<std::endl;
#endif /* DEBUG */
const* data = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) const* data ,args( 0 ).string_value().c_str());
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
_Fl_Color=FL_GRAY0 = (  Fl_Color=FL_GRAY  ) args( 3 ).long_value();
long int ret_type=(long int) fl_draw_pixmap ( x,y,_Fl_Color=FL_GRAY0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_measure_pixmap , args , , " int Fl_measure_pixmap (char* const* data,int &w,int &h); " )
{
char*   const* data ;
int   &w ;
int   &h ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_measure_pixmap (char* const* data,int &w,int &h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_measure_pixmap "<<std::endl;
#endif /* DEBUG */
const* data = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) const* data ,args( 0 ).string_value().c_str());
&w = (  int  ) args( 1 ).int_value();
&h = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) fl_measure_pixmap ( &w,&h);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_draw_pixmap , args , , " int Fl_draw_pixmap (char* const* data,int x,int y,Fl_Color=FL_GRAY ); " )
{
char*   const* data ;
int   x ;
int   y ;
Fl_Color=FL_GRAY   _Fl_Color=FL_GRAY0 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  int Fl_draw_pixmap (char* const* data,int x,int y,Fl_Color=FL_GRAY ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw_pixmap "<<std::endl;
#endif /* DEBUG */
const* data = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) const* data ,args( 0 ).string_value().c_str());
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
_Fl_Color=FL_GRAY0 = (  Fl_Color=FL_GRAY  ) args( 3 ).long_value();
long int ret_type=(long int) fl_draw_pixmap ( x,y,_Fl_Color=FL_GRAY0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_measure_pixmap , args , , " int Fl_measure_pixmap (char* const* data,int &w,int &h); " )
{
char*   const* data ;
int   &w ;
int   &h ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_measure_pixmap (char* const* data,int &w,int &h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_measure_pixmap "<<std::endl;
#endif /* DEBUG */
const* data = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) const* data ,args( 0 ).string_value().c_str());
&w = (  int  ) args( 1 ).int_value();
&h = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) fl_measure_pixmap ( &w,&h);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_shortcut_label , args , , " const Fl_shortcut_label (int ); " )
{
int   _int0 ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  const Fl_shortcut_label (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_shortcut_label "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
long int ret_type=(long int) fl_shortcut_label ( );
return octave_value(ret_type);
}
DEFUN_DLD( Fl_overlay_rect , args , , " void Fl_overlay_rect (int ,int ,int ,int ); " )
{
int   _int0 ;
int   _int1 ;
int   _int2 ;
int   _int3 ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_overlay_rect (int ,int ,int ,int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_overlay_rect "<<std::endl;
#endif /* DEBUG */
_int0 = (  int  ) args( 0 ).int_value();
_int1 = (  int  ) args( 1 ).int_value();
_int2 = (  int  ) args( 2 ).int_value();
_int3 = (  int  ) args( 3 ).int_value();
fl_overlay_rect ( _int1,_int2,_int3);
return octave_value();
}
DEFUN_DLD( Fl_overlay_clear , args , , " void Fl_overlay_clear ( ); " )
{
 if(args.length()!= 0 )
  {
   std::cout<< "eg:  void Fl_overlay_clear ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_overlay_clear "<<std::endl;
#endif /* DEBUG */
fl_overlay_clear ( );
return octave_value();
}
DEFUN_DLD( Fl_cursor , args , , " void Fl_cursor (Fl_Cursor ,Fl_Color=FL_BLACK ,Fl_Color=FL_WHITE ); " )
{
Fl_Cursor   _Fl_Cursor0 ;
Fl_Color=FL_BLACK   _Fl_Color=FL_BLACK1 ;
Fl_Color=FL_WHITE   _Fl_Color=FL_WHITE2 ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_cursor (Fl_Cursor ,Fl_Color=FL_BLACK ,Fl_Color=FL_WHITE ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_cursor "<<std::endl;
#endif /* DEBUG */
_Fl_Cursor0 = (  Fl_Cursor  ) args( 0 ).long_value();
_Fl_Color=FL_BLACK1 = (  Fl_Color=FL_BLACK  ) args( 1 ).long_value();
_Fl_Color=FL_WHITE2 = (  Fl_Color=FL_WHITE  ) args( 2 ).long_value();
fl_cursor ( _Fl_Color=FL_BLACK1,_Fl_Color=FL_WHITE2);
return octave_value();
}
DEFUN_DLD( Fl_draw_symbol , args , , " int Fl_draw_symbol (char* label,int x,int y,int w,int h,Fl_Color ); " )
{
char*   label ;
int   x ;
int   y ;
int   w ;
int   h ;
Fl_Color   _Fl_Color0 ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  int Fl_draw_symbol (char* label,int x,int y,int w,int h,Fl_Color ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_draw_symbol "<<std::endl;
#endif /* DEBUG */
label = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) label ,args( 0 ).string_value().c_str());
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
w = (  int  ) args( 3 ).int_value();
h = (  int  ) args( 4 ).int_value();
_Fl_Color0 = (  Fl_Color  ) args( 5 ).long_value();
long int ret_type=(long int) fl_draw_symbol ( x,y,w,h,_Fl_Color0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_add_symbol , args , , " int Fl_add_symbol (char* name,void (*drawit); " )
{
char*   name ;
void   (*drawit ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_add_symbol (char* name,void (*drawit); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_add_symbol "<<std::endl;
#endif /* DEBUG */
name = new  char  [args( 0 ).string_value ().length()];
strcpy( (char *) name ,args( 0 ).string_value().c_str());
long int ret_type=(long int) fl_add_symbol ( (*drawit);
return octave_value(ret_type);
}
#endif  /* 0 */

/* Overridden functions */
/* Linked Separately */
DEFUN_DLD(fl_draw , args , , " void -generate_static_code(void); " )
{
octave_dynamic_loader::load("Fl_color" ,"");
octave_dynamic_loader::load("Fl_color" ,"");
octave_dynamic_loader::load("Fl_push_clip" ,"");
octave_dynamic_loader::load("Fl_push_no_clip" ,"");
octave_dynamic_loader::load("Fl_pop_clip" ,"");
octave_dynamic_loader::load("Fl_not_clipped" ,"");
octave_dynamic_loader::load("Fl_clip_box" ,"");
octave_dynamic_loader::load("Fl_point" ,"");
octave_dynamic_loader::load("Fl_line_style" ,"");
octave_dynamic_loader::load("Fl_rect" ,"");
octave_dynamic_loader::load("Fl_rectf" ,"");
octave_dynamic_loader::load("Fl_line" ,"");
octave_dynamic_loader::load("Fl_line" ,"");
octave_dynamic_loader::load("Fl_loop" ,"");
octave_dynamic_loader::load("Fl_loop" ,"");
octave_dynamic_loader::load("Fl_polygon" ,"");
octave_dynamic_loader::load("Fl_polygon" ,"");
octave_dynamic_loader::load("Fl_xyline" ,"");
octave_dynamic_loader::load("Fl_xyline" ,"");
octave_dynamic_loader::load("Fl_xyline" ,"");
octave_dynamic_loader::load("Fl_yxline" ,"");
octave_dynamic_loader::load("Fl_yxline" ,"");
octave_dynamic_loader::load("Fl_yxline" ,"");
octave_dynamic_loader::load("Fl_arc" ,"");
octave_dynamic_loader::load("Fl_pie" ,"");
octave_dynamic_loader::load("Fl_chord" ,"");
octave_dynamic_loader::load("Fl_push_matrix" ,"");
octave_dynamic_loader::load("Fl_pop_matrix" ,"");
octave_dynamic_loader::load("Fl_scale" ,"");
octave_dynamic_loader::load("Fl_scale" ,"");
octave_dynamic_loader::load("Fl_translate" ,"");
octave_dynamic_loader::load("Fl_rotate" ,"");
octave_dynamic_loader::load("Fl_mult_matrix" ,"");
octave_dynamic_loader::load("Fl_begin_points" ,"");
octave_dynamic_loader::load("Fl_begin_line" ,"");
octave_dynamic_loader::load("Fl_begin_loop" ,"");
octave_dynamic_loader::load("Fl_begin_polygon" ,"");
octave_dynamic_loader::load("Fl_vertex" ,"");
octave_dynamic_loader::load("Fl_curve" ,"");
octave_dynamic_loader::load("Fl_arc" ,"");
octave_dynamic_loader::load("Fl_circle" ,"");
octave_dynamic_loader::load("Fl_end_points" ,"");
octave_dynamic_loader::load("Fl_end_line" ,"");
octave_dynamic_loader::load("Fl_end_loop" ,"");
octave_dynamic_loader::load("Fl_end_polygon" ,"");
octave_dynamic_loader::load("Fl_begin_complex_polygon" ,"");
octave_dynamic_loader::load("Fl_gap" ,"");
octave_dynamic_loader::load("Fl_end_complex_polygon" ,"");
octave_dynamic_loader::load("Fl_transform_x" ,"");
octave_dynamic_loader::load("Fl_transform_y" ,"");
octave_dynamic_loader::load("Fl_transform_dx" ,"");
octave_dynamic_loader::load("Fl_transform_dy" ,"");
octave_dynamic_loader::load("Fl_transformed_vertex" ,"");
octave_dynamic_loader::load("Fl_font" ,"");
octave_dynamic_loader::load("Fl_height" ,"");
octave_dynamic_loader::load("Fl_descent" ,"");
octave_dynamic_loader::load("Fl_width" ,"");
octave_dynamic_loader::load("Fl_width" ,"");
octave_dynamic_loader::load("Fl_width" ,"");
octave_dynamic_loader::load("Fl_draw" ,"");
octave_dynamic_loader::load("Fl_draw" ,"");
octave_dynamic_loader::load("Fl_measure" ,"");
octave_dynamic_loader::load("Fl_frame" ,"");
octave_dynamic_loader::load("Fl_frame2" ,"");
octave_dynamic_loader::load("Fl_draw_box" ,"");
octave_dynamic_loader::load("Fl_draw_image" ,"");
octave_dynamic_loader::load("Fl_draw_image_mono" ,"");
octave_dynamic_loader::load("Fl_draw_image" ,"");
octave_dynamic_loader::load("Fl_draw_image_mono" ,"");
octave_dynamic_loader::load("Fl_rectf" ,"");
octave_dynamic_loader::load("Fl_read_image" ,"");
octave_dynamic_loader::load("Fl_draw_pixmap" ,"");
octave_dynamic_loader::load("Fl_measure_pixmap" ,"");
octave_dynamic_loader::load("Fl_draw_pixmap" ,"");
octave_dynamic_loader::load("Fl_measure_pixmap" ,"");
octave_dynamic_loader::load("Fl_shortcut_label" ,"");
octave_dynamic_loader::load("Fl_overlay_rect" ,"");
octave_dynamic_loader::load("Fl_overlay_clear" ,"");
octave_dynamic_loader::load("Fl_cursor" ,"");
octave_dynamic_loader::load("Fl_draw_symbol" ,"");
octave_dynamic_loader::load("Fl_add_symbol" ,"");
std::cout<<"Code generated onMon Aug  1 23:53:34 2005\n Compiled on " __DATE__  __TIME__ "\n loaded-generate_static_codeLibrary!"<<std::endl;
/* All static functions belong to Fl space */
return octave_value(new FLTKStaticWrapper(0,"Fl"));
}
