#! /usr/bin/python
#generate Fl Widget heiarchy.

x="""    *  Fl
    * Fl_End
    * Fl_File_Icon
    * Fl_Image
          o Fl_Bitmap
                + Fl_XBM_Image
          o Fl_Pixmap
                + Fl_GIF_Image
                + Fl_XPM_Image
          o Fl_RGB_Image
                + Fl_BMP_Image
                + Fl_JPEG_Image
                + Fl_PNG_Image
                + Fl_PNM_Image
          o Fl_Shared_Image
          o Fl_Tiled_Image
    * Fl_Menu_Item
    * Fl_Preferences
    * Fl_Text_Buffer
    * Fl_Tooltip
    * Fl_Widget
          o Fl_Box
          o Fl_Browser_
                + Fl_Browser
                      # Fl_File_Browser
                      # Fl_Hold_Browser
                      # Fl_Multi_Browser
                      # Fl_Select_Browser 
                + Fl_Check_Browser 
          o Fl_Button
                + Fl_Check_Button
                + Fl_Light_Button
                + Fl_Repeat_Button
                + Fl_Return_Button
                + Fl_Round_Button 
          o Fl_Chart
          o Fl_Clock
          o Fl_Free
          o Fl_Group
                + Fl_Color_Chooser
                + Fl_File_Chooser
                + Fl_Help_Dialog
                + Fl_Help_View
                + Fl_Pack
                + Fl_Scroll
                + Fl_Tabs
                + Fl_Text_Display
                      # Fl_Text_Editor 
                + Fl_Tile
                + Fl_Window
                      # Fl_Double_Window
                      # Fl_Gl_Window
                      # Fl_Menu_Window
                      # Fl_Overlay_Window
                      # Fl_Single_Window 
                + Fl_Wizard 
          o Fl_Input_
                + Fl_Input
                      # Fl_Float_Input
                      # Fl_Int_Input
                      # Fl_Multiline_Input
                      # Fl_Secret_Input 
                + Fl_Output
                      # Fl_Multiline_Output 
          o Fl_Menu_
                + Fl_Choice
                + Fl_Menu_Bar
                + Fl_Menu_Button 
          o Fl_Positioner
          o Fl_Progress
          o Fl_Timer
          o Fl_Valuator
                + Fl_Adjuster
                + Fl_Counter
                + Fl_Dial
                + Fl_Roller
                + Fl_Slider
                      # Fl_Scrollbar
                      # Fl_Value_Slider 
                + Fl_Value_Input
                + Fl_Value_Output """

def func(x):
    lines=x.split("\n");
    
    stack=[];
    tree=[];
    iter=tree;
    
    prev=0
    curr=0
    depth=1;


    parts=lines[0].split("Fl_")
    prev=len(parts[0]);
    
    for l in lines:
        parts=l.split("Fl_")
        if(len(parts)!=2):
            continue
        curr=len(parts[0])
        
        if curr > prev:
            iter.append([])
            stack.append(iter);
            iter=iter[-1]
            iter.append(parts[1])
            depth=depth+1
            print "\t"*depth,parts[1]
        elif curr < prev:
            if (stack!=[]):            
                iter=stack[-1]
                del stack[-1]
            iter.append(parts[1])
            depth=depth-1;
            print "\t"*depth,parts[1]
        else:
            iter.append(parts[1])
            print "\t"*depth,parts[1]
            pass
        prev=curr
    print tree
    return tree


def printrec(tree,depth=0,path=""):
    prev=None
    for i in tree:
        if type(i) is list:
            #print tree[tree.index(i)-1]
            printrec(i,depth+1,path+"/"+ tree[tree.index(i)-1])
        else:
            fpath=path+"/"+i;
            #print " "*depth,fpath
            l=fpath.split("/")[1:];
            print l,","
            
#tree=func(x);
#printrec(tree)

fltype=[['End'] ,
         ['File_Icon'] ,
         ['Image'] ,
         ['Image', 'Bitmap'] ,
         ['Image', 'Bitmap', 'XBM_Image'] ,
         ['Image', 'Pixmap'] ,
         ['Image', 'Pixmap', 'GIF_Image'] ,
         ['Image', 'Pixmap', 'XPM_Image'] ,
         ['Image', 'RGB_Image'] ,
         ['Image', 'RGB_Image', 'BMP_Image'] ,
         ['Image', 'RGB_Image', 'JPEG_Image'] ,
         ['Image', 'RGB_Image', 'PNG_Image'] ,
         ['Image', 'RGB_Image', 'PNM_Image'] ,
         ['Image', 'Shared_Image'] ,
         ['Image', 'Tiled_Image'] ,
         ['Menu_Item'] ,
         ['Preferences'] ,
         ['Text_Buffer'] ,
         ['Tooltip'] ,
         ['Widget'] ,
         ['Widget', 'Box'] ,
	['Widget', 'Browser_'] ,
	['Widget', 'Browser_', 'Browser'] ,
	['Widget', 'Browser_', 'Browser', 'File_Browser'] ,
	['Widget', 'Browser_', 'Browser', 'Hold_Browser'] ,
	['Widget', 'Browser_', 'Browser', 'Multi_Browser'] ,
	['Widget', 'Browser_', 'Browser', 'Select_Browser '] ,
	['Widget', 'Browser_', 'Check_Browser '] ,
	['Widget', 'Button'] ,
	['Widget', 'Button', 'Check_Button'] ,
	['Widget', 'Button', 'Light_Button'] ,
	['Widget', 'Button', 'Repeat_Button'] ,
	['Widget', 'Button', 'Return_Button'] ,
	['Widget', 'Button', 'Round_Button '] ,
	['Widget', 'Chart'] ,
	['Widget', 'Clock'] ,
	['Widget', 'Free'] ,
	['Widget', 'Group'] ,
	['Widget', 'Group', 'Color_Chooser'] ,
	['Widget', 'Group', 'File_Chooser'] ,
	['Widget', 'Group', 'Help_Dialog'] ,
	['Widget', 'Group', 'Help_View'] ,
	['Widget', 'Group', 'Pack'] ,
	['Widget', 'Group', 'Scroll'] ,
	['Widget', 'Group', 'Tabs'] ,
	['Widget', 'Group', 'Text_Display'] ,
	['Widget', 'Group', 'Text_Display', 'Text_Editor '] ,
	['Widget', 'Group', 'Tile'] ,
	['Widget', 'Group', 'Window'] ,
	['Widget', 'Group', 'Window', 'Double_Window'] ,
	['Widget', 'Group', 'Window', 'Gl_Window'] ,
	['Widget', 'Group', 'Window', 'Menu_Window'] ,
	['Widget', 'Group', 'Window', 'Overlay_Window'] ,
	['Widget', 'Group', 'Window', 'Single_Window '] ,
	['Widget', 'Group', 'Wizard '] ,
	['Widget', 'Input_'] ,
	['Widget', 'Input_', 'Input'] ,
	['Widget', 'Input_', 'Input', 'Float_Input'] ,
	['Widget', 'Input_', 'Input', 'Int_Input'] ,
	['Widget', 'Input_', 'Input', 'Multiline_Input'] ,
	['Widget', 'Input_', 'Input', 'Secret_Input '] ,
	['Widget', 'Input_', 'Output'] ,
	['Widget', 'Input_', 'Output', 'Multiline_Output '] ,
	['Widget', 'Input_', 'Menu_'] ,
	['Widget', 'Input_', 'Menu_', 'Choice'] ,
	['Widget', 'Input_', 'Menu_', 'Menu_Bar'] ,
	['Widget', 'Input_', 'Menu_', 'Menu_Button '] ,
	['Widget', 'Input_', 'Positioner'] ,
	['Widget', 'Input_', 'Progress'] ,
	['Widget', 'Input_', 'Timer'] ,
	['Widget', 'Input_', 'Valuator'] ,
	['Widget', 'Input_', 'Valuator', 'Adjuster'] ,
	['Widget', 'Input_', 'Valuator', 'Counter'] ,
	['Widget', 'Input_', 'Valuator', 'Dial'] ,
	['Widget', 'Input_', 'Valuator', 'Roller'] ,
	['Widget', 'Input_', 'Valuator', 'Slider'] ,
	['Widget', 'Input_', 'Valuator', 'Slider', 'Scrollbar'] ,
	['Widget', 'Input_', 'Valuator', 'Slider', 'Value_Slider '] ,
	['Widget', 'Input_', 'Valuator', 'Value_Input'] ,
	['Widget', 'Input_', 'Valuator', 'Value_Output '] ]

for i in fltype:
    i.reverse()

    st="{"
    for item in i:
        st=st +"\"Fl_"+ item +"\","
    st=st[:-1]+"},"
    print st
