#ifndef FLTKWRAPPER_H
#define FLTKWRAPPER_H

/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<octave/ov.h>/* for octave-value */
#include<octave/ov-struct.h>/* for octave-struct */
#include<vector>
#include<string>

/* FLTK specific includes */
#include<FL/Fl.H>
#include<FL/Fl_Window.H>
#include<FL/Fl_Box.H>
#include<FL/Fl_Adjuster.H>
#include<FL/Fl_Bitmap.H>
#include<FL/Fl_BMP_Image.H>
#include<FL/Fl_Box.H>
#include<FL/Fl_Browser_.H>
#include<FL/Fl_Browser.H>
#include<FL/Fl_Button.H>
#include<FL/Fl_Chart.H>
#include<FL/Fl_Check_Browser.H>
#include<FL/Fl_Check_Button.H>
#include<FL/Fl_Choice.H>
#include<FL/Fl_Clock.H>
#include<FL/Fl_Color_Chooser.H>
#include<FL/Fl_Counter.H>
#include<FL/Fl_Dial.H>
#include<FL/Fl_Double_Window.H>
#include<FL/Fl_Export.H>
#include<FL/Fl_File_Browser.H>
#include<FL/Fl_File_Chooser.H>
#include<FL/Fl_File_Icon.H>
#include<FL/Fl_File_Input.H>
#include<FL/Fl_Fill_Dial.H>
#include<FL/Fl_Fill_Slider.H>
#include<FL/Fl_Float_Input.H>
#include<FL/Fl_FormsBitmap.H>
#include<FL/Fl_FormsPixmap.H>
#include<FL/Fl_Free.H>
#include<FL/Fl_GIF_Image.H>
#include<FL/Fl_Gl_Window.H>
#include<FL/Fl_Group.H>
#include<FL/Fl.H>
#include<FL/Fl_Help_Dialog.H>
#include<FL/Fl_Help_View.H>
#include<FL/Fl_Hold_Browser.H>
#include<FL/Fl_Hor_Fill_Slider.H>
#include<FL/Fl_Hor_Nice_Slider.H>
#include<FL/Fl_Hor_Slider.H>
#include<FL/Fl_Hor_Value_Slider.H>
#include<FL/Fl_Image.H>
#include<FL/Fl_Input_.H>
#include<FL/Fl_Input.H>
#include<FL/Fl_Int_Input.H>
#include<FL/Fl_JPEG_Image.H>
#include<FL/Fl_Light_Button.H>
#include<FL/Fl_Line_Dial.H>
#include<FL/Fl_Menu_Bar.H>
#include<FL/Fl_Menu_Button.H>
#include<FL/Fl_Menu_.H>
#include<FL/Fl_Menu.H>
#include<FL/Fl_Menu_Item.H>
#include<FL/Fl_Menu_Window.H>
#include<FL/Fl_Multi_Browser.H>
#include<FL/Fl_Multi_Label.H>
#include<FL/Fl_Multiline_Input.H>
#include<FL/Fl_Multiline_Output.H>
#include<FL/Fl_Nice_Slider.H>
#include<FL/Fl_Object.H>
#include<FL/Fl_Output.H>
#include<FL/Fl_Overlay_Window.H>
#include<FL/Fl_Pack.H>
#include<FL/Fl_Pixmap.H>
#include<FL/Fl_PNG_Image.H>
#include<FL/Fl_PNM_Image.H>
#include<FL/Fl_Positioner.H>
#include<FL/Fl_Preferences.H>
#include<FL/Fl_Progress.H>
#include<FL/Fl_Radio_Button.H>
#include<FL/Fl_Radio_Light_Button.H>
#include<FL/Fl_Radio_Round_Button.H>
#include<FL/Fl_Repeat_Button.H>
#include<FL/Fl_Return_Button.H>
#include<FL/Fl_Roller.H>
#include<FL/Fl_Round_Button.H>
#include<FL/Fl_Round_Clock.H>
#include<FL/Fl_Scrollbar.H>
#include<FL/Fl_Scroll.H>
#include<FL/Fl_Secret_Input.H>
#include<FL/Fl_Select_Browser.H>
#include<FL/Fl_Shared_Image.H>
#include<FL/Fl_Simple_Counter.H>
#include<FL/Fl_Single_Window.H>
#include<FL/Fl_Slider.H>
#include<FL/Fl_Sys_Menu_Bar.H>
#include<FL/Fl_Tabs.H>
#include<FL/Fl_Text_Buffer.H>
#include<FL/Fl_Text_Display.H>
#include<FL/Fl_Text_Editor.H>
#include<FL/Fl_Tiled_Image.H>
#include<FL/Fl_Tile.H>
#include<FL/Fl_Timer.H>
#include<FL/Fl_Toggle_Button.H>
#include<FL/Fl_Toggle_Light_Button.H>
#include<FL/Fl_Toggle_Round_Button.H>
#include<FL/Fl_Tooltip.H>
#include<FL/Fl_Valuator.H>
#include<FL/Fl_Value_Input.H>
#include<FL/Fl_Value_Output.H>
#include<FL/Fl_Value_Slider.H>
#include<FL/Fl_Widget.H>
#include<FL/Fl_Window.H>
#include<FL/Fl_Wizard.H>
#include<FL/Fl_XBM_Image.H>
#include<FL/Fl_XPM_Image.H>

#include <list>

using namespace std;


extern "C"
{
#include<stdio.h>
#include<string.h>
}

class FLTKCallback;

class FLTKSet
{
 public:
  FLTKCallback *instance;
  void *function;

  FLTKSet()
    {
      instance=NULL;
      function=NULL;
    }

  FLTKSet(FLTKCallback *inst,void *func)
    {
      instance=inst;
      function=func;
    }
}

/* Incomplete: 
   - Must add support for : Callback handling.
   -
   
   Idea of callback handling.
   FLTKCallback will be a closure type whoses instances hold arguments
   and Octave function name, which has to be evaluated.
   They return to you a simple type of function pointer, which is a
   member instance-method, which will be invoked from FLTK, as a event
   happens. To demultiplex this, earlier we create a list of 
   instance-pointers & their corresponding member-function addresses.
   On invocation this member-function looks up its address, in this list,
   and the corresponding function pointer, will have to be invoked for
   this method.
*/
class FLTKCallback
{
  /*  friend class FLTKWrapper; */
 public:
  void *pointer;  /* name of class instance pointer */
  bool ismethod;  /* see, if member function: to pass pointer or not */
  string fcnname; /* name of octave callback */
  void *userdata;  
  void (*function)();/* which function to call */
  
  static std::list <FLTKSet *> pointer_list; /*List of all pointer data */
  static int current_fcn_1;
  static int current_fcn_2;
  static const int max_fcn=100;

  FLTKCallback()
    {
      pointer=0;
      ismethod=false;
      userdata=0;
    };
  
  FLTKCallback(void *invokingtype,string fname)
    {
      pointer=invokingtype;
      fcnname=fname;
    };
  

  FLTKCallback(void *invokingtype,string fname,void *user_data)
    {
      pointer=invokingtype;
      fcnname=fname;
      userdata=user_data;
    }

  void FlCallbackEmpty_handler()
    {
      octave_value_list args;
      /* args(0)=octave_value(type);
	 args(1)=octave_value(ptr); */
      feval(this->fcnname,args);      
    }


  void F1Callback_handler(void *type,void *ptr)
    {
      octave_value_list args;
      args(0)=octave_value(type);
      args(1)=octave_value(ptr);
      feval(this->fcnname,args);
    }

  void FlCallback0_handler(void *type)
    {
      octave_value_list args;
      args(0)=octave_value(type);
      feval(this->fcnname,args);
    }


  static Fl_Callback0* CreateCallbackZero(void *ptr,string fcnname)
    {
      FLTKCallback *clb=new FLTKCallback(ptr,fcnname);
      FLTKSet *set=new FLTKSet(clb,sclb->FlCallback0_handler);
      FLTKCallback::pointer_list.push_back(set);
      return (Fl_Callback0*)clb->FlCallback0_handler;
    }

  static Fl_Callback* CreateCallback(void *ptr,string fcnname,void *userdata)
    {
      FLTKCallback *clb=new FLTKCallback(ptr,fcnname,userdata);
      FLTKSet *set=new FLTKSet(clb,(void *)clb->FlCallback_handler);
      FLTKCallback::pointer_list.push_back(set);
      return (Fl_Callback*)clb->FlCallback_handler;
    }

  /*
  Fl_CallbackEmptry* CreateCallbackEmpty()
    {
      FLTKCallback *clb=new FLTKCallback(ptr,fcnname);
      FLTKSet *set=new FLTKSet(clb,(void *)clb->FlCallbackEmpty_handler);
      FLTKCallback::pointer_list.push_back(set);
      return (Fl_CallbackEmpty*)clb->FlCallbackEmpty_handler;      
    }  
  */
};





class FLTKWrapper : public octave_struct
{
 public:
  string *classname;
  void * pointer;
  bool isstatic;

  /* A list with references of all created FLTKWrapper objects*/
  static std::list<FLTKWrapper *> pointer_list;

 public: 
    void* getPointer(void)
    {
      return this->pointer;
    }

  string getClassname(void)
    {
      return *this->classname;;
    }
  
  FLTKWrapper()
  {
    classname=NULL;
    pointer=(void *)0;
    isstatic=false;
  }
  
  /* Well the constructor */
  FLTKWrapper(void *ptr,string class_na,bool staticflag=false)
  {
    std::cout<<"Wrapper type "<<class_na<<" initialized"<<std::endl;
    pointer=ptr;
    classname=new string(class_na);
    isstatic=staticflag;
    FLTKWrapper::pointer_list.push_back(this);
  }


  static string GetClassName(void * pointer)
    {
      for(std::list<FLTKWrapper *>::const_iterator stli=
	    FLTKWrapper::pointer_list.begin();
	  stli!=FLTKWrapper::pointer_list.end();
	  stli++)
	{
	  if((unsigned long int)(*stli)->pointer == (unsigned long int)pointer)
	    {
	      return (*(*stli)->classname);
	    }
	}
      
      return string("");
    }

  static bool ExistObjectType(void * pointer,string classname)
    {
      //bool searchflag=false;
      for(std::list<FLTKWrapper *>::const_iterator stli=FLTKWrapper::pointer_list.begin();
	  stli!=FLTKWrapper::pointer_list.end();
	  stli++)
	{
	  if(((unsigned long int)(*stli)->pointer == (unsigned long int)pointer)
	     && *((*stli)->classname) == classname)
	    {
	      return true;
	    }
	}
      return false;
    }

  static bool Exists(void * pointer)
    {
      //bool searchflag=false;
      for(std::list<FLTKWrapper *>::const_iterator stli=
	    FLTKWrapper::pointer_list.begin();
	  stli!=FLTKWrapper::pointer_list.end();
	  stli++)
	{
	  if( (unsigned long int) (*stli)->pointer == (unsigned long int)pointer)	    
	    {
	      return true;
	    }
	}
      return false;
    }

  Fl_Callback0* CreateCallback(void *ptr,string fcnname)
     {       
       return FLTKCallback::CreateCallbackZero(ptr,fcnname);
     }
  
  Fl_Callback* CreateCallback(void *ptr,string fcnname,void* user_data)
     {
       return FLTKCallback::CreateCallback(ptr,fcnname,user_data);
     }

  Fl_CallbackEmpty* CreateCallbackEmpty(void *ptr,string fcnname)
    {
      return FLTKCallback::CreateCallbackEmpty(ptr,fcnname);
    }

  ~FLTKWrapper(void)
    {
      /*std::cout<<"Your Object handle is invalidated"<<std::endl;*/
      if( classname != NULL)
	  delete classname;

      FLTKWrapper::pointer_list.remove(this);

#if 0
      for(std::list<FLTKWrapper *>::const_iterator stli=FLTKWrapper::pointer_list.begin();
	  stli!=FLTKWrapper::pointer_list.end();
	  stli++)
	{
	  if((unsigned long int)stli->pointer == (unsigned long int)pointer)
	    {
	    }
	}
#endif

    }  

  octave_value_list subsref(const std::string & str,
		       const std::list<octave_value_list>&  idx,
		       int nargout)
  {    
    octave_value_list ovl=idx.front();
    std::cout<<"subsref operator called with #"<<str<<"# "<<std::endl;
    for(int i=0;i<ovl.length();i++)
      {
	std::cout<<i<<" ";
	ovl(i).print(std::cout,true);
	std::cout<<"\n"<<std::endl;
      }
    std::cout<<"Entering evaluator"<<std::endl;

    if(str[0]=='.')
      {
	octave_value_list args;
	int offset=0;
	//std::cout<<"Ready to Jump String "<<*this->classname<<std::endl;
	std::string func_name (*this->classname +"_" + ovl(0).string_value());
	//std::cout<<"Ready to Jump List"<<std::endl;
	std::list<octave_value_list>::const_iterator pidx = idx.begin();
	//std::cout<<"Ready to Jump Eval"<<std::endl;

	// Static methods donot need a pointer to function.
	if(isstatic)	  
	    offset=0;
	else
	  {
	    // Member-methods *DO* need a pointer to function.
	    args(0)=(long int)this->pointer;
	    offset=1;
	  }
	
	if(pidx!=NULL)
	  {
	    pidx++;
	    for(int i=0;i<(*pidx).length();i++)
	      {
		args(i+offset)=(*pidx)(i);
	      }
	  }
	
	std::cout<<"Evaluating: "<<func_name<<std::endl;

	return feval(func_name,args,nargout);
      }
    return octave_value_list();
  }

  DECLARE_OCTAVE_ALLOCATOR
  DECLARE_OV_TYPEID_FUNCTIONS_AND_DATA
};

DEFINE_OCTAVE_ALLOCATOR (FLTKWrapper);
DEFINE_OV_TYPEID_FUNCTIONS_AND_DATA (FLTKWrapper,"FLTKWrapper","FLTKWrapper");




DEFUN_DLD(FLTKWrapper_Convert,args,,"FLTKWrapper Convert(FLTKWrapper obj,string newtype)")
{
  if(args.length()!=2)
    {
      return octave_value();
    }
  void *pointer=0;

  string classname = args(1).string_value();
  if(args(0).type_name() == "FLTKWrapper")
    {
      FLTKWrapper &flw=(FLTKWrapper &)args(0).get_rep();
      pointer = flw.getPointer();
    }
  else
    pointer = (void *)args(0).int_value();
  return octave_value(new FLTKWrapper(pointer,classname));
}


DEFUN_DLD(FLTKWrapper,args,,"")
{
  FLTKWrapper *flw=new FLTKWrapper();
  return octave_value(new FLTKWrapper(flw,"FLTKWrapper"));
}

class FLTKStaticWrapper : public octave_struct
{
public:
  string *classname;
  void * pointer;
  bool isstatic;

 public: 
  FLTKStaticWrapper()
  {
    classname=NULL;
    pointer=(void *)0;
    isstatic=false;
  }
  
  /* Well the constructor!! */
  FLTKStaticWrapper(void *ptr,string class_na,bool staticflag=true)
  {
    std::cout<<"Wrapper type "<<class_na<<" initialized"<<std::endl;
    pointer=ptr;
    classname=new string(class_na);
    isstatic=staticflag;
  }





  ~FLTKStaticWrapper(void)
    {
      /*std::cout<<"Your Object handle is invalidated"<<std::endl;*/
      if( classname != NULL)
	  delete classname;
    }  

  octave_value_list subsref(const std::string & str,
		       const std::list<octave_value_list>&  idx,
		       int nargout)
  {    
    octave_value_list ovl=idx.front();
    std::cout<<"subsref operator called with #"<<str<<"# "<<std::endl;
    for(int i=0;i<ovl.length();i++)
      {
	std::cout<<i<<" ";
	ovl(i).print(std::cout,true);
	std::cout<<"\n"<<std::endl;
      }
    std::cout<<"Entering evaluator"<<std::endl;

    if(str[0]=='.')
      {
	octave_value_list args;
	int offset=0;
	//std::cout<<"Ready to Jump String "<<*this->classname<<std::endl;
	std::string func_name (*this->classname +"_" + ovl(0).string_value());
	//std::cout<<"Ready to Jump List"<<std::endl;
	std::list<octave_value_list>::const_iterator pidx = idx.begin();
	//std::cout<<"Ready to Jump Eval"<<std::endl;

	// Static methods donot need a pointer to function.
	if(isstatic)	  
	    offset=0;
	else
	  {
	    // Member-methods *DO* need a pointer to function.
	    args(0)=(long int)this->pointer;
	    offset=1;
	  }
	
	if(pidx!=NULL)
	  {
	    pidx++;
	    for(int i=0;i<(*pidx).length();i++)
	      {
		args(i+offset)=(*pidx)(i);
	      }
	  }
	  
	std::cout<<"Evaluating: "<<func_name<<std::endl;

	return feval(func_name,args,nargout);
      }
    return octave_value_list();
  }

  DECLARE_OCTAVE_ALLOCATOR
  DECLARE_OV_TYPEID_FUNCTIONS_AND_DATA
};

DEFINE_OCTAVE_ALLOCATOR (FLTKStaticWrapper);
DEFINE_OV_TYPEID_FUNCTIONS_AND_DATA (FLTKStaticWrapper,"FLTKStaticWrapper","FLTKStaticWrapper");


#endif /* FLTKWRAPPER_H */
