/* Standard headers std.header */
/* Standard headers std.header */
/*
 * This program is free software.
 * This code is a part of Octave-FLTK
 * Code may be used or distributed under GPL.
 * (C) July 2005 Muthiah Annamalai, Octave-FLTK
 */

/*
 *    Octave-FLTK
 *       The GUI bridge from octave.
 *    Copyright (C) July 2005 Muthiah Annamalai, Octave-FLTK
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details. 
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<iostream>
#include<octave/oct.h>
#include<octave/parse.h>
#include<octave/dynamic-ld.h>
#include<octave/oct-map.h>
#include<octave/oct-stream.h>
#include<octave/parse.h> /* for feval */
#include<vector>
#include<string>


/* FLTK specific includes */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "FLTKWrapper.h"

using namespace std;

extern "C"
{
#include<stdio.h>
#include<string.h>
}
DEFUN_DLD( Fl_Glut_Window__init , args , , " void Fl_Glut_Window__init ( ); " )
{
glut *   _glutPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Glut_Window__init ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window__init "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
Fl_Glut_Window__init ( );
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_draw , args , , " void Fl_Glut_Window_draw ( ); " )
{
glut *   _glutPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_draw ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_draw "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
Fl_Glut_Window_draw ( );
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_draw_overlay , args , , " void Fl_Glut_Window_draw_overlay ( ); " )
{
glut *   _glutPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_draw_overlay ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_draw_overlay "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
Fl_Glut_Window_draw_overlay ( );
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_handle , args , , " int Fl_Glut_Window_handle (int ); " )
{
glut *   _glutPtr ;
int   _int0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Glut_Window_handle (int ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_handle "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
_int0 = (  int  ) args( 1 ).int_value();
long int ret_type=(long int) Fl_Glut_Window_handle ( _int0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Glut_Window_make_current , args , , " void Fl_Glut_Window_make_current ( ); " )
{
glut *   _glutPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_make_current ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_make_current "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
Fl_Glut_Window_make_current ( );
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutInit , args , , " void Fl_Glut_Window_glutInit (int * argcp,char * *argv); " )
{
glut *   _glutPtr ;
int *   argcp ;
char *   *argv ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutInit (int * argcp,char * *argv); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutInit "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
argcp =( int * )args( 1 ).long_value();
*argv = new  char   [args( 2 ).string_value ().length()];
strcpy( (char *) *argv ,args( 2 ).string_value().c_str());
Fl_Glut_Window_glutInit ( argcp,*argv);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutInitDisplayMode , args , , " void Fl_Glut_Window_glutInitDisplayMode (unsigned int mode); " )
{
glut *   _glutPtr ;
unsigned int   mode ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutInitDisplayMode (unsigned int mode); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutInitDisplayMode "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
mode = (  unsigned int  ) args( 1 ).int_value();
Fl_Glut_Window_glutInitDisplayMode ( mode);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutInitWindowPosition , args , , " void Fl_Glut_Window_glutInitWindowPosition (int x,int y); " )
{
glut *   _glutPtr ;
int   x ;
int   y ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutInitWindowPosition (int x,int y); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutInitWindowPosition "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
x = (  int  ) args( 1 ).int_value();
y = (  int  ) args( 2 ).int_value();
Fl_Glut_Window_glutInitWindowPosition ( x,y);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutInitWindowSize , args , , " void Fl_Glut_Window_glutInitWindowSize (int w,int h); " )
{
glut *   _glutPtr ;
int   w ;
int   h ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutInitWindowSize (int w,int h); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutInitWindowSize "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
w = (  int  ) args( 1 ).int_value();
h = (  int  ) args( 2 ).int_value();
Fl_Glut_Window_glutInitWindowSize ( w,h);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutMainLoop , args , , " void Fl_Glut_Window_glutMainLoop ( ); " )
{
glut *   _glutPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutMainLoop ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutMainLoop "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
Fl_Glut_Window_glutMainLoop ( );
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutCreateWindow , args , , " int Fl_Glut_Window_glutCreateWindow (char * title); " )
{
glut *   _glutPtr ;
char *   title ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Glut_Window_glutCreateWindow (char * title); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutCreateWindow "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
title = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) title ,args( 1 ).string_value().c_str());
long int ret_type=(long int) Fl_Glut_Window_glutCreateWindow ( title);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Glut_Window_glutCreateSubWindow , args , , " int Fl_Glut_Window_glutCreateSubWindow (int win,int x,int y,int width,int height); " )
{
glut *   _glutPtr ;
int   win ;
int   x ;
int   y ;
int   width ;
int   height ;
 if(args.length()!= 6 )
  {
   std::cout<< "eg:  int Fl_Glut_Window_glutCreateSubWindow (int win,int x,int y,int width,int height); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutCreateSubWindow "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
win = (  int  ) args( 1 ).int_value();
x = (  int  ) args( 2 ).int_value();
y = (  int  ) args( 3 ).int_value();
width = (  int  ) args( 4 ).int_value();
height = (  int  ) args( 5 ).int_value();
long int ret_type=(long int) Fl_Glut_Window_glutCreateSubWindow ( win,x,y,width,height);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Glut_Window_glutDestroyWindow , args , , " void Fl_Glut_Window_glutDestroyWindow (int win); " )
{
glut *   _glutPtr ;
int   win ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutDestroyWindow (int win); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutDestroyWindow "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
win = (  int  ) args( 1 ).int_value();
Fl_Glut_Window_glutDestroyWindow ( win);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutSwapBuffers , args , , " void Fl_Glut_Window_glutSwapBuffers ( ); " )
{
glut *   _glutPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutSwapBuffers ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutSwapBuffers "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
Fl_Glut_Window_glutSwapBuffers ( );
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutSetWindow , args , , " void Fl_Glut_Window_glutSetWindow (int win); " )
{
glut *   _glutPtr ;
int   win ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutSetWindow (int win); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutSetWindow "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
win = (  int  ) args( 1 ).int_value();
Fl_Glut_Window_glutSetWindow ( win);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glut_window->make_overlay_current , args , , " layer Fl_Glut_Window_glut_window->make_overlay_current ( ); " )
{
glut *   _glutPtr ;
 if(args.length()!= 1 )
  {
   std::cout<< "eg:  layer Fl_Glut_Window_glut_window->make_overlay_current ( ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glut_window->make_overlay_current "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Glut_Window__glutPtr->window->make_overlay_current ( );
return octave_value(ret_type);
}
/* void: zero arguments taken */
DEFUN_DLD( Fl_Glut_Window_glutCreateMenu , args , , " int Fl_Glut_Window_glutCreateMenu (void); " )
{
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Glut_Window_glutCreateMenu (void); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutCreateMenu "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
long int ret_type=(long int) Fl_Glut_Window_glutCreateMenu ( (*);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Glut_Window_glutDestroyMenu , args , , " void Fl_Glut_Window_glutDestroyMenu (int menu); " )
{
glut *   _glutPtr ;
int   menu ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutDestroyMenu (int menu); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutDestroyMenu "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
menu = (  int  ) args( 1 ).int_value();
Fl_Glut_Window_glutDestroyMenu ( menu);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutAddMenuEntry , args , , " void Fl_Glut_Window_glutAddMenuEntry (char * label,int value); " )
{
glut *   _glutPtr ;
char *   label ;
int   value ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutAddMenuEntry (char * label,int value); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutAddMenuEntry "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
label = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) label ,args( 1 ).string_value().c_str());
value = (  int  ) args( 2 ).int_value();
Fl_Glut_Window_glutAddMenuEntry ( label,value);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutAddSubMenu , args , , " void Fl_Glut_Window_glutAddSubMenu (char * label,int submenu); " )
{
glut *   _glutPtr ;
char *   label ;
int   submenu ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutAddSubMenu (char * label,int submenu); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutAddSubMenu "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
label = new  char   [args( 1 ).string_value ().length()];
strcpy( (char *) label ,args( 1 ).string_value().c_str());
submenu = (  int  ) args( 2 ).int_value();
Fl_Glut_Window_glutAddSubMenu ( label,submenu);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutChangeToMenuEntry , args , , " void Fl_Glut_Window_glutChangeToMenuEntry (int item,char * label,int value); " )
{
glut *   _glutPtr ;
int   item ;
char *   label ;
int   value ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutChangeToMenuEntry (int item,char * label,int value); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutChangeToMenuEntry "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
item = (  int  ) args( 1 ).int_value();
label = new  char   [args( 2 ).string_value ().length()];
strcpy( (char *) label ,args( 2 ).string_value().c_str());
value = (  int  ) args( 3 ).int_value();
Fl_Glut_Window_glutChangeToMenuEntry ( item,label,value);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutChangeToSubMenu , args , , " void Fl_Glut_Window_glutChangeToSubMenu (int item,char * label,int submenu); " )
{
glut *   _glutPtr ;
int   item ;
char *   label ;
int   submenu ;
 if(args.length()!= 4 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutChangeToSubMenu (int item,char * label,int submenu); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutChangeToSubMenu "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
item = (  int  ) args( 1 ).int_value();
label = new  char   [args( 2 ).string_value ().length()];
strcpy( (char *) label ,args( 2 ).string_value().c_str());
submenu = (  int  ) args( 3 ).int_value();
Fl_Glut_Window_glutChangeToSubMenu ( item,label,submenu);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutRemoveMenuItem , args , , " void Fl_Glut_Window_glutRemoveMenuItem (int item); " )
{
glut *   _glutPtr ;
int   item ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutRemoveMenuItem (int item); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutRemoveMenuItem "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
item = (  int  ) args( 1 ).int_value();
Fl_Glut_Window_glutRemoveMenuItem ( item);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutGet , args , , " int Fl_Glut_Window_glutGet (GLenum type); " )
{
glut *   _glutPtr ;
GLenum   type ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Glut_Window_glutGet (GLenum type); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutGet "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
type = (  GLenum  ) args( 1 ).long_value();
long int ret_type=(long int) Fl_Glut_Window_glutGet ( type);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Glut_Window_glutLayerGet , args , , " int Fl_Glut_Window_glutLayerGet (GLenum ); " )
{
glut *   _glutPtr ;
GLenum   _GLenum0 ;
 if(args.length()!= 2 )
  {
   std::cout<< "eg:  int Fl_Glut_Window_glutLayerGet (GLenum ); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutLayerGet "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
_GLenum0 = (  GLenum  ) args( 1 ).long_value();
long int ret_type=(long int) Fl_Glut_Window_glutLayerGet ( _GLenum0);
return octave_value(ret_type);
}
DEFUN_DLD( Fl_Glut_Window_glutBitmapCharacter , args , , " void Fl_Glut_Window_glutBitmapCharacter (void * font,int character); " )
{
glut *   _glutPtr ;
void *   font ;
int   character ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  void Fl_Glut_Window_glutBitmapCharacter (void * font,int character); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutBitmapCharacter "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
font =( void * )args( 1 ).long_value();
character = (  int  ) args( 2 ).int_value();
Fl_Glut_Window_glutBitmapCharacter ( font,character);
return octave_value();
}
DEFUN_DLD( Fl_Glut_Window_glutBitmapWidth , args , , " int Fl_Glut_Window_glutBitmapWidth (void * font,int character); " )
{
glut *   _glutPtr ;
void *   font ;
int   character ;
 if(args.length()!= 3 )
  {
   std::cout<< "eg:  int Fl_Glut_Window_glutBitmapWidth (void * font,int character); " <<std::endl;
   return octave_value(-1);
  }
#ifdef DEBUG
std::cout<<" Fl_Glut_Window_glutBitmapWidth "<<std::endl;
#endif /* DEBUG */
_glutPtr =( glut * )args( 0 ).long_value();
font =( void * )args( 1 ).long_value();
character = (  int  ) args( 2 ).int_value();
long int ret_type=(long int) Fl_Glut_Window_glutBitmapWidth ( font,character);
return octave_value(ret_type);
}
/* Overridden functions */
/* Linked Separately */
DEFUN_DLD( glut , args , , " void glut(void); " )
{
  if (args.length() >= 4 && args.length() <= 5)
    {
      char *str=NULL;      
      if(args.length()==5)
	str=strdup(args(4).string_value().c_str());
      glut *flb=new glut(args(0).int_value(),
                             args(1).int_value(),
			     args(2).int_value(),
                             args(3).int_value(),str);
      return octave_value(new FLTKWrapper(flb,"glut"));
    }
octave_dynamic_loader::load("Fl_Glut_Window__init" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_draw" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_draw_overlay" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_handle" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_make_current" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutInit" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutInitDisplayMode" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutInitWindowPosition" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutInitWindowSize" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutMainLoop" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutCreateWindow" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutCreateSubWindow" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutDestroyWindow" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutSwapBuffers" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutSetWindow" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glut_window->make_overlay_current" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutCreateMenu" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutDestroyMenu" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutAddMenuEntry" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutAddSubMenu" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutChangeToMenuEntry" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutChangeToSubMenu" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutRemoveMenuItem" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutGet" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutLayerGet" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutBitmapCharacter" ,"");
octave_dynamic_loader::load("Fl_Glut_Window_glutBitmapWidth" ,"");
std::cout<<"Code generated onMon Aug  1 20:24:54 2005\n Compiled on " __DATE__  __TIME__ "\n loadedglutLibrary!"<<std::endl;

 return octave_value(new FLTKStaticWrapper(0,"Fl_Glut"));
}
