#! /usr/bin/python

# This program is free software.
# This code is a part of Octave-GTK, Octave-FLTK
# Code may be used or distributed under GPL.
# (C) July 2005 Muthiah Annamalai, Octave-GTK,Octave-FLTK

import sys
import os
import time

enumerated=[] #contains a list of enums dumped. avoids duplication.


def print_enum(line,val):
    if line.find(";")>=0:
        return
    if line=="private:" >=0 or line=="public:">=0:
        return        
    if line[:2]=="__" or line.find("PRIVATE")>= 0:
        print "/* DEFCONST_INTERNAL("+line+",",val,",\"\"); [seems internal]*/"
        return
    if line.find(")") >= 0 or line.find("(") >=0 :
        return
    if line=="int" or line.find("int ")>=0 or line.find("void") >= 0:
        return
    if line.find("*")>=0:
        return
    if line.find(" ")>=0 :
        if line.find(" ") < len(line.strip()):
            #space in the middle of a enum declaration
            #case: long flags, int max_width max_height;, etc.
            return

    try:
        x=enumerated.index(line);
        print "/* Enum Already Generated: %s */"%line
        return;    
    except:
        enumerated.append(line);    
        print "DEFCONST_INTERNAL("+line+",",val,",\"\");"
    return

def enums_grab(file):
    tmp_file=time.asctime().replace(' ',"_");
    os.system("cpp "+ "-o"+tmp_file+"< "+ file)
    try:
        data=open(tmp_file).readlines()
    except IOError:
        print "/* Error : cannot open file"+tmp_file+" */"
        return
    count=0
    print "/*file : ",file,"*/"
    EnumFlag = False

    for line in data:
        line=line.strip()

        if len(line)<= 0:
                continue
            
        if line[0]=="#":
            continue
        if line.find("typedef")>=0 and line.find("enum")< 0:
            continue
            
        if line.find("struct")>=0:
            continue
        

        if EnumFlag :
            if line.find("{") >= 0:
                continue
            if line.find("}") >= 0:
                EnumFlag = False
                count=0
            else:
                if line.find("=") >= 0:
                    #forms like 'GTK_SHEET_LEFT_BORDER     = 1 << 0,'
                    valine=line.split("=")[1].strip().split(",")[0].split("/*")[0]
                    if valine.find("<<") < 0:
                        val=valine
                    else:
                        try:
                            val=eval(valine)
                        except:
                            val=-1;
                        
                    line=line.split("=")[0].strip()
                    if len(line.split(","))>=2:
                        count=0;
                        for item in line.split(","):
                            print_enum(item,count);
                            count=count+1;
                        continue
                    line=line.replace(',','')
                    print_enum(line,val)
                else:
                    line=line.replace(',','')
                    print_enum(line,count)
                count=count+1
        elif line.find("enum")>= 0:
		cont=True
                if line.find("typedef") >= 0:
			cont=False
		elif line[:4] == "enum":
			cont = False
		else:
			cont = True
		if cont :
			continue
	    	EnumFlag = True
	    	count=0
    os.unlink(tmp_file)
    return    

if __name__ == "__main__":
    for file in sys.argv[1:]:
        #sys.stderr.write("File: "+file+"\n");
        enums_grab(file);
