#! /usr/bin/python

# This program is free software.
# This code is a part of Octave-GTK, Octave-FLTK
# Code may be used or distributed under GPL.
# (C) July 2005 Muthiah Annamalai, Octave-GTK,Octave-FLTK

# changed to work with C++ classes.

import sys
import re
import glob
import os
import time
import structer


class FunMatch:
    def __init__(self):
        self.ObjList=[]
        pass

    def totalDump(self):
        structer.writeFormat(self.ObjList,self.class_prefix)
        return

    def GetNextLine(self):
        self.lineno=self.lineno+1;
        if not self.LineOver():
            return self.data[self.lineno]
        return None
        
    def LineOver(self):
        if self.lineno >= self.linemax:
            return True 
        return False

    def funmatch(self,filename):
	"""This function does the job of reading the header file @filename
	and extracting the function definitions from it, and saves the
	function definition into a ObjList[] list.
	"""
        filp=open(filename)
        self.data=filp.readlines()
        
        fcnlist=[] #actual func list
        funcdef=[] #temporary, smells like function 
        
        infunc=False
        incomment=False
        instruct=False

        self.class_prefix=""

        complete=False
        self.lineno=0;
        self.linemax=len(self.data);
        #sys.stderr.write("In FunMatch\n");
    
        while not complete:
            i=self.GetNextLine();
            if i == None:
                complete=True
                break;

            if(i[0:5]=="class" and i.find("{")>=0):
                i=i.replace("class","")
                i=i.strip().replace("FL_EXPORT"," ").strip()
                self.class_prefix=re.split("[\n\s]+",i)[0]
                sys.stderr.write("Generating for "+ self.class_prefix+"\n");
                
            if(i.find(")")>=0):
                i=i.split(")")[0]+')'
                funcdef.append(i)
                if(i.find(")")>=0):
                    fcnlist.append("".join(funcdef))
                    #fcnlist[-1]=fcnlist[-1].replace("\n","");
                    #add some checks for functions.                    
                    if(fcnlist[-1].find("(")>=0 and fcnlist[-1].find(")")>=0):
                        pass
                    else:
                        sys.stderr.write("deleting : "+fcnlist[-1]+"\n")
                        del fcnlist[-1]
                    funcdef=[]
                    
        #sys.stderr.write("Entering FcnList")
        for i in fcnlist:
            i=i.strip();
            i=re.split("[\n\s]+",i);
            i=" ".join(i).strip()
            sys.stderr.write("X-X-X-X: "+i+"\n");
            #sys.stderr.write(i+"\n");
            self.ObjList.append(structer.doTheHardWork(i));
        #sys.stderr.write("Leaving FcnList\n")

        

if __name__ == "__main__":
    if(len(sys.argv)>=2):
        stdout=sys.stdout
        sys.stdout=open(sys.argv[1],"w")
        tmp_file=time.asctime().replace(' ',"_");
        fobj=FunMatch()
        for files in sys.argv[1:]:
            #print "cpp ",files,"-o",tmp_file
            os.system("cpp "+ "-o"+tmp_file+"< "+ files)
            #os.system("cat "+tmp_file)
            sys.stderr.write("#listing functions in "+files+"\n")
            fobj.ObjList.append(structer.CommentStruct("# "+files+" Functions listed here"))
            fobj.funmatch("./"+tmp_file)
            fobj.ObjList.append(structer.CommentStruct("# "+"*"*10+"End of "+files+"*"*10))
        fobj.totalDump()
        sys.stdout.close()        
    else:
        sys.stderr.write("\t usage: ./funmatch.py <output header file> <file1> <file2> ...\n\n")
        sys.stderr.write("\t preferably use a [$pre-processor]$ on the <header file>\n")
        sys.stderr.write("\t before you do this funmatch magic.\n")
        sys.exit(-1)
        
    os.unlink(tmp_file)

