#! /usr/bin/python

# (C) 2005 Muthiah Annamalai 
#
# What the hell was it supposed to do?
# A: Read from the function list, and make python readable arrays.
# second stage after running a lexer on the .h file.
import sys

#modified to work on C++ classes

class FunctionStruct:
    def __init__(self):
        """default init function"""
        self.ReturnType=""
        self.Name =  ""
        self.ArgsList = [] #{type:default_argument}
        self.definition = {}
	self.info = None
        
    def write(self,ClassPrefix):
	""" retval of 1 indicates error,
	    retval of 0 indicate success"""
        #print "def: ",self.definition
	tmp=self.Name+" "
	self.Name=self.Name.split("(")[0]
        if self.Name[0]=='~':
            print "#function "+tmp+"is destructor"
            return 1;
        if len(self.Name)==0 or self.Name == "sizeof" or self.Name == "SSizeof_gnu_v3":
		print "#function "+tmp+" couldnt be grabbed. error.";
		return 1;
        print "[\t\""+self.ReturnType+"\",\n\t\""+ClassPrefix+"_"+self.Name+"\",\n\t",self.ArgsList,"\n]"
	#print "# "+self.info
        #print "rt",self.ReturnType
        #print "name",self.Name
        #print "args",self.ArgsList
	return 0;

class CommentStruct:
    def __init__(self,comment_str):
        self.comment=comment_str

    def write(self,classpreefix):
        print self.comment
        

def writeFormat(FcnList,ClassPrefix):
    print "#/* AutoGenerated File : DONOT-EDIT */"
    print "#/* Contains GTK library functions like this: */"
    print "#/* [ret-type, func-name, {type1:param-name1, ...}] */"
    print "function_list = ["
    for i in range(0,len(FcnList)):
        if not (FcnList[i] is None):
            val=FcnList[i].write(ClassPrefix)  # 1, means error
            if(hasattr(FcnList[i],"comment") or val==1):
                pass
            elif(i < len(FcnList)-1):
                print ","
    print "]"
    return None

def getSanityLine(line):
        #find return type.
    UnsignedFlag=False;
    rt=line.find(" ")
    sys.stderr.write("***** Get Sanity:  "+line+"\n")
    if(rt != -1):
        if line[:rt]=="extern" or line[:rt]=="typedef":
            sys.stderr.write("losing: "+line+"\n")
            return None #extern things are mostly library stuff, dont wrap it.
            rt=rt+1
            line=line[rt:].strip()
            rt=line.find(" ")
        elif line[:rt]=="G_CONST_RETURN":
            line=line[rt:].strip()
            #sys.stderr.write("G_CONST found "+fs.ReturnType+" \n");
            rt=line.find(" ");
        elif line[:rt]=="const":
            line=line[rt:].strip()
            rt=line.find(" ");
        elif line[:rt]=="G_GNUC_PRINTF":
            line=line[rt:].strip()
            rt=-1
        elif line[:rt]=="G_MODULE_EXPORT":
            line=line[rt:].strip()
            rt=line.find(" ")
        elif line[:rt]=="unsigned":
            line=line[rt:].strip()
            rt=line.find(" ")
            UnsignedFlag=True;
        elif line[0:2]=="__":
            line=line[rt:].strip()
            rt=line.find(" ")
            line=line[rt:].strip();
            return getSanityLine(line);
    return [line,UnsignedFlag]


def  doTheHardWork(line):
    fs=FunctionStruct()
    
    fs.definition = line

    if(line[0]==';' or line[0]=='#' or len(line.strip())<1):#comments,#defines & newlines
        return None

    obj=getSanityLine(line);
    if (obj)!=None:
        [line,UnsignedFlag] = obj
    else:
        return None
            
    sys.stderr.write("**** Sanitized Line: "+line+"\n");
    line=line.replace("G_CONST_RETURN *","")
    line=line.replace("FL_EXPORT","")    
    line=line.strip()

    if line[:6]=="inline":
        sys.stderr.write("**** Inline Function: "+line+"\n");
        return
    
    rt=line.find(" ")
    if rt!= -1 and line[rt+1]=="*":
        rt=rt+2
        fs.ReturnType=line[:rt]
        sys.stderr.write( ">>>"+line+" / "+str(rt)+" / "+fs.ReturnType+"<<<")
        #line=line[rt+1:]
        rt=rt-1
        if  UnsignedFlag:
            fs.ReturnType="unsigned "+fs.ReturnType;
    else:
        fs.ReturnType=line[:rt]
    
    #find function name
    fn=line.find("(")
    fs.Name=line[rt+1:fn].strip().split(" ")[-1]
    del rt
    
    if(fs.Name=="") :
        sys.stderr.write("Weve got some mess ..."+fs.ReturnType+"\n")
        fs.Name=fs.ReturnType
        fs.ReturnType="int"
        return None
    
        
    #find arguments
    al=line.find(")")
    arglist=line[fn+1:al]
    del al
    del fn

    arglist=arglist.split(",")
    #        print arglist
    for z in arglist:
        UnsignedFlag=False;
        ConstFlag = False;
        z=z.strip()
        rt=z.find(" ")
        #reached VarArgs..
        if(z.find("...")>=0):
            #sys.stderr.write("Found VarArgs..\n")
            fs.ArgsList.append({"char *":"varargs_value"})
            break;
        if(rt!=-1):
            if (z[:rt] == "unsigned"):
                UnsignedFlag=True
                
            if (z[:rt] == "const" ):
                ConstFlag = not True;
                
            if(z[:rt]=="const" or z[:rt]=="G_CONST_RETURN" or z[:rt] == "unsigned" or z[:rt] == "enum"):                
                z=z[rt+1:]
                rt=z.find(" ")
        
        if(rt != -1):                
            if(z[rt+1]=="*"):
                rt=rt+1
            tn=z[0:rt+1].strip()
            if(UnsignedFlag):
                tn="unsigned "+tn;
            if(ConstFlag):
                tn="const "+tn;
             
            sys.stderr.write("** "+tn+"\n")
            tv=z[rt+1:].strip()

            fs.ArgsList.append({tn:tv})
        else:
            fs.ArgsList.append({z.strip():""})
    return fs
    

def format(filename):
    fp=open(filename)
    data=fp.readlines()
    fp.close()

    FcnList=[]

    for line in data:
        fs=doTheHardWork(line)
        if fs is None:
            continue
	fs.info=line
        FcnList.append(fs)
    writeFormat(FcnList,"");

if __name__ == "__main__":
    import sys
    if len(sys.argv) >= 2:
        format(sys.argv[1])
    else:
        print "Usage: ./structer.py <filename>"
        doTheHardWork("G_CONST_RETURN char *gdk_get_program_class (void);").write()
        doTheHardWork("PangoContext *gdk_pango_context_get_for_screen (GdkScreen    *screen);").write()
        doTheHardWork("gboolean gdk_init_check (gint *argc,gchar ***argv);").write()
        doTheHardWork("gchar* gdk_get_display (void);").write();
        doTheHardWork("gint gdk_screen_height (void) G_GNUC_CONST;").write();
